/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContributionService","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function(ge){for(var e=[],I=0,O=ge.length;I<O;I++)e[I]=Ce[ge[I]];return e};define(Ce[68],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=O,e.$Nh=M,e.$Oh=N;function I(A){return(m,d,k)=>{let F=null,E=null;if(typeof k.value=="function"?(F="value",E=k.value):typeof k.get=="function"&&(F="get",E=k.get),!E)throw new Error("not supported");k[F]=A(E,d)}}function O(A,m,d){let k=null,F=null;if(typeof d.value=="function"?(k="value",F=d.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(k="get",F=d.get),!F)throw new Error("not supported");const E=`$memoize$${m}`;d[k]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,u)}),this[E]}}function M(A,m,d){return I((k,F)=>{const E=`$debounce$${F}`,u=`$debounce$result$${F}`;return function(...b){this[u]||(this[u]=d?d():void 0),clearTimeout(this[E]),m&&(this[u]=m(this[u],...b),b=[this[u]]),this[E]=setTimeout(()=>{k.apply(this,b),this[u]=d?d():void 0},A)}})}function N(A,m,d){return I((k,F)=>{const E=`$throttle$timer$${F}`,u=`$throttle$result$${F}`,b=`$throttle$lastRun$${F}`,f=`$throttle$pending$${F}`;return function(...r){if(this[u]||(this[u]=d?d():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),m&&(this[u]=m(this[u],...r)),this[f])return;const o=this[b]+A;o<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[u]]),this[u]=d?d():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),k.apply(this,[this[u]]),this[u]=d?d():void 0},o-Date.now()))}})}}),define(Ce[90],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0;class I{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$MO=I,e.$NO=new I("id#")}),define(Ce[122],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=A,e.$un=E,e.$vn=u,e.$wn=b,e.$xn=f,e.$yn=r,e.$zn=o,e.$An=s,e.$Bn=n,e.$Cn=i,e.$Dn=a,e.$En=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,p=!1){let c=0;const $=t.length;let w="",v=0,l=16,D=0;function g(q){let R=0,z=0;for(;R<q;){const G=t.charCodeAt(c);if(G>=48&&G<=57)z=z*16+G-48;else if(G>=65&&G<=70)z=z*16+G-65+10;else if(G>=97&&G<=102)z=z*16+G-97+10;else break;c++,R++}return R<q&&(z=-1),z}function S(q){c=q,w="",v=0,l=16,D=0}function y(){const q=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&k(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&k(t.charCodeAt(c)))for(c++;c<t.length&&k(t.charCodeAt(c));)c++;else return D=3,t.substring(q,c);let R=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&k(t.charCodeAt(c))){for(c++;c<t.length&&k(t.charCodeAt(c));)c++;R=c}else D=3;return t.substring(q,R)}function P(){let q="",R=c;for(;;){if(c>=$){q+=t.substring(R,c),D=2;break}const z=t.charCodeAt(c);if(z===34){q+=t.substring(R,c),c++;break}if(z===92){if(q+=t.substring(R,c),c++,c>=$){D=2;break}switch(t.charCodeAt(c++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=g(4);ie>=0?q+=String.fromCharCode(ie):D=4;break}default:D=5}R=c;continue}if(z>=0&&z<=31)if(d(z)){q+=t.substring(R,c),D=2;break}else D=6;c++}return q}function C(){if(w="",D=0,v=c,c>=$)return v=$,l=17;let q=t.charCodeAt(c);if(m(q)){do c++,w+=String.fromCharCode(q),q=t.charCodeAt(c);while(m(q));return l=15}if(d(q))return c++,w+=String.fromCharCode(q),q===13&&t.charCodeAt(c)===10&&(c++,w+=`
`),l=14;switch(q){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,w=P(),l=10;case 47:{const R=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<$&&!d(t.charCodeAt(c));)c++;return w=t.substring(R,c),l=12}if(t.charCodeAt(c+1)===42){c+=2;const z=$-1;let G=!1;for(;c<z;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,G=!0;break}c++}return G||(c++,D=1),w=t.substring(R,c),l=13}return w+=String.fromCharCode(q),c++,l=16}case 45:if(w+=String.fromCharCode(q),c++,c===$||!k(t.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=y(),l=11;default:for(;c<$&&W(q);)c++,q=t.charCodeAt(c);if(v!==c){switch(w=t.substring(v,c),w){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return w+=String.fromCharCode(q),c++,l=16}}function W(q){if(m(q)||d(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=C();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>c,scan:p?V:C,getToken:()=>l,getTokenValue:()=>w,getTokenOffset:()=>v,getTokenLength:()=>c-v,getTokenError:()=>D}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var F;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(F||(F={}));function E(t,p){const c=[],$=new Object;let w;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(g,S,y,P){v.value=g,v.offset=S,v.length=y,v.type=P,v.colonOffset=void 0,w=v}try{i(t,{onObjectBegin:(g,S)=>{if(p<=g)throw $;w=void 0,l=p>g,c.push("")},onObjectProperty:(g,S,y)=>{if(p<S||(D(g,S,y,"property"),c[c.length-1]=g,p<=S+y))throw $},onObjectEnd:(g,S)=>{if(p<=g)throw $;w=void 0,c.pop()},onArrayBegin:(g,S)=>{if(p<=g)throw $;w=void 0,c.push(0)},onArrayEnd:(g,S)=>{if(p<=g)throw $;w=void 0,c.pop()},onLiteralValue:(g,S,y)=>{if(p<S||(D(g,S,y,h(g)),p<=S+y))throw $},onSeparator:(g,S,y)=>{if(p<=S)throw $;if(g===":"&&w&&w.type==="property")w.colonOffset=S,l=!1,w=void 0;else if(g===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(l=!0,c[c.length-1]=""),w=void 0}}})}catch(g){if(g!==$)throw g}return{path:c,previousNode:w,isAtPropertyKey:l,matches:g=>{let S=0;for(let y=0;S<g.length&&y<c.length;y++)if(g[S]===c[y]||g[S]==="*")S++;else if(g[S]!=="**")return!1;return S===g.length}}}function u(t,p=[],c=N.DEFAULT){let $=null,w=[];const v=[];function l(g){Array.isArray(w)?w.push(g):$!==null&&(w[$]=g)}return i(t,{onObjectBegin:()=>{const g={};l(g),v.push(w),w=g,$=null},onObjectProperty:g=>{$=g},onObjectEnd:()=>{w=v.pop()},onArrayBegin:()=>{const g=[];l(g),v.push(w),w=g,$=null},onArrayEnd:()=>{w=v.pop()},onLiteralValue:l,onError:(g,S,y)=>{p.push({error:g,offset:S,length:y})}},c),w[0]}function b(t,p=[],c=N.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(g){$.type==="property"&&($.length=g-$.offset,$=$.parent)}function v(g){return $.children.push(g),g}i(t,{onObjectBegin:g=>{$=v({type:"object",offset:g,length:-1,parent:$,children:[]})},onObjectProperty:(g,S,y)=>{$=v({type:"property",offset:S,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:g,offset:S,length:y,parent:$})},onObjectEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,w(g+S)},onArrayBegin:(g,S)=>{$=v({type:"array",offset:g,length:-1,parent:$,children:[]})},onArrayEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,w(g+S)},onLiteralValue:(g,S,y)=>{v({type:h(g),offset:S,length:y,parent:$,value:g}),w(S+y)},onSeparator:(g,S,y)=>{$.type==="property"&&(g===":"?$.colonOffset=S:g===","&&w(S))},onError:(g,S,y)=>{p.push({error:g,offset:S,length:y})}},c);const D=$.children[0];return D&&delete D.parent,D}function f(t,p){if(!t)return;let c=t;for(const $ of p)if(typeof $=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let w=!1;for(const v of c.children)if(Array.isArray(v.children)&&v.children[0].value===$){c=v.children[1],w=!0;break}if(!w)return}else{const w=$;if(c.type!=="array"||w<0||!Array.isArray(c.children)||w>=c.children.length)return;c=c.children[w]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const p=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;p.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&p.push(c)}return p}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const p=Object.create(null);for(const c of t.children){const $=c.children[1];$&&(p[c.children[0].value]=o($))}return p}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,p,c=!1){return p>=t.offset&&p<t.offset+t.length||c&&p===t.offset+t.length}function n(t,p,c=!1){if(s(t,p,c)){const $=t.children;if(Array.isArray($))for(let w=0;w<$.length&&$[w].offset<=p;w++){const v=n($[w],p,c);if(v)return v}return t}}function i(t,p,c=N.DEFAULT){const $=A(t,!1);function w(ne){return ne?()=>ne($.getTokenOffset(),$.getTokenLength()):()=>!0}function v(ne){return ne?Se=>ne(Se,$.getTokenOffset(),$.getTokenLength()):()=>!0}const l=w(p.onObjectBegin),D=v(p.onObjectProperty),g=w(p.onObjectEnd),S=w(p.onArrayBegin),y=w(p.onArrayEnd),P=v(p.onLiteralValue),C=v(p.onSeparator),W=w(p.onComment),V=v(p.onError),q=c&&c.disallowComments,R=c&&c.allowTrailingComma;function z(){for(;;){const ne=$.scan();switch($.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:q||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(ne){case 12:case 13:q?G(10):W();break;case 16:G(1);break;case 15:case 14:break;default:return ne}}}function G(ne,Se=[],Le=[]){if(V(ne),Se.length+Le.length>0){let re=$.getToken();for(;re!==17;){if(Se.indexOf(re)!==-1){z();break}else if(Le.indexOf(re)!==-1)break;re=z()}}}function ie(ne){const Se=$.getTokenValue();return ne?P(Se):D(Se),z(),!0}function fe(){switch($.getToken()){case 11:{let ne=0;try{ne=JSON.parse($.getTokenValue()),typeof ne!="number"&&(G(2),ne=0)}catch{G(2)}P(ne);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return z(),!0}function De(){return $.getToken()!==10?(G(3,[],[2,5]),!1):(ie(!1),$.getToken()===6?(C(":"),z(),$e()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function we(){l(),z();let ne=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(ne||G(4,[],[]),C(","),z(),$.getToken()===2&&R)break}else ne&&G(6,[],[]);De()||G(4,[],[2,5]),ne=!0}return g(),$.getToken()!==2?G(7,[2],[]):z(),!0}function oe(){S(),z();let ne=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(ne||G(4,[],[]),C(","),z(),$.getToken()===4&&R)break}else ne&&G(6,[],[]);$e()||G(4,[],[4,5]),ne=!0}return y(),$.getToken()!==4?G(8,[4],[]):z(),!0}function $e(){switch($.getToken()){case 3:return oe();case 1:return we();case 10:return ie(!0);default:return fe()}}return z(),$.getToken()===17?c.allowEmptyContent?!0:(G(4,[],[]),!1):$e()?($.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}function a(t,p){const c=A(t),$=[];let w,v=0,l;do switch(l=c.getPosition(),w=c.scan(),w){case 12:case 13:case 17:v!==l&&$.push(t.substring(v,l)),p!==void 0&&$.push(c.getTokenValue().replace(/[^\r\n]/g,p)),v=c.getPosition();break}while(w!==17);return $.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Ce[123],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(ye,pe){for(var de=0;de<pe.length;de++){var J=pe[de];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ye,J.key,J)}}function I(ye,pe,de){return pe&&e(ye.prototype,pe),de&&e(ye,de),Object.defineProperty(ye,"prototype",{writable:!1}),ye}function O(ye,pe){if(ye){if(typeof ye=="string")return M(ye,pe);var de=Object.prototype.toString.call(ye).slice(8,-1);if(de==="Object"&&ye.constructor&&(de=ye.constructor.name),de==="Map"||de==="Set")return Array.from(ye);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return M(ye,pe)}}function M(ye,pe){(pe==null||pe>ye.length)&&(pe=ye.length);for(var de=0,J=new Array(pe);de<pe;de++)J[de]=ye[de];return J}function N(ye,pe){var de=typeof Symbol<"u"&&ye[Symbol.iterator]||ye["@@iterator"];if(de)return(de=de.call(ye)).next.bind(de);if(Array.isArray(ye)||(de=O(ye))||pe&&ye&&typeof ye.length=="number"){de&&(ye=de);var J=0;return function(){return J>=ye.length?{done:!0}:{done:!1,value:ye[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=A();function m(ye){ge.defaults=ye}var d=/[&<>"']/,k=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(pe){return u[pe]};function f(ye,pe){if(pe){if(d.test(ye))return ye.replace(k,b)}else if(F.test(ye))return ye.replace(E,b);return ye}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ye){return ye.replace(r,function(pe,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(ye,pe){ye=typeof ye=="string"?ye:ye.source,pe=pe||"";var de={replace:function(Y,ue){return ue=ue.source||ue,ue=ue.replace(s,"$1"),ye=ye.replace(Y,ue),de},getRegex:function(){return new RegExp(ye,pe)}};return de}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ye,pe,de){if(ye){var J;try{J=decodeURIComponent(o(de)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}pe&&!a.test(de)&&(de=w(pe,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},p=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ye,pe){t[" "+ye]||(p.test(ye)?t[" "+ye]=ye+"/":t[" "+ye]=g(ye,"/",!0)),ye=t[" "+ye];var de=ye.indexOf(":")===-1;return pe.substring(0,2)==="//"?de?pe:ye.replace(c,"$1")+pe:pe.charAt(0)==="/"?de?pe:ye.replace($,"$1")+pe:ye+pe}var v={exec:function(){}};function l(ye){for(var pe=1,de,J;pe<arguments.length;pe++){de=arguments[pe];for(J in de)Object.prototype.hasOwnProperty.call(de,J)&&(ye[J]=de[J])}return ye}function D(ye,pe){var de=ye.replace(/\|/g,function(ue,he,Ne){for(var le=!1,Ie=he;--Ie>=0&&Ne[Ie]==="\\";)le=!le;return le?"|":" |"}),J=de.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>pe)J.splice(pe);else for(;J.length<pe;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function g(ye,pe,de){var J=ye.length;if(J===0)return"";for(var Y=0;Y<J;){var ue=ye.charAt(J-Y-1);if(ue===pe&&!de)Y++;else if(ue!==pe&&de)Y++;else break}return ye.slice(0,J-Y)}function S(ye,pe){if(ye.indexOf(pe[1])===-1)return-1;for(var de=ye.length,J=0,Y=0;Y<de;Y++)if(ye[Y]==="\\")Y++;else if(ye[Y]===pe[0])J++;else if(ye[Y]===pe[1]&&(J--,J<0))return Y;return-1}function y(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ye,pe){if(pe<1)return"";for(var de="";pe>1;)pe&1&&(de+=ye),pe>>=1,ye+=ye;return de+ye}function C(ye,pe,de,J){var Y=pe.href,ue=pe.title?f(pe.title):null,he=ye[1].replace(/\\([\[\]])/g,"$1");if(ye[0].charAt(0)!=="!"){J.state.inLink=!0;var Ne={type:"link",raw:de,href:Y,title:ue,text:he,tokens:J.inlineTokens(he)};return J.state.inLink=!1,Ne}return{type:"image",raw:de,href:Y,title:ue,text:f(he)}}function W(ye,pe){var de=ye.match(/^(\s+)(?:```)/);if(de===null)return pe;var J=de[1];return pe.split(`
`).map(function(Y){var ue=Y.match(/^\s+/);if(ue===null)return Y;var he=ue[0];return he.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var V=function(){function ye(de){this.options=de||ge.defaults}var pe=ye.prototype;return pe.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},pe.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var ue=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:g(ue,`
`)}}},pe.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var ue=Y[0],he=W(ue,Y[3]||"");return{type:"code",raw:ue,lang:Y[2]?Y[2].trim():Y[2],text:he}}},pe.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var ue=Y[2].trim();if(/#$/.test(ue)){var he=g(ue,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ue=he.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:ue,tokens:this.lexer.inline(ue)}}},pe.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},pe.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var ue=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},pe.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var ue,he,Ne,le,Ie,Re,je,U,j,K,H,ee,se=Y[1].trim(),Fe=se.length>1,Ve={type:"list",raw:"",ordered:Fe,start:Fe?+se.slice(0,-1):"",loose:!1,items:[]};se=Fe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Fe?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ee=!1,!(!(Y=Qe.exec(J))||this.rules.block.hr.test(J)));){if(ue=Y[0],J=J.substring(ue.length),U=Y[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(le=2,H=U.trimLeft()):(le=Y[2].search(/[^ ]/),le=le>4?1:le,H=U.slice(le),le+=Y[1].length),Re=!1,!U&&/^ *$/.test(j)&&(ue+=j+`
`,J=J.substring(j.length+1),ee=!0),!ee)for(var xe=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");J&&(K=J.split(`
`,1)[0],U=K,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(U)||it.test(U)||xe.test(U)||tt.test(J)));){if(U.search(/[^ ]/)>=le||!U.trim())H+=`
`+U.slice(le);else if(!Re)H+=`
`+U;else break;!Re&&!U.trim()&&(Re=!0),ue+=K+`
`,J=J.substring(K.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test(ue)&&(je=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(H),he&&(Ne=he[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ue,task:!!he,checked:Ne,loose:!1,text:H}),Ve.raw+=ue}Ve.items[Ve.items.length-1].raw=ue.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var nt=Ve.items.length;for(Ie=0;Ie<nt;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var ct=Ve.items[Ie].tokens.filter(function(Ue){return Ue.type==="space"}),ft=ct.every(function(Ue){for(var ot=Ue.raw.split(""),Z=0,X=N(ot),me;!(me=X()).done;){var qe=me.value;if(qe===`
`&&(Z+=1),Z>1)return!0}return!1});!Ve.loose&&ct.length&&ft&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},pe.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var ue={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]);ue.type="paragraph",ue.text=he,ue.tokens=this.lexer.inline(he)}return ue}},pe.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var ue=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:Y[0],href:Y[2],title:Y[3]}}},pe.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var ue={type:"table",header:D(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=Y[0];var he=ue.align.length,Ne,le,Ie,Re;for(Ne=0;Ne<he;Ne++)/^ *-+: *$/.test(ue.align[Ne])?ue.align[Ne]="right":/^ *:-+: *$/.test(ue.align[Ne])?ue.align[Ne]="center":/^ *:-+ *$/.test(ue.align[Ne])?ue.align[Ne]="left":ue.align[Ne]=null;for(he=ue.rows.length,Ne=0;Ne<he;Ne++)ue.rows[Ne]=D(ue.rows[Ne],ue.header.length).map(function(je){return{text:je}});for(he=ue.header.length,le=0;le<he;le++)ue.header[le].tokens=this.lexer.inline(ue.header[le].text);for(he=ue.rows.length,le=0;le<he;le++)for(Re=ue.rows[le],Ie=0;Ie<Re.length;Ie++)Re[Ie].tokens=this.lexer.inline(Re[Ie].text);return ue}}},pe.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},pe.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var ue=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:ue,tokens:this.lexer.inline(ue)}}},pe.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},pe.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:f(Y[1])}},pe.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]}},pe.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var ue=Y[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var he=g(ue.slice(0,-1),"\\");if((ue.length-he.length)%2===0)return}else{var Ne=S(Y[2],"()");if(Ne>-1){var le=Y[0].indexOf("!")===0?5:4,Ie=le+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ie).trim(),Y[3]=""}}var Re=Y[2],je="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);U&&(Re=U[1],je=U[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(ue)?Re=Re.slice(1):Re=Re.slice(1,-1)),C(Y,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},pe.reflink=function(J,Y){var ue;if((ue=this.rules.inline.reflink.exec(J))||(ue=this.rules.inline.nolink.exec(J))){var he=(ue[2]||ue[1]).replace(/\s+/g," ");if(he=Y[he.toLowerCase()],!he||!he.href){var Ne=ue[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return C(ue,he,ue[0],this.lexer)}},pe.emStrong=function(J,Y,ue){ue===void 0&&(ue="");var he=this.rules.inline.emStrong.lDelim.exec(J);if(he&&!(he[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=he[1]||he[2]||"";if(!Ne||Ne&&(ue===""||this.rules.inline.punctuation.exec(ue))){var le=he[0].length-1,Ie,Re,je=le,U=0,j=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,Y=Y.slice(-1*J.length+le);(he=j.exec(Y))!=null;)if(Ie=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Ie){if(Re=Ie.length,he[3]||he[4]){je+=Re;continue}else if((he[5]||he[6])&&le%3&&!((le+Re)%3)){U+=Re;continue}if(je-=Re,!(je>0)){if(Re=Math.min(Re,Re+je+U),Math.min(le,Re)%2){var K=J.slice(1,le+he.index+Re);return{type:"em",raw:J.slice(0,le+he.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=J.slice(2,le+he.index+Re-1);return{type:"strong",raw:J.slice(0,le+he.index+Re+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},pe.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var ue=Y[2].replace(/\n/g," "),he=/[^ ]/.test(ue),Ne=/^ /.test(ue)&&/ $/.test(ue);return he&&Ne&&(ue=ue.substring(1,ue.length-1)),ue=f(ue,!0),{type:"codespan",raw:Y[0],text:ue}}},pe.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},pe.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},pe.autolink=function(J,Y){var ue=this.rules.inline.autolink.exec(J);if(ue){var he,Ne;return ue[2]==="@"?(he=f(this.options.mangle?Y(ue[1]):ue[1]),Ne="mailto:"+he):(he=f(ue[1]),Ne=he),{type:"link",raw:ue[0],text:he,href:Ne,tokens:[{type:"text",raw:he,text:he}]}}},pe.url=function(J,Y){var ue;if(ue=this.rules.inline.url.exec(J)){var he,Ne;if(ue[2]==="@")he=f(this.options.mangle?Y(ue[0]):ue[0]),Ne="mailto:"+he;else{var le;do le=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(le!==ue[0]);he=f(ue[0]),ue[1]==="www."?Ne="http://"+he:Ne=he}return{type:"link",raw:ue[0],text:he,href:Ne,tokens:[{type:"text",raw:he,text:he}]}}},pe.inlineText=function(J,Y){var ue=this.rules.inline.text.exec(J);if(ue){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]):ue[0]:he=f(this.options.smartypants?Y(ue[0]):ue[0]),{type:"text",raw:ue[0],text:he}}},ye}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=l({},q),q.gfm=l({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=l({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=n(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=n(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=n(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=n(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=n(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=n(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=n(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=n(R.reflink).replace("label",R._label).replace("ref",q._label).getRegex(),R.nolink=n(R.nolink).replace("ref",q._label).getRegex(),R.reflinkSearch=n(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=l({},R),R.pedantic=l({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=l({},R.normal,{escape:n(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=n(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=l({},R.gfm,{br:n(R.br).replace("{2,}","*").getRegex(),text:n(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(ye){var pe="",de,J,Y=ye.length;for(de=0;de<Y;de++)J=ye.charCodeAt(de),Math.random()>.5&&(J="x"+J.toString(16)),pe+="&#"+J+";";return pe}var ie=function(){function ye(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ge.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:q.normal,inline:R.normal};this.options.pedantic?(J.block=q.pedantic,J.inline=R.pedantic):this.options.gfm&&(J.block=q.gfm,this.options.breaks?J.inline=R.breaks:J.inline=R.gfm),this.tokenizer.rules=J}ye.lex=function(J,Y){var ue=new ye(Y);return ue.lex(J)},ye.lexInline=function(J,Y){var ue=new ye(Y);return ue.inlineTokens(J)};var pe=ye.prototype;return pe.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},pe.blockTokens=function(J,Y){var ue=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(je,U,j){return U+"    ".repeat(j.length)});for(var he,Ne,le,Ie;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(he=je.call({lexer:ue},J,Y))?(J=J.substring(he.raw.length),Y.push(he),!0):!1}))){if(he=this.tokenizer.space(J)){J=J.substring(he.raw.length),he.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(he);continue}if(he=this.tokenizer.code(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he);continue}if(he=this.tokenizer.fences(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.heading(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.hr(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.blockquote(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.list(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.html(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.def(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.lheading(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(le=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,U=J.slice(1),j=void 0;ue.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},U),typeof j=="number"&&j>=0&&(je=Math.min(je,j))}),je<1/0&&je>=0&&(le=J.substring(0,je+1))}(),this.state.top&&(he=this.tokenizer.paragraph(le))){Ne=Y[Y.length-1],Ie&&Ne.type==="paragraph"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he),Ie=le.length!==J.length,J=J.substring(he.raw.length);continue}if(he=this.tokenizer.text(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he);continue}if(J){var Re="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Y},pe.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},pe.inlineTokens=function(J,Y){var ue=this;Y===void 0&&(Y=[]);var he,Ne,le,Ie=J,Re,je,U;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)j.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Re.index)+"["+P("a",Re[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Re.index)+"["+P("a",Re[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Re.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(je||(U=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(he=H.call({lexer:ue},J,Y))?(J=J.substring(he.raw.length),Y.push(he),!0):!1}))){if(he=this.tokenizer.escape(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.tag(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&he.type==="text"&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(he=this.tokenizer.link(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&he.type==="text"&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(he=this.tokenizer.emStrong(J,Ie,U)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.codespan(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.br(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.del(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.autolink(J,G)){J=J.substring(he.raw.length),Y.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(J,G))){J=J.substring(he.raw.length),Y.push(he);continue}if(le=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=J.slice(1),se=void 0;ue.options.extensions.startInline.forEach(function(Fe){se=Fe.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(le=J.substring(0,H+1))}(),he=this.tokenizer.inlineText(le,z)){J=J.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(U=he.raw.slice(-1)),je=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Y},I(ye,null,[{key:"rules",get:function(){return{block:q,inline:R}}}]),ye}(),fe=function(){function ye(de){this.options=de||ge.defaults}var pe=ye.prototype;return pe.code=function(J,Y,ue){var he=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(J,he);Ne!=null&&Ne!==J&&(ue=!0,J=Ne)}return J=J.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+f(he,!0)+'">'+(ue?J:f(J,!0))+`</code></pre>
`:"<pre><code>"+(ue?J:f(J,!0))+`</code></pre>
`},pe.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},pe.html=function(J){return J},pe.heading=function(J,Y,ue,he){if(this.options.headerIds){var Ne=this.options.headerPrefix+he.slug(ue);return"<h"+Y+' id="'+Ne+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(J,Y,ue){var he=Y?"ol":"ul",Ne=Y&&ue!==1?' start="'+ue+'"':"";return"<"+he+Ne+`>
`+J+"</"+he+`>
`},pe.listitem=function(J){return"<li>"+J+`</li>
`},pe.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(J){return"<p>"+J+`</p>
`},pe.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},pe.tablerow=function(J){return`<tr>
`+J+`</tr>
`},pe.tablecell=function(J,Y){var ue=Y.header?"th":"td",he=Y.align?"<"+ue+' align="'+Y.align+'">':"<"+ue+">";return he+J+("</"+ue+`>
`)},pe.strong=function(J){return"<strong>"+J+"</strong>"},pe.em=function(J){return"<em>"+J+"</em>"},pe.codespan=function(J){return"<code>"+J+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(J){return"<del>"+J+"</del>"},pe.link=function(J,Y,ue){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ue;var he='<a href="'+f(J)+'"';return Y&&(he+=' title="'+Y+'"'),he+=">"+ue+"</a>",he},pe.image=function(J,Y,ue){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ue;var he='<img src="'+J+'" alt="'+ue+'"';return Y&&(he+=' title="'+Y+'"'),he+=this.options.xhtml?"/>":">",he},pe.text=function(J){return J},ye}(),De=function(){function ye(){}var pe=ye.prototype;return pe.strong=function(J){return J},pe.em=function(J){return J},pe.codespan=function(J){return J},pe.del=function(J){return J},pe.html=function(J){return J},pe.text=function(J){return J},pe.link=function(J,Y,ue){return""+ue},pe.image=function(J,Y,ue){return""+ue},pe.br=function(){return""},ye}(),we=function(){function ye(){this.seen={}}var pe=ye.prototype;return pe.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(J,Y){var ue=J,he=0;if(this.seen.hasOwnProperty(ue)){he=this.seen[J];do he++,ue=J+"-"+he;while(this.seen.hasOwnProperty(ue))}return Y||(this.seen[J]=he,this.seen[ue]=0),ue},pe.slug=function(J,Y){Y===void 0&&(Y={});var ue=this.serialize(J);return this.getNextSafeSlug(ue,Y.dryrun)},ye}(),oe=function(){function ye(de){this.options=de||ge.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new we}ye.parse=function(J,Y){var ue=new ye(Y);return ue.parse(J)},ye.parseInline=function(J,Y){var ue=new ye(Y);return ue.parseInline(J)};var pe=ye.prototype;return pe.parse=function(J,Y){Y===void 0&&(Y=!0);var ue="",he,Ne,le,Ie,Re,je,U,j,K,H,ee,se,Fe,Ve,Qe,xe,tt,at,it,nt=J.length;for(he=0;he<nt;he++){if(H=J[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){ue+=it||"";continue}switch(H.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(j="",U="",Ie=H.header.length,Ne=0;Ne<Ie;Ne++)U+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(j+=this.renderer.tablerow(U),K="",Ie=H.rows.length,Ne=0;Ne<Ie;Ne++){for(je=H.rows[Ne],U="",Re=je.length,le=0;le<Re;le++)U+=this.renderer.tablecell(this.parseInline(je[le].tokens),{header:!1,align:H.align[le]});K+=this.renderer.tablerow(U)}ue+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(H.tokens),ue+=this.renderer.blockquote(K);continue}case"list":{for(ee=H.ordered,se=H.start,Fe=H.loose,Ie=H.items.length,K="",Ne=0;Ne<Ie;Ne++)Qe=H.items[Ne],xe=Qe.checked,tt=Qe.task,Ve="",Qe.task&&(at=this.renderer.checkbox(xe),Fe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=at+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=at+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:at}):Ve+=at),Ve+=this.parse(Qe.tokens,Fe),K+=this.renderer.listitem(Ve,tt,xe);ue+=this.renderer.list(K,ee,se);continue}case"html":{ue+=this.renderer.html(H.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;he+1<nt&&J[he+1].type==="text";)H=J[++he],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);ue+=Y?this.renderer.paragraph(K):K;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return ue},pe.parseInline=function(J,Y){Y=Y||this.renderer;var ue="",he,Ne,le,Ie=J.length;for(he=0;he<Ie;he++){if(Ne=J[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(le=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){ue+=le||"";continue}switch(Ne.type){case"escape":{ue+=Y.text(Ne.text);break}case"html":{ue+=Y.html(Ne.text);break}case"link":{ue+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{ue+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{ue+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{ue+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{ue+=Y.codespan(Ne.text);break}case"br":{ue+=Y.br();break}case"del":{ue+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{ue+=Y.text(Ne.text);break}default:{var Re='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return ue},ye}();function $e(ye,pe,de){if(typeof ye>"u"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof pe=="function"&&(de=pe,pe=null),pe=l({},$e.defaults,pe||{}),y(pe),de){var J=pe.highlight,Y;try{Y=ie.lex(ye,pe)}catch(Ie){return de(Ie)}var ue=function(Re){var je;if(!Re)try{pe.walkTokens&&$e.walkTokens(Y,pe.walkTokens),je=oe.parse(Y,pe)}catch(U){Re=U}return pe.highlight=J,Re?de(Re):de(null,je)};if(!J||J.length<3||(delete pe.highlight,!Y.length))return ue();var he=0;$e.walkTokens(Y,function(Ie){Ie.type==="code"&&(he++,setTimeout(function(){J(Ie.text,Ie.lang,function(Re,je){if(Re)return ue(Re);je!=null&&je!==Ie.text&&(Ie.text=je,Ie.escaped=!0),he--,he===0&&ue()})},0))}),he===0&&ue();return}function Ne(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+f(Ie.message+"",!0)+"</pre>";throw Ie}try{var le=ie.lex(ye,pe);if(pe.walkTokens){if(pe.async)return Promise.all($e.walkTokens(le,pe.walkTokens)).then(function(){return oe.parse(le,pe)}).catch(Ne);$e.walkTokens(le,pe.walkTokens)}return oe.parse(le,pe)}catch(Ie){Ne(Ie)}}$e.options=$e.setOptions=function(ye){return l($e.defaults,ye),m($e.defaults),$e},$e.getDefaults=A,$e.defaults=ge.defaults,$e.use=function(){for(var ye=arguments.length,pe=new Array(ye),de=0;de<ye;de++)pe[de]=arguments[de];var J=l.apply(void 0,[{}].concat(pe)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},ue;pe.forEach(function(he){if(he.extensions&&(ue=!0,he.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var Ie=Y.renderers?Y.renderers[le.name]:null;Ie?Y.renderers[le.name]=function(){for(var Re=arguments.length,je=new Array(Re),U=0;U<Re;U++)je[U]=arguments[U];var j=le.renderer.apply(this,je);return j===!1&&(j=Ie.apply(this,je)),j}:Y.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[le.level]?Y[le.level].unshift(le.tokenizer):Y[le.level]=[le.tokenizer],le.start&&(le.level==="block"?Y.startBlock?Y.startBlock.push(le.start):Y.startBlock=[le.start]:le.level==="inline"&&(Y.startInline?Y.startInline.push(le.start):Y.startInline=[le.start]))}le.childTokens&&(Y.childTokens[le.name]=le.childTokens)})),he.renderer&&function(){var le=$e.defaults.renderer||new fe,Ie=function(U){var j=le[U];le[U]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=he.renderer[U].apply(le,H);return se===!1&&(se=j.apply(le,H)),se}};for(var Re in he.renderer)Ie(Re);J.renderer=le}(),he.tokenizer&&function(){var le=$e.defaults.tokenizer||new V,Ie=function(U){var j=le[U];le[U]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=he.tokenizer[U].apply(le,H);return se===!1&&(se=j.apply(le,H)),se}};for(var Re in he.tokenizer)Ie(Re);J.tokenizer=le}(),he.walkTokens){var Ne=$e.defaults.walkTokens;J.walkTokens=function(le){var Ie=[];return Ie.push(he.walkTokens.call(this,le)),Ne&&(Ie=Ie.concat(Ne.call(this,le))),Ie}}ue&&(J.extensions=Y),$e.setOptions(J)})},$e.walkTokens=function(ye,pe){for(var de=[],J=function(){var Ne=ue.value;switch(de=de.concat(pe.call($e,Ne)),Ne.type){case"table":{for(var le=N(Ne.header),Ie;!(Ie=le()).done;){var Re=Ie.value;de=de.concat($e.walkTokens(Re.tokens,pe))}for(var je=N(Ne.rows),U;!(U=je()).done;)for(var j=U.value,K=N(j),H;!(H=K()).done;){var ee=H.value;de=de.concat($e.walkTokens(ee.tokens,pe))}break}case"list":{de=de.concat($e.walkTokens(Ne.items,pe));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Ne.type]?$e.defaults.extensions.childTokens[Ne.type].forEach(function(se){de=de.concat($e.walkTokens(Ne[se],pe))}):Ne.tokens&&(de=de.concat($e.walkTokens(Ne.tokens,pe)))}},Y=N(ye),ue;!(ue=Y()).done;)J();return de},$e.parseInline=function(ye,pe){if(typeof ye>"u"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");pe=l({},$e.defaults,pe||{}),y(pe);try{var de=ie.lexInline(ye,pe);return pe.walkTokens&&$e.walkTokens(de,pe.walkTokens),oe.parseInline(de,pe)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+f(J.message+"",!0)+"</pre>";throw J}},$e.Parser=oe,$e.parser=oe.parse,$e.Renderer=fe,$e.TextRenderer=De,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=V,$e.Slugger=we,$e.parse=$e;var ne=$e.options,Se=$e.setOptions,Le=$e.use,re=$e.walkTokens,L=$e.parseInline,x=$e,ve=oe.parse,Oe=ie.lex;ge.Lexer=ie,ge.Parser=oe,ge.Renderer=fe,ge.Slugger=we,ge.TextRenderer=De,ge.Tokenizer=V,ge.getDefaults=A,ge.lexer=Oe,ge.marked=$e,ge.options=ne,ge.parse=x,ge.parseInline=L,ge.parser=ve,ge.setOptions=Se,ge.use=Le,ge.walkTokens=re,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ce[124],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=I;function I(r){const o=N(r);if(o&&o.length>0)return new Uint32Array(o)}let O=0;const M=new Uint32Array(10);function N(r){if(O=0,A(r,E,4352),O>0||(A(r,u,4449),O>0)||(A(r,b,4520),O>0)||(A(r,f,12593),O))return M.subarray(0,O);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,n=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(n<E.length?A(n,E,0):4352+n-12593<f.length&&A(4352+n,f,12593),i<u.length?A(i,u,0):4449+i-12593<f.length&&A(4449+i-12593,f,12593),a>=0&&(a<b.length?A(a,b,0):4520+a-12593<f.length&&A(4520+a-12593,f,12593)),O>0)return M.subarray(0,O)}}function A(r,o,s){r>=s&&r<s+o.length&&m(o[r-s])}function m(r){r!==0&&(M[O++]=r&255,r>>8&&(M[O++]=r>>8&255),r>>16&&(M[O++]=r>>16&255))}var d;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var k;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(k||(k={}));var F;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(F||(F={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[125],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=I,e.rot=O;function I(m,d,k){return Math.min(Math.max(m,d),k)}function O(m,d){return(d+m%d)%d}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=M;class N{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=N;class A{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const k=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=A}),function(){function ge(M){const N=[];typeof M=="number"&&N.push("code/timeOrigin",M);function A(d){N.push(d,Date.now())}function m(){const d=[];for(let k=0;k<N.length;k+=2)d.push({name:N[k],startTime:N[k+1]});return d}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(M+A.startTime)});return N}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=I(O))}(),define(Ce[126],Pe([1,0,39]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=void 0;const O=Symbol("unset");class M{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(d,k,F){this.d(d,E=>E._value=k,F)}mutate(d,k){this.d(d,F=>F._value=k(F._value===O?void 0:F._value))}delete(d){const k=this.c(d);if(!k)return;let F=k.length-1;const E=k[F].node._value;if(E!==O){for(this.b--,k[F].node._value=O;F>0;F--){const{node:u,part:b}=k[F];if(u.children?.size||u._value!==O)break;k[F-1].node.children.delete(b)}return E}}*deleteRecursive(d){const k=this.c(d);if(!k)return;const F=k[k.length-1].node;for(let E=k.length-1;E>0;E--){const u=k[E-1];if(u.node.children.delete(k[E].part),u.node.children.size>0||u.node._value!==O)break}for(const E of N(F))E._value!==O&&(this.b--,yield E._value)}find(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return;k=E}return k._value===O?void 0:k._value}hasKeyOrParent(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return!1;if(E._value!==O)return!0;k=E}return!1}hasKeyOrChildren(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return!1;k=E}return!0}hasKey(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return!1;k=E}return k._value!==O}c(d){const k=[{part:"",node:this.a}];let F=0;for(const E of d){const u=k[F].node.children?.get(E);if(!u)return;k.push({part:E,node:u}),F++}return k}d(d,k,F){let E=this.a;for(const f of d){if(E.children)if(E.children.has(f))E=E.children.get(f);else{const r=new A;E.children.set(f,r),E=r}else{const r=new A;E.children=new Map([[f,r]]),E=r}F?.(E)}const u=E._value===O?0:1;k(E);const b=E._value===O?0:1;this.b+=b-u}*values(){for(const{_value:d}of N(this.a))d!==O&&(yield d)}}e.$wO=M;function*N(m){const d=[m];for(;d.length>0;){const k=d.pop();if(yield k,k.children)for(const F of k.children.values())d.push(F)}}class A{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(d){this._value=d===void 0?O:d}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var O in I)(typeof exports=="object"?exports:ge)[O]=I[O]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(O){if(e[O])return e[O].exports;var M=e[O]={i:O,l:!1,exports:{}};return ge[O].call(M.exports,M,M.exports,I),M.l=!0,M.exports}return I.m=ge,I.c=e,I.d=function(O,M,N){I.o(O,M)||Object.defineProperty(O,M,{enumerable:!0,get:N})},I.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},I.t=function(O,M){if(1&M&&(O=I(O)),8&M||4&M&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(I.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&M&&typeof O!="string")for(var A in O)I.d(N,A,function(m){return O[m]}.bind(null,A));return N},I.n=function(O){var M=O&&O.__esModule?function(){return O.default}:function(){return O};return I.d(M,"a",M),M},I.o=function(O,M){return Object.prototype.hasOwnProperty.call(O,M)},I.p="",I(I.s=0)}([function(ge,e,I){(function(O){var M;e=ge.exports=Le,M=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],d=e.src=[],k=0,F=k++;d[F]="0|[1-9]\\d*";var E=k++;d[E]="[0-9]+";var u=k++;d[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;d[b]="("+d[F]+")\\.("+d[F]+")\\.("+d[F]+")";var f=k++;d[f]="("+d[E]+")\\.("+d[E]+")\\.("+d[E]+")";var r=k++;d[r]="(?:"+d[F]+"|"+d[u]+")";var o=k++;d[o]="(?:"+d[E]+"|"+d[u]+")";var s=k++;d[s]="(?:-("+d[r]+"(?:\\."+d[r]+")*))";var n=k++;d[n]="(?:-?("+d[o]+"(?:\\."+d[o]+")*))";var i=k++;d[i]="[0-9A-Za-z-]+";var a=k++;d[a]="(?:\\+("+d[i]+"(?:\\."+d[i]+")*))";var h=k++,t="v?"+d[b]+d[s]+"?"+d[a]+"?";d[h]="^"+t+"$";var p="[v=\\s]*"+d[f]+d[n]+"?"+d[a]+"?",c=k++;d[c]="^"+p+"$";var $=k++;d[$]="((?:<|>)?=?)";var w=k++;d[w]=d[E]+"|x|X|\\*";var v=k++;d[v]=d[F]+"|x|X|\\*";var l=k++;d[l]="[v=\\s]*("+d[v]+")(?:\\.("+d[v]+")(?:\\.("+d[v]+")(?:"+d[s]+")?"+d[a]+"?)?)?";var D=k++;d[D]="[v=\\s]*("+d[w]+")(?:\\.("+d[w]+")(?:\\.("+d[w]+")(?:"+d[n]+")?"+d[a]+"?)?)?";var g=k++;d[g]="^"+d[$]+"\\s*"+d[l]+"$";var S=k++;d[S]="^"+d[$]+"\\s*"+d[D]+"$";var y=k++;d[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=k++;d[P]="(?:~>?)";var C=k++;d[C]="(\\s*)"+d[P]+"\\s+",m[C]=new RegExp(d[C],"g");var W=k++;d[W]="^"+d[P]+d[l]+"$";var V=k++;d[V]="^"+d[P]+d[D]+"$";var q=k++;d[q]="(?:\\^)";var R=k++;d[R]="(\\s*)"+d[q]+"\\s+",m[R]=new RegExp(d[R],"g");var z=k++;d[z]="^"+d[q]+d[l]+"$";var G=k++;d[G]="^"+d[q]+d[D]+"$";var ie=k++;d[ie]="^"+d[$]+"\\s*("+p+")$|^$";var fe=k++;d[fe]="^"+d[$]+"\\s*("+t+")$|^$";var De=k++;d[De]="(\\s*)"+d[$]+"\\s*("+p+"|"+d[l]+")",m[De]=new RegExp(d[De],"g");var we=k++;d[we]="^\\s*("+d[l]+")\\s+-\\s+("+d[l]+")\\s*$";var oe=k++;d[oe]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var $e=k++;d[$e]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)M(ne,d[ne]),m[ne]||(m[ne]=new RegExp(d[ne]));function Se(j,K){if(j instanceof Le)return j;if(typeof j!="string"||j.length>N||!(K?m[c]:m[h]).test(j))return null;try{return new Le(j,K)}catch{return null}}function Le(j,K){if(j instanceof Le){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Le))return new Le(j,K);M("SemVer",j,K),this.loose=K;var H=j.trim().match(K?m[c]:m[h]);if(!H)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<A)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Se,e.valid=function(j,K){var H=Se(j,K);return H?H.version:null},e.clean=function(j,K){var H=Se(j.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=Le,Le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Le.prototype.toString=function(){return this.version},Le.prototype.compare=function(j){return M("SemVer.compare",this.version,this.loose,j),j instanceof Le||(j=new Le(j,this.loose)),this.compareMain(j)||this.comparePre(j)},Le.prototype.compareMain=function(j){return j instanceof Le||(j=new Le(j,this.loose)),L(this.major,j.major)||L(this.minor,j.minor)||L(this.patch,j.patch)},Le.prototype.comparePre=function(j){if(j instanceof Le||(j=new Le(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ee=j.prerelease[K];if(M("prerelease compare",K,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return L(H,ee)}while(++K)},Le.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Le(j,H).inc(K,ee).version}catch{return null}},e.diff=function(j,K){if(ye(j,K))return null;var H=Se(j),ee=Se(K);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=L;var re=/^[0-9]+$/;function L(j,K){var H=re.test(j),ee=re.test(K);return H&&ee&&(j=+j,K=+K),H&&!ee?-1:ee&&!H?1:j<K?-1:j>K?1:0}function x(j,K,H){return new Le(j,H).compare(new Le(K,H))}function ve(j,K,H){return x(j,K,H)>0}function Oe(j,K,H){return x(j,K,H)<0}function ye(j,K,H){return x(j,K,H)===0}function pe(j,K,H){return x(j,K,H)!==0}function de(j,K,H){return x(j,K,H)>=0}function J(j,K,H){return x(j,K,H)<=0}function Y(j,K,H,ee){var se;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j===H;break;case"!==":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j!==H;break;case"":case"=":case"==":se=ye(j,H,ee);break;case"!=":se=pe(j,H,ee);break;case">":se=ve(j,H,ee);break;case">=":se=de(j,H,ee);break;case"<":se=Oe(j,H,ee);break;case"<=":se=J(j,H,ee);break;default:throw new TypeError("Invalid operator: "+K)}return se}function ue(j,K){if(j instanceof ue){if(j.loose===K)return j;j=j.value}if(!(this instanceof ue))return new ue(j,K);M("comparator",j,K),this.loose=K,this.parse(j),this.semver===he?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(j,K){return L(K,j)},e.major=function(j,K){return new Le(j,K).major},e.minor=function(j,K){return new Le(j,K).minor},e.patch=function(j,K){return new Le(j,K).patch},e.compare=x,e.compareLoose=function(j,K){return x(j,K,!0)},e.rcompare=function(j,K,H){return x(K,j,H)},e.sort=function(j,K){return j.sort(function(H,ee){return e.compare(H,ee,K)})},e.rsort=function(j,K){return j.sort(function(H,ee){return e.rcompare(H,ee,K)})},e.gt=ve,e.lt=Oe,e.eq=ye,e.neq=pe,e.gte=de,e.lte=J,e.cmp=Y,e.Comparator=ue;var he={};function Ne(j,K){if(j instanceof Ne)return j.loose===K?j:new Ne(j.raw,K);if(j instanceof ue)return new Ne(j.value,K);if(!(this instanceof Ne))return new Ne(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function le(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ie(j,K,H,ee,se,Fe,Ve,Qe,xe,tt,at,it,nt){return((K=le(H)?"":le(ee)?">="+H+".0.0":le(se)?">="+H+"."+ee+".0":">="+K)+" "+(Qe=le(xe)?"":le(tt)?"<"+(+xe+1)+".0.0":le(at)?"<"+xe+"."+(+tt+1)+".0":it?"<="+xe+"."+tt+"."+at+"-"+it:"<="+Qe)).trim()}function Re(j,K){for(var H=0;H<j.length;H++)if(!j[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<j.length;H++)if(M(j[H].semver),j[H].semver!==he&&j[H].semver.prerelease.length>0){var ee=j[H].semver;if(ee.major===K.major&&ee.minor===K.minor&&ee.patch===K.patch)return!0}return!1}return!0}function je(j,K,H){try{K=new Ne(K,H)}catch{return!1}return K.test(j)}function U(j,K,H,ee){var se,Fe,Ve,Qe,xe;switch(j=new Le(j,ee),K=new Ne(K,ee),H){case">":se=ve,Fe=J,Ve=Oe,Qe=">",xe=">=";break;case"<":se=Oe,Fe=de,Ve=ve,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(j,K,ee))return!1;for(var tt=0;tt<K.set.length;++tt){var at=K.set[tt],it=null,nt=null;if(at.forEach(function(ct){ct.semver===he&&(ct=new ue(">=0.0.0")),it=it||ct,nt=nt||ct,se(ct.semver,it.semver,ee)?it=ct:Ve(ct.semver,nt.semver,ee)&&(nt=ct)}),it.operator===Qe||it.operator===xe||(!nt.operator||nt.operator===Qe)&&Fe(j,nt.semver)||nt.operator===xe&&Ve(j,nt.semver))return!1}return!0}ue.prototype.parse=function(j){var K=this.loose?m[ie]:m[fe],H=j.match(K);if(!H)throw new TypeError("Invalid comparator: "+j);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Le(H[2],this.loose):this.semver=he},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(j){return M("Comparator.test",j,this.loose),this.semver===he||(typeof j=="string"&&(j=new Le(j,this.loose)),Y(j,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(j,K){if(!(j instanceof ue))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(j.value,K),je(this.value,H,K);if(j.operator==="")return H=new Ne(this.value,K),je(j.semver,H,K);var ee=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Fe=this.semver.version===j.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Qe=Y(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=Y(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ee||se||Fe&&Ve||Qe||xe},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),M("range",j,K);var H=K?m[oe]:m[we];j=j.replace(H,Ie),M("hyphen replace",j),j=j.replace(m[De],"$1$2$3"),M("comparator trim",j,m[De]),j=(j=(j=j.replace(m[C],"$1~")).replace(m[R],"$1^")).split(/\s+/).join(" ");var ee=K?m[ie]:m[fe],se=j.split(" ").map(function(Fe){return function(Ve,Qe){return M("comp",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(at){return function(it,nt){M("caret",it,nt);var ct=nt?m[G]:m[z];return it.replace(ct,function(ft,Ue,ot,Z,X){var me;return M("caret",it,ft,Ue,ot,Z,X),le(Ue)?me="":le(ot)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":le(Z)?me=Ue==="0"?">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+".0 <"+(+Ue+1)+".0.0":X?(M("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+Z+X+" <"+Ue+"."+ot+"."+(+Z+1):">="+Ue+"."+ot+"."+Z+X+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+Z+X+" <"+(+Ue+1)+".0.0"):(M("no pr"),me=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+Z+" <"+Ue+"."+ot+"."+(+Z+1):">="+Ue+"."+ot+"."+Z+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+Z+" <"+(+Ue+1)+".0.0"),M("caret return",me),me})}(at,tt)}).join(" ")}(Ve,Qe),M("caret",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(at){return function(it,nt){var ct=nt?m[V]:m[W];return it.replace(ct,function(ft,Ue,ot,Z,X){var me;return M("tilde",it,ft,Ue,ot,Z,X),le(Ue)?me="":le(ot)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":le(Z)?me=">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":X?(M("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=">="+Ue+"."+ot+"."+Z+X+" <"+Ue+"."+(+ot+1)+".0"):me=">="+Ue+"."+ot+"."+Z+" <"+Ue+"."+(+ot+1)+".0",M("tilde return",me),me})}(at,tt)}).join(" ")}(Ve,Qe),M("tildes",Ve),Ve=function(xe,tt){return M("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(at){return function(it,nt){it=it.trim();var ct=nt?m[S]:m[g];return it.replace(ct,function(ft,Ue,ot,Z,X,me){M("xRange",it,ft,Ue,ot,Z,X,me);var qe=le(ot),Xe=qe||le(Z),Me=Xe||le(X);return Ue==="="&&Me&&(Ue=""),qe?ft=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&Me?(Xe&&(Z=0),Me&&(X=0),Ue===">"?(Ue=">=",Xe?(ot=+ot+1,Z=0,X=0):Me&&(Z=+Z+1,X=0)):Ue==="<="&&(Ue="<",Xe?ot=+ot+1:Z=+Z+1),ft=Ue+ot+"."+Z+"."+X):Xe?ft=">="+ot+".0.0 <"+(+ot+1)+".0.0":Me&&(ft=">="+ot+"."+Z+".0 <"+ot+"."+(+Z+1)+".0"),M("xRange return",ft),ft})}(at,tt)}).join(" ")}(Ve,Qe),M("xrange",Ve),Ve=function(xe,tt){return M("replaceStars",xe,tt),xe.trim().replace(m[$e],"")}(Ve,Qe),M("stars",Ve),Ve}(Fe,K)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Fe){return!!Fe.match(ee)})),se=se.map(function(Fe){return new ue(Fe,K)})},Ne.prototype.intersects=function(j,K){if(!(j instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return j.set.some(function(se){return se.every(function(Fe){return ee.intersects(Fe,K)})})})})},e.toComparators=function(j,K){return new Ne(j,K).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new Le(j,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],j))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(j,K,H){var ee=null,se=null;try{var Fe=new Ne(K,H)}catch{return null}return j.forEach(function(Ve){Fe.test(Ve)&&(ee&&se.compare(Ve)!==-1||(se=new Le(ee=Ve,H)))}),ee},e.minSatisfying=function(j,K,H){var ee=null,se=null;try{var Fe=new Ne(K,H)}catch{return null}return j.forEach(function(Ve){Fe.test(Ve)&&(ee&&se.compare(Ve)!==1||(se=new Le(ee=Ve,H)))}),ee},e.validRange=function(j,K){try{return new Ne(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,H){return U(j,K,"<",H)},e.gtr=function(j,K,H){return U(j,K,">",H)},e.outside=U,e.prerelease=function(j,K){var H=Se(j,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(j,K,H){return j=new Ne(j,H),K=new Ne(K,H),j.intersects(K)},e.coerce=function(j){if(j instanceof Le)return j;if(typeof j!="string")return null;var K=j.match(m[y]);return K==null?null:Se((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,O,M=ge.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(o){if(I===setTimeout)return setTimeout(o,0);if((I===N||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:N}catch{I=N}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var d,k=[],F=!1,E=-1;function u(){F&&d&&(F=!1,d.length?k=d.concat(k):E=-1,k.length&&b())}function b(){if(!F){var o=m(u);F=!0;for(var s=k.length;s;){for(d=k,k=[];++E<s;)d&&d[E].run();E=-1,s=k.length}d=null,F=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(o)}}function f(o,s){this.fun=o,this.array=s}function r(){}M.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];k.push(new f(o,s)),k.length!==1||F||m(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=r,M.addListener=r,M.once=r,M.off=r,M.removeListener=r,M.removeAllListeners=r,M.emit=r,M.prependListener=r,M.prependOnceListener=r,M.listeners=function(o){return[]},M.binding=function(o){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(o){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Ce[127],Pe([1,0,14,6]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=M,e.$ge=N,e.$he=A,e.$ie=m,e.$je=k,e.$ke=F,e.$le=E,e.$me=u,e.$ne=b,e.$oe=f,e.$pe=r,e.$qe=o,e.$re=s,e.$se=n,e.$te=i;function M(a){const h=a;return h?typeof h.read=="function":!1}function N(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function A(a){const h=a;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(a,h){return new d(a,h)}class d{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let p;switch(h){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const c=p.indexOf(t);c>=0&&p.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(a,h){const t=[];let p;for(;(p=a.read())!==null;)t.push(p);return h(t)}function F(a,h,t){const p=[];let c;for(;(c=a.read())!==null&&p.length<t;)p.push(c);return c===null&&p.length>0?h(p):{read:()=>{if(p.length>0)return p.shift();if(typeof c<"u"){const $=c;return c=void 0,$}return a.read()}}}function E(a,h){return new Promise((t,p)=>{const c=[];u(a,{onData:$=>{h&&c.push($)},onError:$=>{h?p($):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}function u(a,h,t){a.on("error",p=>{t?.isCancellationRequested||h.onError(p)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",p=>{t?.isCancellationRequested||h.onData(p)})}function b(a,h){return new Promise((t,p)=>{const c=new O.$Tc,$=[],w=D=>{if($.push(D),$.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:$,ended:!1})},v=D=>(c.dispose(),p(D)),l=()=>(c.dispose(),t({stream:a,buffer:$,ended:!0}));c.add((0,O.$Sc)(()=>a.removeListener("error",v))),a.on("error",v),c.add((0,O.$Sc)(()=>a.removeListener("end",l))),a.on("end",l),c.add((0,O.$Sc)(()=>a.removeListener("data",w))),a.on("data",w)})}function f(a,h){const t=m(h);return t.end(a),t}function r(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}function s(a,h,t){const p=m(t);return u(a,{onData:c=>p.write(h.data(c)),onError:c=>p.error(h.error?h.error(c):c),onEnd:()=>p.end()}),p}function n(a,h,t){let p=!1;return{read:()=>{const c=h.read();return p?c:(p=!0,c!==null?t([a,c]):a)}}}function i(a,h,t){let p=!1;const c=m(t);return u(h,{onData:$=>p?c.write($):(p=!0,c.write(t([a,$]))),onError:$=>c.error($),onEnd:()=>{p||(p=!0,c.write(a)),c.end()}}),c}}),define(Ce[22],Pe([1,0,40,127]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=k,e.$we=F,e.$xe=E,e.$ye=u,e.$ze=b,e.$Ae=f,e.$Be=r,e.$Ce=o,e.$De=s,e.$Ee=n,e.$Fe=i,e.$Ge=a,e.$He=h,e.$Ie=t,e.$Je=p,e.$Ke=c,e.$Le=$,e.$Me=w,e.$Ne=v,e.$Oe=g;const M=typeof Buffer<"u",N=new I.$V(()=>new Uint8Array(256));let A,m;class d{static alloc(y){return M?new d(Buffer.allocUnsafe(y)):new d(new Uint8Array(y))}static wrap(y){return M&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new d(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&M?new d(Buffer.from(y)):(A||(A=new TextEncoder),new d(A.encode(y)))}static fromByteArray(y){const P=d.alloc(y.length);for(let C=0,W=y.length;C<W;C++)P.buffer[C]=y[C];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let V=0,q=y.length;V<q;V++)P+=y[V].byteLength}const C=d.alloc(P);let W=0;for(let V=0,q=y.length;V<q;V++){const R=y[V];C.set(R,W),W+=R.byteLength}return C}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=d.alloc(this.byteLength);return y.set(this),y}toString(){return M?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,P){return new d(this.buffer.subarray(y,P))}set(y,P){if(y instanceof d)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,P){b(this.buffer,y,P)}readUInt32LE(y){return f(this.buffer,y)}writeUInt32LE(y,P){r(this.buffer,y,P)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,P){s(this.buffer,y,P)}indexOf(y,P=0){return k(this.buffer,y instanceof d?y.buffer:y,P)}}e.$ue=d;function k(S,y,P=0){const C=y.byteLength,W=S.byteLength;if(C===0)return 0;if(C===1)return S.indexOf(y[0]);if(C>W-P)return-1;const V=N.value;V.fill(y.length);for(let G=0;G<y.length;G++)V[y[G]]=y.length-G-1;let q=P+y.length-1,R=q,z=-1;for(;q<W;)if(S[q]===y[R]){if(R===0){z=q;break}q--,R--}else q+=Math.max(y.length-R,V[S[q]]),R=y.length-1;return z}function F(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0}function E(S,y,P){S[P+0]=y&255,y=y>>>8,S[P+1]=y&255}function u(S,y){return S[y]*2**24+S[y+1]*2**16+S[y+2]*2**8+S[y+3]}function b(S,y,P){S[P+3]=y,y=y>>>8,S[P+2]=y,y=y>>>8,S[P+1]=y,y=y>>>8,S[P]=y}function f(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0|S[y+2]<<16>>>0|S[y+3]<<24>>>0}function r(S,y,P){S[P+0]=y&255,y=y>>>8,S[P+1]=y&255,y=y>>>8,S[P+2]=y&255,y=y>>>8,S[P+3]=y&255}function o(S,y){return S[y]}function s(S,y,P){S[P]=y}function n(S){return O.$je(S,y=>d.concat(y))}function i(S){return O.$qe(S)}function a(S){return O.$le(S,y=>d.concat(y))}async function h(S){return S.ended?d.concat(S.buffer):d.concat([...S.buffer,await a(S.stream)])}function t(S){return O.$oe(S,y=>d.concat(y))}function p(S){return O.$re(S,{data:y=>typeof y=="string"?d.fromString(y):d.wrap(y)},y=>d.concat(y))}function c(S){return O.$ie(y=>d.concat(y),S)}function $(S,y){return O.$se(S,y,P=>d.concat(P))}function w(S,y){return O.$te(S,y,P=>d.concat(P))}function v(S){let y=0,P=0,C=0;const W=new Uint8Array(Math.floor(S.length/4*3)),V=R=>{switch(P){case 3:W[C++]=y|R,P=0;break;case 2:W[C++]=y|R>>>2,y=R<<6,P=3;break;case 1:W[C++]=y|R>>>4,y=R<<4,P=2;break;default:y=R<<2,P=1}};for(let R=0;R<S.length;R++){const z=S.charCodeAt(R);if(z>=65&&z<=90)V(z-65);else if(z>=97&&z<=122)V(z-97+26);else if(z>=48&&z<=57)V(z-48+52);else if(z===43||z===45)V(62);else if(z===47||z===95)V(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${S[R]}`)}}const q=C;for(;P>0;)V(0);return d.wrap(W).slice(0,q)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:S},y=!0,P=!1){const C=P?D:l;let W="";const V=S.byteLength%3;let q=0;for(;q<S.byteLength-V;q+=3){const R=S[q+0],z=S[q+1],G=S[q+2];W+=C[R>>>2],W+=C[(R<<4|z>>>4)&63],W+=C[(z<<2|G>>>6)&63],W+=C[G&63]}if(V===1){const R=S[q+0];W+=C[R>>>2],W+=C[R<<4&63],y&&(W+="==")}else if(V===2){const R=S[q+0],z=S[q+1];W+=C[R>>>2],W+=C[(R<<4|z>>>4)&63],W+=C[z<<2&63],y&&(W+="=")}return W}}),define(Ce[128],Pe([1,0,28,124,15]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=N,e.$lk=m,e.$mk=d,e.$nk=E,e.$ok=v,e.$pk=l,e.$qk=C,e.$rk=W,e.$sk=V,e.$tk=q,e.$uk=x,e.$wk=pe,e.$xk=Y,e.$yk=ue;function N(...le){return function(Ie,Re){for(let je=0,U=le.length;je<U;je++){const j=le[je](Ie,Re);if(j)return j}return null}}e.$jk=A.bind(void 0,!1),e.$kk=A.bind(void 0,!0);function A(le,Ie,Re){if(!Re||Re.length<Ie.length)return null;let je;return le?je=M.$mf(Re,Ie):je=Re.indexOf(Ie)===0,je?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function m(le,Ie){const Re=Ie.toLowerCase().indexOf(le.toLowerCase());return Re===-1?null:[{start:Re,end:Re+le.length}]}function d(le,Ie){return k(le.toLowerCase(),Ie.toLowerCase(),0,0)}function k(le,Ie,Re,je){if(Re===le.length)return[];if(je===Ie.length)return null;if(le[Re]===Ie[je]){let U=null;return(U=k(le,Ie,Re+1,je+1))?a({start:je,end:je+1},U):null}return k(le,Ie,Re,je+1)}function F(le){return 97<=le&&le<=122}function E(le){return 65<=le&&le<=90}function u(le){return 48<=le&&le<=57}function b(le){return le===32||le===9||le===10||le===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>f.add(le.charCodeAt(0)));function r(le){return b(le)||f.has(le)}function o(le,Ie){return le===Ie||r(le)&&r(Ie)}const s=new Map;function n(le){if(s.has(le))return s.get(le);let Ie;const Re=(0,O.$hk)(le);return Re&&(Ie=Re),s.set(le,Ie),Ie}function i(le){return F(le)||E(le)||u(le)}function a(le,Ie){return Ie.length===0?Ie=[le]:le.end===Ie[0].start?Ie[0].start=le.start:Ie.unshift(le),Ie}function h(le,Ie){for(let Re=Ie;Re<le.length;Re++){const je=le.charCodeAt(Re);if(E(je)||u(je)||Re>0&&!i(le.charCodeAt(Re-1)))return Re}return le.length}function t(le,Ie,Re,je){if(Re===le.length)return[];if(je===Ie.length)return null;if(le[Re]!==Ie[je].toLowerCase())return null;{let U=null,j=je+1;for(U=t(le,Ie,Re+1,je+1);!U&&(j=h(Ie,j))<Ie.length;)U=t(le,Ie,Re+1,j),j++;return U===null?null:a({start:je,end:je+1},U)}}function p(le){let Ie=0,Re=0,je=0,U=0,j=0;for(let Fe=0;Fe<le.length;Fe++)j=le.charCodeAt(Fe),E(j)&&Ie++,F(j)&&Re++,i(j)&&je++,u(j)&&U++;const K=Ie/le.length,H=Re/le.length,ee=je/le.length,se=U/le.length;return{upperPercent:K,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function c(le){const{upperPercent:Ie,lowerPercent:Re}=le;return Re===0&&Ie>.6}function $(le){const{upperPercent:Ie,lowerPercent:Re,alphaPercent:je,numericPercent:U}=le;return Re>.2&&Ie<.8&&je>.6&&U<.2}function w(le){let Ie=0,Re=0,je=0,U=0;for(let j=0;j<le.length;j++)je=le.charCodeAt(j),E(je)&&Ie++,F(je)&&Re++,b(je)&&U++;return(Ie===0||Re===0)&&U===0?le.length<=30:Ie<=5}function v(le,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!w(le))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Re=p(Ie);if(!$(Re)){if(!c(Re))return null;Ie=Ie.toLowerCase()}let je=null,U=0;for(le=le.toLowerCase();U<Ie.length&&(je=t(le,Ie,0,U))===null;)U=h(Ie,U+1);return je}function l(le,Ie,Re=!1){if(!Ie||Ie.length===0)return null;let je=null,U=0;for(le=le.toLowerCase(),Ie=Ie.toLowerCase();U<Ie.length&&(je=D(le,Ie,0,U,Re),je===null);)U=g(Ie,U+1);return je}function D(le,Ie,Re,je,U){let j=0;if(Re===le.length)return[];if(je===Ie.length)return null;if(!o(le.charCodeAt(Re),Ie.charCodeAt(je))){const ee=n(le.charCodeAt(Re));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!o(ee[se],Ie.charCodeAt(je+se)))return null;j+=ee.length-1}let K=null,H=je+j+1;if(K=D(le,Ie,Re+1,H,U),!U)for(;!K&&(H=g(Ie,H))<Ie.length;)K=D(le,Ie,Re+1,H,U),H++;if(!K)return null;if(le.charCodeAt(Re)!==Ie.charCodeAt(je)){const ee=n(le.charCodeAt(Re));if(!ee)return K;for(let se=0;se<ee.length;se++)if(ee[se]!==Ie.charCodeAt(je+se))return K}return a({start:je,end:je+j+1},K)}function g(le,Ie){for(let Re=Ie;Re<le.length;Re++)if(r(le.charCodeAt(Re))||Re>0&&r(le.charCodeAt(Re-1)))return Re;return le.length}const S=N(e.$kk,v,m),y=N(e.$kk,v,d),P=new I.$Ec(1e4);function C(le,Ie,Re=!1){if(typeof le!="string"||typeof Ie!="string")return null;let je=P.get(le);je||(je=new RegExp(M.$7e(le),"i"),P.set(le,je));const U=je.exec(Ie);return U?[{start:U.index,end:U.index+U[0].length}]:Re?y(le,Ie):S(le,Ie)}function W(le,Ie){const Re=pe(le,le.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?q(Re):null}function V(le,Ie,Re,je,U,j){const K=Math.min(13,le.length);for(;Re<K;Re++){const H=pe(le,Ie,Re,je,U,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,j]}function q(le){if(typeof le>"u")return[];const Ie=[],Re=le[1];for(let je=le.length-1;je>1;je--){const U=le[je]+Re,j=Ie[Ie.length-1];j&&j.end===U?j.end=U+1:Ie.push({start:U,end:U+1})}return Ie}const R=128;function z(){const le=[],Ie=[];for(let Re=0;Re<=R;Re++)Ie[Re]=0;for(let Re=0;Re<=R;Re++)le.push(Ie.slice(0));return le}function G(le){const Ie=[];for(let Re=0;Re<=le;Re++)Ie[Re]=0;return Ie}const ie=G(2*R),fe=G(2*R),De=z(),we=z(),oe=z(),$e=!1;function ne(le,Ie,Re,je,U){function j(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let K=` |   |${je.split("").map(H=>j(H,3)).join("|")}
`;for(let H=0;H<=Re;H++)H===0?K+=" |":K+=`${Ie[H-1]}|`,K+=le[H].slice(0,U+1).map(ee=>j(ee.toString(),3)).join("|")+`
`;return K}function Se(le,Ie,Re,je){le=le.substr(Ie),Re=Re.substr(je),console.log(ne(we,le,le.length,Re,Re.length)),console.log(ne(oe,le,le.length,Re,Re.length)),console.log(ne(De,le,le.length,Re,Re.length))}function Le(le,Ie){if(Ie<0||Ie>=le.length)return!1;const Re=le.codePointAt(Ie);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Ef(Re)}}function re(le,Ie){if(Ie<0||Ie>=le.length)return!1;switch(le.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function L(le,Ie,Re){return Ie[le]!==Re[le]}function x(le,Ie,Re,je,U,j,K=!1){for(;Ie<Re&&U<j;)le[Ie]===je[U]&&(K&&(ie[Ie]=U),Ie+=1),U+=1;return Ie===Re}var ve;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Oe;(function(le){le.Default=[-100,0];function Ie(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}le.isDefault=Ie})(Oe||(e.FuzzyScore=Oe={}));class ye{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Re){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Re}}e.$vk=ye;function pe(le,Ie,Re,je,U,j,K=ye.default){const H=le.length>R?R:le.length,ee=je.length>R?R:je.length;if(Re>=H||j>=ee||H-Re>ee-j||!x(Ie,Re,H,U,j,ee,!0))return;de(H,ee,Re,j,Ie,U);let se=1,Fe=1,Ve=Re,Qe=j;const xe=[!1];for(se=1,Ve=Re;Ve<H;se++,Ve++){const ct=ie[Ve],ft=fe[Ve],Ue=Ve+1<H?fe[Ve+1]:ee;for(Fe=ct-j+1,Qe=ct;Qe<Ue;Fe++,Qe++){let ot=Number.MIN_SAFE_INTEGER,Z=!1;Qe<=ft&&(ot=J(le,Ie,Ve,Re,je,U,Qe,ee,j,De[se-1][Fe-1]===0,xe));let X=0;ot!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=ot+we[se-1][Fe-1]);const me=Qe>ct,qe=me?we[se][Fe-1]+(De[se][Fe-1]>0?-5:0):0,Xe=Qe>ct+1&&De[se][Fe-1]>0,Me=Xe?we[se][Fe-2]+(De[se][Fe-2]>0?-5:0):0;if(Xe&&(!me||Me>=qe)&&(!Z||Me>=X))we[se][Fe]=Me,oe[se][Fe]=3,De[se][Fe]=0;else if(me&&(!Z||qe>=X))we[se][Fe]=qe,oe[se][Fe]=2,De[se][Fe]=0;else if(Z)we[se][Fe]=X,oe[se][Fe]=1,De[se][Fe]=De[se-1][Fe-1]+1;else throw new Error("not possible")}}if($e&&Se(le,Re,je,j),!xe[0]&&!K.firstMatchCanBeWeak)return;se--,Fe--;const tt=[we[se][Fe],j];let at=0,it=0;for(;se>=1;){let ct=Fe;do{const ft=oe[se][ct];if(ft===3)ct=ct-2;else if(ft===2)ct=ct-1;else break}while(ct>=1);at>1&&Ie[Re+se-1]===U[j+Fe-1]&&!L(ct+j-1,je,U)&&at+1>De[se][ct]&&(ct=Fe),ct===Fe?at++:at=1,it||(it=ct),se--,Fe=ct-1,tt.push(Fe)}ee===H&&K.boostFullMatch&&(tt[0]+=2);const nt=it-H;return tt[0]-=nt,tt}function de(le,Ie,Re,je,U,j){let K=le-1,H=Ie-1;for(;K>=Re&&H>=je;)U[K]===j[H]&&(fe[K]=H,K--),H--}function J(le,Ie,Re,je,U,j,K,H,ee,se,Fe){if(Ie[Re]!==j[K])return Number.MIN_SAFE_INTEGER;let Ve=1,Qe=!1;return K===Re-je?Ve=le[Re]===U[K]?7:5:L(K,U,j)&&(K===0||!L(K-1,U,j))?(Ve=le[Re]===U[K]?7:5,Qe=!0):Le(j,K)&&(K===0||!Le(j,K-1))?Ve=5:(Le(j,K-1)||re(j,K-1))&&(Ve=5,Qe=!0),Ve>1&&Re===je&&(Fe[0]=!0),Qe||(Qe=L(K,U,j)||Le(j,K-1)||re(j,K-1)),Re===je?K>ee&&(Ve-=Qe?3:5):se?Ve+=Qe?2:0:Ve+=Qe?0:1,K+1===H&&(Ve-=Qe?3:5),Ve}function Y(le,Ie,Re,je,U,j,K){return he(le,Ie,Re,je,U,j,!0,K)}function ue(le,Ie,Re,je,U,j,K){return he(le,Ie,Re,je,U,j,!1,K)}function he(le,Ie,Re,je,U,j,K,H){let ee=pe(le,Ie,Re,je,U,j,H);if(ee&&!K)return ee;if(le.length>=3){const se=Math.min(7,le.length-1);for(let Fe=Re+1;Fe<se;Fe++){const Ve=Ne(le,Fe);if(Ve){const Qe=pe(Ve,Ve.toLowerCase(),Re,je,U,j,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Ne(le,Ie){if(Ie+1>=le.length)return;const Re=le[Ie],je=le[Ie+1];if(Re!==je)return le.slice(0,Ie)+je+Re+le.slice(Ie+2)}}),define(Ce[32],Pe([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(O||(O={})),function(M){const N="error",A="warning",m="warn",d="info",k="ignore";function F(u){return u?I.$lf(N,u)?M.Error:I.$lf(A,u)||I.$lf(m,u)?M.Warning:I.$lf(d,u)?M.Info:M.Ignore:M.Ignore}M.fromValue=F;function E(u){switch(u){case M.Error:return N;case M.Warning:return A;case M.Info:return d;default:return k}}M.toString=E}(O||(O={})),e.default=O}),define(Ce[129],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Ce[51],Pe([1,0,18,15]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class M{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),r=this.b.charCodeAt(this.c);return f-r}value(){return this.b[this.c]}}e.$ki=M;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,O.$ff)(b,this.b,0,b.length,this.c,this.d):(0,O.$hf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=N;class A{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const r=this.b.charCodeAt(f);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,O.$ff)(b,this.b,0,b.length,this.d,this.e):(0,O.$hf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=A;var m;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(m||(m={}));class d{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,O.$gf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,O.$gf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,O.$ef)(b,this.c.query);if(this.d[this.e]===5)return(0,O.$ef)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=d;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var F;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(F||(F={}));class E{static forUris(b=()=>!1,f=()=>!1){return new E(new d(b,f))}static forPaths(b=!1){return new E(new A(void 0,!b))}static forStrings(){return new E(new M)}static forConfigKeys(){return new E(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const r=f.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o,b)}else{const r=b.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(b,f){const r=this.b.reset(b);let o;this.c||(this.c=new k,this.c.segment=r.value());const s=[];for(o=this.c;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new k,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new k,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new k,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=f,o.key=b;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=s[i][0],p=s[i+1][0];if(t===1&&p===1)s[i][1]=a.rotateLeft();else if(t===-1&&p===-1)s[i][1]=a.rotateRight();else if(t===1&&p===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&p===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let r=this.c;for(;r;){const o=f.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(f.hasNext())f.next(),r=r.mid;else break}return r}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const r=this.b.reset(b),o=[];let s=this.c;for(;s;){const n=r.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(f?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:i,value:a,segment:h}=n;this.e(n.key,!1),s.key=i,s.value=a,s.segment=h}}else{const n=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const i=o[n][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[n][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[n][1]=i.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let r=this.c,o;for(;r;){const s=f.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(f.hasNext())f.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(b){return this.g(b,!1)}g(b,f){const r=this.b.reset(b);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):f?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,r]of this)b(r,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){b&&(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const r=f.balanceFactor();return r<-1||r>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.$oi=E}),define(Ce[41],Pe([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=M;var O;(function(A){function m(d){return d&&typeof d=="object"&&typeof d.id=="string"}A.isThemeColor=m})(O||(e.ThemeColor=O={}));function M(A){return{id:A}}var N;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function d(n){const i=m.exec(n.id);if(!i)return d(I.$Hj.error);const[,a,h]=i,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=d;function k(n){return d(n).join(" ")}A.asClassName=k;function F(n){return"."+d(n).join(".")}A.asCSSSelector=F;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}A.isThemeIcon=E;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(n){const i=u.exec(n);if(!i)return;const[,a]=i;return{id:a}}A.fromString=b;function f(n){return{id:n}}A.fromId=f;function r(n,i){let a=n.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}A.modify=r;function o(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}A.getModifier=o;function s(n,i){return n.id===i.id&&n.color?.id===i.color?.id}A.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Ce[130],Pe([1,0,128,15,41]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=d,e.$Ak=F,e.$Bk=u,e.$Ck=b,e.$Dk=r,e.$Ek=o;const N="$(",A=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function d(s){return s.replace(m,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${A.source}`,"g");function F(s){return s.replace(k,n=>`\\${n}`)}const E=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(s){return s.indexOf(N)===-1?s:s.replace(E,(n,i,a,h)=>a?n:i||h||"")}function b(s){return s?s.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){f.lastIndex=0;let n="";const i=[];let a=0;for(;;){const h=f.lastIndex,t=f.exec(s),p=s.substring(h,t?.index);if(p.length>0){n+=p;for(let c=0;c<p.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:n,iconOffsets:i}}function o(s,n,i=!1){const{text:a,iconOffsets:h}=n;if(!h||h.length===0)return(0,I.$qk)(s,a,i);const t=(0,O.$5e)(a," "),p=a.length-t.length,c=(0,I.$qk)(s,t,i);if(c)for(const $ of c){const w=h[$.start+p]+p;$.start+=w,$.end+=w}return c}}),define(Ce[34],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=O;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(M){return I.test(M)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(m){for(let d=0;d<m.length;d++)m[d]=Math.floor(Math.random()*256);return m};const N=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){M(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let d=0,k="";return k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k}}()}),define(Ce[131],Pe([1,0,18,39,34]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.$Jt=void 0,e.$Ht=N,e.$It=A,e.$Kt=k;function N(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function A(E,u,b){const f={id:(0,M.$Eg)(),name:E,uri:u,data:b};return{asString:async()=>"",asFile:()=>f,value:void 0}}class m{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return O.Iterable.some(this,([f,r])=>r.asFile())&&b.push("files"),F(d(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const f=this.a.get(u);f?f.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const f of b)yield[u,f]}b(u){return d(u)}}e.$Jt=m;function d(E){return E.toLowerCase()}function k(E,u){return F(d(E),u.map(d))}function F(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const b=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[f,r,o]=b;return o==="*"?u.some(s=>s.startsWith(r+"/")):!1}e.$Lt=Object.freeze({create:E=>(0,I.$Mb)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Lt.split(E).filter(u=>!u.startsWith("#"))})}),define(Ce[132],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ot=O;var I;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function O(M){let N=0,A=0,m=0,d=0;for(let k=0,F=M.length;k<F;k++){const E=M.charCodeAt(k);E===13?(N===0&&(A=k),N++,k+1<F&&M.charCodeAt(k+1)===10?(d|=2,k++):d|=3,m=k+1):E===10&&(d|=1,N===0&&(A=k),N++,m=k+1)}return N===0&&(A=M.length),[N,A,M.length-m,d]}}),define(Ce[133],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ms={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[134],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.$bu=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let d=0,k=m.notIn.length;d<k;d++)switch(m.notIn[d]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,d){if(m.getTokenCount()===0)return!0;const k=m.findTokenIndexAtOffset(d-2),F=m.getStandardTokenType(k);return this.isOK(F)}g(m,d){for(let k=m;k<=d;k++){const F=String.fromCharCode(k);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$bu=O;class M{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const d of m)N(this.autoClosingPairsOpenByStart,d.open.charAt(0),d),N(this.autoClosingPairsOpenByEnd,d.open.charAt(d.open.length-1),d),N(this.autoClosingPairsCloseByStart,d.close.charAt(0),d),N(this.autoClosingPairsCloseByEnd,d.close.charAt(d.close.length-1),d),d.close.length===1&&d.open.length===1&&N(this.autoClosingPairsCloseSingleChar,d.close,d)}}e.$cu=M;function N(A,m,d){A.has(m)?A.get(m).push(d):A.set(m,[d])}}),define(Ce[135],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.NodeColor=e.$eC=void 0,e.$gC=M,e.$hC=N,e.$iC=k,e.$jC=F,e.$kC=E,e.$lC=u,e.$mC=b,e.$nC=f;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$fC)return M(this.right);let o=this;for(;o.parent!==e.$fC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$fC?e.$fC:o.parent}prev(){if(this.left!==e.$fC)return N(this.left);let o=this;for(;o.parent!==e.$fC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$fC?e.$fC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$eC=I;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$fC=new I(null,0),e.$fC.parent=e.$fC,e.$fC.left=e.$fC,e.$fC.right=e.$fC,e.$fC.color=0;function M(r){for(;r.left!==e.$fC;)r=r.left;return r}function N(r){for(;r.right!==e.$fC;)r=r.right;return r}function A(r){return r===e.$fC?0:r.size_left+r.piece.length+A(r.right)}function m(r){return r===e.$fC?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function d(){e.$fC.parent=e.$fC}function k(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$fC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$fC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function F(r,o){const s=o.left;o.left=s.right,s.right!==e.$fC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$fC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function E(r,o){let s,n;if(o.left===e.$fC?(n=o,s=n.right):o.right===e.$fC?(n=o,s=n.left):(n=M(o.right),s=n.right),n===r.root){r.root=s,s.color=0,o.detach(),d(),r.root.parent=e.$fC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===o?(s.parent=n.parent,f(r,s)):(n.parent===o?s.parent=n:s.parent=n.parent,f(r,s),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$fC&&(n.left.parent=n),n.right!==e.$fC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,f(r,n)),o.detach(),s.parent.left===s){const h=A(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const p=h-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,b(r,s.parent,p,c)}}if(f(r,s.parent),i){d();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,k(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,F(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,k(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,F(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,k(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,F(r,s.parent),s=r.root));s.color=0,d()}function u(r,o){for(f(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(r,o)),o.parent.color=0,o.parent.parent.color=1,F(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,F(r,o)),o.parent.color=0,o.parent.parent.color=1,k(r,o.parent.parent))}r.root.color=0}function b(r,o,s,n){for(;o!==r.root&&o!==e.$fC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}function f(r,o){let s=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=A(o.left)-o.size_left,n=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=n;o!==r.root&&(s!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}}}),define(Ce[92],Pe([1,0,93,29,94,135,95]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=void 0,e.$uC=F,e.$vC=E;const m=65535;function d(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class k{constructor(n,i,a,h,t){this.lineStarts=n,this.cr=i,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function F(s,n=!0){const i=[0];let a=1;for(let h=0,t=s.length;h<t;h++){const p=s.charCodeAt(h);p===13?h+1<t&&s.charCodeAt(h+1)===10?(i[a++]=h+2,h++):i[a++]=h+1:p===10&&(i[a++]=h+1)}return n?d(i):i}function E(s,n){s.length=0,s[0]=0;let i=1,a=0,h=0,t=0,p=!0;for(let $=0,w=n.length;$<w;$++){const v=n.charCodeAt($);v===13?$+1<w&&n.charCodeAt($+1)===10?(t++,s[i++]=$+2,$++):(a++,s[i++]=$+1):v===10?(h++,s[i++]=$+1):p&&v!==9&&(v<32||v>126)&&(p=!1)}const c=new k(d(s),a,h,t,p);return s.length=0,c}class u{constructor(n,i,a,h,t){this.bufferIndex=n,this.start=i,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$wC=u;class b{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$xC=b;class f{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==N.$fC&&n.iterate(n.root,a=>(a!==N.$fC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=n){a[h]=null,i=!0;continue}}if(i){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class o{constructor(n,i,a){this.create(n,i,a)}create(n,i,a){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$fC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let h=null;for(let t=0,p=n.length;t<p;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=F(n[t].buffer));const c=new u(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,c)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=m,a=i-Math.floor(i/3),h=a*2;let t="",p=0;const c=[];if(this.iterate(this.root,$=>{const w=this.R($),v=w.length;if(p<=a||p+v<h)return t+=w,p+=v,!0;const l=t.replace(/\r\n|\r|\n/g,n);return c.push(new b(l,F(l))),t=w,p=v,!0}),p>0){const $=t.replace(/\r\n|\r|\n/g,n);c.push(new b($,F($)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new f(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===N.$fC)return!0;const t=this.R(h),p=t.length,c=n.G(i),$=n.G(i+p),w=n.getValueInRange2(c,$);return i+=p,t===w})}getOffsetAt(n,i){let a=0,h=this.root;for(;h!==N.$fC;)if(h.left!==N.$fC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){a+=h.size_left;const t=this.B(h,n-h.lf_left-2);return a+=t+i-1}else n-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,a=0;const h=n;for(;i!==N.$fC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const p=this.getOffsetAt(a+1,1),c=h-p;return new I.$bt(a+1,c+1)}return new I.$bt(a+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$fC){const t=this.getOffsetAt(a+1,1),p=h-n-t;return new I.$bt(a+1,p+1)}else i=i.right;return new I.$bt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(a,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const c=n.node,$=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return $.substring(w+n.remainder,w+i.remainder)}let a=n.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let p=h.substring(t+n.remainder,t+a.piece.length);for(a=a.next();a!==N.$fC;){const c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){p+=c.substring($,$+i.remainder);break}else p+=c.substr($,a.piece.length);a=a.next()}return p}getLinesContent(){const n=[];let i=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===N.$fC)return!0;const p=t.piece;let c=p.length;if(c===0)return!0;const $=this.a[p.bufferIndex].buffer,w=this.a[p.bufferIndex].lineStarts,v=p.start.line,l=p.end.line;let D=w[v]+p.start.column;if(h&&($.charCodeAt(D)===10&&(D++,c--),n[i++]=a,a="",h=!1,c===0))return!0;if(v===l)return!this.f&&$.charCodeAt(D+c-1)===13?(h=!0,a+=$.substr(D,c-1)):a+=$.substr(D,c),!0;a+=this.f?$.substring(D,Math.max(D,w[v+1]-this.e)):$.substring(D,w[v+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;for(let g=v+1;g<l;g++)a=this.f?$.substring(w[g],w[g+1]-this.e):$.substring(w[g],w[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;return!this.f&&$.charCodeAt(w[l]+p.end.column-1)===13?(h=!0,p.end.column===0?i--:a=$.substr(w[l],p.end.column-1)):a=$.substr(w[l],p.end.column),!0}),h&&(n[i++]=a,a=""),n[i++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(h)}else{const i=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(n,i){const a=this.H(n,i+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,a,h,t,p,c,$,w,v,l){const D=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start),S=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,p);let P;const C={line:0,column:0};let W,V;i._wordSeparators?(W=D.buffer.substring(S,y),V=q=>q+S,i.reset(0)):(W=D.buffer,V=q=>q,i.reset(S));do if(P=i.next(W),P){if(V(P.index)>=y)return v;this.s(n,V(P.index)-g,C);const q=this.t(n.piece.bufferIndex,t,C),R=C.line===t.line?C.column-t.column+h:C.column+1,z=R+P[0].length;if(l[v++]=(0,A.$qC)(new O.$ct(a+q,R,a+q,z),P,$),V(P.index)+P[0].length>=y||v>=w)return v}while(P);return v}findMatchesLineByLine(n,i,a,h){const t=[];let p=0;const c=new A.$tC(i.wordSeparators,i.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const w=this.H(n.endLineNumber,n.endColumn);if(w===null)return[];let v=this.s($.node,$.remainder);const l=this.s(w.node,w.remainder);if($.node===w.node)return this.findMatchesInNode($.node,c,n.startLineNumber,n.startColumn,v,l,i,a,h,p,t),t;let D=n.startLineNumber,g=$.node;for(;g!==w.node;){const y=this.t(g.piece.bufferIndex,v,g.piece.end);if(y>=1){const C=this.a[g.piece.bufferIndex].lineStarts,W=this.u(g.piece.bufferIndex,g.piece.start),V=C[v.line+y],q=D===n.startLineNumber?n.startColumn:1;if(p=this.findMatchesInNode(g,c,D,q,v,this.s(g,V-W),i,a,h,p,t),p>=h)return t;D+=y}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const C=this.getLineContent(D).substring(P,n.endColumn-1);return p=this.n(i,c,C,n.endLineNumber,P,p,t,a,h),t}if(p=this.n(i,c,this.getLineContent(D).substr(P),D,P,p,t,a,h),p>=h)return t;D++,$=this.H(D,1),g=$.node,v=this.s($.node,$.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(y,n.endColumn-1);return p=this.n(i,c,P,n.endLineNumber,y,p,t,a,h),t}const S=D===n.startLineNumber?n.startColumn:1;return p=this.findMatchesInNode(w.node,c,D,S,v,l,i,a,h,p,t),t}n(n,i,a,h,t,p,c,$,w){const v=n.wordSeparators;if(!$&&n.simpleSearch){const D=n.simpleSearch,g=D.length,S=a.length;let y=-g;for(;(y=a.indexOf(D,y+g))!==-1;)if((!v||(0,A.$sC)(v,a,S,y,g))&&(c[p++]=new M.$wv(new O.$ct(h,y+1+t,h,y+1+g+t),null),p>=w))return p;return p}let l;i.reset(0);do if(l=i.next(a),l&&(c[p++]=(0,A.$qC)(new O.$ct(h,l.index+1+t,h,l.index+1+l[0].length+t),l,$),p>=w))return p;while(l);return p}insert(n,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==N.$fC){const{node:h,remainder:t,nodeStartOffset:p}=this.G(n),c=h.piece,$=c.bufferIndex,w=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&p+c.length===n&&i.length<m){this.F(h,i),this.y();return}if(p===n)this.o(i,h),this.h.validate(n);else if(p+h.piece.length>n){const v=[];let l=new u(c.bufferIndex,w,c.end,this.t(c.bufferIndex,w,c.end),this.u($,c.end)-this.u($,w));if(this.K()&&this.M(i)&&this.I(h,t)===10){const y={line:l.start.line+1,column:0};l=new u(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),i="\r"+i,h.piece.length===0&&v.push(h)}else this.C(h,w);else this.C(h,w);const D=this.w(i);l.length>0&&this.S(h,l);let g=h;for(let S=0;S<D.length;S++)g=this.S(g,D[S]);this.v(v)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let p=1;p<h.length;p++)t=this.S(t,h[p])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$fC)return;const a=this.G(n),h=this.G(n+i),t=a.node,p=h.node;if(t===p){const D=this.s(t,a.remainder),g=this.s(t,h.remainder);if(a.nodeStartOffset===n){if(i===t.piece.length){const S=t.next();(0,N.$kC)(this,t),this.N(S),this.y();return}this.D(t,g),this.h.validate(n),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,g),this.y();return}const c=[],$=this.s(t,a.remainder);this.C(t,$),this.h.validate(n),t.piece.length===0&&c.push(t);const w=this.s(p,h.remainder);this.D(p,w),p.piece.length===0&&c.push(p);const v=t.next();for(let D=v;D!==N.$fC&&D!==p;D=D.next())c.push(D);const l=t.piece.length===0?t.prev():t;this.v(c),this.O(l),this.y()}o(n,i){const a=[];if(this.K()&&this.M(n)&&this.L(i)){const p=i.piece,c={line:p.start.line+1,column:0},$=new u(p.bufferIndex,c,p.end,this.t(p.bufferIndex,c,p.end),p.length-1);i.piece=$,n+=`
`,(0,N.$mC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const h=this.w(n);let t=this.T(i,h[h.length-1]);for(let p=h.length-2;p>=0;p--)t=this.T(t,h[p]);this.N(t),this.v(a)}q(n,i){this.Q(n,i)&&(n+=`
`);const a=this.w(n),h=this.S(i,a[0]);let t=h;for(let p=1;p<a.length;p++)t=this.S(t,a[p]);this.N(h)}s(n,i,a){const h=n.piece,t=n.piece.bufferIndex,p=this.a[t].lineStarts,$=p[h.start.line]+h.start.column+i;let w=h.start.line,v=h.end.line,l=0,D=0,g=0;for(;w<=v&&(l=w+(v-w)/2|0,g=p[l],l!==v);)if(D=p[l+1],$<g)v=l-1;else if($>=D)w=l+1;else break;return a?(a.line=l,a.column=$-g,null):{line:l,column:$-g}}t(n,i,a){if(a.column===0)return a.line-i.line;const h=this.a[n].lineStarts;if(a.line===h.length-1)return a.line-i.line;const t=h[a.line+1],p=h[a.line]+a.column;if(t>p+1)return a.line-i.line;const c=p-1;return this.a[n].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,N.$kC)(this,n[i])}w(n){if(n.length>m){const v=[];for(;n.length>m;){const D=n.charCodeAt(m-1);let g;D===13||D>=55296&&D<=56319?(g=n.substring(0,m-1),n=n.substring(m-1)):(g=n.substring(0,m),n=n.substring(m));const S=F(g);v.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:g.length-S[S.length-1]},S.length-1,g.length)),this.a.push(new b(g,S))}const l=F(n);return v.push(new u(this.a.length,{line:0,column:0},{line:l.length-1,column:n.length-l[l.length-1]},l.length-1,n.length)),this.a.push(new b(n,l)),v}let i=this.a[0].buffer.length;const a=F(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let v=0;v<a.length;v++)a[v]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let v=0;v<a.length;v++)a[v]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[p],$={line:p,column:c},w=new u(0,h,$,this.t(0,h,$),t-i);return this.g=$,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let a=this.root,h="";const t=this.h.get2(n);if(t){a=t.node;const p=this.B(a,n-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===n)h=c.substring($+p,$+a.piece.length);else{const w=this.B(a,n-t.nodeStartLineNumber);return c.substring($+p,$+w-i)}}else{let p=0;const c=n;for(;a!==N.$fC;)if(a.left!==N.$fC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const $=this.B(a,n-a.lf_left-2),w=this.B(a,n-a.lf_left-1),v=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return p+=a.size_left,this.h.set({node:a,nodeStartOffset:p,nodeStartLineNumber:c-(n-1-a.lf_left)}),v.substring(l+$,l+w-i)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const $=this.B(a,n-a.lf_left-2),w=this.a[a.piece.bufferIndex].buffer,v=this.u(a.piece.bufferIndex,a.piece.start);h=w.substring(v+$,v+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,p+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==N.$fC;){const p=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),$=this.u(a.piece.bufferIndex,a.piece.start);return h+=p.substring($,$+c-i),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=p.substr(c,a.piece.length)}a=a.next()}return h}y(){let n=this.root,i=1,a=0;for(;n!==N.$fC;)i+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=a,this.h.validate(this.c)}A(n,i){const a=n.piece,h=this.s(n,i),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const p=this.t(n.piece.bufferIndex,a.start,h);if(p!==t)return{index:p,remainder:0}}return{index:t,remainder:h.column}}B(n,i){if(i<0)return 0;const a=n.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),p=i,c=this.u(a.bufferIndex,p),$=this.t(a.bufferIndex,a.start,p),w=$-h,v=c-t,l=a.length+v;n.piece=new u(a.bufferIndex,a.start,p,$,l),(0,N.$mC)(this,n,v,w)}D(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),p=i,c=this.t(a.bufferIndex,p,a.end),$=this.u(a.bufferIndex,p),w=c-h,v=t-$,l=a.length+v;n.piece=new u(a.bufferIndex,p,a.end,c,l),(0,N.$mC)(this,n,v,w)}E(n,i,a){const h=n.piece,t=h.start,p=h.end,c=h.length,$=h.lineFeedCnt,w=i,v=this.t(h.bufferIndex,h.start,w),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);n.piece=new u(h.bufferIndex,h.start,w,v,l),(0,N.$mC)(this,n,l-c,v-$);const D=new u(h.bufferIndex,a,p,this.t(h.bufferIndex,a,p),this.u(h.bufferIndex,p)-this.u(h.bufferIndex,a)),g=this.S(n,D);this.N(g)}F(n,i){this.Q(i,n)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=F(i,!1);for(let g=0;g<t.length;g++)t[g]+=h;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const p=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[p],$={line:p,column:c},w=n.piece.length+i.length,v=n.piece.lineFeedCnt,l=this.t(0,n.piece.start,$),D=l-v;n.piece=new u(n.piece.bufferIndex,n.piece.start,$,l,w),this.g=$,(0,N.$mC)(this,n,i.length,D)}G(n){let i=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let h=0;for(;i!==N.$fC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){h+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let a=this.root,h=0;for(;a!==N.$fC;)if(a.left!==N.$fC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const t=this.B(a,n-a.lf_left-2),p=this.B(a,n-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+i-1,p),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const t=this.B(a,n-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:h};i-=a.piece.length-t;break}else n-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==N.$fC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),p=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:p}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+i;return a.buffer.charCodeAt(h)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$fC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,a=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=a[h]+i.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$fC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const a=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const p=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,t,c,p),(0,N.$mC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const $={line:i.piece.start.line+1,column:0},w=i.piece.length-1,v=this.t(i.piece.bufferIndex,$,i.piece.end);i.piece=new u(i.piece.bufferIndex,$,i.piece.end,v,w),(0,N.$mC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const l=this.w(`\r
`);this.S(n,l[0]);for(let D=0;D<a.length;D++)(0,N.$kC)(this,a[D])}Q(n,i){if(this.K()&&this.M(n)){const a=i.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,N.$kC)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},p=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new u(h.bufferIndex,t,h.end,c,p),(0,N.$mC)(this,a,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.$fC)return i(N.$fC);const a=this.iterate(n.left,i);return a&&i(n)&&this.iterate(n.right,i)}R(n){if(n===N.$fC)return"";const i=this.a[n.piece.bufferIndex],a=n.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(h,t)}getPieceContent(n){const i=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return i.buffer.substring(a,h)}S(n,i){const a=new N.$eC(i,1);if(a.left=N.$fC,a.right=N.$fC,a.parent=N.$fC,a.size_left=0,a.lf_left=0,this.root===N.$fC)this.root=a,a.color=0;else if(n.right===N.$fC)n.right=a,a.parent=n;else{const t=(0,N.$gC)(n.right);t.left=a,a.parent=t}return(0,N.$lC)(this,a),a}T(n,i){const a=new N.$eC(i,1);if(a.left=N.$fC,a.right=N.$fC,a.parent=N.$fC,a.size_left=0,a.lf_left=0,this.root===N.$fC)this.root=a,a.color=0;else if(n.left===N.$fC)n.left=a,a.parent=n;else{const h=(0,N.$hC)(n.left);h.right=a,a.parent=h}return(0,N.$lC)(this,a),a}U(n){let i="";return this.iterate(n,a=>(i+=this.R(a),!0)),i}}e.$yC=o}),define(Ce[136],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c0=e.$b0=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const A=this.a.get(N);return this.a.delete(N),A}}addDragOperationTransfer(N,A){this.a.set(N,A)}}e.$b0=I;class O{constructor(N){this.identifier=N}}e.$c0=O}),define(Ce[137],Pe([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ce[138],Pe([1,0,5,6,137]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=F;class N extends O.$Uc{constructor(u,b="",f="",r=!0,o){super(),this.h=this.B(new I.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=f,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$Zi=N;class A extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$7d),this.onWillRun=this.f.event,this.m=this.B(new I.$7d),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let f;try{await this.u(u,b)}catch(r){f=r}this.m.fire({action:u,error:f})}async u(u,b){await u.run(b)}}e.$1i=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const f of u)f.length&&(b.length?b=[...b,new m,...f]:b=f);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$2i=m;class d{get actions(){return this.a}constructor(u,b,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=r,this.a=f}async run(){}}e.$3i=d;class k extends N{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,M.localize(0,null),void 0,!1)}}e.$4i=k;function F(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u),tooltip:E.label}}}),define(Ce[139],Pe([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ce[140],Pe([1,0,139]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=k,e.$Om=F,e.$Pm=E;const O=60,M=O*60,N=M*24,A=N*7,m=N*30,d=N*365;function k(u,b,f,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<O?(s=o,b?s===1?f?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):f?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?f?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):f?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<M?(s=Math.floor(o/O),b?s===1?f?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):f?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?f?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):f?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<N?(s=Math.floor(o/M),b?s===1?f?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):f?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?f?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):f?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<A?(s=Math.floor(o/N),b?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<m?(s=Math.floor(o/A),b?s===1?f?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):f?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?f?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):f?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<d?(s=Math.floor(o/m),b?s===1?f?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):f?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?f?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):f?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/d),b?s===1?f?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):f?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?f?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):f?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function F(u,b){const f=Math.abs(u/1e3);return f<1?b?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):f<O?b?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):f<M?b?(0,I.localize)(58,null,Math.round(u/(1e3*O))):(0,I.localize)(59,null,Math.round(u/(1e3*O))):f<N?b?(0,I.localize)(60,null,Math.round(u/(1e3*M))):(0,I.localize)(61,null,Math.round(u/(1e3*M))):(0,I.localize)(62,null,Math.round(u/(1e3*N)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[141],Pe([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ce[42],Pe([1,0,18,16,141]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=d,e.$7i=k,e.$8i=F;function N(E,u){return u&&(E.stack||E.stacktrace)?M.localize(0,null,m(E),A(E.stack)||A(E.stacktrace)):m(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function m(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?M.localize(1,null,E.message):E.message||M.localize(2,null)}function d(E=null,u=!1){if(!E)return M.localize(3,null);if(Array.isArray(E)){const b=I.$Hb(E),f=d(b[0],u);return b.length>1?M.localize(4,null,f,b.length):f}if(O.$Vf(E))return E;if(E.detail){const b=E.detail;if(b.error)return N(b.error,u);if(b.exception)return N(b.exception,u)}return E.stack?N(E,u):E.message?E.message:M.localize(5,null)}function k(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function F(E,u){let b;return typeof E=="string"?b=new Error(E):b=E,b.actions=u,b}}),define(Ce[142],Pe([1,0,40,19]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=m,e.$4q=d,e.$5q=k,e.$6q=F,e.$7q=E,e.$8q=u,e.$9q=b,e.$0q=f,e.$$q=r,e.$_q=o,e.$ar=w,e.$br=v,e.$cr=l;const M=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),N=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(D,g,S=!1){const y=D||"",P=g||"",C=M.value.collator.compare(y,P);return M.value.collatorIsNumeric&&C===0&&y!==P?y<P?-1:1:C}function d(D,g){const S=N.value.collator;return D=D||"",g=g||"",a(S,D,g)}function k(D,g){const S=N.value.collator;return D=D||"",g=g||"",c(D,g)||a(S,D,g)}function F(D,g){const S=N.value.collator;return D=D||"",g=g||"",p(D,g)||a(S,D,g)}function E(D,g){return D=D||"",g=g||"",D===g?0:D<g?-1:1}function u(D,g){const[S,y]=n(D),[P,C]=n(g);let W=M.value.collator.compare(y,C);if(W===0){if(M.value.collatorIsNumeric&&y!==C)return y<C?-1:1;if(W=M.value.collator.compare(S,P),M.value.collatorIsNumeric&&W===0&&S!==P)return S<P?-1:1}return W}function b(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),P=N.value.collator,C=A.value.collator;return a(C,S,y)||a(P,D,g)}function f(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),P=N.value.collator,C=A.value.collator;return a(C,S,y)||c(D,g)||a(P,D,g)}function r(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),P=N.value.collator,C=A.value.collator;return a(C,S,y)||p(D,g)||a(P,D,g)}function o(D,g){D=D||"",g=g||"";const S=i(D).toLowerCase(),y=i(g).toLowerCase();return S!==y?S<y?-1:1:D!==g?D<g?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(D,g=!1){const S=D?s.exec(D):[];let y=[S&&S[1]||"",S&&S[3]||""];return g&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const g=D?s.exec(D):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(D,g,S){const y=D.compare(g,S);return y!==0?y:g.length!==S.length?g.length<S.length?-1:1:0}function h(D){const g=D.charAt(0);return g.toLocaleUpperCase()!==g}function t(D){const g=D.charAt(0);return g.toLocaleLowerCase()!==g}function p(D,g){return h(D)&&t(g)?-1:t(D)&&h(g)?1:0}function c(D,g){return t(D)&&h(g)?-1:h(D)&&t(g)?1:0}function $(D,g,S=!1){return S||(D=D&&D.toLowerCase(),g=g&&g.toLowerCase()),D===g?0:D<g?-1:1}function w(D,g,S=!1){const y=D.split(O.sep),P=g.split(O.sep),C=y.length-1,W=P.length-1;let V,q;for(let R=0;;R++){if(V=C===R,q=W===R,V&&q)return m(y[R],P[R],S);if(V)return-1;if(q)return 1;const z=$(y[R],P[R],S);if(z!==0)return z}}function v(D,g,S){const y=D.toLowerCase(),P=g.toLowerCase(),C=l(D,g,S);if(C)return C;const W=y.endsWith(S),V=P.endsWith(S);if(W!==V)return W?-1:1;const q=m(y,P);return q!==0?q:y.localeCompare(P)}function l(D,g,S){const y=D.toLowerCase(),P=g.toLowerCase(),C=y.startsWith(S),W=P.startsWith(S);if(C!==W)return C?-1:1;if(C&&W){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}}),define(Ce[46],Pe([1,0,19,21,15,16]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=A,e.$cg=m,e.$dg=d,e.$eg=k,e.$fg=F,e.$gg=f,e.$hg=r,e.$ig=o,e.$jg=s,e.$kg=n,e.$lg=i,e.$mg=a,e.$ng=h,e.$og=t,e.$pg=p,e.$qg=w;function A(v){return v===47||v===92}function m(v){return v.replace(/[\\/]/g,I.$hc.sep)}function d(v){return v.indexOf("/")===-1&&(v=m(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function k(v,l=I.$hc.sep){if(!v)return"";const D=v.length,g=v.charCodeAt(0);if(A(g)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let y=3;const P=y;for(;y<D&&!A(v.charCodeAt(y));y++);if(P!==y&&!A(v.charCodeAt(y+1))){for(y+=1;y<D;y++)if(A(v.charCodeAt(y)))return v.slice(0,y+1).replace(/[\\/]/g,l)}}return l}else if(s(g)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+l:v.slice(0,2);let S=v.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(A(v.charCodeAt(S)))return v.slice(0,S+1)}return""}function F(v){if(!O.$i||!v||v.length<5)return!1;let l=v.charCodeAt(0);if(l!==92||(l=v.charCodeAt(1),l!==92))return!1;let D=2;const g=D;for(;D<v.length&&(l=v.charCodeAt(D),l!==92);D++);return!(g===D||(l=v.charCodeAt(D+1),isNaN(l)||l===92))}const E=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(v,l=O.$i){const D=l?E:u;return!(!v||v.length===0||/^\s+$/.test(v)||(D.lastIndex=0,D.test(v))||l&&b.test(v)||v==="."||v===".."||l&&v[v.length-1]==="."||l&&v.length!==v.trim().length||v.length>255)}function r(v,l,D){const g=v===l;return!D||g?g:!v||!l?!1:(0,M.$lf)(v,l)}function o(v,l,D,g=I.sep){if(v===l)return!0;if(!v||!l||l.length>v.length)return!1;if(D){if(!(0,M.$mf)(v,l))return!1;if(l.length===v.length)return!0;let y=l.length;return l.charAt(l.length-1)===g&&y--,v.charAt(y)===g}return l.charAt(l.length-1)!==g&&(l+=g),v.indexOf(l)===0}function s(v){return v>=65&&v<=90||v>=97&&v<=122}function n(v,l){return O.$i&&v.endsWith(":")&&(v+=I.sep),(0,I.$jc)(v)||(v=(0,I.$kc)(l,v)),v=(0,I.$ic)(v),O.$i?(v=(0,M.$6e)(v,I.sep),v.endsWith(":")&&(v+=I.sep)):(v=(0,M.$6e)(v,I.sep),v||(v=I.sep)),v}function i(v){const l=(0,I.$ic)(v);return O.$i?v.length>3?!1:a(l)&&(v.length===2||l.charCodeAt(2)===92):l===I.$hc.sep}function a(v,l=O.$i){return l?s(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function h(v,l=O.$i){return a(v,l)?v[0]:void 0}function t(v,l,D){return l.length>v.length?-1:v===l?0:(D&&(v=v.toLowerCase(),l=l.toLowerCase()),v.indexOf(l))}function p(v){const l=v.split(":");let D,g,S;for(const y of l){const P=Number(y);(0,N.$Zf)(P)?g===void 0?g=P:S===void 0&&(S=P):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:g!==void 0?g:void 0,column:S!==void 0?S:g!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(v,l,D=8){let g="";for(let y=0;y<D;y++){let P;y===0&&O.$i&&!l&&(D===3||D===4)?P=$:P=c,g+=P.charAt(Math.floor(Math.random()*P.length))}let S;return l?S=`${l}-${g}`:S=g,v?(0,I.$kc)(v,S):S}}),define(Ce[69],Pe([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0,e.$As=N,e.$Bs=A,e.$Cs=m,e.$Ds=k,e.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(F){const E=(0,I.$pc)(F),u=O[E.toLowerCase()];return u!==void 0?u:A(F)}function A(F){const E=(0,I.$pc)(F);return M[E.toLowerCase()]}function m(F){for(const E in M)if(M[E]===F)return E}const d=/^(.+)\/(.+?)(;.+)?$/;function k(F,E){const u=d.exec(F);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:F}}),define(Ce[52],Pe([1,0,22,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=M,e.$Qh=N,e.$Rh=m;function M(d){return JSON.stringify(d,A)}function N(d){let k=JSON.parse(d);return k=m(k),k}function A(d,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function m(d,k=0){if(!d||k>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return O.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof I.$ue||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let F=0;F<d.length;++F)d[F]=m(d[F],k+1);else for(const F in d)Object.hasOwnProperty.call(d,F)&&(d[F]=m(d[F],k+1))}return d}}),define(Ce[12],Pe([1,0,14,21,15,2,19]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=d,e.$sg=k,e.$wg=E;var m;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.codeSetting="code-setting"})(m||(e.Schemas=m={}));function d(f,r){return N.URI.isUri(f)?(0,M.$lf)(f.scheme,r):(0,M.$mf)(f,r+":")}function k(f,...r){return r.some(o=>d(f,o))}e.$tg="vscode-tkn",e.$ug="tkn";class F{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=E(r,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,m.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return I.$1(h),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(a+=`&${e.$ug}=${encodeURIComponent(i)}`),N.URI.from({scheme:O.$o?this.d:m.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:a})}}e.$vg=new F;function E(f,r){return A.$hc.join(r??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class u{static{this.a=e.$Bg}asBrowserUri(r){const o=this.b(r,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===m.vscodeRemote?e.$vg.rewrite(r):r.scheme===m.file&&(O.$m||O.$q===`${m.vscodeFileResource}://${u.a}`)?r.with({scheme:m.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,ge);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===m.vscodeFileResource?r.with({scheme:m.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return N.URI.isUri(r)?r:N.URI.parse(o.toUrl(r))}}e.$Cg=new u;var b;(function(f){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:N.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const h=a?.get(o);if(h)return r.get(h)}f.getHeadersFromQuery=s;function n(i,a,h){if(!globalThis.crossOriginIsolated)return;const t=a&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}f.addSearchParam=n})(b||(e.COI=b={}))}),define(Ce[23],Pe([1,0,46,12,19,21,15,2]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=d,e.$5g=F,e.$6g=u;function d(b){return(0,m.$xc)(b,!0)}class k{constructor(f){this.a=f}compare(f,r,o=!1){return f===r?0:(0,A.$ef)(this.getComparisonKey(f,o),this.getComparisonKey(r,o))}isEqual(f,r,o=!1){return f===r?!0:!f||!r?!1:this.getComparisonKey(f,o)===this.getComparisonKey(r,o)}getComparisonKey(f,r=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,r,o=!1){if(f.scheme===r.scheme){if(f.scheme===O.Schemas.file)return I.$ig(d(f),d(r),this.a(f))&&f.query===r.query&&(o||f.fragment===r.fragment);if((0,e.$1g)(f.authority,r.authority))return I.$ig(f.path,r.path,this.a(f),"/")&&f.query===r.query&&(o||f.fragment===r.fragment)}return!1}joinPath(f,...r){return m.URI.joinPath(f,...r)}basenameOrAuthority(f){return(0,e.$Sg)(f)||f.authority}basename(f){return M.$hc.basename(f.path)}extname(f){return M.$hc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let r;return f.scheme===O.Schemas.file?r=m.URI.file(M.$nc(d(f))).path:(r=M.$hc.dirname(f.path),f.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),r="/")),f.with({path:r})}normalizePath(f){if(!f.path.length)return f;let r;return f.scheme===O.Schemas.file?r=m.URI.file(M.$ic(d(f))).path:r=M.$hc.normalize(f.path),f.with({path:r})}relativePath(f,r){if(f.scheme!==r.scheme||!(0,e.$1g)(f.authority,r.authority))return;if(f.scheme===O.Schemas.file){const n=M.$mc(d(f),d(r));return N.$i?I.$cg(n):n}let o=f.path||"/";const s=r.path||"/";if(this.a(f)){let n=0;for(const i=Math.min(o.length,s.length);n<i&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return M.$hc.relative(o,s)}resolvePath(f,r){if(f.scheme===O.Schemas.file){const o=m.URI.file(M.$lc(d(f),r));return f.with({authority:o.authority,path:o.path})}return r=I.$dg(r),f.with({path:M.$hc.resolve(f.path,r)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,r){return f===r||f!==void 0&&r!==void 0&&(0,A.$lf)(f,r)}hasTrailingPathSeparator(f,r=M.sep){if(f.scheme===O.Schemas.file){const o=d(f);return o.length>I.$eg(o).length&&o[o.length-1]===r}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,r=M.sep){return(0,e.$2g)(f,r)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,r=M.sep){let o=!1;if(f.scheme===O.Schemas.file){const s=d(f);o=s!==void 0&&s.length===I.$eg(s).length&&s[s.length-1]===r}else{r="/";const s=f.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$2g)(f,r)?f.with({path:f.path+"/"}):f}}e.$Kg=k,e.$Lg=new k(()=>!1),e.$Mg=new k(b=>b.scheme===O.Schemas.file?!N.$k:!0),e.$Ng=new k(b=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function F(b,f){const r=[];for(let o=0;o<b.length;o++){const s=f(b[o]);b.some((n,i)=>i===o?!1:(0,e.$Pg)(s,f(n)))||r.push(b[o])}return r}var E;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,h]=i.split(":");a&&h&&o.set(a,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(b.META_DATA_MIME,n),o}b.parseMetaData=f})(E||(e.DataUri=E={}));function u(b,f,r){if(f){let o=b.path;return o&&o[0]!==M.$hc.sep&&(o=M.$hc.sep+o),b.with({scheme:r,authority:f,path:o})}return b.with({scheme:r})}}),define(Ce[11],Pe([1,0,24,14,5,6,23,21,129,40]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=F,e.$8g=E,e.$9g=u,e.$0g=b,e.$$g=f,e.$_g=r,e.$ah=o,e.$bh=s,e.$jh=v,e.$kh=l,e.$lh=D,e.$mh=g,e.$nh=S,e.$Ch=we,e.$Kh=ye;function F(de){return!!de&&typeof de.then=="function"}function E(de){const J=new I.$ee,Y=de(J.token),ue=new Promise((he,Ne)=>{const le=J.token.onCancellationRequested(()=>{le.dispose(),Ne(new O.$5)});Promise.resolve(Y).then(Ie=>{le.dispose(),J.dispose(),he(Ie)},Ie=>{le.dispose(),J.dispose(),Ne(Ie)})});return new class{cancel(){J.cancel(),J.dispose()}then(he,Ne){return ue.then(he,Ne)}catch(he){return this.then(void 0,he)}finally(he){return ue.finally(he)}}}function u(de,J,Y){return new Promise((ue,he)=>{const Ne=J.onCancellationRequested(()=>{Ne.dispose(),ue(Y)});de.then(ue,he).finally(()=>Ne.dispose())})}function b(de,J){return new Promise((Y,ue)=>{const he=J.onCancellationRequested(()=>{he.dispose(),ue(new O.$5)});de.then(Y,ue).finally(()=>he.dispose())})}async function f(de){let J=-1;const Y=de.map((ue,he)=>ue.then(Ne=>(J=he,Ne)));try{return await Promise.race(Y)}finally{de.forEach((ue,he)=>{he!==J&&ue.cancel()})}}function r(de,J,Y){let ue;const he=setTimeout(()=>{ue?.(void 0),Y?.()},J);return Promise.race([de.finally(()=>clearTimeout(he)),new Promise(Ne=>ue=Ne)])}function o(de){return new Promise((J,Y)=>{const ue=de();F(ue)?ue.then(J,Y):J(ue)})}function s(){let de,J;return{promise:new Promise((ue,he)=>{de=ue,J=he}),resolve:de,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(Y,Y).then(ue)})}return new Promise((Y,ue)=>{this.b.then(Y,ue)})}return this.a=J(),new Promise((Y,ue)=>{this.a.then(he=>{this.a=null,Y(he)},he=>{this.a=null,ue(he)})})}dispose(){this.f=!0}}e.$ch=n;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$dh=i;class a{constructor(){this.a=new Map}queue(J,Y){const he=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===he&&this.a.delete(J)});return this.a.set(J,he),he}}e.$eh=a;const h=(de,J)=>{let Y=!0;const ue=setTimeout(()=>{Y=!1,J()},de);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(ue),Y=!1}}},t=de=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,de())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class p{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((he,Ne)=>{this.d=he,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=Y===d.$4d?t(ue):h(Y,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=p;class c{constructor(J){this.a=new p(J),this.b=new n}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=c;class ${constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=$;class w extends ${constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$ih=w;function v(de,J){return J?new Promise((Y,ue)=>{const he=setTimeout(()=>{Ne.dispose(),Y()},de),Ne=J.onCancellationRequested(()=>{clearTimeout(he),Ne.dispose(),ue(new O.$5)})}):E(Y=>v(de,Y))}function l(de,J=0,Y){const ue=setTimeout(()=>{de(),Y&&he.dispose()},J),he=(0,N.$Sc)(()=>{clearTimeout(ue),Y?.deleteAndLeak(he)});return Y?.add(he),he}function D(de){const J=[];let Y=0;const ue=de.length;function he(){return Y<ue?de[Y++]():null}function Ne(le){le!=null&&J.push(le);const Ie=he();return Ie?Ie.then(Ne):Promise.resolve(J)}return Promise.resolve(null).then(Ne)}function g(de,J=ue=>!!ue,Y=null){let ue=0;const he=de.length,Ne=()=>{if(ue>=he)return Promise.resolve(Y);const le=de[ue++];return Promise.resolve(le()).then(Re=>J(Re)?Promise.resolve(Re):Ne())};return Ne()}function S(de,J=ue=>!!ue,Y=null){if(de.length===0)return Promise.resolve(Y);let ue=de.length;const he=()=>{ue=-1;for(const Ne of de)Ne.cancel?.()};return new Promise((Ne,le)=>{for(const Ie of de)Ie.then(Re=>{--ue>=0&&J(Re)?(he(),Ne(Re)):ue===0&&Ne(Y)}).catch(Re=>{--ue>=0&&(he(),le(Re))})})}class y{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new M.$7d}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,ue)=>{this.g.push({factory:J,c:Y,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=y;class P extends y{constructor(){super(1)}}e.$ph=P;class C{constructor(){this.a=new oe,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$qh=C;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new Se;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=A.$Lg){const ue=Y.getComparisonKey(J);return this.a.get(ue)?.size??0}queueFor(J,Y,ue=A.$Lg){const he=ue.getComparisonKey(J);let Ne=this.a.get(he);if(!Ne){Ne=new P;const le=this.f++,Ie=M.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(he),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(le,Ie),this.a.set(he,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=W;class V{constructor(J,Y){this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$sh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,ue=globalThis){this.cancel();const he=ue.setInterval(()=>{J()},Y);this.d=(0,N.$Sc)(()=>{ue.clearInterval(he),this.d=void 0})}dispose(){this.cancel()}}e.$th=q;class R{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=R;class z{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=z;class G extends R{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$wh=G;class ie extends N.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(de,J)=>{(0,m.$B)(()=>{if(Y)return;const ue=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$zh=(de,J,Y)=>{const ue=de.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let he=!1;return{dispose(){he||(he=!0,de.cancelIdleCallback(ue))}}},e.$yh=de=>(0,e.$zh)(globalThis,de)}();class fe{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$zh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=fe;class De extends fe{constructor(J){super(globalThis,J)}}e.$Bh=De;async function we(de,J,Y){let ue;for(let he=0;he<Y;he++)try{return await de()}catch(Ne){ue=Ne,await v(J)}throw ue}class oe{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,ue){return this.a={taskId:J,cancel:()=>ue?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:ue,reject:he}=s();this.b={run:J,promise:Y,promiseResolve:ue,promiseReject:he}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=oe;class $e{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Eh=$e;var ne;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(ne||(ne={}));class Se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:0,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:1,value:J},Y()})}cancel(){return this.error(new O.$5)}}e.$Fh=Se;var Le;(function(de){async function J(ue){let he;const Ne=await Promise.all(ue.map(le=>le.then(Ie=>Ie,Ie=>{he||(he=Ie)})));if(typeof he<"u")throw he;return Ne}de.settled=J;function Y(ue){return new Promise(async(he,Ne)=>{try{await ue(he,Ne)}catch(le){Ne(le)}})}de.withAsyncBody=Y})(Le||(e.Promises=Le={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=re;class L{constructor(J){this.b=J,this.a=new k.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=L;var x;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(J){return new ve(Y=>{Y.emitMany(J)})}static fromPromise(J){return new ve(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new ve(async Y=>{await Promise.all(J.map(async ue=>Y.emitOne(await ue)))})}static merge(J){return new ve(async Y=>{await Promise.all(J.map(async ue=>{for await(const he of ue)Y.emitOne(he)}))})}static{this.EMPTY=ve.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new M.$7d,queueMicrotask(async()=>{const Y={emitOne:ue=>this.g(ue),emitMany:ue=>this.h(ue),reject:ue=>this.k(ue)};try{await Promise.resolve(J(Y)),this.j()}catch(ue){this.k(ue)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.f.event)}while(!0)}}}static map(J,Y){return new ve(async ue=>{for await(const he of J)ue.emitOne(Y(he))})}map(J){return ve.map(this,J)}static filter(J,Y){return new ve(async ue=>{for await(const he of J)Y(he)&&ue.emitOne(he)})}filter(J){return ve.filter(this,J)}static coalesce(J){return ve.filter(J,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(J){const Y=[];for await(const ue of J)Y.push(ue);return Y}toPromise(){return ve.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Ih=ve;class Oe extends ve{constructor(J,Y){super(Y),this.l=J}cancel(){this.l.cancel()}}e.$Jh=Oe;function ye(de){const J=new I.$ee,Y=de(J.token);return new Oe(J,async ue=>{const he=J.token.onCancellationRequested(()=>{he.dispose(),J.dispose(),ue.reject(new O.$5)});try{for await(const Ne of Y){if(J.token.isCancellationRequested)return;ue.emitOne(Ne)}he.dispose(),J.dispose()}catch(Ne){he.dispose(),J.dispose(),ue.reject(Ne)}})}class pe{constructor(){this.a=new Se,this.b=new ve(ue=>{if(J){ue.reject(J);return}return Y&&ue.emitMany(Y),this.d=he=>ue.reject(he),this.f=he=>ue.emitOne(he),this.a.p});let J,Y;this.f=ue=>{Y||(Y=[]),Y.push(ue)},this.d=ue=>{J||(J=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Lh=pe}),define(Ce[35],Pe([1,0,18,11,46,28,19,21,15]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=k,e.$ak=f,e.$bk=P,e.$ck=C,e.$dk=W,e.$ek=V,e.$fk=q,e.$gk=ie;function k(){return Object.create(null)}e.$$j="**",e.$_j="/";const F="[/\\\\]",E="[^/\\\\]",u=/\//g;function b(fe,De){switch(fe){case 0:return"";case 1:return`${E}*?`;default:return`(?:${F}|${E}+${F}${De?`|${F}${E}+`:""})*?`}}function f(fe,De){if(!fe)return[];const we=[];let oe=!1,$e=!1,ne="";for(const Se of fe){switch(Se){case De:if(!oe&&!$e){we.push(ne),ne="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}ne+=Se}return ne&&we.push(ne),we}function r(fe){if(!fe)return"";let De="";const we=f(fe,e.$_j);if(we.every(oe=>oe===e.$$j))De=".*";else{let oe=!1;we.forEach(($e,ne)=>{if($e===e.$$j){if(oe)return;De+=b(2,ne===we.length-1)}else{let Se=!1,Le="",re=!1,L="";for(const x of $e){if(x!=="}"&&Se){Le+=x;continue}if(re&&(x!=="]"||!L)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!L?ve="^":x===e.$_j?ve="":ve=(0,d.$Ze)(x),L+=ve;continue}switch(x){case"{":Se=!0;continue;case"[":re=!0;continue;case"}":{const Oe=`(?:${f(Le,",").map(ye=>r(ye)).join("|")})`;De+=Oe,Se=!1,Le="";break}case"]":{De+="["+L+"]",re=!1,L="";break}case"?":De+=E;continue;case"*":De+=b(1);continue;default:De+=(0,d.$Ze)(x)}}ne<we.length-1&&(we[ne+1]!==e.$$j||ne+2<we.length)&&(De+=F)}oe=$e===e.$$j})}return De}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Ec(1e4),p=function(){return!1},c=function(){return null};function $(fe,De){if(!fe)return c;let we;typeof fe!="string"?we=fe.pattern:we=fe,we=we.trim();const oe=`${we}_${!!De.trimForExclusions}`;let $e=t.get(oe);if($e)return w($e,fe);let ne;return o.test(we)?$e=l(we.substr(4),we):(ne=s.exec(v(we,De)))?$e=D(ne[1],we):(De.trimForExclusions?i:n).test(we)?$e=g(we,De):(ne=a.exec(v(we,De)))?$e=S(ne[1].substr(1),we,!0):(ne=h.exec(v(we,De)))?$e=S(ne[1],we,!1):$e=y(we),t.set(oe,$e),w($e,fe)}function w(fe,De){if(typeof De=="string")return fe;const we=function(oe,$e){return(0,M.$ig)(oe,De.base,!m.$k)?fe((0,d.$5e)(oe.substr(De.base.length),A.sep),$e):null};return we.allBasenames=fe.allBasenames,we.allPaths=fe.allPaths,we.basenames=fe.basenames,we.patterns=fe.patterns,we}function v(fe,De){return De.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function l(fe,De){return function(we,oe){return typeof we=="string"&&we.endsWith(fe)?De:null}}function D(fe,De){const we=`/${fe}`,oe=`\\${fe}`,$e=function(Se,Le){return typeof Se!="string"?null:Le?Le===fe?De:null:Se===fe||Se.endsWith(we)||Se.endsWith(oe)?De:null},ne=[fe];return $e.basenames=ne,$e.patterns=[De],$e.allBasenames=ne,$e}function g(fe,De){const we=G(fe.slice(1,-1).split(",").map(Le=>$(Le,De)).filter(Le=>Le!==c),fe),oe=we.length;if(!oe)return c;if(oe===1)return we[0];const $e=function(Le,re){for(let L=0,x=we.length;L<x;L++)if(we[L](Le,re))return fe;return null},ne=we.find(Le=>!!Le.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Se=we.reduce((Le,re)=>re.allPaths?Le.concat(re.allPaths):Le,[]);return Se.length&&($e.allPaths=Se),$e}function S(fe,De,we){const oe=A.sep===A.$hc.sep,$e=oe?fe:fe.replace(u,A.sep),ne=A.sep+$e,Se=A.$hc.sep+fe;let Le;return we?Le=function(re,L){return typeof re=="string"&&(re===$e||re.endsWith(ne)||!oe&&(re===fe||re.endsWith(Se)))?De:null}:Le=function(re,L){return typeof re=="string"&&(re===$e||!oe&&re===fe)?De:null},Le.allPaths=[(we?"*/":"./")+fe],Le}function y(fe){try{const De=new RegExp(`^${r(fe)}$`);return function(we){return De.lastIndex=0,typeof we=="string"&&De.test(we)?fe:null}}catch{return c}}function P(fe,De,we){return!fe||typeof De!="string"?!1:C(fe)(De,void 0,we)}function C(fe,De={}){if(!fe)return p;if(typeof fe=="string"||W(fe)){const we=$(fe,De);if(we===c)return p;const oe=function($e,ne){return!!we($e,ne)};return we.allBasenames&&(oe.allBasenames=we.allBasenames),we.allPaths&&(oe.allPaths=we.allPaths),oe}return R(fe,De)}function W(fe){const De=fe;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}function V(fe){return fe.allBasenames||[]}function q(fe){return fe.allPaths||[]}function R(fe,De){const we=G(Object.getOwnPropertyNames(fe).map(Le=>z(Le,fe[Le],De)).filter(Le=>Le!==c)),oe=we.length;if(!oe)return c;if(!we.some(Le=>!!Le.requiresSiblings)){if(oe===1)return we[0];const Le=function(x,ve){let Oe;for(let ye=0,pe=we.length;ye<pe;ye++){const de=we[ye](x,ve);if(typeof de=="string")return de;(0,O.$7g)(de)&&(Oe||(Oe=[]),Oe.push(de))}return Oe?(async()=>{for(const ye of Oe){const pe=await ye;if(typeof pe=="string")return pe}return null})():null},re=we.find(x=>!!x.allBasenames);re&&(Le.allBasenames=re.allBasenames);const L=we.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return L.length&&(Le.allPaths=L),Le}const $e=function(Le,re,L){let x,ve;for(let Oe=0,ye=we.length;Oe<ye;Oe++){const pe=we[Oe];pe.requiresSiblings&&L&&(re||(re=(0,A.$oc)(Le)),x||(x=re.substr(0,re.length-(0,A.$pc)(Le).length)));const de=pe(Le,re,x,L);if(typeof de=="string")return de;(0,O.$7g)(de)&&(ve||(ve=[]),ve.push(de))}return ve?(async()=>{for(const Oe of ve){const ye=await Oe;if(typeof ye=="string")return ye}return null})():null},ne=we.find(Le=>!!Le.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Se=we.reduce((Le,re)=>re.allPaths?Le.concat(re.allPaths):Le,[]);return Se.length&&($e.allPaths=Se),$e}function z(fe,De,we){if(De===!1)return c;const oe=$(fe,we);if(oe===c)return c;if(typeof De=="boolean")return oe;if(De){const $e=De.when;if(typeof $e=="string"){const ne=(Se,Le,re,L)=>{if(!L||!oe(Se,Le))return null;const x=$e.replace("$(basename)",()=>re),ve=L(x);return(0,O.$7g)(ve)?ve.then(Oe=>Oe?fe:null):ve?fe:null};return ne.requiresSiblings=!0,ne}}return oe}function G(fe,De){const we=fe.filter(Le=>!!Le.basenames);if(we.length<2)return fe;const oe=we.reduce((Le,re)=>{const L=re.basenames;return L?Le.concat(L):Le},[]);let $e;if(De){$e=[];for(let Le=0,re=oe.length;Le<re;Le++)$e.push(De)}else $e=we.reduce((Le,re)=>{const L=re.patterns;return L?Le.concat(L):Le},[]);const ne=function(Le,re){if(typeof Le!="string")return null;if(!re){let x;for(x=Le.length;x>0;x--){const ve=Le.charCodeAt(x-1);if(ve===47||ve===92)break}re=Le.substr(x)}const L=oe.indexOf(re);return L!==-1?$e[L]:null};ne.basenames=oe,ne.patterns=$e,ne.allBasenames=oe;const Se=fe.filter(Le=>!Le.basenames);return Se.push(ne),Se}function ie(fe,De){return(0,I.$ub)(fe,De,(we,oe)=>typeof we=="string"&&typeof oe=="string"?we===oe:typeof we!="string"&&typeof oe!="string"?we.base===oe.base&&we.pattern===oe.pattern:!1)}}),define(Ce[53],Pe([1,0,14,130,23,15,2]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=k,e.$Hk=F,e.$Ik=E,e.$Jk=u,e.$Kk=b,e.$Lk=f,e.$Mk=r,e.$Nk=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class d{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=u(this.supportThemeIcons?(0,O.$zk)(n):n).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${b(i,n)}
`,this}appendLink(n,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(n,i){const a=new RegExp((0,N.$Ze)(i),"g");return n.replace(a,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Fk=d;function k(s){return F(s)?!s.value:Array.isArray(s)?s.every(k):!0}function F(s){return s instanceof d?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function E(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,M.$Og)(A.URI.from(s.baseUri),A.URI.from(n.baseUri)))}function u(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(s,n){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${n}`,s,`${"`".repeat(a)}`].join(`
`)}function f(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const n=[],i=s.split("|").map(h=>h.trim());s=i[0];const a=i[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),p=h?h[1]:"",c=t?t[1]:"",$=isFinite(parseInt(c)),w=isFinite(parseInt(p));$&&n.push(`width="${c}"`),w&&n.push(`height="${p}"`)}return{href:s,dimensions:n}}}),define(Ce[96],Pe([1,0,18,46,19,21,23,15]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=d,e.$hw=F,e.$iw=u,e.$jw=b,e.$kw=s,e.$lw=i,e.$mw=a,e.$nw=h,e.$ow=t,e.$pw=p;function d($,w){const{os:v,tildify:l,relative:D}=w;if(D){const y=k($,D,v);if(typeof y=="string")return y}let g=$.fsPath;if(v===1&&!N.$i?g=g.replace(/\//g,"\\"):v!==1&&N.$i&&(g=g.replace(/\\/g,"/")),v!==1&&l?.userHome){const y=l.userHome.fsPath;let P;$.scheme!==l.userHome.scheme&&$.path[0]===M.$hc.sep&&$.path[1]!==M.$hc.sep?P=l.userHome.with({path:$.path}).fsPath:P=g,g=u(P,y,v)}return(v===1?M.$gc:M.$hc).normalize(F(g,v===1))}function k($,w,v){const l=v===1?M.$gc:M.$hc,D=v===3?A.$Lg:A.$Ng,g=w.getWorkspace(),S=(0,I.$Ob)(g.folders);if(!S)return;$.scheme!==S.uri.scheme&&$.path[0]===M.$hc.sep&&$.path[1]!==M.$hc.sep&&($=S.uri.with({path:$.path}));const y=w.getWorkspaceFolder($);if(!y)return;let P;if(D.isEqual(y.uri,$)?P="":P=D.relativePath(y.uri,$)??"",P&&(P=l.normalize(P)),g.folders.length>1&&!w.noPrefix){const C=y.name?y.name:D.basenameOrAuthority(y.uri);P=P?`${C} \u2022 ${P}`:C}return P}function F($,w=N.$i){return(0,O.$mg)($,w)?$.charAt(0).toUpperCase()+$.slice(1):$}let E=Object.create(null);function u($,w,v=N.OS){if(v===1||!$||!w)return $;let l=E.original===w?E.normalized:void 0;l||(l=w,N.$i&&(l=(0,O.$cg)(l)),l=`${(0,m.$6e)(l,M.$hc.sep)}${M.$hc.sep}`,E={original:w,normalized:l});let D=$;return N.$i&&(D=(0,O.$cg)(D)),(v===3?D.startsWith(l):(0,m.$mf)(D,l))?`~/${D.substr(l.length)}`:$}function b($,w){return $.replace(/^~($|\/|\\)/,`${w}$1`)}const f="\u2026",r="\\\\",o="~";function s($,w=M.sep){const v=new Array($.length);let l=!1;for(let D=0;D<$.length;D++){const g=$[D];if(g===""){v[D]=`.${w}`;continue}if(!g){v[D]=g;continue}l=!0;let S="",y=g;y.indexOf(r)===0?(S=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(w)===0?(S=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(o)===0&&(S=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const P=y.split(w);for(let C=1;l&&C<=P.length;C++)for(let W=P.length-C;l&&W>=0;W--){l=!1;let V=P.slice(W,W+C).join(w);for(let q=0;!l&&q<$.length;q++)if(q!==D&&$[q]&&$[q].indexOf(V)>-1){const R=W+C===P.length,z=W>0&&$[q].indexOf(w)>-1?w+V:V,G=$[q].endsWith(z);l=!R||G}if(!l){let q="";(P[0].endsWith(":")||S!=="")&&(W===1&&(W=0,C++,V=P[0]+w+V),W>0&&(q=P[0]+w),q=S+q),W>0&&(q=q+f+w),q=q+V,W+C<P.length&&(q=q+w+f),v[D]=q}}l&&(v[D]=g)}return v}var n;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i($,w=Object.create(null)){const v=[];let l=!1,D="";for(const g of $)if(g==="$"||l&&g==="{")D&&v.push({value:D,type:n.TEXT}),D="",l=!0;else if(g==="}"&&l){const S=w[D];if(typeof S=="string")S.length&&v.push({value:S,type:n.VARIABLE});else if(S){const y=v[v.length-1];(!y||y.type!==n.SEPARATOR)&&v.push({value:S.label,type:n.SEPARATOR})}D="",l=!1}else D+=g;return D&&!l&&v.push({value:D,type:n.TEXT}),v.filter((g,S)=>{if(g.type===n.SEPARATOR){const y=v[S-1],P=v[S+1];return[y,P].every(C=>C&&(C.type===n.VARIABLE||C.type===n.TEXT)&&C.value.length>0)}return!0}).map(g=>g.value).join("")}function a($,w){return N.$j||w?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):$.replace(/&&|&/g,v=>v==="&"?"&&":"&")}function h($,w){return N.$j||w?$.replace(/\(&&\w\)|&&/g,""):N.$i?$.replace(/&&|&/g,v=>v==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function p($){if($.endsWith("]")){const w=$.lastIndexOf(" [",$.length-2);if(w!==-1){const v=c($.substring(0,w)),l=$.substring(w);return{name:v.name+l,parentPath:v.parentPath}}}return c($)}function c($){const w=$.indexOf("/")!==-1?M.$hc:M.$gc,v=w.basename($),l=w.dirname($);return v.length?{name:v,parentPath:l}:{name:l,parentPath:""}}}),define(Ce[143],Pe([1,0,22,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=m,e.$nn=k,e.$on=F;function M(E){return E.toJSON()}class N{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:M(O.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:M(O.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:O.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$kn=N,e.$ln=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function A(E,u,b){if(!E||b>200)return null;if(typeof E=="object"){if(E instanceof O.URI)return u.transformOutgoing(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const r=A(E[f],u,b+1);r!==null&&(E[f]=r)}}return null}function m(E,u){const b=A(E,u,0);return b===null?E:b}function d(E,u,b,f){if(!E||f>200)return null;if(typeof E=="object"){if(E.$mid===1)return b?O.URI.revive(u.transformIncoming(E)):u.transformIncoming(E);if(E instanceof I.$ue)return null;for(const r in E)if(Object.hasOwnProperty.call(E,r)){const o=d(E[r],u,b,f+1);o!==null&&(E[r]=o)}}return null}function k(E,u){const b=d(E,u,!1,0);return b===null?E:b}function F(E,u){const b=d(E,u,!0,0);return b===null?E:b}}),define(Ce[144],Pe([1,0,15,21,22]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$ut=F,e.$vt=E;let N;function A(){return N||(N=new TextDecoder("UTF-16LE")),N}let m;function d(){return m||(m=new TextDecoder("UTF-16BE")),m}let k;function F(){return k||(k=O.$D()?A():d()),k}function E(f,r,o){const s=new Uint16Array(f.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?u(f,r,o):A().decode(s)}function u(f,r,o){const s=[];let n=0;for(let i=0;i<o;i++){const a=M.$we(f,r);r+=2,s[n++]=String.fromCharCode(a)}return s.join("")}class b{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return F().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||I.$pf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$wt=b}),define(Ce[145],Pe([1,0,22,144]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$yt=A;function M(d){return d.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,F,E,u){this.oldPosition=k,this.oldText=F,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,F,E){const u=F.length;I.$ze(k,u,E),E+=4;for(let b=0;b<u;b++)I.$xe(k,F.charCodeAt(b),E),E+=2;return E}static d(k,F){const E=I.$ye(k,F);return F+=4,(0,O.$vt)(k,F,E)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(k,F){return I.$ze(k,this.oldPosition,F),F+=4,I.$ze(k,this.newPosition,F),F+=4,F=N.c(k,this.oldText,F),F=N.c(k,this.newText,F),F}static read(k,F,E){const u=I.$ye(k,F);F+=4;const b=I.$ye(k,F);F+=4;const f=N.d(k,F);F+=N.a(f);const r=N.d(k,F);return F+=N.a(r),E.push(new N(u,f,b,r)),F}}e.$xt=N;function A(d,k){return d===null||d.length===0?k:new m(d,k).compress()}class m{constructor(k,F){this.a=k,this.c=F,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,F=0,E=this.n(k),u=this.l(F);for(;k<this.f||F<this.h;){if(E===null){this.k(u),u=this.l(++F);continue}if(u===null){this.m(E),E=this.n(++k);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++F);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++k);continue}if(u.oldPosition<E.newPosition){const[s,n]=m.r(u,E.newPosition-u.oldPosition);this.k(s),u=n;continue}if(E.newPosition<u.oldPosition){const[s,n]=m.q(E,u.oldPosition-E.newPosition);this.m(s),E=n;continue}let r,o;if(u.oldEnd===E.newEnd)r=E,o=u,E=this.n(++k),u=this.l(++F);else if(u.oldEnd<E.newEnd){const[s,n]=m.q(E,u.oldLength);r=s,o=u,E=n,u=this.l(++F)}else{const[s,n]=m.r(u,E.newLength);r=E,o=s,E=this.n(++k),u=n}this.d[this.e++]=new N(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const b=m.s(this.d);return m.t(b)}k(k){this.d[this.e++]=m.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=m.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,F){return new N(F.oldPosition-k,F.oldText,F.newPosition,F.newText)}static p(k,F){return new N(F.oldPosition,F.oldText,F.newPosition+k,F.newText)}static q(k,F){const E=k.newText.substr(0,F),u=k.newText.substr(F);return[new N(k.oldPosition,k.oldText,k.newPosition,E),new N(k.oldEnd,"",k.newPosition+F,u)]}static r(k,F){const E=k.oldText.substr(0,F),u=k.oldText.substr(F);return[new N(k.oldPosition,E,k.newPosition,k.newText),new N(k.oldPosition+F,u,k.newEnd,"")]}static s(k){if(k.length===0)return k;const F=[];let E=0,u=k[0];for(let b=1;b<k.length;b++){const f=k[b];u.oldEnd===f.oldPosition?u=new N(u.oldPosition,u.oldText+f.oldText,u.newPosition,u.newText+f.newText):(F[E++]=u,u=f)}return F[E++]=u,F}static t(k){if(k.length===0)return k;const F=[];let E=0;for(let u=0;u<k.length;u++){const b=k[u];b.oldText!==b.newText&&(F[E++]=b)}return F}}}),define(Ce[146],Pe([1,0,35,19]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=M,e.$Wt=N;function M(A,m,d,k,F,E){if(Array.isArray(A)){let u=0;for(const b of A){const f=M(b,m,d,k,F,E);if(f===10)return f;f>u&&(u=f)}return u}else{if(typeof A=="string")return k?A==="*"?5:A===d?10:0:0;if(A){const{language:u,pattern:b,scheme:f,hasAccessToAllModels:r,notebookType:o}=A;if(!k&&!r)return 0;o&&F&&(m=F);let s=0;if(f)if(f===m.scheme)s=10;else if(f==="*")s=5;else return 0;if(u)if(u===d)s=10;else if(u==="*")s=Math.max(s,5);else return 0;if(o)if(o===E)s=10;else if(o==="*"&&E!==void 0)s=Math.max(s,5);else return 0;if(b){let n;if(typeof b=="string"?n=b:n={...b,base:(0,O.$ic)(b.base)},n===m.fsPath||(0,I.$bk)(n,m.fsPath))s=10;else return 0}return s}else return 0}}function N(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(N):!!A.notebookType}}),define(Ce[147],Pe([1,0,5,15,29,94,92,132,145,6]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class F extends k.$Uc{constructor(u,b,f,r,o,s,n){super(),this.m=this.B(new I.$7d),this.onDidChangeContent=this.m.event,this.f=b,this.j=!s,this.g=r,this.h=o,this.c=new A.$yC(u,f,n)}equals(u){return!(u instanceof F)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const f=u+b,r=this.getPositionAt(u),o=this.getPositionAt(f);return new M.$ct(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const f=this.n(b);return this.c.getValueInRange(u,f)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const f=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const s=this.n(b),n=this.getEOL();if(s.length!==n.length){const i=s.length-n.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return r-f+o}getCharacterCountInRange(u,b=0){if(this.j){let f=0;const r=u.startLineNumber,o=u.endLineNumber;for(let s=r;s<=o;s++){const n=this.getLineContent(s),i=s===r?u.startColumn-1:0,a=s===o?u.endColumn-1:n.length;for(let h=i;h<a;h++)O.$pf(n.charCodeAt(h))?(f=f+1,h=h+1):f=f+1}return f+=this.n(b).length*(o-r),f}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=O.$af(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=O.$cf(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,f){let r=this.g,o=this.h,s=this.j,n=!0,i=[];for(let w=0;w<u.length;w++){const v=u[w];n&&v._isTracked&&(n=!1);const l=v.range;if(v.text){let P=!0;s||(P=!O.$Af(v.text),s=P),!r&&P&&(r=O.$zf(v.text)),!o&&P&&(o=O.$Cf(v.text))}let D="",g=0,S=0,y=0;if(v.text){let P;[g,S,y,P]=(0,m.$Ot)(v.text);const C=this.getEOL();P===0||P===(C===`\r
`?2:1)?D=v.text:D=v.text.replace(/\r\n|\r|\n/g,C)}i[w]={sortIndex:w,identifier:v.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:D,eolCount:g,firstLineLength:S,lastLineLength:y,forceMoveMarkers:!!v.forceMoveMarkers,isAutoWhitespaceEdit:v.isAutoWhitespaceEdit||!1}}i.sort(F.u);let a=!1;for(let w=0,v=i.length-1;w<v;w++){const l=i[w].range.getEndPosition(),D=i[w+1].range.getStartPosition();if(D.isBeforeOrEqual(l)){if(D.isBefore(l))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(i=this.s(i));const h=f||b?F._getInverseEditRanges(i):[],t=[];if(b)for(let w=0;w<i.length;w++){const v=i[w],l=h[w];if(v.isAutoWhitespaceEdit&&v.range.isEmpty())for(let D=l.startLineNumber;D<=l.endLineNumber;D++){let g="";D===l.startLineNumber&&(g=this.getLineContent(v.range.startLineNumber),O.$af(g)!==-1)||t.push({lineNumber:D,oldContent:g})}}let p=null;if(f){let w=0;p=[];for(let v=0;v<i.length;v++){const l=i[v],D=h[v],g=this.getValueInRange(l.range),S=l.rangeOffset+w;w+=l.text.length-g.length,p[v]={sortIndex:l.sortIndex,identifier:l.identifier,range:D,text:g,textChange:new d.$xt(l.rangeOffset,g,S,l.text)}}a||p.sort((v,l)=>v.sortIndex-l.sortIndex)}this.g=r,this.h=o,this.j=s;const c=this.t(i);let $=null;if(b&&t.length>0){t.sort((w,v)=>v.lineNumber-w.lineNumber),$=[];for(let w=0,v=t.length;w<v;w++){const l=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===l)continue;const D=t[w].oldContent,g=this.getLineContent(l);g.length===0||g===D||O.$af(g)!==-1||$.push(l)}}return this.m.fire(),new N.$Av(p,c,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const f=u[0].range,r=u[u.length-1].range,o=new M.$ct(f.startLineNumber,f.startColumn,r.endLineNumber,r.endColumn);let s=f.startLineNumber,n=f.startColumn;const i=[];for(let c=0,$=u.length;c<$;c++){const w=u[c],v=w.range;b=b||w.forceMoveMarkers,i.push(this.getValueInRange(new M.$ct(s,n,v.startLineNumber,v.startColumn))),w.text.length>0&&i.push(w.text),s=v.endLineNumber,n=v.endColumn}const a=i.join(""),[h,t,p]=(0,m.$Ot)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:p,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(F.w);const b=[];for(let f=0;f<u.length;f++){const r=u[f],o=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(o===n&&s===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const a=new M.$ct(o,s,n,i);b.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,f,r){return this.c.findMatchesLineByLine(u,b,f,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const f=u.startLineNumber,r=u.startColumn,[o,s,n]=(0,m.$Ot)(b);let i;if(b.length>0){const a=o+1;a===1?i=new M.$ct(f,r,f,r+s):i=new M.$ct(f,r,f+a-1,n+1)}else i=new M.$ct(f,r,f,r);return i}static _getInverseEditRanges(u){const b=[];let f=0,r=0,o=null;for(let s=0,n=u.length;s<n;s++){const i=u[s];let a,h;o?o.range.endLineNumber===i.range.startLineNumber?(a=f,h=r+(i.range.startColumn-o.range.endColumn)):(a=f+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(a=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const p=i.eolCount+1;p===1?t=new M.$ct(a,h,a,h+i.firstLineLength):t=new M.$ct(a,h,a+p-1,i.lastLineLength+1)}else t=new M.$ct(a,h,a,h);f=t.endLineNumber,r=t.endColumn,b.push(t),o=i}return b}static u(u,b){const f=M.$ct.compareRangesUsingEnds(u.range,b.range);return f===0?u.sortIndex-b.sortIndex:f}static w(u,b){const f=M.$ct.compareRangesUsingEnds(u.range,b.range);return f===0?b.sortIndex-u.sortIndex:-f}}e.$zC=F}),define(Ce[148],Pe([1,0,15,92,147]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=void 0;class N{constructor(d,k,F,E,u,b,f,r,o){this.a=d,this.b=k,this.c=F,this.d=E,this.e=u,this.f=b,this.g=f,this.h=r,this.j=o}k(d){const k=this.c+this.d+this.e,F=this.c+this.e;return k===0?d===1?`
`:`\r
`:F>k/2?`\r
`:`
`}create(d){const k=this.k(d),F=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let u=0,b=F.length;u<b;u++){const f=F[u].buffer.replace(/\r\n|\r|\n/g,k),r=(0,O.$uC)(f);F[u]=new O.$xC(f,r)}const E=new M.$zC(F,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(d){return this.a[0].buffer.substr(0,d).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(d){if(d.length===0)return;this.a.length===0&&I.$Jf(d)&&(this.b=I.$If,d=d.substr(1));const k=d.charCodeAt(d.length-1);k===13||k>=55296&&k<=56319?(this.m(d.substr(0,d.length-1),!1),this.c=!0,this.d=k):(this.m(d,!1),this.c=!1,this.d=k)}m(d,k){!k&&d.length===0||(this.c?this.n(String.fromCharCode(this.d)+d):this.n(d))}n(d){const k=(0,O.$vC)(this.e,d);this.a.push(new O.$xC(d,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=I.$zf(d)),this.k||(this.k=I.$Cf(d)))}finish(d=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,d)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const d=this.a[this.a.length-1];d.buffer+=String.fromCharCode(this.d);const k=(0,O.$uC)(d.buffer);d.lineStarts=k,this.d===13&&this.f++}}}e.$AC=A}),define(Ce[97],Pe([1,0,22,21]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iab=d,e.$Jab=F;var M;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(M||(M={}));function N(E){for(let u=0,b=E.length;u<b;u+=4){const f=E[u+0],r=E[u+1],o=E[u+2],s=E[u+3];E[u+0]=s,E[u+1]=o,E[u+2]=r,E[u+3]=f}}function A(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return O.$D()||N(u),I.$ue.wrap(u)}function m(E){const u=E.buffer;if(O.$D()||N(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function d(E){const u=new Uint32Array(k(E));let b=0;if(u[b++]=E.id,E.type==="full")u[b++]=1,u[b++]=E.data.length,u.set(E.data,b),b+=E.data.length;else{u[b++]=2,u[b++]=E.deltas.length;for(const f of E.deltas)u[b++]=f.start,u[b++]=f.deleteCount,f.data?(u[b++]=f.data.length,u.set(f.data,b),b+=f.data.length):u[b++]=0}return A(u)}function k(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const b of E.deltas)b.data&&(u+=b.data.length)}return u}function F(E){const u=m(E);let b=0;const f=u[b++];if(u[b++]===1){const n=u[b++],i=u.subarray(b,b+n);return b+=n,{id:f,type:"full",data:i}}const o=u[b++],s=[];for(let n=0;n<o;n++){const i=u[b++],a=u[b++],h=u[b++];let t;h>0&&(t=u.subarray(b,b+h),b+=h),s[n]={start:i,deleteCount:a,data:t}}return{id:f,type:"delta",deltas:s}}}),define(Ce[149],Pe([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ce[150],Pe([1,0,18,26,21,133,151,149]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=a,e.stringSet=p,e.cursorStyleToString=y,e.filterValidationDecorations=he;var d;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(d||(e.EditorAutoIndentStrategy=d={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=k;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class E{constructor(X,me,qe,Xe){this.id=X,this.name=me,this.defaultValue=qe,this.schema=Xe}applyUpdate(X,me){return b(X,me)}compute(X,me,qe){return qe}}class u{constructor(X,me){this.newValue=X,this.didChange=me}}e.ApplyUpdateResult=u;function b(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new u(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const qe=Array.isArray(Z)&&Array.isArray(X)&&I.$ub(Z,X);return new u(X,!qe)}let me=!1;for(const qe in X)if(X.hasOwnProperty(qe)){const Xe=b(Z[qe],X[qe]);Xe.didChange&&(Z[qe]=Xe.newValue,me=!0)}return new u(Z,me)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,me){return b(X,me)}validate(X){return this.defaultValue}}class r{constructor(X,me,qe,Xe){this.id=X,this.name=me,this.defaultValue=qe,this.schema=Xe}applyUpdate(X,me){return b(X,me)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,me,qe){return qe}}function o(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class s extends r{constructor(X,me,qe,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=qe),super(X,me,qe,Xe)}validate(X){return o(X,this.defaultValue)}}function n(Z,X,me,qe){if(typeof Z>"u")return X;let Xe=parseInt(Z,10);return isNaN(Xe)?X:(Xe=Math.max(me,Xe),Xe=Math.min(qe,Xe),Xe|0)}class i extends r{static clampedInt(X,me,qe,Xe){return n(X,me,qe,Xe)}constructor(X,me,qe,Xe,Me,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=qe,dt.minimum=Xe,dt.maximum=Me),super(X,me,qe,dt),this.minimum=Xe,this.maximum=Me}validate(X){return i.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Z,X,me,qe){if(typeof Z>"u")return X;const Xe=h.float(Z,X);return h.clamp(Xe,me,qe)}class h extends r{static clamp(X,me,qe){return X<me?me:X>qe?qe:X}static float(X,me){if(typeof X=="number")return X;if(typeof X>"u")return me;const qe=parseFloat(X);return isNaN(qe)?me:qe}constructor(X,me,qe,Xe,Me){typeof Me<"u"&&(Me.type="number",Me.default=qe),super(X,me,qe,Me),this.validationFn=Xe}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class t extends r{static string(X,me){return typeof X!="string"?me:X}constructor(X,me,qe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=qe),super(X,me,qe,Xe)}validate(X){return t.string(X,this.defaultValue)}}function p(Z,X,me,qe){return typeof Z!="string"?X:qe&&Z in qe?qe[Z]:me.indexOf(Z)===-1?X:Z}class c extends r{constructor(X,me,qe,Xe,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Xe,Me.default=qe),super(X,me,qe,Me),this.c=Xe}validate(X){return p(X,this.defaultValue,this.c)}}class $ extends E{constructor(X,me,qe,Xe,Me,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=Me,Pt.default=Xe),super(X,me,qe,Pt),this.c=Me,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,me,qe){return qe===0?X.accessibilitySupport:qe}}class l extends E{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:m.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function g(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function y(Z){switch(Z){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function P(Z){switch(Z){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class C extends f{constructor(){super(142)}compute(X,me,qe){const Xe=["monaco-editor"];return me.get(39)&&Xe.push(me.get(39)),X.extraEditorClassName&&Xe.push(X.extraEditorClassName),me.get(74)==="default"?Xe.push("mouse-default"):me.get(74)==="copy"&&Xe.push("mouse-copy"),me.get(111)&&Xe.push("showUnused"),me.get(140)&&Xe.push("showDeprecated"),Xe.join(" ")}}class W extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(X,me,qe){return qe&&X.emptySelectionClipboard}}class V extends E{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:m.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:m.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":p(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":p(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?q.OFF:X==="true"?q.ON:X:X?q.ON:q.OFF}}e.EditorFontLigatures=q;class R extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.TRANSLATE:X:X?R.TRANSLATE:R.OFF}compute(X,me,qe){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class z extends f{constructor(){super(50)}compute(X,me,qe){return X.fontInfo}}class G extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(X){const me=h.float(X,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(X,me,qe){return X.fontInfo.fontSize}}class ie extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(i.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class fe extends E{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:qe,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:qe,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:qe,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:qe,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:qe,description:m.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{multiple:p(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??p(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??p(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??p(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??p(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??p(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends E{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:m.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var we;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class oe extends f{constructor(){super(145)}compute(X,me,qe){return oe.computeLayout(me,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const me=X.height/X.lineHeight,qe=Math.floor(X.paddingTop/X.lineHeight);let Xe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Xe=Math.max(Xe,me-1));const Me=(qe+X.viewLineCount+Xe)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/Me);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Xe,desiredRatio:Me,minimapLineCount:dt}}static c(X,me){const qe=X.outerWidth,Xe=X.outerHeight,Me=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const dt=me.stableMinimapLayoutInput,Pt=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,zt=X.lineHeight,xt=X.typicalHalfwidthCharacterWidth,Jt=X.scrollBeyondLastLine,_t=X.minimap.renderCharacters;let Et=Me>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Qt=X.minimap.maxColumn,Vt=X.minimap.size,ai=X.minimap.side,Ye=X.verticalScrollbarWidth,ei=X.viewLineCount,ti=X.remainingWidth,ht=X.isViewportWrapping,vt=_t?2:3;let si=Math.floor(Me*Xe);const ii=si/Me;let Ft=!1,mt=!1,Mt=vt*Et,Wt=Et/Me,Xt=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:Rt,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:ni,desiredRatio:oi,minimapLineCount:qt}=oe.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Jt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Xe,lineHeight:zt,pixelRatio:Me});if(ei/qt>1)Ft=!0,mt=!0,Et=1,Mt=1,Wt=Et/Me;else{let Dt=!1,Ht=Et+1;if(Vt==="fit"){const Ct=Math.ceil((Lt+ei+ni)*Mt);ht&&Pt&&ti<=me.stableFitRemainingWidth?(Dt=!0,Ht=me.stableFitMaxMinimapScale):Dt=Ct>si}if(Vt==="fill"||Dt){Ft=!0;const Ct=Et;Mt=Math.min(zt*Me,Math.max(1,Math.floor(1/oi))),ht&&Pt&&ti<=me.stableFitRemainingWidth&&(Ht=me.stableFitMaxMinimapScale),Et=Math.min(Ht,Math.max(1,Math.floor(Mt/vt))),Et>Ct&&(Xt=Math.min(2,Et/Ct)),Wt=Et/Me/Xt,si=Math.ceil(Math.max(Rt,Lt+ei+ni)*Mt),ht?(me.stableMinimapLayoutInput=X,me.stableFitRemainingWidth=ti,me.stableFitMaxMinimapScale=Et):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Ke=Math.floor(Qt*Wt),Zt=Math.min(Ke,Math.max(0,Math.floor((ti-Ye-2)*Wt/(xt+Wt)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(Me*Zt);const Ut=jt/Me;jt=Math.floor(jt*Xt);const $t=_t?1:2,Tt=ai==="left"?0:qe-Zt-Ye;return{renderMinimap:$t,minimapLeft:Tt,minimapWidth:Zt,minimapHeightIsEditorHeight:Ft,minimapIsSampling:mt,minimapScale:Et,minimapLineHeight:Mt,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:si,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:ii}}static computeLayout(X,me){const qe=me.outerWidth|0,Xe=me.outerHeight|0,Me=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,zt=me.maxDigitWidth,xt=me.pixelRatio,Jt=me.viewLineCount,_t=X.get(137),Et=_t==="inherit"?X.get(136):_t,Qt=Et==="inherit"?X.get(132):Et,Vt=X.get(135),ai=me.isDominatedByLongLines,Ye=X.get(57),ei=X.get(68).renderType!==0,ti=X.get(69),ht=X.get(105),vt=X.get(84),si=X.get(73),ii=X.get(103),Ft=ii.verticalScrollbarSize,mt=ii.verticalHasArrows,Mt=ii.arrowSize,Wt=ii.horizontalScrollbarSize,Xt=X.get(43),Ke=X.get(110)!=="never";let Zt=X.get(66);Xt&&Ke&&(Zt+=16);let jt=0;if(ei){const St=Math.max(dt,ti);jt=Math.round(St*zt)}let Ut=0;Ye&&(Ut=Me*me.glyphMarginDecorationLaneCount);let $t=0,Tt=$t+Ut,Rt=Tt+jt,Lt=Rt+Zt;const ni=qe-Ut-jt-Zt;let oi=!1,qt=!1,It=-1;Et==="inherit"&&ai?(oi=!0,qt=!0):Qt==="on"||Qt==="bounded"?qt=!0:Qt==="wordWrapColumn"&&(It=Vt);const Dt=oe.c({outerWidth:qe,outerHeight:Xe,lineHeight:Me,typicalHalfwidthCharacterWidth:Pt,pixelRatio:xt,scrollBeyondLastLine:ht,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:si,verticalScrollbarWidth:Ft,viewLineCount:Jt,remainingWidth:ni,isViewportWrapping:qt},me.memory||new F);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&($t+=Dt.minimapWidth,Tt+=Dt.minimapWidth,Rt+=Dt.minimapWidth,Lt+=Dt.minimapWidth);const Ht=ni-Dt.minimapWidth,Ct=Math.max(1,Math.floor((Ht-Ft-2)/Pt)),wt=mt?Mt:0;return qt&&(It=Math.max(1,Ct),Qt==="bounded"&&(It=Math.min(It,Vt))),{width:qe,height:Xe,glyphMarginLeft:$t,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Tt,lineNumbersWidth:jt,decorationsLeft:Rt,decorationsWidth:Zt,contentLeft:Lt,contentWidth:Ht,minimap:Dt,viewportColumn:Ct,isWordWrapMinified:oi,isViewportWrapping:qt,wrappingColumn:It,verticalScrollbarWidth:Ft,horizontalScrollbarHeight:Wt,overviewRuler:{top:wt,width:Ft,height:Xe-2*wt,right:0}}}}e.EditorLayoutInfoComputer=oe;class $e extends E{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(X){return p(X,"simple",["simple","advanced"])}compute(X,me,qe){return me.get(2)===2?"advanced":qe}}var ne;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class Se extends E{constructor(){const X={enabled:ne.OnCode};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:X.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:p(X.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class Le extends E{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:m.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends E{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:m.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:p(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class L extends E{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):i.clampedInt(X,this.defaultValue,0,1e3)}compute(X,me,qe){return qe<0?i.clampedInt(-qe*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>h.clamp(X,0,150),{markdownDescription:m.localize(66,null)})}compute(X,me,qe){return X.fontInfo.lineHeight}}class ve extends E{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:X.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:m.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:m.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:m.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:m.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:p(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(me.side,this.defaultValue.side,["right","left"]),showSlider:p(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Oe(Z){return Z==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class ye extends E{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class pe extends E{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:m.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:m.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class de extends f{constructor(){super(143)}compute(X,me,qe){return X.pixelRatio}}class J extends E{constructor(){const X={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:X.strings,description:m.localize(88,null)},comments:{anyOf:me,default:X.comments,description:m.localize(89,null)},other:{anyOf:me,default:X.other,description:m.localize(90,null)}},default:X,markdownDescription:m.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const xt=X?"on":"off";return{comments:xt,strings:xt,other:xt}}if(!X||typeof X!="object")return this.defaultValue;const{other:me,comments:qe,strings:Xe}=X,Me=["on","inline","off"];let dt,Pt,zt;return typeof me=="boolean"?dt=me?"on":"off":dt=p(me,this.defaultValue.other,Me),typeof qe=="boolean"?Pt=qe?"on":"off":Pt=p(qe,this.defaultValue.comments,Me),typeof Xe=="boolean"?zt=Xe?"on":"off":zt=p(Xe,this.defaultValue.strings,Me),{other:dt,comments:Pt,strings:zt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class ue extends E{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null),m.localize(95,null)],default:"on",description:m.localize(96,null)})}validate(X){let me=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(me=4,qe=X):X==="interval"?me=3:X==="relative"?me=2:X==="on"?me=1:me=0),{renderType:me,renderFn:qe}}}function he(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Ne extends E{constructor(){const X=[],me={type:"number",description:m.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:m.localize(98,null),format:"color-hex"}}}]},default:X,description:m.localize(99,null)})}validate(X){if(Array.isArray(X)){const me=[];for(const qe of X)if(typeof qe=="number")me.push({column:i.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Xe=qe;me.push({column:i.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return me.sort((qe,Xe)=>qe.column-Xe.column),me}return this.defaultValue}}class le extends E{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends E{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:"auto",description:m.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(104,null),m.localize(105,null),m.localize(106,null)],default:"auto",description:m.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:m.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:m.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:m.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:m.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X,qe=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(me.vertical,this.defaultValue.vertical),horizontal:Ie(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:i.clampedInt(me.verticalSliderSize,Xe,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends E{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:m.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:m.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:m.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:m.localize(118,null)}})}applyUpdate(X,me){let qe=!1;me.allowedCharacters&&X&&(O.$Sn(X.allowedCharacters,me.allowedCharacters)||(X={...X,allowedCharacters:me.allowedCharacters},qe=!0)),me.allowedLocales&&X&&(O.$Sn(X.allowedLocales,me.allowedLocales)||(X={...X,allowedLocales:me.allowedLocales},qe=!0));const Xe=super.applyUpdate(X,me);return qe?new u(Xe.newValue,!0):Xe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,me){if(typeof X!="object"||!X)return me;const qe={};for(const[Xe,Me]of Object.entries(X))Me===!0&&(qe[Xe]=!0);return qe}}class U extends E{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:m.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(120,null),m.localize(121,null),m.localize(122,null)],description:m.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:m.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:p(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class j extends E{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:m.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],description:m.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:m.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:p(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends E{constructor(){const X={enabled:N.$Ms.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$Ms.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:m.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends E{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:X.bracketPairs,description:m.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null)],default:X.bracketPairsHorizontal,description:m.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:m.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:m.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null)],default:X.highlightActiveIndentation,description:m.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,X,me){const qe=me.indexOf(Z);return qe===-1?X:me[qe]}class se extends E{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(149,null),m.localize(150,null)],default:X.insertMode,description:m.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:m.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:m.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:m.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(155,null),m.localize(156,null),m.localize(157,null),m.localize(158,null)],default:X.selectionMode,markdownDescription:m.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:m.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:m.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:m.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:m.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:m.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertMode:p(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:p(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Fe extends E{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends E{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:m.localize(199,null),type:"string"},{description:m.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const me=[];for(const qe of X)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&me.push(qe)}catch{}return me}return this.defaultValue}}var Qe;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class xe extends E{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(201,null),m.localize(202,null),m.localize(203,null),m.localize(204,null)],description:m.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,me,qe){return me.get(2)===2?0:qe}}class tt extends f{constructor(){super(146)}compute(X,me,qe){const Xe=me.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class at extends E{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(208,null),m.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:p(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends E{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(212,null),m.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:p(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?ct:M.$k?ft:nt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var ot;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ot||(e.EditorOption=ot={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(214,null)})),acceptSuggestionOnEnter:Ue(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(215,null),""],markdownDescription:m.localize(216,null)})),accessibilitySupport:Ue(new v),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(218,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),""],description:m.localize(222,null)})),autoClosingComments:Ue(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),autoClosingDelete:Ue(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(226,null),""],description:m.localize(227,null)})),autoClosingOvertype:Ue(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(228,null),""],description:m.localize(229,null)})),autoClosingQuotes:Ue(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(230,null),m.localize(231,null),""],description:m.localize(232,null)})),autoIndent:Ue(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null),""],description:m.localize(242,null)})),bracketPairColorization:Ue(new K),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:m.localize(243,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:m.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(245,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(246,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:m.localize(247,null)})),colorDecoratorActivatedOn:Ue(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(252,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:m.localize(253,null)})),comments:Ue(new l),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(254,null)})),cursorBlinking:Ue(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:m.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),cursorStyle:Ue(new $(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:m.localize(260,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(262,null),m.localize(263,null)],markdownDescription:m.localize(264,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(265,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:m.localize(266,null)})),emptySelectionClipboard:Ue(new W),dropIntoEditor:Ue(new at),stickyScroll:Ue(new Le),experimentalWhitespaceRendering:Ue(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(271,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:m.localize(272,null)})),foldingStrategy:Ue(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:m.localize(276,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:m.localize(277,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(280,null)})),fontInfo:Ue(new z),fontLigatures2:Ue(new q),fontSize:Ue(new G),fontWeight:Ue(new ie),fontVariations:Ue(new R),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:m.localize(281,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:m.localize(282,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:m.localize(283,null)})),gotoLocation:Ue(new fe),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(284,null)})),hover:Ue(new De),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:m.localize(285,null)})),lightbulb:Ue(new Se),lineDecorationsWidth:Ue(new L),lineHeight:Ue(new x),lineNumbers:Ue(new ue),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:m.localize(286,null)})),links:Ue(new s(71,"links",!0,{description:m.localize(287,null)})),matchBrackets:Ue(new c(72,"matchBrackets","always",["always","near","never"],{description:m.localize(288,null)})),minimap:Ue(new ve),mouseStyle:Ue(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(289,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?m.localize(290,null):m.localize(291,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(292,null)})),multiCursorModifier:Ue(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Oe,{markdownEnumDescriptions:[m.localize(293,null),m.localize(294,null)],markdownDescription:m.localize(295,null)})),multiCursorPaste:Ue(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(299,null)})),occurrencesHighlight:Ue(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],markdownDescription:m.localize(303,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:m.localize(304,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ye),pasteAs:Ue(new it),parameterHints:Ue(new pe),peekWidgetDefaultFocus:Ue(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(305,null),m.localize(306,null)],description:m.localize(307,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(308,null)})),quickSuggestions:Ue(new J),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(309,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new le),renameOnType:Ue(new s(93,"renameOnType",!1,{description:m.localize(310,null),markdownDeprecationMessage:m.localize(311,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:m.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new c(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(313,null)})),renderLineHighlight:Ue(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(314,null)],description:m.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(316,null)})),renderValidationDecorations:Ue(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(317,null),m.localize(318,null),m.localize(319,null),""],description:m.localize(320,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:m.localize(321,null)})),rulers:Ue(new Ne),scrollbar:Ue(new Re),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(322,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(323,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:m.localize(324,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:m.localize(325,null),included:M.$k})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:m.localize(326,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(327,null),m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:m.localize(331,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:m.localize(332,null)})),inlayHints:Ue(new re),snippetSuggestions:Ue(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(333,null),m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),smartSelect:Ue(new Fe),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:m.localize(338,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new se),inlineSuggest:Ue(new U),inlineEdit:Ue(new j),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(339,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(342,null)})),suggestSelection:Ue(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),tabCompletion:Ue(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null)],description:m.localize(350,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(351,null),m.localize(352,null),m.localize(353,null)],description:m.localize(354,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:m.localize(355,null)})),wordBreak:Ue(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(356,null),m.localize(357,null)],description:m.localize(358,null)})),wordSegmenterLocales:Ue(new Ve),wordSeparators:Ue(new t(131,"wordSeparators",A.$Ns,{description:m.localize(359,null)})),wordWrap:Ue(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(360,null),m.localize(361,null),m.localize(362,null),m.localize(363,null)],description:m.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(365,null)})),wordWrapOverride1:Ue(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new C),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:m.localize(366,null)})),pixelRatio:Ue(new de),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:m.localize(367,null)})),layoutInfo:Ue(new oe),wrappingInfo:Ue(new tt),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new $e)}}),define(Ce[152],Pe([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[153],Pe([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[154],Pe([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[155],Pe([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[156],Pe([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[157],Pe([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ce[158],Pe([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Ce[159],Pe([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ce[160],Pe([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[161],Pe([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ce[162],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[163],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[164],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[165],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[166],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[167],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[168],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[169],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[170],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[171],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[172],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[173],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[174],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[175],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ce[176],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ce[177],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ce[178],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[179],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[180],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[181],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[182],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[183],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[184],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[185],Pe([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[186],Pe([1,0,14,154]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var M;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(M||(e.TokenType=M={}));function N(...k){switch(k.length){case 1:return(0,O.localize)(0,null,k[0]);case 2:return(0,O.localize)(1,null,k[0],k[1]);case 3:return(0,O.localize)(2,null,k[0],k[1],k[2]);default:return}}const A=(0,O.localize)(3,null),m=(0,O.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(F){switch(F.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return F.isTripleEq?"===":"==";case 4:return F.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return F.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return F.lexeme;case 18:return F.lexeme;case 19:return F.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(F)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(F=>F.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(F){return this.c=F,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(F){return this.r()||this.c.charCodeAt(this.e)!==F?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(F){this.f.push({type:F,offset:this.d})}l(F){const E=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:E,lexeme:u,additionalInfo:F}),this.f.push(b)}n(){this.m.lastIndex=this.d;const F=this.m.exec(this.c);if(F){this.e=this.d+F[0].length;const E=this.c.substring(this.d,this.e),u=d.b.get(E);u?this.k(u):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let F=this.e,E=!1,u=!1;for(;;){if(F>=this.c.length){this.e=F,this.l(m);return}const f=this.c.charCodeAt(F);if(E)E=!1;else if(f===47&&!u){F++;break}else f===91?u=!0:f===92?E=!0:f===93&&(u=!1);F++}for(;F<this.c.length&&d.a.has(this.c.charCodeAt(F));)F++;this.e=F;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=d}),define(Ce[187],Pe([1,0,23,32,156,301]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=d,e.$tp=k,e.$up=F,e.$vp=E,e.$wp=u,e.$xp=b,e.$yp=f;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function d(s){return s=s.trim(),s==="*"||A.test(s)}function k(s){if(!d(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function F(s){if(!s)return null;const n=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let p=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),p=!1);let c=0;if(s.preRelease){const $=m.exec(s.preRelease);if($){const[,w,v,l]=$;c=Date.UTC(Number(w),Number(v)-1,Number(l))}}return{majorBase:n,majorMustEqual:i,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:p,isMinimum:s.hasGreaterEquals,notBefore:c}}function E(s,n,i){let a;typeof s=="string"?a=F(k(s)):a=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof i=="string"?t=F(k(i)):t=i,!a||!t)return!1;const p=a.majorBase,c=a.minorBase,$=a.patchBase;let w=t.majorBase,v=t.minorBase,l=t.patchBase;const D=t.notBefore;let g=t.majorMustEqual,S=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?p>w?!0:p<w?!1:c>v?!0:c<v||h&&h<D?!1:$>=l:(p===1&&w===0&&(!g||!S||!y)&&(w=1,v=0,l=0,g=!0,S=!1,y=!1),p<w?!1:p>w?!g:c<v?!1:c>v?!S:$<l?!1:$>l?!y:!(h&&h<D))}function u(s,n,i,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([O.default.Error,M.localize(0,null)]),t;if(typeof a.name!="string")return t.push([O.default.Error,M.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([O.default.Error,M.localize(2,null,"version")]),t;if(!a.engines)return t.push([O.default.Error,M.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([O.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([O.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([O.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([O.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([O.default.Warning,M.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([O.default.Error,M.localize(9,null,"main")]),t;{const $=(0,I.$Vg)(i,a.main);(0,I.$Pg)($,i)||t.push([O.default.Warning,M.localize(10,null,$.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([O.default.Error,M.localize(11,null,"browser")]),t;{const $=(0,I.$Vg)(i,a.browser);(0,I.$Pg)($,i)||t.push([O.default.Warning,M.localize(12,null,$.path,i.path)])}}if(!N.valid(a.version))return t.push([O.default.Error,M.localize(13,null)]),t;const p=[];if(!b(s,n,a,h,p))for(const $ of p)t.push([O.default.Error,$]);return t}function b(s,n,i,a,h){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(s,n,i.engines.vscode,h)}function f(s,n,i){return s==="*"||r(n,i,s)}function r(s,n,i,a=[]){const h=F(k(i));if(!h)return a.push(M.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(M.localize(15,null,i)),!1}else if(!h.majorMustEqual)return a.push(M.localize(16,null,i)),!1;return E(s,n,h)?!0:(a.push(M.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,i=s.length;n<i;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Ce[70],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class I{constructor(M,N=[],A=!1){this.ctor=M,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$fi=I}),define(Ce[54],Pe([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=N,e.$hs=A;const O=[];var M;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function N(m,d,k){d instanceof I.$fi||(d=new I.$fi(d,[],!!k)),O.push([m,d])}function A(){return O}}),define(Ce[188],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class I{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=I;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const m=this.lookupOrInsertNode(N),d=this.lookupOrInsertNode(A);m.outgoing.set(d.key,d),d.incoming.set(m.key,m)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let m=this.a.get(A);return m||(m=new I(A,N),this.a.set(A,m)),m}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,m]of this.a)N.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const m=new Set([N]),d=this.c(A,m);if(d)return d}}c(N,A){for(const[m,d]of N.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const k=this.c(d,A);if(k)return k;A.delete(m)}}}e.$Xq=O}),define(Ce[3],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=M,e.$ji=N;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(d){return d[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(I||(e._util=I={})),e.$hi=M("instantiationService");function O(A,m,d){m[I.DI_TARGET]===m?m[I.DI_DEPENDENCIES].push({id:A,index:d}):(m[I.DI_DEPENDENCIES]=[{id:A,index:d}],m[I.DI_TARGET]=m)}function M(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const m=function(d,k,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(m,d,F)};return m.toString=()=>A,I.serviceIds.set(A,m),m}function N(A){return A}}),define(Ce[47],Pe([1,0,16,2,3]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=N,e.$Qi=A,e.$Ri=d,e.$Si=k,e.$Ti=F,e.$Ui=E,e.$Vi=u,e.$Wi=f,e.$Xi=r,e.$Yi=o,e.$Oi=(0,M.$ii)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof O.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof O.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function d(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function F(s,n){const i=Object.create(null);for(const a in s)E(i,a,s[a],n);return i}function E(s,n,i,a){const h=n.split("."),t=h.pop();let p=s;for(let c=0;c<h.length;c++){const $=h[c];let w=p[$];switch(typeof w){case"undefined":w=p[$]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(w)}`);return}p=w}if(typeof p=="object"&&p!==null)try{p[t]=i}catch{a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(p)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(p)}`)}function u(s,n){const i=n.split(".");b(s,i)}function b(s,n){const i=n.shift();if(n.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(b(a,n),Object.keys(a).length===0&&delete s[i])}}function f(s,n,i){function a(p,c){let $=p;for(const w of c){if(typeof $!="object"||$===null)return;$=$[w]}return $}const h=n.split("."),t=a(s,h);return typeof t>"u"?i:t}function r(s,n,i){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in s?I.$Xf(s[a])&&I.$Xf(n[a])?r(s[a],n[a],i):i&&(s[a]=n[a]):s[a]=n[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Ce[33],Pe([1,0,21,15,186,3,153,14]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=k,e.$hj=p,e.$ij=c,e.$Bj=ne;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",I.$j),d.set("isLinux",I.$k),d.set("isWindows",I.$i),d.set("isWeb",I.$o),d.set("isMacNative",I.$j&&!I.$o),d.set("isEdge",I.$H),d.set("isFirefox",I.$F),d.set("isChrome",I.$E),d.set("isSafari",I.$G);function k(re,L){if(d.get(re)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(re,L)}const F=Object.prototype.hasOwnProperty;var E;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),f=(0,A.localize)(1,null),r=(0,A.localize)(2,null),o=(0,A.localize)(3,null),s=(0,A.localize)(4,null),n=(0,A.localize)(5,null),i=(0,A.localize)(6,null),a=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=u){this.k=L,this.d=new M.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Oe=ve.type===17?n:void 0;throw this.h.push({message:s,offset:ve.offset,lexeme:M.$dj.getLexeme(ve),additionalInfo:Oe}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const x=this.o();L.push(x)}return L.length===1?L[0]:t.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const x=this.s();L.push(x)}return L.length===1?L[0]:t.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),P.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=L.lexeme;if(this.z(),this.y(9)){const Oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Oe.type!==10)throw this.B("REGEX",Oe);const ye=Oe.lexeme,pe=ye.lastIndexOf("/"),de=pe===ye.length-1?void 0:this.w(ye.substring(pe+1));let J;try{J=new RegExp(ye.substring(1,pe),de)}catch{throw this.B("REGEX",Oe)}return z.create(x,J)}switch(Oe.type){case 10:case 19:{const ye=[Oe.lexeme];this.z();let pe=this.D(),de=0;for(let Ne=0;Ne<Oe.lexeme.length;Ne++)Oe.lexeme.charCodeAt(Ne)===40?de++:Oe.lexeme.charCodeAt(Ne)===41&&de--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Ne=0;Ne<pe.lexeme.length;Ne++)pe.lexeme.charCodeAt(Ne)===40?de++:Oe.lexeme.charCodeAt(Ne)===41&&de--}if(de<0)break;ye.push(M.$dj.getLexeme(pe)),this.z(),pe=this.D()}const J=ye.join(""),Y=J.lastIndexOf("/"),ue=Y===J.length-1?void 0:this.w(J.substring(Y+1));let he;try{he=new RegExp(J.substring(1,Y),ue)}catch{throw this.B("REGEX",Oe)}return t.regex(x,he)}case 18:{const ye=Oe.lexeme;this.z();let pe=null;if(!(0,O.$Ue)(ye)){const de=ye.indexOf("/"),J=ye.lastIndexOf("/");if(de!==J&&de>=0){const Y=ye.slice(de+1,J),ue=ye[J+1]==="i"?"i":"";try{pe=new RegExp(Y,ue)}catch{throw this.B("REGEX",Oe)}}}if(pe===null)throw this.B("REGEX",Oe);return z.create(x,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Oe=this.u();return t.notIn(x,Oe)}switch(this.D().type){case 3:{this.z();const Oe=this.u();if(this.x().type===18)return t.equals(x,Oe);switch(Oe){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Oe)}}case 4:{this.z();const Oe=this.u();if(this.x().type===18)return t.notEquals(x,Oe);switch(Oe){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Oe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),R.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:i,offset:L.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,x){if(this.C(L))return this.z();throw this.B(x,this.D())}B(L,x,ve){const Oe=(0,A.localize)(8,null,L,M.$dj.getLexeme(x)),ye=x.offset,pe=M.$dj.getLexeme(x);return this.h.push({message:Oe,offset:ye,lexeme:pe,additionalInfo:ve}),h.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=h;class t{static false(){return w.INSTANCE}static true(){return v.INSTANCE}static has(L){return l.create(L)}static equals(L,x){return D.create(L,x)}static notEquals(L,x){return y.create(L,x)}static regex(L,x){return z.create(L,x)}static in(L,x){return g.create(L,x)}static notIn(L,x){return S.create(L,x)}static not(L){return P.create(L)}static and(...L){return fe.create(L,null,!0)}static or(...L){return De.create(L,null,!0)}static greater(L,x){return W.create(L,x)}static greaterEquals(L,x){return V.create(L,x)}static smaller(L,x){return q.create(L,x)}static smallerEquals(L,x){return R.create(L,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$gj=t;function p(re){const L=new h({regexParsingWithErrorRecovery:!1});return re.map(x=>(L.parse(x),L.lexingErrors.length>0?L.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,A.localize)(9,null,ve.additionalInfo):(0,A.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function c(re,L){const x=re?re.substituteConstants():void 0,ve=L?L.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function $(re,L){return re.cmp(L)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return v.INSTANCE}}e.$jj=w;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}e.$kj=v;class l{static create(L,x=null){const ve=d.get(L);return typeof ve=="boolean"?ve?v.INSTANCE:w.INSTANCE:new l(L,x)}constructor(L,x){this.key=L,this.c=x,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=d.get(this.key);return typeof L=="boolean"?L?v.INSTANCE:w.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$lj=l;class D{static create(L,x,ve=null){if(typeof x=="boolean")return x?l.create(L,ve):P.create(L,ve);const Oe=d.get(L);return typeof Oe=="boolean"?x===(Oe?"true":"false")?v.INSTANCE:w.INSTANCE:new D(L,x,ve)}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=d.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?v.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$mj=D;class g{static create(L,x){return new g(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.f),ve=L.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?F.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$nj=g;class S{static create(L,x){return new S(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=11,this.c=g.create(L,x)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=S;class y{static create(L,x,ve=null){if(typeof x=="boolean")return x?P.create(L,ve):l.create(L,ve);const Oe=d.get(L);return typeof Oe=="boolean"?x===(Oe?"true":"false")?w.INSTANCE:v.INSTANCE:new y(L,x,ve)}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=d.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?w.INSTANCE:v.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$pj=y;class P{static create(L,x=null){const ve=d.get(L);return typeof ve=="boolean"?ve?w.INSTANCE:v.INSTANCE:new P(L,x)}constructor(L,x){this.c=L,this.d=x,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=d.get(this.c);return typeof L=="boolean"?L?w.INSTANCE:v.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$qj=P;function C(re,L){if(typeof re=="string"){const x=parseFloat(re);isNaN(x)||(re=x)}return typeof re=="string"||typeof re=="number"?L(re):w.INSTANCE}class W{static create(L,x,ve=null){return C(x,Oe=>new W(L,Oe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$rj=W;class V{static create(L,x,ve=null){return C(x,Oe=>new V(L,Oe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$sj=V;class q{static create(L,x,ve=null){return C(x,Oe=>new q(L,Oe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$tj=q;class R{static create(L,x,ve=null){return C(x,Oe=>new R(L,Oe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$uj=R;class z{static create(L,x){return new z(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const x=this.f?this.f.source:"",ve=L.f?L.f.source:"";return x<ve?-1:x>ve?1:0}equals(L){if(L.type===this.type){const x=this.f?this.f.source:"",ve=L.f?L.f.source:"";return this.d===L.d&&x===ve}return!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$vj=z;class G{static create(L){return new G(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new G(this.c.map(L))}negate(){return this.c}}e.$wj=G;function ie(re){let L=null;for(let x=0,ve=re.length;x<ve;x++){const Oe=re[x].substituteConstants();if(re[x]!==Oe&&L===null){L=[];for(let ye=0;ye<x;ye++)L[ye]=re[ye]}L!==null&&(L[x]=Oe)}return L===null?re:L}class fe{static create(L,x,ve){return fe.d(L,x,ve)}constructor(L,x){this.expr=L,this.c=x,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Oe=$(this.expr[x],L.expr[x]);if(Oe!==0)return Oe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=ie(this.expr);return L===this.expr?this:fe.create(L,this.c,!1)}evaluate(L){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(L))return!1;return!0}static d(L,x,ve){const Oe=[];let ye=!1;for(const pe of L)if(pe){if(pe.type===1){ye=!0;continue}if(pe.type===0)return w.INSTANCE;if(pe.type===6){Oe.push(...pe.expr);continue}Oe.push(pe)}if(Oe.length===0&&ye)return v.INSTANCE;if(Oe.length!==0){if(Oe.length===1)return Oe[0];Oe.sort($);for(let pe=1;pe<Oe.length;pe++)Oe[pe-1].equals(Oe[pe])&&(Oe.splice(pe,1),pe--);if(Oe.length===1)return Oe[0];for(;Oe.length>1;){const pe=Oe[Oe.length-1];if(pe.type!==9)break;Oe.pop();const de=Oe.pop(),J=Oe.length===0,Y=De.create(pe.expr.map(ue=>fe.create([ue,de],null,ve)),null,J);Y&&(Oe.push(Y),Oe.sort($))}if(Oe.length===1)return Oe[0];if(ve){for(let pe=0;pe<Oe.length;pe++)for(let de=pe+1;de<Oe.length;de++)if(Oe[pe].negate().equals(Oe[de]))return w.INSTANCE;if(Oe.length===1)return Oe[0]}return new fe(Oe,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new fe(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());this.c=De.create(L,this,!0)}return this.c}}e.$xj=fe;class De{static create(L,x,ve){return De.d(L,x,ve)}constructor(L,x){this.expr=L,this.c=x,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Oe=$(this.expr[x],L.expr[x]);if(Oe!==0)return Oe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=ie(this.expr);return L===this.expr?this:De.create(L,this.c,!1)}evaluate(L){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(L))return!0;return!1}static d(L,x,ve){let Oe=[],ye=!1;if(L){for(let pe=0,de=L.length;pe<de;pe++){const J=L[pe];if(J){if(J.type===0){ye=!0;continue}if(J.type===1)return v.INSTANCE;if(J.type===9){Oe=Oe.concat(J.expr);continue}Oe.push(J)}}if(Oe.length===0&&ye)return w.INSTANCE;Oe.sort($)}if(Oe.length!==0){if(Oe.length===1)return Oe[0];for(let pe=1;pe<Oe.length;pe++)Oe[pe-1].equals(Oe[pe])&&(Oe.splice(pe,1),pe--);if(Oe.length===1)return Oe[0];if(ve){for(let pe=0;pe<Oe.length;pe++)for(let de=pe+1;de<Oe.length;de++)if(Oe[pe].negate().equals(Oe[de]))return v.INSTANCE;if(Oe.length===1)return Oe[0]}return new De(Oe,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new De(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());for(;L.length>1;){const x=L.shift(),ve=L.shift(),Oe=[];for(const ye of Le(x))for(const pe of Le(ve))Oe.push(fe.create([ye,pe],null,!1));L.unshift(De.create(Oe,null,!1))}this.c=De.create(L,this,!0)}return this.c}}e.$yj=De;class we extends l{static{this.d=[]}static all(){return we.d.values()}constructor(L,x,ve){super(L,null),this.f=x,typeof ve=="object"?we.d.push({...ve,key:L}):ve!==!0&&we.d.push({key:L,description:ve,type:x!=null?typeof x:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return D.create(this.key,L)}notEqualsTo(L){return y.create(this.key,L)}}e.$zj=we,e.$Aj=(0,N.$ii)("contextKeyService");function oe(re,L){return re<L?-1:re>L?1:0}function $e(re,L,x,ve){return re<x?-1:re>x?1:L<ve?-1:L>ve?1:0}function ne(re,L){if(re.type===0||L.type===1)return!0;if(re.type===9)return L.type===9?Se(re.expr,L.expr):!1;if(L.type===9){for(const x of L.expr)if(ne(re,x))return!0;return!1}if(re.type===6){if(L.type===6)return Se(L.expr,re.expr);for(const x of re.expr)if(ne(x,L))return!0;return!1}return re.equals(L)}function Se(re,L){let x=0,ve=0;for(;x<re.length&&ve<L.length;){const Oe=re[x].cmp(L[ve]);if(Oe<0)return!1;Oe===0&&x++,ve++}return x===re.length}function Le(re){return re.type===9?re.expr:[re]}}),define(Ce[189],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,I.$ii)("environmentService"),e.$qi=(0,I.$ji)(e.$pi)}),define(Ce[98],Pe([1,0,155,3]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=M,e.$Mo=N,e.$No=A,e.$Oo=m,e.$Po=d,e.$Qo=k,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,a){return a==="web"&&!i.includes("web")}function d(i,a,h){return m(a,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var F;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(F||(e.SortBy=F={}));var E;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Ro=(0,O.$ii)("extensionGalleryService");var f;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var r;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$So=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$To=n,e.$Uo=(0,O.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,O.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,O.$ii)("IExtensionTipsService"),e.$Zo=(0,I.localize2)(0,"Extensions"),e.$1o=(0,I.localize2)(1,"Preferences")}),define(Ce[43],Pe([1,0,51,19,15,16,2,157,3,21,12,40]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=u,e.$Qk=r,e.$Rk=s,e.$Sk=n,e.$Tk=i,e.$Uk=a,e.$Vk=h,e.$Wk=t,e.$Xk=p,e.$Yk=c,e.$Zk=$,e.$2k=l,e.$3k=D,e.$4k=g,e.$5k=S,e.$6k=y,e.$9k=q,e.$il=De,e.$jl=we,e.$ll=$e,e.$Ok=(0,d.$ii)("fileService");function u(ne){return ne.create===!0}var b;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(f||(e.FilePermission=f={}));function r(ne){const Se=ne;return!!Se&&typeof Se.onDidChange=="function"}var o;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(ne){return!!(ne.capabilities&2)}function n(ne){return!!(ne.capabilities&8)}function i(ne){return!!(ne.capabilities&131072)}function a(ne){return!!(ne.capabilities&4)}function h(ne){return!!(ne.capabilities&16)}function t(ne){return s(ne)?!!(ne.capabilities&16384):!1}function p(ne){return s(ne)?!!(ne.capabilities&32768):!1}function c(ne){return!!(ne.capabilities&65536)}function $(ne){return!!(ne.capabilities&2048)}var w;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class v extends Error{static create(Se,Le){const re=new v(Se.toString(),Le);return g(re,Le),re}constructor(Se,Le){super(Se),this.code=Le}}e.$1k=v;function l(ne,Se){return v.create(ne,Se)}function D(ne){return ne||l((0,m.localize)(0,null),w.Unknown)}function g(ne,Se){return ne.name=Se?`${Se} (FileSystemError)`:"FileSystemError",ne}function S(ne){if(!ne)return w.Unknown;if(ne instanceof v)return ne.code;const Se=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Se)return w.Unknown;switch(Se[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function y(ne){if(ne instanceof R)return ne.fileOperationResult;switch(S(ne)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}var P;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class C{constructor(Se,Le,re){this.resource=Se,this.operation=Le,this.target=re}isOperation(Se){return this.operation===Se}}e.$7k=C;var W;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class V{static{this.a=null}constructor(Se,Le){this.c=Le,this.b=void 0,this.d=new E.$V(()=>{const re=I.$oi.forUris(()=>this.c);return re.fill(this.rawAdded.map(L=>[L,!0])),re}),this.f=new E.$V(()=>{const re=I.$oi.forUris(()=>this.c);return re.fill(this.rawUpdated.map(L=>[L,!0])),re}),this.g=new E.$V(()=>{const re=I.$oi.forUris(()=>this.c);return re.fill(this.rawDeleted.map(L=>[L,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of Se){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==V.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(Se,...Le){return this.h(Se,{includeChildren:!1},...Le)}affects(Se,...Le){return this.h(Se,{includeChildren:!0},...Le)}h(Se,Le,...re){if(!Se)return!1;const L=re.length>0;return!!((!L||re.includes(1))&&(this.d.value.get(Se)||Le.includeChildren&&this.d.value.findSuperstr(Se))||(!L||re.includes(0))&&(this.f.value.get(Se)||Le.includeChildren&&this.f.value.findSuperstr(Se))||(!L||re.includes(2))&&(this.g.value.findSubstr(Se)||Le.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$8k=V;function q(ne,Se,Le){return!ne||!Se||ne===Se||Se.length>ne.length?!1:(Se.charAt(Se.length-1)!==O.sep&&(Se+=O.sep),Le?(0,M.$mf)(ne,Se):ne.indexOf(Se)===0)}class R extends Error{constructor(Se,Le,re){super(Se),this.fileOperationResult=Le,this.options=re}}e.$0k=R;class z extends R{constructor(Se,Le,re,L){super(Se,Le,L),this.fileOperationResult=Le,this.size=re}}e.$$k=z;class G extends R{constructor(Se,Le,re){super(Se,2,re),this.stat=Le}}e.$_k=G;var ie;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var fe;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$hl="";function De(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function we(ne,Se){if(!Se.hasProvider(A.URI.from({scheme:ne.scheme})))return new Promise(Le=>{const re=Se.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===ne.scheme&&L.added&&(re.dispose(),Le())})})}class oe{static{this.KB=1024}static{this.MB=oe.KB*oe.KB}static{this.GB=oe.MB*oe.KB}static{this.TB=oe.GB*oe.KB}static formatSize(Se){return(0,N.$Zf)(Se)||(Se=0),Se<oe.KB?(0,m.localize)(1,null,Se.toFixed(0)):Se<oe.MB?(0,m.localize)(2,null,(Se/oe.KB).toFixed(2)):Se<oe.GB?(0,m.localize)(3,null,(Se/oe.MB).toFixed(2)):Se<oe.TB?(0,m.localize)(4,null,(Se/oe.GB).toFixed(2)):(0,m.localize)(5,null,(Se/oe.TB).toFixed(2))}}e.$kl=oe;function $e(ne){const Se=typeof ne=="string"||ne?.scheme===F.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===F.Schemas.file?1024*oe.MB:Se?10*oe.MB:k.$o?50*oe.MB:1024*oe.MB}}),define(Ce[71],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class I{constructor(...M){this.a=new Map;for(const[N,A]of M)this.set(N,A)}set(M,N){const A=this.a.get(M);return this.a.set(M,N),A}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$gi=I}),define(Ce[190],Pe([1,0,11,14,6,70,188,3,71,191]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const F=!1;class E extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new d.$gi,s=!1,n,i=F){this.f=o,this.g=s,this.h=n,this.i=i,this.o=new Set,this.f.set(m.$hi,this),this._globalGraph=i?n?._globalGraph??new A.$Xq(a=>a):void 0}createChild(o){return new u(o,this.g,this,this.i)}invokeFunction(o,...s){const n=f.traceInvocation(this.i,o);let i=!1;try{return o({get:h=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,n.stop()}}createInstance(o,...s){let n,i;return o instanceof N.$fi?(n=f.traceCreation(this.i,o.ctor),i=this.j(o.ctor,o.staticArguments.concat(s),n)):(n=f.traceCreation(this.i,o),i=this.j(o,s,n)),n.stop(),i}j(o,s=[],n){const i=m._util.getServiceDependencies(o).sort((t,p)=>t.index-p.index),a=[];for(const t of i){const p=this.m(t.id,n);p||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(p)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(a))}k(o,s){if(this.f.get(o)instanceof N.$fi)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof N.$fi?this.q(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}q(o,s,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,n)}finally{this.o.delete(o)}}r(o,s,n){const i=new A.$Xq(t=>t.id.toString());let a=0;const h=[{id:o,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new E(i);for(const p of m._util.getServiceDependencies(t.desc.ctor)){const c=this.l(p.id);if(c||this.u(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(p.id)),c instanceof N.$fi){const $={id:p.id,desc:c,_trace:t._trace.branch(p.id,!0)};i.insertEdge(t,$),h.push($)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:p}of t){if(this.l(p.id)instanceof N.$fi){const $=this.s(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.k(p.id,$)}i.removeNode(p)}}return this.l(o)}s(o,s,n=[],i,a){if(this.f.get(o)instanceof N.$fi)return this.t(o,s,n,i,a);if(this.h)return this.h.s(o,s,n,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,n=[],i,a){if(i){const h=new u(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,p=new I.$Bh(()=>{const c=h.j(s,n,a);for(const[$,w]of t){const v=c[$];if(typeof v=="function")for(const l of w)l.disposable=v.apply(c,l.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,$){if(!p.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let l=t.get($);return l||(l=new k.$5c,t.set($,l)),(g,S,y)=>{if(p.isInitialized)return p.value[$](g,S,y);{const P={listener:[g,S,y],disposable:void 0},C=l.push(P);return(0,M.$Sc)(()=>{C(),P.disposable?.dispose()})}}}if($ in c)return c[$];const w=p.value;let v=w[$];return typeof v!="function"||(v=v.bind(w),c[$]=v),v},set(c,$,w){return p.value[$]=w,!0},getPrototypeOf(c){return s.prototype}})}else return this.j(s,n,a)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$Yq=u;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new f(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,s){return o?new f(1,s.name):f.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const n=new f(3,o.toString());return this.h.push([o,s,n]),n}stop(){const o=Date.now()-this.g;f.f+=o;let s=!1;function n(a,h){const t=[],p=new Array(a+1).join("	");for(const[c,$,w]of h.h)if($&&w){s=!0,t.push(`${p}CREATES -> ${c}`);const v=n(a+1,w);v&&t.push(v)}else t.push(`${p}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||s)&&f.all.add(i.join(`
`))}}e.$Zq=f}),define(Ce[13],Pe([1,0,158,42,5,99,6,28,21,23,16,2,33,3]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=r,e.log=s,e.$3j=l,e.$4j=D,e.$5j=g,e.$6j=S,e.$Oj=(0,b.$ii)("logService"),e.$Pj=(0,b.$ii)("loggerService");function f(){return new Date().toISOString()}function r(y){return(0,F.$Zf)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Rj=o.Info;function s(y,P,C){switch(P){case o.Trace:y.trace(C);break;case o.Debug:y.debug(C);break;case o.Info:y.info(C);break;case o.Warning:y.warn(C);break;case o.Error:y.error(C);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(y,P=!1){let C="";for(let W=0;W<y.length;W++){let V=y[W];if(V instanceof Error&&(V=(0,O.$6i)(V,P)),typeof V=="object")try{V=JSON.stringify(V)}catch{}C+=(W>0?" ":"")+V}return C}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new M.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==o.Off&&this.b<=P}}e.$Tj=i;class a extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...C){this.f(o.Trace)&&this.g(o.Trace,n([P,...C],!0))}debug(P,...C){this.f(o.Debug)&&this.g(o.Debug,n([P,...C]))}info(P,...C){this.f(o.Info)&&this.g(o.Info,n([P,...C]))}warn(P,...C){this.f(o.Warning)&&this.g(o.Warning,n([P,...C]))}error(P,...C){if(this.f(o.Error))if(P instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=P.stack,this.g(o.Error,n(W))}else this.g(o.Error,n([P,...C]))}flush(){}}e.$Uj=a;class h extends i{constructor(P=e.$Rj){super(),this.setLevel(P),this.g=!d.$i}trace(P,...C){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,P,...C):console.log(`[main ${f()}]`,P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,P,...C):console.log(`[main ${f()}]`,P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,P,...C):console.log(`[main ${f()}]`,P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,P,...C):console.warn(`[main ${f()}]`,P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,P,...C):console.error(`[main ${f()}]`,P,...C))}flush(){}}e.$Vj=h;class t extends i{constructor(P=e.$Rj,C=!0){super(),this.g=C,this.setLevel(P)}trace(P,...C){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...C):console.log(P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...C):console.log(P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...C):console.log(P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...C):console.log(P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...C):console.error(P,...C))}flush(){}}e.$Wj=t;class p extends i{constructor(P,C=e.$Rj){super(),this.g=P,this.setLevel(C)}trace(P,...C){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(P),...C])}debug(P,...C){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(P),...C])}info(P,...C){this.f(o.Info)&&this.g.log(o.Info,[this.h(P),...C])}warn(P,...C){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(P),...C])}error(P,...C){this.f(o.Error)&&this.g.log(o.Error,[this.h(P),...C])}h(P){return typeof P=="string"?P:(0,O.$6i)(P,this.f(o.Trace))}flush(){}}e.$Xj=p;class c extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const C of this.g)C.setLevel(P);super.setLevel(P)}trace(P,...C){for(const W of this.g)W.trace(P,...C)}debug(P,...C){for(const W of this.g)W.debug(P,...C)}info(P,...C){for(const W of this.g)W.info(P,...C)}warn(P,...C){for(const W of this.g)W.warn(P,...C)}error(P,...C){for(const W of this.g)W.error(P,...C)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$Yj=c;class $ extends A.$Uc{constructor(P,C,W){if(super(),this.h=P,this.j=C,this.b=new m.$Bc,this.c=this.B(new M.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$7d),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(P){return(0,F.$Vf)(P)?[...this.b.values()].find(C=>C.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,C){const W=this.n(P),V=(0,F.$Vf)(P)?P:C?.id??(0,N.$9i)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const R=C?.logLevel==="always"?o.Trace:C?.logLevel;q||(q=this.s(W,R??this.getLogLevel(W)??this.h,{...C,id:V}));const z={logger:q,info:{resource:W,id:V,logLevel:R,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(z.info),this.b.set(W,z),q}n(P){return(0,F.$Vf)(P)?(0,k.$Vg)(this.j,`${P}.log`):P}setLogLevel(P,C){if(E.URI.isUri(P)){const W=P,V=C,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=P;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,C){const W=this.m(P);W&&C!==!W.info.hidden&&(W.info.hidden=!C,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,C]))}getLogLevel(P){let C;return P&&(C=this.b.get(P)?.info.logLevel),C??this.h}registerLogger(P){const C=this.b.get(P.resource);C?C.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const C=this.b.get(P);C&&(C.logger&&C.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=$;class w{constructor(){this.onDidChangeLogLevel=new M.$7d().event}setLevel(P){}getLevel(){return o.Info}trace(P,...C){}debug(P,...C){}info(P,...C){}warn(P,...C){}error(P,...C){}critical(P,...C){}dispose(){}flush(){}}e.$1j=w;class v extends w{}e.$2j=v;function l(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const P=S(y.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Rj}function D(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function g(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$7j=new u.$zj("logLevel",D(o.Info))}),define(Ce[192],Pe([1,0,6,13]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=void 0;class M extends I.$Uc{constructor(A,m=[]){super(),this.a=new O.$Yj([A,...m]),this.B(A.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$6P=M}),define(Ce[100],Pe([1,0,32,159,3]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var A;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(d){function k(f,r){return r-f}d.compare=k;const F=Object.create(null);F[d.Error]=(0,O.localize)(0,null),F[d.Warning]=(0,O.localize)(1,null),F[d.Info]=(0,O.localize)(2,null);function E(f){return F[f]||""}d.toString=E;function u(f){switch(f){case I.default.Error:return d.Error;case I.default.Warning:return d.Warning;case I.default.Info:return d.Info;case I.default.Ignore:return d.Hint}}d.fromSeverity=u;function b(f){switch(f){case d.Error:return I.default.Error;case d.Warning:return I.default.Warning;case d.Info:return I.default.Info;case d.Hint:return I.default.Ignore}}d.toSeverity=b}(A||(e.MarkerSeverity=A={}));var m;(function(d){const k="";function F(u){return E(u,!0)}d.makeKey=F;function E(u,b){const f=[k];return u.source?f.push(u.source.replace("\xA6","\\\xA6")):f.push(k),u.code?typeof u.code=="string"?f.push(u.code.replace("\xA6","\\\xA6")):f.push(u.code.value.replace("\xA6","\\\xA6")):f.push(k),u.severity!==void 0&&u.severity!==null?f.push(A.toString(u.severity)):f.push(k),u.message&&b?f.push(u.message.replace("\xA6","\\\xA6")):f.push(k),u.startLineNumber!==void 0&&u.startLineNumber!==null?f.push(u.startLineNumber.toString()):f.push(k),u.startColumn!==void 0&&u.startColumn!==null?f.push(u.startColumn.toString()):f.push(k),u.endLineNumber!==void 0&&u.endLineNumber!==null?f.push(u.endLineNumber.toString()):f.push(k),u.endColumn!==void 0&&u.endColumn!==null?f.push(u.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}d.makeKeyOptionalMessage=E})(m||(e.IMarkerData=m={})),e.$Ut=(0,M.$ii)("markerService")}),define(Ce[193],Pe([1,0,5,32,3]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Lv=e.Severity=void 0,e.$Mv=m,e.Severity=O.default,e.$Lv=(0,M.$ii)("notificationService");var N;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var A;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function m(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var d;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(d||(e.NotificationsFilter=d={}));class k{constructor(){this.progress=new F,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Nv=k;class F{infinite(){}done(){}total(u){}worked(u){}}e.$Ov=F}),define(Ce[194],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,I.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,O){var M=arguments.length,N=M<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,I):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ge,e,I,O);else for(var m=ge.length-1;m>=0;m--)(A=ge[m])&&(N=(M<3?A(N):M>3?A(e,I,N):A(e,I))||N);return M>3&&N&&Object.defineProperty(e,I,N),N},We=this&&this.__param||function(ge,e){return function(I,O){e(I,O,ge)}};define(Ce[101],Pe([1,0,11,24,6,3]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.ProgressLocation=e.$Pv=void 0,e.$Pv=(0,N.$ii)("progressService");var A;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Qv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Rv=m;class d{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$Sv=d;let k=class extends M.$Uc{constructor(u,b){super(),this.a=new I.$Fh,b.withProgress(u,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Tv=k,e.$Tv=k=Je([We(1,e.$Pv)],k);class F extends M.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new M.$Tc)}start(u){this.stop();const b=++this.a,f=new O.$ee;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>f.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:f.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Uv=F,e.$Vv=(0,N.$ii)("editorProgressService")}),define(Ce[30],Pe([1,0,55,16]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class M{constructor(){this.a=new Map}add(A,m){I.ok(O.$Vf(A)),I.ok(O.$Xf(m)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$1n=new M}),define(Ce[72],Pe([1,0,5,30]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function M(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class N{constructor(){this.b=new I.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,k){this.a[M(d)]=k,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;O.$1n.add(e.$2n.JSONContribution,A)}),define(Ce[56],Pe([1,0,18,5,16,152,47,72,30]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=r,e.$fo=o,e.$go=s,e.$ho=i,e.$io=a;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$6n={Configuration:"base.contributions.configuration"};var F;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F||(e.ConfigurationScope=F={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const E=d.$1n.as(m.$2n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new O.$7d,this.onDidSchemaChange=this.i.event,this.j=new O.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(t,p=!0){this.registerConfigurations([t],p)}registerConfigurations(t,p=!0){const c=new Set;this.n(t,p,c),E.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const p=new Set;this.o(t,p),E.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:p})}updateConfigurations({add:t,remove:p}){const c=new Set;this.o(p,c),this.n(t,!1,c),E.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const p=new Set;this.k(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}k(t,p){const c=[];for(const{overrides:$,source:w}of t)for(const v in $)if(p.add(v),e.$do.test(v)){const l=this.a.get(v),D=l?.valuesSources??new Map;if(w)for(const P of Object.keys($[v]))D.set(P,w);const g={...l?.value||{},...$[v]};this.a.set(v,{source:w,value:g,valuesSources:D});const S=(0,A.$Yi)(v),y={type:"object",default:g,description:N.localize(1,null,S),$ref:e.$ao,defaultDefaultValue:g,source:M.$Vf(w)?void 0:w,defaultValueSource:w};c.push(...r(v)),this.d[v]=y,this.b.properties[v]=y}else{this.a.set(v,{value:$[v],source:w});const l=this.d[v];l&&(this.w(v,l),this.r(v,l))}this.m(c)}deregisterDefaultConfigurations(t){const p=new Set;this.l(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}l(t,p){for(const{overrides:c,source:$}of t)for(const w in c){const v=this.a.get(w),l=M.$Vf($)?$:$?.id,D=M.$Vf(v?.source)?v?.source:v?.source?.id;if(l===D)if(p.add(w),this.a.delete(w),e.$do.test(w))delete this.d[w],delete this.b.properties[w];else{const g=this.d[w];g&&(this.w(w,g),this.r(w,g))}}this.u()}deltaConfiguration(t){let p=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),p=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),p=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const p of t)this.h.add(p);this.u()}n(t,p,c){t.forEach($=>{this.p($,p,$.extensionInfo,$.restrictedProperties,void 0,c),this.c.push($),this.q($)})}o(t,p){const c=$=>{if($.properties)for(const w in $.properties){p.add(w);const v=this.d[w];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[w],this.s(w,$.properties[w])}$.allOf?.forEach(w=>c(w))};for(const $ of t){c($);const w=this.c.indexOf($);w!==-1&&this.c.splice(w,1)}}p(t,p=!0,c,$,w=3,v){w=M.$5f(t.scope)?w:t.scope;const l=t.properties;if(l)for(const g in l){const S=l[g];if(p&&i(g,S)){delete l[g];continue}if(S.source=c,S.defaultDefaultValue=l[g].default,this.w(g,S),e.$do.test(g)?S.scope=void 0:(S.scope=M.$5f(S.scope)?w:S.scope,S.restricted=M.$5f(S.restricted)?!!$?.includes(g):S.restricted),l[g].hasOwnProperty("included")&&!l[g].included){this.f[g]=l[g],delete l[g];continue}else this.d[g]=l[g],l[g].policy?.name&&this.e.set(l[g].policy.name,g);!l[g].deprecationMessage&&l[g].markdownDeprecationMessage&&(l[g].deprecationMessage=l[g].markdownDeprecationMessage),v.add(g)}const D=t.allOf;if(D)for(const g of D)this.p(g,p,c,$,w,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const p=c=>{const $=c.properties;if($)for(const v in $)this.r(v,$[v]);c.allOf?.forEach(p)};p(t)}r(t,p){switch(e.$7n.properties[t]=p,p.scope){case 1:e.$8n.properties[t]=p;break;case 2:e.$9n.properties[t]=p;break;case 6:e.$0n.properties[t]=p;break;case 3:e.$$n.properties[t]=p;break;case 4:e.$_n.properties[t]=p;break;case 5:e.$_n.properties[t]=p,this.g.properties[t]=p;break}}s(t,p){switch(delete e.$7n.properties[t],p.scope){case 1:delete e.$8n.properties[t];break;case 2:delete e.$9n.properties[t];break;case 6:delete e.$0n.properties[t];break;case 3:delete e.$$n.properties[t];break;case 4:case 5:delete e.$_n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const p=`[${t}]`,c={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ao};this.w(p,c),e.$7n.properties[p]=c,e.$8n.properties[p]=c,e.$9n.properties[p]=c,e.$0n.properties[p]=c,e.$$n.properties[p]=c,e.$_n.properties[p]=c}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=t,e.$8n.patternProperties[e.$co]=t,e.$9n.patternProperties[e.$co]=t,e.$0n.patternProperties[e.$co]=t,e.$$n.patternProperties[e.$co]=t,e.$_n.patternProperties[e.$co]=t,this.i.fire()}w(t,p){const c=this.a.get(t);let $=c?.value,w=c?.source;M.$3f($)&&($=p.defaultDefaultValue,w=void 0),M.$3f($)&&($=s(p.type)),p.default=$,p.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.$co=`^(${b})+$`,e.$do=new RegExp(e.$co);function r(h){const t=[];if(e.$do.test(h)){let p=f.exec(h);for(;p?.length;){const c=p[1].trim();c&&t.push(c),p=f.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,p)=>`${t}[${p}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new u;d.$1n.add(e.$6n.Configuration,n);function i(h,t){return h.trim()?e.$do.test(h)?N.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function a(){const h=[],t=n.getConfigurationProperties();for(const p of Object.keys(t))h.push([p,t[p].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Ce[195],Pe([1,0,18,5,122,6,28,26,16,2,47,56,30]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=i;function b(p){return Object.isFrozen(p)?p:m.$Pn(p)}class f{constructor(c={},$=[],w=[],v){this.b=c,this.c=$,this.d=w,this.raw=v,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map($=>{if($ instanceof f)return $;const w=new r("");return w.parseRaw($),w.configurationModel});this.f=c.reduce(($,w)=>w===$?w:$.merge(w),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,F.$Wi)(this.contents,c):this.contents}inspect(c,$){const w=this;return{get value(){return b(w.rawConfiguration.getValue(c))},get override(){return $?b(w.rawConfiguration.getOverrideValue(c,$)):void 0},get merged(){return b($?w.rawConfiguration.override($).getValue(c):w.rawConfiguration.getValue(c))},get overrides(){const v=[];for(const{contents:l,identifiers:D,keys:g}of w.rawConfiguration.overrides){const S=new f(l,g).getValue(c);S!==void 0&&v.push({identifiers:D,value:S})}return v.length?b(v):void 0}}}getOverrideValue(c,$){const w=this.i($);return w?c?(0,F.$Wi)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const $=[];for(const w of this.overrides)w.identifiers.includes(c)&&$.push(...w.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const c=[];for(const $ of this.overrides)c.push(...$.identifiers);return I.$Mb(c)}override(c){let $=this.a.get(c);return $||($=this.g(c),this.a.set(c,$)),$}merge(...c){const $=m.$On(this.contents),w=m.$On(this.overrides),v=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of c)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h($,D.contents);for(const g of D.overrides){const[S]=w.filter(y=>I.$ub(y.identifiers,g.identifiers));S?(this.h(S.contents,g.contents),S.keys.push(...g.keys),S.keys=I.$Mb(S.keys)):w.push(m.$On(g))}for(const g of D.keys)v.indexOf(g)===-1&&v.push(g)}return new f($,v,w,l.every(D=>D instanceof f)?void 0:l)}g(c){const $=this.i(c);if(!$||typeof $!="object"||!Object.keys($).length)return this;const w={};for(const v of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let l=this.contents[v];const D=$[v];D&&(typeof l=="object"&&typeof D=="object"?(l=m.$On(l),this.h(l,D)):l=D),w[v]=l}return new f(w,this.keys,this.overrides)}h(c,$){for(const w of Object.keys($)){if(w in c&&d.$Xf(c[w])&&d.$Xf($[w])){this.h(c[w],$[w]);continue}c[w]=m.$On($[w])}}i(c){let $=null,w=null;const v=l=>{l&&(w?this.h(w,l):w=m.$On(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===c?$=l.contents:l.identifiers.includes(c)&&v(l.contents);return v($),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,$){this.j(c,$,!0)}setValue(c,$){this.j(c,$,!1)}removeValue(c){const $=this.keys.indexOf(c);$!==-1&&(this.keys.splice($,1),(0,F.$Vi)(this.contents,c),E.$do.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>I.$ub(w.identifiers,(0,E.$eo)(c))),1))}j(c,$,w){(0,F.$Ui)(this.contents,c,$,v=>console.error(v)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),E.$do.test(c)&&this.overrides.push({identifiers:(0,E.$eo)(c),keys:Object.keys(this.contents[c]),contents:(0,F.$Ti)(this.contents[c],v=>console.error(v))})}}e.$jo=f;class r{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,$){if(!d.$5f(c)){const w=this.g(c);this.parseRaw(w,$)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,$){this.a=c;const{contents:w,keys:v,overrides:l,restricted:D,hasExcludedProperties:g}=this.h(c,$);this.b=new f(w,v,l,g?[c]:void 0),this.c=D||[]}g(c){let $={},w=null,v=[];const l=[],D=[];function g(y){Array.isArray(v)?v.push(y):w!==null&&(v[w]=y)}const S={onObjectBegin:()=>{const y={};g(y),l.push(v),v=y,w=null},onObjectProperty:y=>{w=y},onObjectEnd:()=>{v=l.pop()},onArrayBegin:()=>{const y=[];g(y),l.push(v),v=y,w=null},onArrayEnd:()=>{v=l.pop()},onLiteralValue:g,onError:(y,P,C)=>{D.push({error:y,offset:P,length:C})}};if(c)try{M.$Cn(c,S),$=v[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return $}h(c,$){const w=u.$1n.as(E.$6n.Configuration).getConfigurationProperties(),v=this.i(c,w,!0,$);c=v.raw;const l=(0,F.$Ti)(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(c),g=this.j(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:D,overrides:g,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}i(c,$,w,v){let l=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:l};const D={},g=[];for(const S in c)if(E.$do.test(S)&&w){const y=this.i(c[S],$,!1,v);D[S]=y.raw,l=l||y.hasExcludedProperties,g.push(...y.restricted)}else{const y=$[S],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&g.push(S),!v.exclude?.includes(S)&&(v.include?.includes(S)||(P===void 0||v.scopes===void 0||v.scopes.includes(P))&&!(v.skipRestricted&&y?.restricted))?D[S]=c[S]:l=!0}return{raw:D,restricted:g,hasExcludedProperties:l}}j(c,$){const w=[];for(const v of Object.keys(c))if(E.$do.test(v)){const l={};for(const D in c[v])l[D]=c[v][D];w.push({identifiers:(0,E.$eo)(v),keys:Object.keys(l),contents:(0,F.$Ti)(l,$)})}return w}}e.$ko=r;class o extends N.$Uc{constructor(c,$,w,v){super(),this.c=c,this.f=$,this.g=v,this.b=this.B(new O.$7d),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&w.isEqual(l.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new f}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=o;class s{constructor(c,$,w,v,l,D,g,S,y,P,C,W,V){this.a=c,this.b=$,this.c=w,this.overrideIdentifiers=v,this.d=l,this.f=D,this.g=g,this.h=S,this.i=y,this.j=P,this.k=C,this.l=W,this.m=V}get value(){return b(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(c,$,w,v,l=new f,D=new f,g=new A.$Bc,S=new f,y=new A.$Bc){this.c=c,this.d=$,this.f=w,this.g=v,this.h=l,this.i=D,this.j=g,this.l=S,this.m=y,this.a=null,this.b=new A.$Bc,this.n=null}getValue(c,$,w){return this.p(c,$,w).getValue(c)}updateValue(c,$,w={}){let v;w.resource?(v=this.m.get(w.resource),v||(v=new f,this.m.set(w.resource,v))):v=this.l,$===void 0?v.removeValue(c):v.setValue(c,$),w.resource||(this.a=null)}inspect(c,$,w){const v=this.p(c,$,w),l=this.t($.resource,w),D=$.resource?this.m.get($.resource)||this.l:this.l,g=new Set;for(const S of v.overrides)for(const y of S.identifiers)v.getOverrideValue(c,y)!==void 0&&g.add(y);return new s(c,$,v.getValue(c),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,l||void 0,D)}keys(c){const $=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,$){this.j.set(c,$),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,$){const w=[];if(!$){const{added:v,updated:l,removed:D}=h(this.c,c);$=[...v,...l,...D]}for(const v of $)for(const l of(0,E.$eo)(v)){const D=this.c.getKeysForOverrideIdentifier(l),g=c.getKeysForOverrideIdentifier(l),S=[...g.filter(y=>D.indexOf(y)===-1),...D.filter(y=>g.indexOf(y)===-1),...D.filter(y=>!m.$Sn(this.c.override(l).getValue(y),c.override(l).getValue(y)))];w.push([l,S])}return this.updateDefaultConfiguration(c),{keys:$,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:$,updated:w,removed:v}=h(this.d,c),l=[...$,...w,...v];return l.length&&this.updatePolicyConfiguration(c),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:$,updated:w,removed:v,overrides:l}=h(this.applicationConfiguration,c),D=[...$,...w,...v];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(c){const{added:$,updated:w,removed:v,overrides:l}=h(this.localUserConfiguration,c),D=[...$,...w,...v];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:$,updated:w,removed:v,overrides:l}=h(this.remoteUserConfiguration,c),D=[...$,...w,...v];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:$,updated:w,removed:v,overrides:l}=h(this.workspaceConfiguration,c),D=[...$,...w,...v];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(c,$){const w=this.folderConfigurations.get(c),{added:v,updated:l,removed:D,overrides:g}=h(w,$),S=[...v,...l,...D];return(S.length||!w)&&this.updateFolderConfiguration(c,$),{keys:S,overrides:g}}compareAndDeleteFolderConfiguration(c){const $=this.folderConfigurations.get(c);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:v,removed:l,overrides:D}=h($,void 0);return{keys:[...w,...v,...l],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,$,w){let v=this.q($,w);return $.overrideIdentifier&&(v=v.override($.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(v=v.merge(this.d)),v}q({resource:c},$){let w=this.r();if($&&c){const v=$.getFolder(c);v&&(w=this.s(v.uri)||w);const l=this.m.get(c);l&&(w=w.merge(l))}return w}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let $=this.b.get(c);if(!$){const w=this.r(),v=this.j.get(c);v?($=w.merge(v),this.b.set(c,$)):$=w}return $}t(c,$){if($&&c){const w=$.getFolder(c);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,$)=>{const{contents:w,overrides:v,keys:l}=this.j.get($);return c.push([$,{contents:w,overrides:v,keys:l}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach($=>c.add($)),this.userConfiguration.keys.forEach($=>c.add($)),this.i.keys.forEach($=>c.add($)),this.j.forEach($=>$.keys.forEach(w=>c.add(w))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach($=>c.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>c.add($)),this.i.getAllOverrideIdentifiers().forEach($=>c.add($)),this.j.forEach($=>$.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}v(c){const $=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.i.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(v=>$.add(v))),[...$.values()]}static parse(c){const $=this.w(c.defaults),w=this.w(c.policy),v=this.w(c.application),l=this.w(c.user),D=this.w(c.workspace),g=c.folders.reduce((S,y)=>(S.set(k.URI.revive(y[0]),this.w(y[1])),S),new A.$Bc);return new n($,w,v,l,new f,D,g,new f,new A.$Bc)}static w(c){return new f(c.contents,c.keys,c.overrides)}}e.$mo=n;function i(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const c=new Set,$=new Map;for(const v of p)v.keys.forEach(l=>c.add(l)),v.overrides.forEach(([l,D])=>{const g=(0,A.$yc)($,l,new Set);D.forEach(S=>g.add(S))});const w=[];return $.forEach((v,l)=>w.push([l,[...v.values()]])),{keys:[...c.values()],overrides:w}}class a{constructor(c,$,w,v){this.change=c,this.f=$,this.g=w,this.h=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of c.keys)this.affectedKeys.add(l);for(const[,l]of c.overrides)for(const D of l)this.affectedKeys.add(D);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,$){const w=this.a+c,v=this.d.indexOf(w);if(v<0)return!1;const l=v+w.length;if(l>=this.d.length)return!1;const D=this.d.charCodeAt(l);if(D!==this.b&&D!==this.c)return!1;if($){const g=this.previousConfiguration?this.previousConfiguration.getValue(c,$,this.f?.workspace):void 0,S=this.g.getValue(c,$,this.h);return!m.$Sn(g,S)}return!0}}e.$oo=a;function h(p,c){const{added:$,removed:w,updated:v}=t(c?.rawConfiguration,p?.rawConfiguration),l=[],D=p?.getAllOverrideIdentifiers()||[],g=c?.getAllOverrideIdentifiers()||[];if(c){const S=g.filter(y=>!D.includes(y));for(const y of S)l.push([y,c.getKeysForOverrideIdentifier(y)])}if(p){const S=D.filter(y=>!g.includes(y));for(const y of S)l.push([y,p.getKeysForOverrideIdentifier(y)])}if(c&&p){for(const S of D)if(g.includes(S)){const y=t({contents:p.getOverrideValue(void 0,S)||{},keys:p.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});l.push([S,[...y.added,...y.removed,...y.updated]])}}return{added:$,removed:w,updated:v,overrides:l}}function t(p,c){const $=p?c?p.keys.filter(l=>c.keys.indexOf(l)===-1):[...p.keys]:[],w=c?p?c.keys.filter(l=>p.keys.indexOf(l)===-1):[...c.keys]:[],v=[];if(p&&c){for(const l of c.keys)if(p.keys.indexOf(l)!==-1){const D=(0,F.$Wi)(c.contents,l),g=(0,F.$Wi)(p.contents,l);m.$Sn(D,g)||v.push(l)}}return{added:$,removed:w,updated:v}}}),define(Ce[102],Pe([1,0,14,3]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=k,e.$tl=(0,O.$ii)("remoteAuthorityResolverService");var M;(function(F){F[F.WebSocket=0]="WebSocket",F[F.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class N{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=N;class A{constructor(E,u){this.host=E,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=A;var m;(function(F){F.Unknown="Unknown",F.NotAvailable="NotAvailable",F.TemporarilyNotAvailable="TemporarilyNotAvailable",F.NoResolverFound="NoResolverFound",F.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class d extends I.$bb{static isNotAvailable(E){return E instanceof d&&E._code===m.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof d&&E._code===m.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof d&&E._code===m.NoResolverFound}static isInvalidAuthority(E){return E instanceof d&&E._code===m.InvalidAuthority}static isHandled(E){return E instanceof d&&E.isHandled}constructor(E,u=m.Unknown,b){super(E),this._message=E,this._code=u,this._detail=b,this.isHandled=u===m.NotAvailable&&b===!0,Object.setPrototypeOf(this,d.prototype)}}e.$wl=d;function k(F){const E=F.indexOf("+");return E===-1?F:F.substring(0,E)}}),define(Ce[57],Pe([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=O,e.$um=M,e.$vm=N,e.$wm=A;function O(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}function M(d){if(!d)return;const k=d.indexOf("+");return k<0?d:d.substr(0,k)}function N(d){const{host:k,port:F}=m(d);if(typeof F>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:F}}function A(d,k){let{host:F,port:E}=m(d);return typeof E>"u"&&(E=k),{host:F,port:E}}function m(d){const k=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const F=d.match(/^(\[[0-9a-z:]+\])$/);if(F)return{host:F[1],port:void 0};const E=d.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:d,port:void 0}}}),define(Ce[20],Pe([1,0,15,3,57]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=N,e.$Gm=E,e.$Hm=u,e.$Im=b,e.$Jm=f,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class d{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return I.$lf(n,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Dm=d;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(d.toKey(o))}delete(o){return this.c.delete(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}}e.$Em=k;class F{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(d.toKey(o))}get(o){return this.c.get(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}set(o,s){this.c.set(d.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=F;function E(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function b(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function f(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,M.$um)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Km=(0,O.$ii)("IBuiltinExtensionsScannerService")}),define(Ce[103],Pe([1,0,14,20]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=e.$NF=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const d of A){const k=this.readActivationEvents(d);k.length>0&&(m[O.$Dm.toKey(d.identifier)]=k)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let d=0;d<m.length;d++)m[d]==="onUri"&&(m[d]=`onUri:${O.$Dm.toKey(A.identifier)}`);if(!A.contributes)return m;for(const d in A.contributes){const k=this.a.get(d);if(!k)continue;const F=A.contributes[d],E=Array.isArray(F)?F:[F];try{k(E,m)}catch(u){(0,I.$1)(u)}}return m}}e.$NF=M,e.$OF=new M}),define(Ce[196],Pe([1,0,21,73,34]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=A,e.$3o=m;function N(d){if(I.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function A(d,k,F,E,u,b,f,r,o){const s=Object.create(null);s["common.machineId"]=b,s["common.sqmId"]=f,s.sessionID=(0,M.$Eg)()+Date.now(),s.commitHash=E,s.version=u,s["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=O.$ec,s["common.nodeArch"]=F,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const a=N(k);return a&&(s["common.platformDetail"]=a),s}function m(d){const k=O.env.USERDNSDOMAIN;if(!k)return!1;const F=k.toLowerCase();return d.some(E=>F===E)}}),define(Ce[197],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,I.$ii)("telemetryService"),e.$Ol=(0,I.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var M;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Ce[58],Pe([1,0,26,16,57,196,197]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=F,e.$_o=E,e.$ap=u,e.$bp=b,e.$cp=r,e.$dp=s,e.$ep=n,e.$fp=h;class m{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$4o=m;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=d,e.$6o=new d;class k{async publicLog(p,c,$){}async publicLogError(p,c,$){}}e.$7o=k,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function F(t,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!t.enableTelemetry)}function E(t,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const p=t.getValue(A.$Vl),c=t.getValue(A.$Wl);if(t.getValue(A.$Xl)===!1||c===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const p={},c={},$={};o(t,$);for(let w in $){w=w.length>150?w.substr(w.length-149):w;const v=$[w];typeof v=="number"?c[w]=v:typeof v=="boolean"?c[w]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${v.length}`),p[w]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(p[w]=v)}return{properties:p,measurements:c}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const p=(0,M.$um)(t);return f.has(p)?p:"other"}function o(t,p,c=0,$){if(t)for(const w of Object.getOwnPropertyNames(t)){const v=t[w],l=$?$+w:w;Array.isArray(v)?p[l]=(0,I.$Tn)(v):v instanceof Date?p[l]=v.toISOString():(0,O.$Xf)(v)?c<2?o(v,p,c+1,l+"."):p[l]=(0,I.$Tn)(v):p[l]=v}}function s(t,p){const c=t.msftInternalDomains||[],$=p.getValue("telemetry.internalTesting");return(0,N.$3o)(c)||$}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,p){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const $=[];for(const D of p)for(;;){const g=D.exec(t);if(!g)break;$.push([g.index,D.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(c="";;){const D=v.exec(t);if(!D)break;const g=$.some(([S,y])=>D.index<y&&S<v.lastIndex);!w.test(D[0])&&!g&&(c+=t.substring(l,D.index)+"<REDACTED: user-file-path>",l=v.lastIndex)}return l<t.length&&(c+=t.substr(l)),c}function a(t){if(!t)return t;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of p)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,p){return(0,I.$Qn)(t,c=>{if(c instanceof m||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=i($,p);for(const w of p)$=$.replace(w,"");return $=a($),$}})}}),define(Ce[198],Pe([1,0,15,98,20,21,2,14,73,58]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=F,e.$ip=f,e.$jp=r,e.$kp=o,e.$lp=s,e.$mp=n,e.$np=i,e.$op=a,e.$qp=h,e.$rp=p;function F(c,$){return c.uuid&&$.uuid?c.uuid===$.uuid:c.id===$.id?!0:(0,I.$gf)(c.id,$.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const w=$.manifest?$.manifest.version:$.version,v=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,w,v)}static parse($){const w=E.exec($);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor($,w,v="undefined"){this.version=w,this.targetPlatform=v,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?F(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$hp=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(c){const $=b.exec(c);return $&&$[1]?[o($[1]),$[2]]:[o(c),void 0]}function r(c,$){return`${c}.${$}`}function o(c){return c.toLowerCase()}function s(c,$){return o(r(c??M.$zm,$))}function n(c,$){const w=[],v=l=>{for(const D of w)if(D.some(g=>F($(g),$(l))))return D;return null};for(const l of c){const D=v(l);D?D.push(l):w.push([l])}return w}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new k.$4o(c.identifier.id),name:new k.$4o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$pp=new M.$Dm("pprice.better-merge");function h(c,$){const w=[],v=$.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const l=v.shift();if(l&&w.every(D=>!F(D.identifier,{id:l}))){const D=c.filter(g=>F(g.identifier,{id:l}));D.length===1&&(w.push(D[0]),v.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(c,$){if(!N.$k)return!1;let w;try{w=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){$.debug("Error while getting the os-release file.",(0,m.$0)(l))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function p(c,$){const w=await t(c,$),v=(0,O.$No)(w?"alpine":N.$u,d.$fc);return $.debug("ComputeTargetPlatform:",v),v}}),define(Ce[199],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=I,e.$8r=O,e.$9r=M,e.$0r=N,e.$$r=A,e.$_r=m;function I(d){return[...d.entries()]}function O(d){return d?[...d.entries()]:[]}function M(d){return new Map(d)}function N(d){return new Map(d??[])}function A(d){return Array.from(d.entries()).map(k=>[k[0],I(k[1].map),O(k[1].descriptionMap)])}function m(d){return new Map(d.map(k=>[k[0],{map:M(k[1]),descriptionMap:N(k[2])}]))}}),define(Ce[200],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hub=void 0;class I{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,N,A=5){const m=N(d=>{const k=typeof d=="string"?d:d.data;let F=this.a.get(M);if(F){F.data.push(k);return}const E=setTimeout(()=>this.flushBuffer(M),A);F={data:[k],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(M),m.dispose()}},this.a.set(M,F)});return m}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const N=this.a.get(M);N&&(this.a.delete(M),this.b(M,N.data.join("")))}}e.$Hub=I}),define(Ce[201],Pe([1,0,11,91,302,41,5,16,2,160,72,30]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.IconFontDefinition=e.IconContribution=e.$Tw=void 0,e.$Uw=o,e.$Vw=s,e.$Tw={IconContribution:"base.contributions.icons"};var u;(function(h){function t(p,c){let $=p.defaults;for(;N.ThemeIcon.isThemeIcon($);){const w=r.getIcon($.id);if(!w)return;$=w.defaults}return $}h.getDefinition=t})(u||(e.IconContribution=u={}));var b;(function(h){function t(c){return{weight:c.weight,style:c.style,src:c.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=t;function p(c){const $=w=>(0,m.$Vf)(w)?w:void 0;if(c&&Array.isArray(c.src)&&c.src.every(w=>(0,m.$Vf)(w.format)&&(0,m.$Vf)(w.location)))return{weight:$(c.weight),style:$(c.style),src:c.src.map(w=>({format:w.format,location:d.URI.parse(w.location)}))}}h.fromJSONObject=p})(b||(e.IconFontDefinition=b={}));class f{constructor(){this.a=new A.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,p,c,$){const w=this.b[t];if(w){if(c&&!w.description){w.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return w}const v={id:t,description:c,defaults:p,deprecationMessage:$};this.b[t]=v;const l={$ref:"#/definitions/icons"};return $&&(l.deprecationMessage=$),c&&(l.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const p=this.e.enum.indexOf(t);p!==-1&&(this.e.enum.splice(p,1),this.e.enumDescriptions.splice(p,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,p){const c=this.f[t];return c||(this.f[t]=p,this.a.fire(),p)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,v)=>w.id.localeCompare(v.id),p=w=>{for(;N.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(w=>this.b[w]);for(const w of $.filter(v=>!!v.description).sort(t))c.push(`|<i class="${p(w)}"></i>|${w.id}|${N.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const w of $.filter(v=>!N.ThemeIcon.isThemeIcon(v.defaults)).sort(t))c.push(`|<i class="${p(w)}"></i>|${w.id}|`);return c.join(`
`)}}const r=new f;E.$1n.add(e.$Tw.IconContribution,r);function o(h,t,p,c){return r.registerIcon(h,t,p,c)}function s(){return r}function n(){const h=(0,M.$Dj)();for(const t in h){const p="\\"+h[t].toString(16);r.registerIcon(t,{fontCharacter:p})}}n(),e.$Ww="vscode://schemas/icons";const i=E.$1n.as(F.$2n.JSONContribution);i.registerSchema(e.$Ww,r.getIconSchema());const a=new I.$uh(()=>i.notifySchemaChanged(e.$Ww),200);r.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$Xw=o("widget-close",O.$Hj.close,(0,k.localize)(2,null)),e.$Yw=o("goto-previous-location",O.$Hj.arrowUp,(0,k.localize)(3,null)),e.$Zw=o("goto-next-location",O.$Hj.arrowDown,(0,k.localize)(4,null)),e.$1w=N.ThemeIcon.modify(O.$Hj.sync,"spin"),e.$2w=N.ThemeIcon.modify(O.$Hj.loading,"spin")}),define(Ce[202],Pe([1,0,5,2,47,3,13]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$4v=e.$2v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xv=e.$Wv=void 0,e.$Yv=k,e.$Zv=E,e.$1v=u,e.$3v=b,e.$5v=f,e.$6v=r,e.$Wv=(0,N.$ii)("tunnelService"),e.$Xv=(0,N.$ii)("sharedTunnelsService");var m;(function(n){n.Http="http",n.Https="https"})(m||(e.TunnelProtocol=m={}));var d;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(d||(e.TunnelPrivacyId=d={}));function k(n){return!!n.forwardPort}var F;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(F||(e.ProvidedOnAutoForward=F={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function u(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const a of i){const h=a.split("=")[1];if(/^https?:/.exec(h)){const t=E(O.URI.parse(h));if(t)return t}}}e.$2v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(n){return e.$2v.indexOf(n)>=0}e.$4v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(n){return e.$4v.indexOf(n)>=0}function r(n,i,a,h){if(a===1)return!1;if(a===2&&f(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class o{constructor(i,a,h){this.remoteAddress=i,this.localAddress=a,this.b=h,this.a=new I.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$7v=o;let s=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$7d,this.onTunnelOpened=this.a.event,this.b=new I.$7d,this.onTunnelClosed=this.b.event,this.c=new I.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const h of a){const t=Array.from(h.values());for(const p of t){const c=await p.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,h,t,p){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:h,privacy:t,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(f(i)||b(i))&&(i=e.$2v[0]);const h=this.s(i,a);if(h)return++h.refcount,h.value}openTunnel(i,a,h,t,p,c=!1,$,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${h} on local port ${p}.`);const v=this.f??i;if(!v)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(v,a,h,t,p,c,$,w);return l?l.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const h=a.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,a,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=h.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const h=this.e.get(i);if(h&&h.has(a)){const t=h.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:h})}async r(i,a){const h=this.e.get(i);if(h){const t=h.get(a),p=t?await t.value:void 0;(!p||typeof p=="string")&&h.delete(a),h.size===0&&this.e.delete(i)}}s(i,a){const h=[i];b(i)?(h.push(...e.$2v),h.push(...e.$4v)):f(i)&&h.push(...e.$4v);const t=h.map(p=>this.e.get(p));for(const p of t){const c=p?.get(a);if(c)return c}}canTunnel(i){return!!E(i)}u(i,a,h,t,p,c,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${h} on local port ${t}.`);const w=h;this.j.add(w);const v=t===void 0?h:t,l={elevationRequired:p?this.isPortPrivileged(v):!1},D={remoteAddress:{host:a,port:h},localAddressPort:t,privacy:c,public:c?c!==d.Private:void 0,protocol:$},g=i.forwardPort(D,l);return g?(this.q(a,h,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),g}};e.$8v=s,e.$8v=s=Je([We(0,A.$Oj),We(1,M.$Oi)],s)}),define(Ce[203],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$9v=void 0,e.$9v=(0,I.$ii)("editSessionIdentityService");var O;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Ce[204],Pe([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=O,e.$WL=M,e.$XL=N,e.$YL=A,e.$ZL=m;function O(d){return d.scheme!==I.Schemas.file&&d.scheme!==I.Schemas.vscodeRemote}function M(d){if(d.folders.length)return d.folders.every(k=>O(k.uri))?d.folders[0].uri:void 0;if(d.configuration&&O(d.configuration))return d.configuration}function N(d){return M(d)?.scheme}function A(d){return M(d)?.authority}function m(d){return M(d)!==void 0}}),define(Ce[48],Pe([1,0,161,19,51,23,2,3,12]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=k,e.$ti=F,e.$wi=E,e.$xi=u,e.$yi=b,e.$zi=r,e.$Ai=o,e.$Di=i,e.$Ii=a,e.$Ji=h,e.$Li=t,e.$Mi=p,e.$Ni=c,e.$ri=(0,m.$ii)("contextService");function k($){const w=$;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}function F($){return typeof $?.id=="string"&&!k($)&&!u($)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function E($,w){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,O.$oc)($)}:w?e.$ui:e.$vi;const v=$;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}function u($){const w=$;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}function b($){const w=$;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const v=$;if(v?.configPath)return{id:v.id,configPath:A.URI.revive(v.configPath)};if($?.id)return{id:$.id}}var f;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function r($){const w=$;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function o($){const w=$;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class s{constructor(w,v,l,D,g){this.h=w,this.j=l,this.k=D,this.l=g,this.c=M.$oi.forUris(this.l,()=>!0),this.folders=v}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=M.$oi.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=s;class n{constructor(w,v){this.raw=v,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,N.$Vg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=n;function i($){return new n({uri:$,index:0,name:(0,N.$Rg)($)},{uri:$.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,I.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function a($,w){return N.$Mg.isEqualOrParent($,w.untitledWorkspacesHome)}function h($){let w;return A.URI.isUri($)?w=$:w=$.configuration,w?.scheme===d.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Ki}function p($,w){return!a($,w)&&!h($)}function c($){return(typeof $=="string"?(0,O.$pc)($):(0,N.$Tg)($))===e.$Fi}}),define(Ce[74],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class I{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const N=this.c++;return this.b.set(N,M),this.e(),N}get(M,N){return this.b.has(M)?this.b.get(M)[N]:void 0}delete(M){this.b.delete(M),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$7ic=I}),define(Ce[44],Pe([1,0,12,23,3]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=void 0;class N{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new O.$Kg(m=>{const d=this.b.get(m.scheme);return!(d===void 0||d&1024)})}$acceptProviderInfos(m,d){d===null?this.b.delete(m.scheme):this.b.set(m.scheme,d)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$_ic=N,e.$ajc=(0,M.$ii)("IExtHostFileSystemInfo")}),define(Ce[27],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=void 0,e.$XO=(0,I.$ii)("IExtHostInitDataService")}),define(Ce[205],Pe([1,0,167,13,192,27]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;let A=class extends M.$6P{constructor(d,k,F){const E=F.remote.isRemote?"remoteexthost":d?"workerexthost":"exthost",u=F.remote.isRemote?(0,I.localize)(0,null):d?(0,I.localize)(1,null):(0,I.localize)(2,null);super(k.createLogger(E,{name:u}))}};e.$glc=A,e.$glc=A=Je([We(1,O.$Pj),We(2,N.$XO)],A)}),define(Ce[206],Pe([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=void 0;class O{constructor(A,m,d){this.h=new Map,this.a=A,this.b=m,this.c=d,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new I.$uh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const F of k.values())F.complete()}catch(F){for(const E of k.values())E.error(F)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let d=this.f[A];return typeof d>"u"&&(d=m),d}update(A,m){this.f[A]=m;const d=this.h.get(A);if(d!==void 0)return d.p;const k=new I.$Fh;return this.h.set(A,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$Ujc=O;class M extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$Vjc=M}),define(Ce[207],Pe([1,0,5,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;class M{constructor(A){this.c=A,this.a=new I.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,d,k){const E=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged(m.value,d,k);this.b.fire(E)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$Ikc=M}),define(Ce[17],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0,e.$HO=(0,I.$ii)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$IO=O}),define(Ce[208],Pe([1,0,20,5]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=void 0;class M{#e;constructor(A,m){this.b=new O.$7d,this.onDidChange=this.b.event,this.a=I.$Dm.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$3jc=M}),define(Ce[59],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=e.$sjc=void 0,e.$sjc=(0,I.$ii)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$tjc=O}),define(Ce[209],Pe([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nb=M,e.$4nb=A;class O{constructor(){this.buffers=[]}add(d){let k=this.buffers.indexOf(d);return k<0&&(k=this.buffers.length,this.buffers.push(d)),k}}function M(m,d){if(d.serializeBuffersForPostMessage){const k=new O,E=JSON.stringify(m,(b,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(f)};if(ArrayBuffer.isView(f)){const r=N(f);if(r)return{$$vscode_array_buffer_reference$$:!0,index:k.add(f.buffer),view:{type:r,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),u=k.buffers.map(b=>{const f=new Uint8Array(b);return I.$ue.wrap(f)});return{message:E,buffers:u}}else return{message:JSON.stringify(m),buffers:[]}}function N(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,d){const k=d.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),F=d.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:r}=f,o=k[r];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(m,F),arrayBuffers:k}}}),define(Ce[104],Pe([1,0,176,16,2,6,3,30,43,12,42,138,32]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$pF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gF=e.EditorInputCapabilities=e.$fF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=void 0,e.$9E=r,e.$0E=o,e.$$E=s,e.$_E=n,e.$aF=i,e.$bF=a,e.$cF=h,e.$dF=t,e.$eF=p,e.$hF=D,e.$iF=S,e.$jF=y,e.$kF=P,e.$lF=C,e.$mF=W,e.$nF=V,e.$oF=fe,e.$qF=oe,e.$rF=ne,e.$sF=Se,e.$tF=Le,e.$4E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5E={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$6E="workbench.editor.sidebysideEditor",e.$7E="workbench.editors.textDiffEditor",e.$8E="workbench.editors.binaryResourceDiffEditor";var b;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var f;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function r(re){const L=re;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function o(re){const L=re;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function s(re,L,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===L&&re.matches(ve.input))return ve.getViewState()}function n(re){if(D(re))return!1;const L=re;return M.URI.isUri(L?.resource)}function i(re){if(D(re))return!1;const L=re;return L?.original!==void 0&&L.modified!==void 0}function a(re){if(D(re))return!1;const L=re;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function h(re){if(D(re)||i(re))return!1;const L=re;return L?.primary!==void 0&&L.secondary!==void 0}function t(re){if(D(re))return!1;const L=re;return L?L.resource===void 0||L.resource.scheme===k.Schemas.untitled||L.forceUntitled===!0:!1}function p(re){if(D(re))return!1;const L=re;return M.URI.isUri(L?.base?.resource)&&M.URI.isUri(L?.input1?.resource)&&M.URI.isUri(L?.input2?.resource)&&M.URI.isUri(L?.result?.resource)}var c;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var $;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class w{constructor(){this.a=new Map}registerSource(L,x){let ve=this.a.get(L);return ve||(ve={source:L,label:x},this.a.set(L,ve)),ve.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$fF=new w;var v;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad"})(v||(e.EditorInputCapabilities=v={}));class l extends N.$Uc{}e.$gF=l;function D(re){return re instanceof l}function g(re){const L=re;return M.URI.isUri(L?.preferredResource)}function S(re){const L=re;return D(L?.primary)&&D(L?.secondary)}function y(re){const L=re;return D(L?.modified)&&D(L?.original)}function P(re,L,x,ve,Oe){return Le(ve,[(0,E.$5i)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const ye={...x,limits:{size:Number.MAX_VALUE}};re.openEditor(L,ye)}}),(0,E.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Oe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function C(re){return D(re?.editor)}function W(re){const L=re;return C(re)&&L?.group!==void 0}function V(re){const L=re;return typeof L?.groupId=="number"&&D(L.editor)}var q;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var R;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",re[re.EDITOR_STICKY=12]="EDITOR_STICKY",re[re.EDITOR_DIRTY=13]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var z;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class G{getOriginalUri(L,x){if(!L)return;if(p(L))return e.$pF.getOriginalUri(L.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ye}=this.a(L);if(Oe&&ye){if(x?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ye,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ye,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===z.PRIMARY?Oe:ye}}if(i(L)||a(L)||h(L)||p(L))return;const ve=g(L)?L.preferredResource:L.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(L){return S(L)||h(L)?{primary:L.primary,secondary:L.secondary}:y(L)||i(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,x){if(!L)return;if(p(L))return e.$pF.getCanonicalUri(L.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ye}=this.a(L);if(Oe&&ye){if(x?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ye,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ye,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===z.PRIMARY?Oe:ye}}if(i(L)||a(L)||h(L)||p(L))return;const ve=L.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(L,x){if(Array.isArray(x)){if(x.some(ve=>L.scheme===ve))return L}else if(x===L.scheme)return L}}var ie;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function fe(re,L,x,ve){if(!re.isSticky(L))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$pF=new G;var De;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(De||(e.CloseDirection=De={}));class we{constructor(){this.c=new Map,this.d=new Map}start(L){const x=this.a=L.get(A.$hi);for(const[ve,Oe]of this.c)this.e(ve,Oe,x);this.c.clear()}e(L,x,ve){const Oe=ve.createInstance(x);this.d.set(L,Oe)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,O.$7f)(this.b)}registerEditorSerializer(L,x){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,x,this.a):this.c.set(L,x),(0,N.$Sc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}m.$1n.add(e.$4E.EditorFactory,new we);async function oe(re,L,x){return!re||!re.length?[]:await Promise.all(re.map(async ve=>{const Oe=M.URI.revive(ve.fileUri);if(!Oe){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await L.canHandleResource(Oe)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let pe=ve.exists,de=ve.type;if(typeof pe!="boolean"||typeof de!="number")try{de=(await L.stat(Oe)).isDirectory?d.FileType.Directory:d.FileType.Unknown,pe=!0}catch(Y){x.error(Y),pe=!1}if(!pe&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(de===d.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const J={...ve.options,pinned:!0};return pe?{resource:Oe,options:J}:{resource:Oe,options:J,forceUntitled:!0}}))}var $e;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function ne(re){const L=re;if(!L)return!1;const x=L;if(x.modified)return ne(x.modified);const ve=L;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Se(re){return(0,F.$7i)(re)}function Le(re,L,x){const ve=(0,F.$8i)(re,L);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Ce[210],Pe([1,0,5,177,3,6,28,30,18,26,91,201]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$zF=e.ViewContentGroups=e.$xF=e.ViewContainerLocation=e.Extensions=e.$wF=e.$vF=e.$uF=void 0,e.$yF=f,e.$uF="views",e.$vF=(0,O.localize)(0,null),e.$wF=(0,E.$Uw)("default-view-icon",F.$Hj.window,(0,O.localize)(1,null));var u;(function(p){p.ViewContainersRegistry="workbench.registry.view.containers",p.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(p){p[p.Sidebar=0]="Sidebar",p[p.Panel=1]="Panel",p[p.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$xF=[0,1,2];function f(p){switch(p){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onDidRegister=this.c.event,this.f=this.B(new I.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,d.$Rb)([...this.g.values()])}registerViewContainer(c,$,w){const v=this.get(c.id);if(v)return v;const l=c;return l.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,A.$yc)(this.g,$,[]).push(l),w?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:$}),l}deregisterViewContainer(c){for(const $ of this.g.keys()){const w=this.g.get($),v=w?.indexOf(c);if(v!==-1){w?.splice(v,1),w.length===0&&this.g.delete($),this.f.fire({viewContainer:c,viewContainerLocation:$});return}}}get(c){return this.all.filter($=>$.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find($=>this.getViewContainerLocation($)===c)}}m.$1n.add(u.ViewContainersRegistry,new r);var o;(function(p){p.Open="2_open",p.Debug="4_debug",p.SCM="5_scm",p.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(p,c){const $=p.group??o.More,w=c.group??o.More;return $!==w?$.localeCompare(w):(p.order??5)-(c.order??5)}class n extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(c,$){this.registerViews2([{views:c,viewContainer:$}])}registerViews2(c){c.forEach(({views:$,viewContainer:w})=>this.r($,w)),this.c.fire(c)}deregisterViews(c,$){const w=this.s(c,$);w.length&&this.f.fire({views:w,viewContainer:$})}moveViews(c,$){for(const w of this.m.keys())if(w!==$){const v=this.s(c,w);v.length&&(this.r(v,$),this.g.fire({views:v,from:w,to:$}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const $ of this.j){const w=(this.m.get($)||[]).filter(v=>v.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const $ of this.j)if((this.m.get($)||[]).filter(v=>v.id===c)[0])return $;return null}registerViewWelcomeContent(c,$){return this.n.add(c,$),this.h.fire(c),(0,N.$Sc)(()=>{this.n.delete(c,$),this.h.fire(c)})}registerViewWelcomeContent2(c,$){const w=new Map;for(const[v,l]of $)this.n.add(c,l),w.set(v,(0,N.$Sc)(()=>{this.n.delete(c,l),this.h.fire(c)}));return this.h.fire(c),w}getViewWelcomeContent(c){const $=[];return this.n.forEach(c,w=>$.push(w)),$.sort(s)}r(c,$){let w=this.m.get($);w||(w=[],this.m.set($,w),this.j.push($));for(const v of c){if(this.getView(v.id)!==null)throw new Error((0,O.localize)(2,null,v.id));w.push(v)}}s(c,$){const w=this.m.get($);if(!w)return[];const v=[],l=[];for(const D of w)c.includes(D)?v.push(D):l.push(D);return v.length&&(l.length?this.m.set($,l):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),v}}m.$1n.add(u.ViewsRegistry,new n),e.$zF=(0,M.$ii)("viewDescriptorService");var i;(function(p){p[p.Default=0]="Default",p[p.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(p){p[p.None=0]="None",p[p.Collapsed=1]="Collapsed",p[p.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,$){this.c=!1,this.d=!1,(0,k.$Rn)(this,c),this.d=!!$,this.resolve=async w=>{if($&&!this.c){const v=await $(w);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$AF=h;class t extends Error{constructor(c){super((0,O.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$BF=t}),define(Ce[211],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=void 0,e.$FF=(0,I.$ii)("IChatContributionService")}),define(Ce[212],Pe([1,0,18,5,39,6,33,3,211]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.$AG=e.ChatAgentLocation=void 0;var k;(function(u){u[u.Panel=1]="Panel",u[u.Terminal=2]="Terminal",u[u.Notebook=3]="Notebook"})(k||(e.ChatAgentLocation=k={})),function(u){function b(f){switch(f){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook}return u.Panel}u.fromRaw=b}(k||(e.ChatAgentLocation=k={})),e.$AG=(0,m.$ii)("chatAgentService");let F=class extends N.$Uc{static{this.AGENT_LEADER="@"}constructor(b,f){super(),this.g=b,this.h=f,this.b=new Map,this.f=this.B(new O.$7d),this.onDidChangeAgents=this.f.event}dispose(){super.dispose(),this.b.clear()}registerAgent(b,f){if(this.b.has(b))throw new Error(`Already registered an agent with id ${b}`);const r=this.getAgent(b);if(!r)throw new Error(`Unknown agent: ${b}`);const o={data:r,impl:f};return this.b.set(b,o),this.f.fire(new E(r,f)),(0,N.$Sc)(()=>{this.b.delete(b)&&this.f.fire(void 0)})}registerDynamicAgent(b,f){const r={data:b,impl:f};return this.b.set(b.id,r),this.f.fire(new E(b,f)),(0,N.$Sc)(()=>{this.b.delete(b.id)&&this.f.fire(void 0)})}updateAgent(b,f){const r=this.b.get(b);if(!r?.impl)throw new Error(`No activated agent with id ${b} registered`);r.data.metadata={...r.data.metadata,...f},this.f.fire(new E(r.data,r.impl))}getDefaultAgent(){return this.getActivatedAgents().find(b=>!!b.isDefault)}getSecondaryAgent(){return M.Iterable.find(this.b.values(),b=>!!b.data.metadata.isSecondary)?.data}getRegisteredAgents(){const b=this;return this.g.registeredParticipants.map(f=>({extensionId:f.extensionId,id:f.name,metadata:this.b.has(f.name)?this.b.get(f.name).data.metadata:{description:f.description},isDefault:f.isDefault,defaultImplicitVariables:f.defaultImplicitVariables,locations:(0,I.$Lb)(f.locations)?f.locations.map(k.fromRaw):[k.Panel],get slashCommands(){return(f.commands??[]).filter(o=>!o.when||b.h.contextMatchesRules(A.$gj.deserialize(o.when)))}}))}getAgents(){const b=this.getRegisteredAgents(),f=Array.from(this.b.values()).map(o=>o.data),r=[...b,...f];return(0,I.$Mb)(r,o=>o.id)}getActivatedAgents(){return Array.from(this.b.values()).filter(b=>!!b.impl).map(b=>new E(b.data,b.impl))}getAgent(b){return this.getAgents().find(f=>f.id===b)}async invokeAgent(b,f,r,o,s){const n=this.b.get(b);if(!n?.impl)throw new Error(`No activated agent with id ${b}`);return await n.impl.invoke(f,r,o,s)}async getFollowups(b,f,r,o,s){const n=this.b.get(b);if(!n?.impl)throw new Error(`No activated agent with id ${b}`);return n.impl?.provideFollowups?n.impl.provideFollowups(f,r,o,s):[]}};e.$BG=F,e.$BG=F=Je([We(0,d.$FF),We(1,A.$Aj)],F);class E{constructor(b,f){this.b=b,this.d=f}get id(){return this.b.id}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(b,f,r,o){return this.d.invoke(b,f,r,o)}async provideFollowups(b,f,r,o){return this.d.provideFollowups?this.d.provideFollowups(b,f,r,o):[]}provideWelcomeMessage(b){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(b)}provideSampleQuestions(b){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(b)}}e.$CG=E}),define(Ce[213],Pe([1,0,2,29,3]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=e.$LF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$JF=N,e.$KF=A;function N(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof I.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(O.$ct.isIRange)}function A(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(N)}var m;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var d;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(d||(e.ChatCopyKind=d={})),e.$LF=(0,M.$ii)("IChatService"),e.$MF="accessibility.voice.keywordActivation"}),define(Ce[214],Pe([1,0,5,11,178]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xob=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new I.$7d,this.o=new I.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,d,k,F){const E={command:m};if(d&&Object.keys(d).length>0&&(E.arguments=d),this.u("request",E),typeof F=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(E.seq);if(b){this.f.delete(E.seq);const f={type:"response",seq:0,request_seq:E.seq,success:!1,command:m,message:(0,M.localize)(0,null,F,m)};b(f)}},F)}return k&&this.f.set(E.seq,k),E.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,d){return m.type!=="event"||d.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,O.$jh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const d=m,k=this.f.get(d.request_seq);k&&(this.f.delete(d.request_seq),k(d));break}}}}u(m,d){d.type=m,d.seq=this.d++,this.sendMessage(d)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((d,k)=>m.set(k,d)),await(0,O.$jh)(500),m.forEach((d,k)=>{d({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$xob=N}),define(Ce[215],Pe([1,0,2,179,33,3]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$RI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$QI=e.MemoryRangeType=e.State=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=void 0,e.$PI=d,e.$DH="workbench.view.debug",e.$EH="workbench.debug.variablesView",e.$FH="workbench.debug.watchExpressionsView",e.$GH="workbench.debug.callStackView",e.$HH="workbench.debug.loadedScriptsView",e.$IH="workbench.debug.breakPointsView",e.$JH="workbench.debug.disassemblyView",e.$KH="workbench.panel.repl",e.$LH="workbench.panel.repl.view",e.$MH=new M.$zj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$NH=new M.$zj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$OH=new M.$zj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$PH="debugUx",e.$QH=new M.$zj(e.$PH,"default",{type:"string",description:O.localize(3,null)}),e.$RH=new M.$zj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$SH=new M.$zj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$TH=new M.$zj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$UH=new M.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$VH=new M.$zj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$WH=new M.$zj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$XH=new M.$zj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$YH=new M.$zj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$ZH=new M.$zj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$1H=new M.$zj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$2H=new M.$zj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$3H=new M.$zj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$4H=new M.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$5H=new M.$zj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$6H=new M.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$7H=new M.$zj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$8H=new M.$zj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$9H=new M.$zj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$0H=new M.$zj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$$H=new M.$zj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$_H=new M.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$aI=new M.$zj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$bI=new M.$zj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$cI=new M.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$dI=new M.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$eI=new M.$zj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$fI=new M.$zj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$gI=new M.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$hI=new M.$zj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$iI=new M.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$jI=new M.$zj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$kI=new M.$zj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$lI=new M.$zj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$mI=new M.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$nI=new M.$zj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$oI=new M.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$pI=new M.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$qI=new M.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$rI=new M.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$sI=new M.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$tI=new M.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$uI=new M.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$vI=new M.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$wI=new M.$zj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$xI=new M.$zj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$yI=new M.$zj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$zI=new M.$zj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$AI=new M.$zj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$BI=new M.$zj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$CI=new M.$zj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$DI=new M.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$EI=new M.$zj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$FI=new M.$zj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$GI=new M.$zj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$HI=new M.$zj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$II=new M.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$JI=new M.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const A=n=>O.localize(61,null,n);e.$KI=A,e.$LI="editor.contrib.debug",e.$MI="editor.contrib.breakpoint",e.$NI="debug",e.$OI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var m;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(m||(e.State=m={}));function d(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$QI="vscode-debug-memory";var F;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(F||(e.DataBreakpointSetType=F={}));var E;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(E||(e.DebugConfigurationProviderTriggerKind=E={}));var u;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(u||(e.DebuggerString=u={})),e.$RI=(0,N.$ii)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var f;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(f||(e.DebugVisualizationType=f={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(o||(e.IDebugVisualizationTreeItem=o={}));var s;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:I.URI.revive(i.iconPath.light),dark:I.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(s||(e.IDebugVisualization=s={}))}),define(Ce[216],Pe([1,0,15,2,19,26,12,29,24,18]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RG=void 0,e.$FG=E,e.$GG=u,e.$HG=b,e.$IG=f,e.$JG=r,e.$KG=o,e.$LG=s,e.$MG=i,e.$NG=t,e.$OG=p,e.$PG=$,e.$QG=v;const F=/{([^}]+)}/g;function E(D,g,S){return D.replace(F,function(y,P){return g&&P.length>0&&P[0]!=="_"?y:S&&S.hasOwnProperty(P)?S[P]:y})}function u(D){const g={};for(const S of Object.keys(D))S.startsWith("!")||(g[S]=D[S]);return g}function b(D){return D.configuration.request==="attach"&&!f(D)&&(!D.parentSession||b(D.parentSession))}function f(D){let g=D.configuration.type;if(g)return g==="vslsShare"&&(g=D.configuration.adapterProxy.configuration.type),(0,I.$lf)(g,"extensionhost")||(0,I.$lf)(g,"pwa-extensionhost")?D:D.parentSession?f(D.parentSession):void 0}function r(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,g,S){let y,P=0;const C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=C.exec(D);){const V=W.index+1,q=V+W[0].length;if(V<=g&&q>=S){y=W[0],P=V;break}}if(y){const V=/\w+/g;let q=null;for(;(q=V.exec(y))&&!(q.index+1+P+q[0].length>=S););q&&(y=y.substring(0,V.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}async function s(D,g,S,y){if(D.evaluatableExpressionProvider.has(g)){const P=D.evaluatableExpressionProvider.ordered(g),C=(0,k.$Hb)(await Promise.all(P.map(async W=>{try{return await W.provideEvaluatableExpression(g,S,y??d.CancellationToken.None)}catch{return}})));if(C.length>0){let W=C[0].expression;const V=C[0].range;return W||(W=g.getLineContent(S.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const P=g.getLineContent(S.lineNumber),{start:C,end:W}=o(P,S.column,S.column),V=P.substring(C-1,W);return{matchingExpression:V,range:new m.$ct(S.lineNumber,C,S.lineNumber,C+V.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return O.URI.parse(D.path);if((0,M.$jc)(D.path))return O.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const g=O.URI.revive(D.path);if(g)return g.scheme===A.Schemas.file?g.fsPath:g.toString()}return D.path}function t(D,g){const S=g?a:h,y=(0,N.$On)(D);return c(y,(P,C)=>{P&&C&&(C.path=S(C))}),y}function p(D,g){const S=g?a:h,y=(0,N.$On)(D);return c(y,(P,C)=>{!P&&C&&(C.path=S(C))}),y}function c(D,g){switch(D.type){case"event":{const S=D;switch(S.event){case"output":g(!1,S.body.source);break;case"loadedSource":g(!1,S.body.source);break;case"breakpoint":g(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":g(!0,S.arguments.source);break;case"breakpointLocations":g(!0,S.arguments.source);break;case"source":g(!0,S.arguments.source);break;case"gotoTargets":g(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(y=>g(!1,y));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(y=>g(!1,y.source));break;case"loadedSources":S.body.sources.forEach(y=>g(!1,y));break;case"scopes":S.body.scopes.forEach(y=>g(!1,y.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(y=>g(!1,y.source));break;case"setBreakpoints":S.body.breakpoints.forEach(y=>g(!1,y.source));break;case"disassemble":S.body?.instructions.forEach(P=>g(!1,P.location));break;default:break}break}}}function $(D){return D.filter(g=>!g.presentation?.hidden).sort((g,S)=>g.presentation?S.presentation?g.presentation.group?S.presentation.group?g.presentation.group!==S.presentation.group?g.presentation.group.localeCompare(S.presentation.group):w(g.presentation.order,S.presentation.order):-1:S.presentation.group?1:w(g.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function w(D,g){return typeof D!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:D-g}async function v(D,g){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(S!=="none"&&(await g.saveAll(),S==="allEditorsInActiveGroup")){const y=g.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await g.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const l=(D,g)=>!D||!g?D===g:D.name===g.name&&D.path===g.path&&D.sourceReference===g.sourceReference;e.$RG=l}),define(Ce[217],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.CellExecutionUpdateType=void 0;var O;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$5J=(0,I.$ii)("INotebookExecutionService")}),define(Ce[218],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhb=e.$Chb=e.ProxyKernelState=e.$Bhb=void 0,e.$Bhb=100;var O;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Chb=(0,I.$ii)("INotebookKernelService"),e.$Dhb=(0,I.$ii)("INotebookKernelHistoryService")}),define(Ce[219],Pe([1,0,6,29,148,95]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EUb=void 0;class A extends I.$Uc{constructor(d,k,F){super(),this._source=d,this.b=k,this.c=F,this.a=void 0}f(d){const k=d.getLineCount();return new O.$ct(1,1,k,this.g(d,k))}g(d,k){if(k<1||k>d.getLineCount())throw new Error("Illegal value for lineNumber");return d.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const d=new M.$AC;d.acceptChunk(this._source);const k=d.finish(!0),{textBuffer:F,disposable:E}=k.create(1);this.b=F,this.B(E)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(d=>{const k=new M.$AC;k.acceptChunk(d);const F=k.finish(!0),{textBuffer:E,disposable:u}=F.create(1);return this.B(u),E})),this.a}findInInputs(d){const F=new N.$oC(d,!1,!1,null).parseSearchRequest();if(!F)return[];const E=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(E,F,!0,5e3)}findInOutputs(d){const F=new N.$oC(d,!1,!1,null).parseSearchRequest();return F?this.outputTextBuffers.map(E=>{const u=E.findMatchesLineByLine(this.f(E),F,!0,5e3);if(u.length!==0)return{textBuffer:E,matches:u}}).filter(E=>!!E):[]}}e.$EUb=A}),define(Ce[49],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(N){N.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class M{static fromExtHostTestItem(A,m,d=A.parent){if(A._isRoot)return new M([m]);const k=[A.id];for(let F=d;F&&F.id!==m;F=F.parent)k.push(F.id);return k.push(m),new M(k.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new M(A.split("\0"))}static join(A,m){return new M([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:M.isChild(A,m)?2:M.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new M(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new M(this.path,A)}compare(A){if(typeof A=="string")return M.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$$K=M}),define(Ce[60],Pe([1,0,2,93,29,49]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$gL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$fL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$eL=e.$dL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$cL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$bL=e.$aL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$_K=e.TestResultState=void 0;var A;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$_K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var d;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$aL=[2,4,8,16,32,64];const k=R=>"runId"in R;e.$bL=k;var F;(function(R){R.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),R.deserialize=(z,G)=>({range:M.$ct.lift(G.range),uri:z.asCanonicalUri(I.URI.revive(G.uri))})})(F||(e.IRichLocation=F={}));var E;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(R){R.serialize=z=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&F.serialize(z.location)}),R.deserialize=(z,G)=>({message:G.message,type:0,expected:G.expected,actual:G.actual,contextValue:G.contextValue,location:G.location&&F.deserialize(z,G.location)})})(u||(e.ITestErrorMessage=u={}));const b=(R,z)=>`${z?"s":"e"}${R}`;e.$cL=b;var f;(function(R){R.serialize=z=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&F.serialize(z.location)}),R.deserialize=(z,G)=>({message:G.message,type:1,offset:G.offset,length:G.length,location:G.location&&F.deserialize(z,G.location)})})(f||(e.ITestOutputMessage=f={}));var r;(function(R){R.serialize=z=>z.type===0?u.serialize(z):f.serialize(z),R.deserialize=(z,G)=>G.type===0?u.deserialize(z,G):f.deserialize(z,G)})(r||(e.ITestMessage=r={}));var o;(function(R){R.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),R.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(r.serialize)}),R.deserialize=(z,G)=>({state:G.state,duration:G.duration,messages:G.messages.map(ie=>r.deserialize(z,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",n=(R,z)=>R+s+z;e.$dL=n;const i=R=>{const z=R.indexOf(s);return{ctrlId:R.slice(0,z),tagId:R.slice(z+1)}};e.$eL=i;var a;(function(R){R.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),R.deserialize=(z,G)=>({extId:G.extId,label:G.label,tags:G.tags,busy:G.busy,children:void 0,uri:G.uri?z.asCanonicalUri(I.URI.revive(G.uri)):void 0,range:G.range?M.$ct.lift(G.range):null,description:G.description,error:G.error,sortText:G.sortText})})(a||(e.ITestItem=a={}));var h;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(R){R.serialize=z=>({expand:z.expand,item:a.serialize(z.item)}),R.deserialize=(z,G)=>({controllerId:N.$$K.root(G.item.extId),expand:G.expand,item:a.deserialize(z,G.item)})})(t||(e.InternalTestItem=t={}));var p;(function(R){R.serialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.uri!==void 0&&(G.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(G.range=z.item.range?.toJSON()),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}},R.deserialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.range!==void 0&&(G.range=z.item.range?M.$ct.lift(z.item.range):null),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}}})(p||(e.ITestItemUpdate=p={}));const c=(R,z)=>{z.expand!==void 0&&(R.expand=z.expand),z.item!==void 0&&(R.item=R.item?Object.assign(R.item,z.item):z.item)};e.$fL=c;var $;(function(R){R.serializeWithoutMessages=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(o.serializeWithoutMessages)}),R.serialize=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(o.serialize)}),R.deserialize=(z,G)=>({...t.deserialize(z,G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(ie=>o.deserialize(z,ie)),retired:!0})})($||(e.TestResultItem=$={}));var w;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(z,G)=>{z.covered+=G.covered,z.total+=G.total}})(w||(e.ICoverageCount=w={}));var v;(function(R){R.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,uri:z.uri.toJSON()}),R.deserialize=(z,G)=>({id:G.id,statement:G.statement,branch:G.branch,declaration:G.declaration,uri:z.asCanonicalUri(I.URI.revive(G.uri))})})(v||(e.IFileCoverage=v={}));function l(R){return{...R,location:R.location?.toJSON()}}function D(R){return R.location=R.location?O.$bt.isIPosition(R.location)?O.$bt.lift(R.location):M.$ct.lift(R.location):void 0,R}e.$gL=3;var g;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(g||(e.DetailType=g={}));var S;(function(R){R.serialize=z=>z.type===0?P.serialize(z):C.serialize(z),R.deserialize=z=>z.type===0?P.deserialize(z):C.deserialize(z)})(S||(e.CoverageDetails=S={}));var y;(function(R){R.serialize=l,R.deserialize=D})(y||(e.IBranchCoverage=y={}));var P;(function(R){R.serialize=l,R.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var C;(function(R){R.serialize=z=>({...l(z),branches:z.branches?.map(y.serialize)}),R.deserialize=z=>({...D(z),branches:z.branches?.map(y.deserialize)})})(C||(e.IStatementCoverage=C={}));var W;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(R){R.deserialize=(z,G)=>G.op===0?{op:G.op,item:t.deserialize(z,G.item)}:G.op===1?{op:G.op,item:p.deserialize(G.item)}:G.op===2?{op:G.op,uri:z.asCanonicalUri(I.URI.revive(G.uri)),docv:G.docv}:G,R.serialize=z=>z.op===0?{op:z.op,item:t.serialize(z.item)}:z.op===1?{op:z.op,item:p.serialize(z.item)}:z})(V||(e.TestsDiffOp=V={}));class q{constructor(z){this.l=z,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(z){const G=this.w();for(const ie of z)switch(ie.op){case 0:this.o(t.deserialize(this.l,ie.item),G);break;case 1:this.p(p.deserialize(ie.item),G);break;case 3:this.q(ie.itemId,G);break;case 5:this.v(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.f.set(ie.tag.id,ie.tag);break;case 7:this.f.delete(ie.id);break}G.complete?.()}o(z,G){const ie=N.$$K.parentId(z.item.extId)?.toString();let fe;if(!ie)fe=this.x(z),this.h.add(fe),this.g.set(z.item.extId,fe);else if(this.g.has(ie)){const De=this.g.get(ie);De.children.add(z.item.extId),fe=this.x(z,De),this.g.set(z.item.extId,fe)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return G.add?.(fe),z.expand===2&&this.j++,fe}p(z,G){const ie=this.g.get(z.extId);if(ie)return z.expand!==void 0&&(ie.expand===2&&this.j--,z.expand===2&&this.j++),(0,e.$fL)(ie,z),G.update?.(ie),ie}q(z,G){const ie=this.g.get(z);if(!ie)return;const fe=N.$$K.parentId(ie.item.extId)?.toString();fe?this.g.get(fe).children.delete(ie.item.extId):this.h.delete(ie);const De=[[z]];for(;De.length;)for(const we of De.pop()){const oe=this.g.get(we);oe&&(De.push(oe.children),this.g.delete(we),G.remove?.(oe,oe!==ie),oe.expand===2&&this.j--)}}v(z){}updatePendingRoots(z){this.k+=z}w(){return{}}}e.$hL=q}),define(Ce[75],Pe([1,0,11,5,6,55,60,49]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.TestItemEventOp=void 0;var d;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(d||(e.TestItemEventOp=d={}));const k=(n,i)=>n===i,E=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(a=>!i.includes(a)))}),u=(n,i)=>{let a;for(const[h,t]of E)t(n[h],i[h])||(a?a[h]=i[h]:a={[h]:i[h]});return a};class b extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$uh(()=>this.flushDiff(),200)),this.g=this.B(new O.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,A.$fL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,A.$fL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(m.$$K.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const h of a.ops)this.w(i,h);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$0c)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const h=m.$$K.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let p=this.tree.get(h.toString());if(!p){p={fullId:h,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(p.fullId.toString(),p),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:p.expand,item:this.s.toITestItem(i)}}),this.I(i,p,a);return}if(p.actual===i){this.H(i,p,a);return}if(p.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,a);const c=this.s.getChildren(p.actual),$=p.actual,w=u(this.s.toITestItem($),this.s.toITestItem(i));this.s.getApiFor($).listener=void 0,p.actual=i,p.expand=0,w&&(w.hasOwnProperty("tags")&&(this.C(i.tags,$.tags,h.toString()),delete w.tags),this.w(p,{op:4,update:w})),this.I(i,p,a);for(const[v,l]of c)this.s.getChildren(i).get(l.id)||this.O(m.$$K.joinToString(h,l.id));this.y(p.actual.uri)}C(i,a,h){const t=new Set(a.map(p=>p.id));for(const p of i)t.delete(p.id)||this.D(p);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(p=>(0,A.$dL)(this.s.controllerId,p.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$dL)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$dL)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=p=>this.w(a,p),this.J(a)}I(i,a,h){this.H(i,a,h);for(const[t,p]of this.s.getChildren(i))this.z(p,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const h=[];for(const[t,p]of this.s.getChildren(i.actual)){const c=this.expand(m.$$K.joinToString(i.fullId,p.id),a);(0,I.$7g)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const p=new I.$hh;return p.open(),p}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$hh,h=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,p)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(p){h(p)}return(0,I.$7g)(t)?t.catch(h).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const p of t.actual.tags)this.F(p.id);this.tree.delete(t.fullId.toString());for(const[p,c]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$$K.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$xO=b;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$yO=f;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$zO=r;class o extends Error{constructor(i,a,h){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$AO=o;const s=(n,i,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,p){for(const c of h.values())t.call(p,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const p=new Map,c=new Set(h.keys()),$={op:5,ops:[]};for(const w of t){if(!(w instanceof a))throw new r(w.id);const v=i(w).controllerId;if(v!==n.controllerId)throw new o(w.id,v,n.controllerId);if(p.has(w.id))throw new f(w.id);p.set(w.id,w),c.delete(w.id),$.ops.push({op:0,item:w})}for(const w of c.keys())$.ops.push({op:3,id:w});n.listener?.($),h=p},add(t){if(!(t instanceof a))throw new r(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$BO=s}),define(Ce[105],Pe([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0;const O=new WeakMap,M=(A,m)=>{const d={controllerId:m};return O.set(A,d),d};e.$CO=M;const N=A=>{const m=O.get(A);if(!m)throw new I.$zO(A?.id||"<unknown>");return m};e.$DO=N}),define(Ce[76],Pe([1,0,12,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dzb=e.$czb=e.$bzb=void 0,e.$ezb=M,e.$fzb=A,e.$bzb="vscode-cdn.net",e.$czb=`vscode-resource.${e.$bzb}`,e.$dzb=`'self' https://*.${e.$bzb}`;function M(m,d){return m.scheme===I.Schemas.http||m.scheme===I.Schemas.https?m:(d&&d.authority&&d.isRemote&&m.scheme===I.Schemas.file&&(m=O.URI.from({scheme:I.Schemas.vscodeRemote,authority:d.authority,path:m.path})),O.URI.from({scheme:I.Schemas.https,authority:`${m.scheme}+${N(m.authority)}.${e.$czb}`,path:m.path,fragment:m.fragment,query:m.query}))}function N(m){return m.replace(/./g,d=>{const k=d.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?d:"-"+k.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(d,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Ce[220],Pe([1,0,5,6,76]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;class N{constructor(m,d,k){this.d=m,this.e=d,this.f=k,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(d.onDidChangeVisibleTextEditors(()=>{const F=d.getVisibleTextEditors();for(const E of this.c.values())F.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,d,k,F,E){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===m){u=i;break}if(!u)throw new Error("not a visible editor");const b=this,f=this.a++,r=new I.$7d,o=new I.$7d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$ezb)(i,b.f)}get cspSource(){return M.$dzb}set options(i){this.b=i,b.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,b.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return b.d.$postMessage(f,i)}},n=new class{constructor(){this.editor=m,this.line=d,this.height=k,this.webview=s,this.onDidDispose=o.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(f,u.id,u.value.document.uri,d+1,k,F||{},E.identifier,E.extensionLocation),this.c.set(f,{editor:m,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(m){const d=this.c.get(m);d&&d.inset.dispose()}$onDidReceiveMessage(m,d){this.c.get(m)?.onDidReceiveMessage.fire(d)}}e.$qjc=N}),define(Ce[106],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$pL=e.$oL=void 0,e.$oL="__",e.$pL=(0,I.$ii)("IAuthenticationService"),e.$qL=(0,I.$ii)("IAuthenticationExtensionsService")}),define(Ce[221],Pe([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.VariableKind=e.$tP=void 0,e.$tP=(0,I.$ii)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class M extends Error{constructor(A,m){super(m),this.variable=A}}e.$uP=M}),define(Ce[222],Pe([1,0,19,73,16,26,21,96,182,221,15]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,f,r,o){this.h=new Map,this.a=b,this.b=f,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(b){if(A.$i){const f=Object.create(null);return Object.keys(b).forEach(r=>{f[r.toLowerCase()]=b[r]}),f}return b}resolveWithEnvironment(b,f,r){return this.l({env:this.i(b),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(b,f){const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,f)}async j(b,f,r,o){const s=N.$On(f);A.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):A.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):A.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,b?b.uri:void 0,s,r,o)}async resolveAnyAsync(b,f,r){return this.j(b,f,r)}async resolveAnyMap(b,f,r){const o=new Map;return{newConfig:await this.j(b,f,r,o),resolvedVariables:o}}resolveWithInteractionReplace(b,f,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,f)}async l(b,f,r,o,s){if(M.$Vf(r))return this.m(b,f,r,o,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(b,f,n,o,s)));if(M.$Xf(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async a=>[await this.m(b,f,a,o,s),await this.l(b,f,r[a],o,s)]));for(const[a,h]of i)n[a]=h;return n}return r}m(b,f,r,o,s){return(0,F.$df)(r,E.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(E.VARIABLE_LHS))return n;let a=await this.o(b,n,i,f,o);return s?.set(i,a),a!==n&&M.$Vf(a)&&a.match(E.VARIABLE_REGEXP)&&(a=await this.m(b,f,a,o,s)),a})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,f,r,o,s){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const a=p=>{const c=this.a.getFilePath();if(c)return(0,m.$hw)(c);throw new k.$uP(p,(0,d.localize)(0,null,f))},h=p=>{const c=a(p);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,m.$hw)($)}throw new k.$uP(p,(0,d.localize)(1,null,f,I.$oc(c)))},t=p=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new k.$uP(p,(0,d.localize)(2,null,f,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$uP(p,(0,d.localize)(3,null,f)):new k.$uP(p,(0,d.localize)(4,null,f))};switch(r){case"env":if(n){if(b.env){const p=b.env[A.$i?n.toLowerCase():n];if(M.$Vf(p))return p}return""}throw new k.$uP(k.VariableKind.Env,(0,d.localize)(5,null,f));case"config":if(n){const p=this.a.getConfigurationValue(o,n);if(M.$5f(p))throw new k.$uP(k.VariableKind.Config,(0,d.localize)(6,null,f,n));if(M.$Xf(p))throw new k.$uP(k.VariableKind.Config,(0,d.localize)(7,null,f,n));return p}throw new k.$uP(k.VariableKind.Config,(0,d.localize)(8,null,f));case"command":return this.p(k.VariableKind.Command,f,n,s,"command");case"input":return this.p(k.VariableKind.Input,f,n,s,"input");case"extensionInstallFolder":if(n){const p=await this.a.getExtension(n);if(!p)throw new k.$uP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(9,null,f,n));return this.n(p.extensionLocation)}throw new k.$uP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(10,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$hw)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,m.$hw)(this.n(t(k.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$hw)(I.$oc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.$uP(k.VariableKind.UserHome,(0,d.localize)(11,null,f))}case"lineNumber":{const p=this.a.getLineNumber();if(p)return p;throw new k.$uP(k.VariableKind.LineNumber,(0,d.localize)(12,null,f))}case"selectedText":{const p=this.a.getSelectedText();if(p)return p;throw new k.$uP(k.VariableKind.SelectedText,(0,d.localize)(13,null,f))}case"file":return a(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?I.$mc(this.n(t(k.VariableKind.RelativeFile)),a(k.VariableKind.RelativeFile)):a(k.VariableKind.RelativeFile);case"relativeFileDirname":{const p=I.$nc(a(k.VariableKind.RelativeFileDirname));if(o||n){const c=I.$mc(this.n(t(k.VariableKind.RelativeFileDirname)),p);return c.length===0?".":c}return p}case"fileDirname":return I.$nc(a(k.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(k.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const p=I.$oc(a(k.VariableKind.FileBasenameNoExtension));return p.slice(0,p.length-I.$pc(p).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(k.VariableKind.FileDirnameBasename)));case"execPath":{const p=this.a.getExecPath();return p||f}case"execInstallFolder":{const p=this.a.getAppRoot();return p||f}case"pathSeparator":case"/":return I.sep;default:try{const p=n?`${r}:${n}`:r;return this.p(k.VariableKind.Unknown,f,p,s,void 0)}catch{return f}}}}p(b,f,r,o,s){if(r&&o){const n=s===void 0?o[r]:o[s+":"+r];if(typeof n=="string")return n;throw new k.$uP(b,(0,d.localize)(14,null,f))}return f}}e.$JP=E}),define(Ce[107],Pe([1,0,3,104]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$wD=void 0,e.$xD=k,e.$yD=u,e.$zD=b,e.$wD=(0,I.$ii)("editorGroupsService");var M;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var d;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(d||(e.MergeGroupMode=d={}));function k(f){const r=f;return(0,O.$hF)(r?.editor)&&(0,O.$hF)(r?.replacement)}var F;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F||(e.GroupsOrder=F={}));var E;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ce[223],Pe([1,0,3,107]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DD=e.$CD=e.$BD=e.$AD=void 0,e.$ED=M,e.$AD=(0,I.$ii)("editorService"),e.$BD=-1,e.$CD=-2,e.$DD=-3;function M(N){const A=N;return typeof N=="number"||(0,O.$yD)(A)}}),define(Ce[224],Pe([1,0,3,189]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JL=void 0,e.$JL=(0,I.$ji)(O.$pi)}),define(Ce[108],Pe([1,0,20,5,19,6,11]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=e.$40b=e.$30b=e.$20b=e.$10b=void 0;class m{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$10b=m;class d{static isHostExtension(n,i,a){if(i.getExtensionDescription(n))return!1;const h=a.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new I.$Fm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=o(this.e,i),this.e=this.e.concat(n);const a=d.l(this.e);return this.e=o(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,$){this.addNode(c),this.addNode($),this.c.has(c)?this.c.get(c).push($):this.c.set(c,[$])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,$){const w=i.getArcs(c);for(let v=0;v<w.length;v++)if(!$.has(w[v]))return!1;return!0}getNodes(){return this.e}},a=new I.$Fm;for(const c of n)if(a.set(c.identifier,c),c.extensionDependencies)for(const $ of c.extensionDependencies)i.addArc(I.$Dm.toKey(c.identifier),I.$Dm.toKey($));const h=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>h.add(c));const t=i.getNodes().filter(c=>!h.has(c));let p;do{p=!1;for(let c=0;c<t.length;c++){const $=t[c];i.hasOnlyGoodArcs($,h)&&(t.splice(c,1),c--,h.add($),p=!0)}}while(p);return t.map(c=>a.get(c))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$20b=d;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$30b=k;class F{constructor(n){this.d=new b,this.c=new d(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new E(this,i)}deltaExtensions(n,i,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$40b=F;class E extends N.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$50b=E;class u{constructor(n){this.name=n;const i=(0,A.$bh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class b{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new u(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};n.resolve((0,N.$Sc)(h))}}var f;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(f||(f={}));function r(s,n){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==a)return i-a;const h=M.$hc.basename(s.extensionLocation.path),t=M.$hc.basename(n.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,n){const i=new I.$Em(n);return s.filter(a=>!i.has(a.identifier))}}),define(Ce[77],Pe([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Lm=A,e.$Mm=m;var O;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(O||(e.UIKind=O={}));var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var N;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function A(k){const F=I.$ue.alloc(1);switch(k){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}function m(k,F){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}var d;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(d||(e.NativeLogMarkers=d={}))}),define(Ce[61],Pe([1,0,3,5,13,27,77,57,58,26,2,6,170]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=e.$ZO=e.$YO=void 0,e.$1O=r;let b=class extends E.$Uc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new O.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=F.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:d.$9o,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$Qj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,i){const a=this.getTelemetryDetails(),h=new f(n,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,i){this.f=s,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$um)((0,d.$cp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((i,a)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$YO=b,e.$YO=b=Je([We(0,N.$XO),We(1,M.$Pj)],b);class f{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,i,a,h,t,p){this.g=i,this.h=a,this.i=h,this.j=t,this.a=new O.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,d.$fp)(n,[]),this.c&&(n=(0,k.$Rn)(n,this.c)),this.b||(n=(0,k.$Rn)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,d.$fp)(i,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$ZO=f;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$2O=(0,I.$ii)("IExtHostTelemetry")}),define(Ce[25],Pe([1,0,5,2,198,103,20,3]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cG=e.ActivationKind=e.$_F=e.$$F=e.$8F=e.ExtensionHostStartup=e.$7F=e.$6F=e.$5F=e.$4F=void 0,e.$9F=u,e.$0F=b,e.$aG=s,e.$bG=n,e.$4F=Object.freeze({identifier:new A.$Dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$5F="extensions.webWorker",e.$6F=(0,m.$ii)("extensionService");class d{constructor(h){this.dependency=h}}e.$7F=d;var k;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class F{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,p){this.c=h,this.d=t.slice(0),this.e=p.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$OF.createActivationEventsMap(this.d)}}set(h,t,p){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],$=[],w=[],v=[],l=E(this.d),D=E(t),g=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=D.get(W.identifier);if(!V){c.push(W.identifier),l.delete(W.identifier);continue}if(!g(W,V)){c.push(W.identifier),l.delete(W.identifier);continue}}for(const W of t){const V=l.get(W.identifier);if(!V){$.push(W);continue}if(!g(V,W)){c.push(V.identifier),l.delete(V.identifier);continue}}const S=new A.$Em(this.e),y=new A.$Em(p);for(const W of this.e)y.has(W)||w.push(W);for(const W of p)S.has(W)||v.push(W);const P=N.$OF.createActivationEventsMap($),C={versionId:h,toRemove:c,toAdd:$,addActivationEvents:P,myToRemove:w,myToAdd:v};return this.delta(C),C}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:p,myToRemove:c,myToAdd:$}=h,w=new A.$Em(t),v=new A.$Em(c);for(let l=0;l<this.d.length;l++)w.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)v.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of p)this.d.push(l);for(const l of $)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(A.$Dm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const p=N.$OF.readActivationEvents(t);for(const c of p)h.add(c)}return h}}e.$8F=F;function E(a){const h=new A.$Fm;for(const t of a)h.set(t.identifier,t);return h}function u(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}function b(a,h){if(!u(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class f{constructor(h,t,p,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=p,this.activationReason=c}}e.$$F=f;class r{constructor(h,t){this.description=h,this.value=t}}e.$_F=r;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,M.$lp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function n(a,h){return{identifier:new A.$Dm((0,M.$jp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$cG=i}),define(Ce[225],Pe([1,0,14,108,20,25,13,11]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=e.$Qjc=e.$Pjc=e.$Ojc=e.$Njc=e.$Mjc=void 0;class d{static{this.NONE=new d(!1,-1,-1,-1)}constructor(s,n,i,a){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=a}}e.$Mjc=d;class k{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new d(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Njc=k;class F{constructor(s,n,i,a,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=i,this.module=a,this.exports=h,this.subscriptions=t}}e.$Ojc=F;class E extends F{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Pjc=E;class u extends F{constructor(){super(!1,null,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Qjc=u;class b extends F{constructor(s){super(!0,s,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(s,n,i,a){this.g=a,this.a=s,this.b=n,this.c=i,this.d=new M.$Fm,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(s){const n=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new b(h));return this.c.onExtensionActivationError(s.id,h,new N.$7F(s.id.value)),t}const i=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const p=this.a.getExtensionDescription(h);if(p){if(!p.main&&!p.browser)continue;i.push(this.j({id:p.identifier,reason:s.reason}));continue}const c=n.displayName||n.identifier.value,$=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),w=this.k(s,n.displayName,[],new b($));return this.c.onExtensionActivationError(n.identifier,$,new N.$7F(h)),w}return this.k(s,n.displayName,i,null)}k(s,n,i,a){const h=new r(s.id,n,s.reason,i,a,this.c,this.g);return this.d.set(s.id,h),h}l(s){return O.$20b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$Rjc=f,e.$Rjc=f=Je([We(3,A.$Oj)],f);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,i,a,h,t,p){this.c=s,this.d=n,this.f=i,this.g=a,this.h=h,this.j=t,this.k=p,this.a=new m.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new b(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new b(n),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([We(6,A.$Oj)],r)}),define(Ce[226],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[227],Pe([1,0,184,14,32,98,72,30,20,226,194,103]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=void 0;const u=m.$1n.as(A.$2n.JSONContribution);class b{constructor(h,t,p){this.a=h,this.b=t,this.c=p}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(M.default.Error,h)}warn(h){this.d(M.default.Warning,h)}info(h){this.d(M.default.Info,h)}}e.$XF=b;class f{static a(h){const t=new d.$Em;for(let p=0,c=h.length;p<c;p++)t.add(h[p].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new f(t,[]);if(!t||!t.length)return new f([],h);const p=this.a(h),c=this.a(t),$=t.filter(v=>!p.has(v.description.identifier)),w=h.filter(v=>!c.has(v.description.identifier));return new f($,w)}constructor(h,t){this.added=h,this.removed=t}}e.$YF=f;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=f.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,O.$1)(h)}}}e.$ZF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$1F={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:d.$Cm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Fo}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Fo}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&E.$OF.register(h.extensionPoint,h.activationEventsGenerator),e.$1F.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(s,e.$1F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$2F=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.$1n.add(i.ExtensionsRegistry,new n),e.$3F=m.$1n.as(i.ExtensionsRegistry),u.registerSchema(s,e.$1F),u.registerSchema(F.$9j,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[228],Pe([1,0,180,16,26,227,33,5]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=void 0;const d={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var k;(function(u){function b(f,r,o){if(!f)return;const s=O.$Vf(f.type)?f.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const n=[];if(Array.isArray(f.required))for(const i of f.required)O.$Vf(i)&&n.push(i);return{extensionId:r.value,taskType:s,required:n,properties:f.properties?M.$On(f.properties):{},when:f.when?A.$gj.deserialize(f.when):void 0}}u.from=b})(k||(k={}));const F=N.$3F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const f of u)f.type&&b.push(`onTaskType:${f.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:d}});class E{constructor(){this.d=new m.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{F.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const n=s.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const n=s.value;for(const i of n){const a=k.from(i,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=M.$On(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},b.push(r)}this.c={oneOf:b}}return this.c}}e.$sH=new E}),define(Ce[229],Pe([1,0,181,16,23,26,33,228]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$CH=e.JsonSchemaVersion=e.ExecutionEngine=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$wH=e.ShellQuoting=e.$vH=e.$uH=e.$tH=void 0,e.$tH="settings",e.$uH=new A.$zj("taskRunning",!1,I.localize(0,null)),e.$vH=I.localize2(2,"Tasks");var d;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(d||(e.ShellQuoting=d={})),e.$wH="$customized",function(R){function z(G){if(!G)return R.Strong;switch(G.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=z}(d||(e.ShellQuoting=d={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var F;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(F||(e.RevealKind=F={})),function(R){function z(G){switch(G.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=z}(F||(e.RevealKind=F={}));var E;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(R){function z(G){switch(G.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=z}(E||(e.RevealProblemKind=E={}));var u;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(u||(e.PanelKind=u={})),function(R){function z(G){switch(G.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=z}(u||(e.PanelKind=u={}));var b;(function(R){R.defaults={echo:!0,reveal:F.Always,revealProblems:E.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var f;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(R){function z(ie){switch(ie.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=z;function G(ie){switch(ie){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=G}(f||(e.RuntimeType=f={}));var r;(function(R){function z(G){return O.$Vf(G)?G:G.value}R.value=z})(r||(e.CommandString=r={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function z(ie){return ie===R.Clean._id||ie===R.Build._id||ie===R.Rebuild._id||ie===R.Test._id}R.is=z;function G(ie){if(ie!==void 0)return O.$Vf(ie)?z(ie)?{_id:ie,isDefault:!1}:void 0:ie}R.from=G})(o||(e.TaskGroup=o={}));var s;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function z(G){switch(G){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=z})(n||(e.TaskSourceKind=n={}));var i;(function(R){R.parallel="parallel",R.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(z,G,ie,fe,De,we){this._label="",this._id=z,G&&(this._label=G),ie&&(this.type=ie),this.runOptions=fe,this.configurationProperties=De,this._source=we}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,G=!1){if(z===void 0)return!1;if(O.$Vf(z))return z===this._label||z===this.configurationProperties.identifier||G&&z===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$xH=t;class p extends t{constructor(z,G,ie,fe,De,we,oe,$e){super(z,ie,void 0,oe,$e,G),this.command={},this._source=G,this.hasDefinedMatchers=we,De&&(this.command=De)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let G;switch(this.command?this.command.runtime:void 0){case f.Shell:G="shell";break;case f.Process:G="process";break;case f.CustomExecution:G="customExecution";break;case void 0:G="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:G,_key:this._id,id:this._id}}}static is(z){return z instanceof p}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$tH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(G+=this._source.kind);const ie={type:e.$wH,folder:z,id:G};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new p(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$yH=p;class c extends t{constructor(z,G,ie,fe,De,we,oe){super(z,ie,fe,we,oe,G),this._source=G,this.configures=De}static is(z){return z instanceof c}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$tH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(G+=this._source.kind);const ie={type:e.$wH,folder:z,id:G};return JSON.stringify(ie)}}e.$zH=c;class $ extends t{constructor(z,G,ie,fe,De,we,oe,$e,ne){super(z,ie,fe,$e,ne,G),this.defines=De,this.hasDefinedMatchers=oe,this.command=we,this.icon=ne.icon,this.hide=ne.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof $}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new $(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$AH=$;class w extends t{constructor(z,G,ie,fe,De,we){super(z,ie,fe,De,we,G),this._source=G}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new w(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$BH=w;var v;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(R){R._default=R.Terminal}(v||(e.ExecutionEngine=v={}));var l;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class D{constructor(z){this.c=new Map;for(let G=0;G<z.length;G++)this.c.set(z[G].uri.toString(),G)}compare(z,G){const ie=z.getWorkspaceFolder(),fe=G.getWorkspaceFolder();if(ie&&fe){let De=this.c.get(ie.uri.toString());De=De===void 0?0:De+1;let we=this.c.get(fe.uri.toString());return we=we===void 0?0:we+1,De===we?z._label.localeCompare(G._label):De-we}else return!ie&&fe?-1:ie&&!fe?1:0}}e.$CH=D;var g;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(g||(e.TaskEventKind=g={}));var S;(function(R){R.SingleRun="singleRun",R.Background="background"})(S||(e.TaskRunType=S={}));var y;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(R){function z($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function G($e,ne,Se){return{...z($e),kind:"start",terminalId:ne,resolvedVariables:Se}}R.start=G;function ie($e,ne,Se){return{...z($e),kind:"processStarted",terminalId:ne,processId:Se}}R.processStarted=ie;function fe($e,ne,Se){return{...z($e),kind:"processEnded",terminalId:ne,exitCode:Se}}R.processEnded=fe;function De($e,ne,Se){return{...z($e),kind:"terminated",exitReason:Se,terminalId:ne}}R.terminated=De;function we($e,ne,Se){return{...z(ne),kind:$e,terminalId:Se}}R.general=we;function oe(){return{kind:"changed"}}R.changed=oe})(P||(e.TaskEvent=P={}));var C;(function(R){function z(ie){const fe=Object.keys(ie).sort();let De="";for(const we of fe){let oe=ie[we];oe instanceof Object?oe=z(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),De+=we+","+oe+","}return De}function G(ie){const De={_key:z(ie),type:ie.taskType};return Object.assign(De,ie),De}R.create=G})(C||(e.KeyedTaskIdentifier=C={}));var W;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(R){function z(G,ie){const fe=m.$sH.get(G.type);if(fe===void 0){const $e=N.$On(G);return delete $e._key,C.create($e)}const De=Object.create(null);De.type=fe.taskType;const we=new Set;fe.required.forEach($e=>we.add($e));const oe=fe.properties;for(const $e of Object.keys(oe)){const ne=G[$e];if(ne!=null)De[$e]=ne;else if(we.has($e)){const Se=oe[$e];if(Se.default!==void 0)De[$e]=N.$On(Se.default);else switch(Se.type){case"boolean":De[$e]=!1;break;case"number":case"integer":De[$e]=0;break;case"string":De[$e]="";break;default:ie.error(I.localize(1,null,JSON.stringify(G,void 0,0),$e));return}}}return C.create(De)}R.createTaskIdentifier=z})(q||(e.TaskDefinition=q={}))}),define(Ce[230],Pe([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=e.$60b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,I.$1)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$60b=O;class M extends O{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$70b=M}),define(Ce[50],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$bw=void 0,e.$cw=M,e.$dw=N;class I{static{this.count=0}constructor(d){this._proxyIdentifierBrand=void 0,this.sid=d,this.nid=++I.count}}e.$bw=I;const O=[];function M(m){const d=new I(m);return O[d.nid]=d,d}function N(m){return O[m].sid}class A{constructor(d){this.value=d}}e.$ew=A}),define(Ce[4],Pe([1,0,50]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$lM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var M;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var d;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(d||(e.CellOutputKind=d={}));var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var F;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(F||(e.CandidatePortSource=F={}));class E{static{this.a=0}static mixin(o){return o._id=E.a++,o}}e.$lM=E;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$mM={MainThreadAuthentication:(0,I.$cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$cw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$cw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$cw)("MainThreadClipboard"),MainThreadCommands:(0,I.$cw)("MainThreadCommands"),MainThreadComments:(0,I.$cw)("MainThreadComments"),MainThreadConfiguration:(0,I.$cw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$cw)("MainThreadConsole"),MainThreadDebugService:(0,I.$cw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$cw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$cw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$cw)("MainThreadLanguages"),MainThreadLogger:(0,I.$cw)("MainThreadLogger"),MainThreadMessageService:(0,I.$cw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$cw)("MainThreadOutputService"),MainThreadProgress:(0,I.$cw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$cw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$cw)("MainThreadSecretState"),MainThreadStorage:(0,I.$cw)("MainThreadStorage"),MainThreadSpeech:(0,I.$cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$cw)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$cw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$cw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$cw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$cw)("MainThreadSCM"),MainThreadSearch:(0,I.$cw)("MainThreadSearch"),MainThreadShare:(0,I.$cw)("MainThreadShare"),MainThreadTask:(0,I.$cw)("MainThreadTask"),MainThreadWindow:(0,I.$cw)("MainThreadWindow"),MainThreadLabelService:(0,I.$cw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$cw)("MainThreadInteractive"),MainThreadChat:(0,I.$cw)("MainThreadChat"),MainThreadInlineChat:(0,I.$cw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$cw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$cw)("MainThreadTimeline"),MainThreadTesting:(0,I.$cw)("MainThreadTesting"),MainThreadLocalization:(0,I.$cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$cw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$cw)("MainThreadIssueReporter")},e.$nM={ExtHostCommands:(0,I.$cw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$cw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$cw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$cw)("ExtHostStatusBar"),ExtHostShare:(0,I.$cw)("ExtHostShare"),ExtHostExtensionService:(0,I.$cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$cw)("ExtHostTerminalService"),ExtHostSCM:(0,I.$cw)("ExtHostSCM"),ExtHostSearch:(0,I.$cw)("ExtHostSearch"),ExtHostTask:(0,I.$cw)("ExtHostTask"),ExtHostWorkspace:(0,I.$cw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$cw)("ExtHostWindow"),ExtHostWebviews:(0,I.$cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$cw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$cw)("ExtHostProgress"),ExtHostComments:(0,I.$cw)("ExtHostComments"),ExtHostSecretState:(0,I.$cw)("ExtHostSecretState"),ExtHostStorage:(0,I.$cw)("ExtHostStorage"),ExtHostUrls:(0,I.$cw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$cw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$cw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$cw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$cw)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$cw)("ExtHostChat"),ExtHostChatAgents2:(0,I.$cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$cw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$cw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$cw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$cw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$cw)("ExtHostTimeline"),ExtHostTesting:(0,I.$cw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$cw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$cw)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$cw)("ExtHostIssueReporter")}}),define(Ce[78],Pe([1,0,3,13,4,17]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=e.$9ic=void 0,e.$9ic=(0,I.$ii)("IExtHostApiDeprecationService");let A=class{constructor(d,k){this.c=k,this.a=new Set,this.b=d.getProxy(M.$mM.MainThreadTelemetry)}report(d,k,F){const E=this.d(d,k);this.a.has(E)||(this.a.add(E),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${d}' is deprecated. ${F}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:d}))}d(d,k){return`${d}-${k.identifier.value}`}};e.$0ic=A,e.$0ic=A=Je([We(0,N.$HO),We(1,O.$Oj)],A),e.$$ic=Object.freeze(new class{report(m,d,k){}})}),define(Ce[231],Pe([1,0,39,6,4]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;class N{static{this.a=0}constructor(d,k){this.extension=d,this.provider=k,this.handle=N.a++}}class A{static{this.a=0}constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(M.$mM.MainThreadChat)}registerChatProvider(d,k,F){const E=new N(d,F);return this.b.set(E.handle,E),this.d.$registerChatProvider(E.handle,k),(0,O.$Sc)(()=>{this.d.$unregisterChatProvider(E.handle),this.b.delete(E.handle)})}transferChatSession(d,k){const F=I.Iterable.find(this.c.keys(),E=>this.c.get(E)===d)??0;typeof F=="number"&&this.d.$transferChatSession(F,k)}async $prepareChat(d,k){const F=this.b.get(d);if(!F)return;const E=await F.provider.prepareSession(k);if(!E)return;const u=A.a++;return this.c.set(u,E),{id:u}}$releaseSession(d){this.c.delete(d)}}e.$jjc=A}),define(Ce[232],Pe([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=void 0;class O{constructor(N){const A=N.getProxy(I.$mM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$ojc=O}),define(Ce[233],Pe([1,0,26,4,27,17]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;let A=class{constructor(F,E){this.a=F.getProxy(O.$mM.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(F,E){const u=this,b=console[F];Object.defineProperty(console,F,{set:()=>{},get:()=>function(){u.e(F,E,b,arguments)}})}e(F,E,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:d(b,this.b)}),this.c&&this.f(F,u,b)}};e.$flc=A,e.$flc=A=Je([We(0,N.$HO),We(1,M.$XO)],A);const m=1e5;function d(k,F){const E=[];if(k.length)for(let u=0;u<k.length;u++){let b=k[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}E.push(b)}if(F){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$Tn)(E);return u.length>m?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[234],Pe([1,0,2,4,25]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;class N{constructor(m){this.a=m.getProxy(O.$mM.MainThreadDialogs)}showOpenDialog(m,d){return d?.allowUIResources&&(0,M.$0F)(m,"showLocal"),this.a.$showOpenDialog(d).then(k=>k?k.map(F=>I.URI.revive(F)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(d=>d?I.URI.revive(d):void 0)}}e.$jkc=N}),define(Ce[235],Pe([1,0,6,4]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;class M{constructor(A){this.b=0,this.a=A.getProxy(O.$mM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Ekc=M}),define(Ce[79],Pe([1,0,21,15,2,3,13,4,27,17]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;let F=class{constructor(u,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(m.$mM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,b){const{message:f,args:r,comment:o}=b;if(this.c)return(0,O.$We)(f,r??{});let s=f;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,O.$We)(n??f,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const f=await this.g(u);if(!f){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),o=JSON.parse(r);b=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${f}: ${r.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:f})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return M.URI.revive(b)}return u.l10n?M.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$4jc=F,e.$4jc=F=Je([We(0,d.$XO),We(1,k.$HO),We(2,A.$Oj)],F),e.$5jc=(0,N.$ii)("IExtHostLocalizationService")}),define(Ce[236],Pe([1,0,13,4,27,17,2,52]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;let d=class extends I.$Zj{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,m.$Rh)(b))),this.r=E.getProxy(O.$mM.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(A.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,b){return new k(this.r,E,u,b)}};e.$elc=d,e.$elc=d=Je([We(0,N.$HO),We(1,M.$XO)],d);class k extends I.$Uj{constructor(E,u,b,f){super(f?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,f).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const b=[[E,u]];this.m?this.u(b):this.n.push(...b)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ce[80],Pe([1,0,4,3,6,17,22]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0,e.$6jc=(0,O.$ii)("IExtHostManagedSockets");let m=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(I.$mM.MainThreadManagedSockets)}setFactory(E,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new d(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,b=await this.c.makeConnection(),f=new M.$Tc;return this.d.set(u,new k(u,b,f)),f.add((0,M.$Sc)(()=>this.d.delete(u))),f.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),f.dispose()})),f.add(b.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),f.dispose()})),f.add(b.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,A.$ue.wrap(r)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$7jc=m,e.$7jc=m=Je([We(0,N.$HO)],m);class d{constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class k extends M.$Uc{constructor(E,u,b){super(),this.socketId=E,this.actual=u,this.B(b)}}}),define(Ce[237],Pe([1,0,4,13,25]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;function N(m){return m&&m.title}let A=class{constructor(d,k){this.b=k,this.a=d.getProxy(I.$mM.MainThreadMessageService)}showMessage(d,k,F,E,u){const b={source:{identifier:d.identifier,label:d.displayName||d.name}};let f;typeof E=="string"||N(E)?f=[E,...u]:(b.modal=E?.modal,b.useCustom=E?.useCustom,b.detail=E?.detail,f=u),b.useCustom&&(0,M.$0F)(d,"resolvers");const r=[];let o=!1;for(let s=0;s<f.length;s++){const n=f[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:a}=n;r.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this.b.warn(`[${d.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${d.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,F,b,r).then(s=>{if(typeof s=="number")return f[s]})}};e.$Gkc=A,e.$Gkc=A=Je([We(1,O.$Oj)],A)}),define(Ce[238],Pe([1,0,6,16,2,25,4]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class m{constructor(k){this.b=new Map,this.a=k.getProxy(A.$mM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,F,E){if((0,N.$0F)(k,"profileContentHandlers"),this.b.has(F))throw new Error(`Handler with id '${F}' already registered`);return this.b.set(F,E),this.a.$registerProfileContentHandler(F,E.name,E.description,k.identifier.value),(0,I.$Sc)(()=>{this.b.delete(F),this.a.$unregisterProfileContentHandler(F)})}async $saveProfile(k,F,E,u){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(F,E,u)}async $readProfile(k,F,E){const u=this.b.get(k);if(!u)throw new Error(`Unknown handler with id: ${k}`);return u.readProfile((0,O.$Vf)(F)?F:M.URI.revive(F),E)}}e.$Pkc=m}),define(Ce[81],Pe([1,0,4,5,3]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=e.$1jc=void 0;class N{constructor(m){this.b=new O.$7d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(I.$mM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,d){return this.a.$getPassword(m,d)}store(m,d,k){return this.a.$setPassword(m,d,k)}delete(m,d){return this.a.$deletePassword(m,d)}}e.$1jc=N,e.$2jc=(0,M.$ii)("IExtHostSecretState")}),define(Ce[239],Pe([1,0,24,6,4]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;class N{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(M.$mM.MainThreadSpeech)}async $createSpeechToTextSession(m,d,k){const F=this.c.get(m);if(!F)return;const E=new O.$Tc,u=new I.$ee;this.d.set(d,u);const b=E.add(F.provideSpeechToTextSession(u.token,k?{language:k}:void 0));E.add(b.onDidChange(f=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(d,f)})),E.add(u.token.onCancellationRequested(()=>E.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,d){const k=this.c.get(m);if(!k)return;const F=new O.$Tc,E=new I.$ee;this.d.set(d,E);const u=F.add(k.provideKeywordRecognitionSession(E.token));F.add(u.onDidChange(b=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(d,b)})),F.add(E.token.onCancellationRequested(()=>F.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,d,k){const F=N.a++;return this.c.set(F,k),this.b.$registerProvider(F,d,{extension:m,displayName:m.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(F),this.c.delete(F)})}}e.$Wkc=N}),define(Ce[82],Pe([1,0,4,5,3]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=e.$Sjc=void 0;class N{constructor(m,d){this.c=d,this.b=new O.$7d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(I.$mM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,d){this.a.$registerExtensionStorageKeysToSync(m,d)}async initializeExtensionStorage(m,d,k){const F=await this.a.$initializeExtensionStorage(m,d);let E;return F&&(E=this.d(m,d,F)),E||k}setValue(m,d,k){return this.a.$setValue(m,d,k)}$acceptValue(m,d,k){const F=this.d(m,d,k);F&&this.b.fire({shared:m,key:d,value:F})}d(m,d,k){try{return JSON.parse(k)}catch(F){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${m}): ${F}`)}}}e.$Sjc=N,e.$Tjc=(0,M.$ii)("IExtHostStorage")}),define(Ce[240],Pe([1,0,6,12,2,4]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(d){this.c=new Map,this.b=d.getProxy(N.$mM.MainThreadUriOpeners)}registerExternalUriOpener(d,k,F,E){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const u=E.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(k,F),this.b.$registerUriOpener(k,E.schemes,d,E.label),(0,I.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(d,k,F){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener with id: ${d}`);const u=M.URI.revive(k);return E.canOpenExternalUri(u,F)}async $openUri(d,k,F){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener id: '${d}'`);return E.openExternalUri(M.URI.revive(k.resolvedUri),{sourceUri:M.URI.revive(k.sourceUri)},F)}}e.$$kc=A}),define(Ce[241],Pe([1,0,4,2,6,14,20]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class m{static{this.a=0}constructor(k){this.c=new A.$Em,this.d=new Map,this.b=k.getProxy(I.$mM.MainThreadUrls)}registerUriHandler(k,F){const E=k.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=m.a++;return this.c.add(E),this.d.set(u,F),this.b.$registerUriHandler(u,E,k.displayName||k.name),(0,M.$Sc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(k,F){const E=this.d.get(k);if(!E)return Promise.resolve(void 0);try{E.handleUri(O.URI.revive(F))}catch(u){(0,N.$1)(u)}return Promise.resolve(void 0)}async createAppUri(k){return O.URI.revive(await this.b.$createAppUri(k))}}e.$_kc=m}),define(Ce[62],Pe([1,0,5,6,12,26,2,187,209,76,4]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Djc=void 0,e.$Ejc=u,e.$Gjc=r,e.$Hjc=o;class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,t,p,c,$,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$7d,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=t,this.#n=p,this.#s=c,this.#r=$,this.#l=u($),this.#d=b($),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,k.$ezb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===M.Schemas.https||a.scheme===M.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$dzb}return k.$dzb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),N.$Sn(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,d.$3nb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,c,$,w,v,l)=>{const D=A.URI.from({scheme:w||"file",path:decodeURIComponent(v)}),g=(0,k.$ezb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,c,$,w,v,l)=>{const D=A.URI.from({scheme:w||"file",path:decodeURIComponent(v)}),g=(0,k.$ezb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`})}}e.$Djc=E;function u(i){try{const a=(0,m.$up)((0,m.$tp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function b(i){try{const a=(0,m.$up)((0,m.$tp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class f extends O.$Uc{constructor(a,h,t,p,c){super(),this.c=h,this.f=t,this.g=p,this.h=c,this.b=new Map,this.a=a.getProxy(F.$mM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,t){const p=this.j(a);if(p){const{message:c}=(0,d.$4nb)(h,t.value);p._onMessageEmitter.fire(c)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,t){const p=new E(a,this.a,s(h),this.c,this.f,t,this.h);this.b.set(a,p);const c=p._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return p}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Fjc=f;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>A.URI.from(a))}}function n(i,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Ce[109],Pe([1,0,5,4,2,12,15,3,17,25]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";var F;Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=void 0;let E=class{static{F=this}static{this.a={focused:!0,active:!0}}getState(b){const f=this.d;return{get focused(){return f.focused},get active(){return(0,k.$0F)(b,"windowActivity"),f.active}}}constructor(b){this.c=new I.$7d,this.onDidChangeWindowState=this.c.event,this.d=F.a,this.b=b.getProxy(O.$mM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:f,isActive:r})=>{this.onDidChangeWindowProperty("focused",f),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,f){f!==this.d[b]&&(this.d={...this.d,[b]:f},this.c.fire(this.d))}openUri(b,f){let r;if(typeof b=="string"){r=b;try{b=M.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Ue)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,r,f)}async asExternalUri(b,f){if((0,A.$Ue)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(b,f);return M.URI.from(r)}};e.$blc=E,e.$blc=E=F=Je([We(0,d.$HO)],E),e.$clc=(0,m.$ii)("IExtHostWindow")}),define(Ce[242],Pe([1,0,233,27,17]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;let N=class extends I.$flc{constructor(m,d){super(m,d)}f(m,d,k){d.apply(console,k)}};e.$nnc=N,e.$nnc=N=Je([We(0,M.$HO),We(1,O.$XO)],N)}),define(Ce[243],Pe([1,0,11,22,24,14,5,6,143,230,50]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=e.ResponsiveState=e.RequestInitiator=void 0,e.$80b=o,e.$90b=s;function u(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class r{constructor(P,C){this.jsonString=P,this.referencedBuffers=C}}function o(y,P=null,C=!1){const W=[];return{jsonString:(C?u:JSON.stringify)(y,(q,R)=>{if(typeof R>"u")return f;if(typeof R=="object"){if(R instanceof O.$ue){const z=W.push(R)-1;return{[b]:z}}if(P)return P(q,R)}return R}),referencedBuffers:W}}function s(y,P,C){return JSON.parse(y,(W,V)=>{if(V){const q=V[b];if(typeof q=="number")return P[q];if(C&&V.$mid===1)return C.transformIncoming(V)}return V})}function n(y,P){return JSON.stringify(y,P)}function i(y){return y?(P,C)=>C&&C.$mid===1?y.transformOutgoing(C):C:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},p=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class $ extends m.$Uc{static{E=p}static{this.a=3*1e3}constructor(P,C=null,W=null){super(),this[E]=!0,this.b=this.B(new A.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=C,this.g=W,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=F.$bw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$uh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const C=this.w[P];delete this.w[P],C.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,d.$nn)(P,this.g):P}getProxy(P){const{nid:C,sid:W}=P;return this.s[C]||(this.s[C]=this.J(C,W)),this.s[C]}J(P,C){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...R)=>this.U(P,q,R)),q===c?C:V[q])};return new Proxy(Object.create(null),W)}set(P,C){return this.m[P.nid]=C,C}assertRegistered(P){for(let C=0,W=P.length;C<W;C++){const V=P[C];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(P){if(this.j)return;const C=P.byteLength,W=v.read(P,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:R,method:z,args:G}=D.deserializeRequestJSONArgs(W);this.g&&(G=(0,d.$nn)(G,this.g)),this.M(C,q,R,z,G,V===2);break}case 3:case 4:{let{rpcId:R,method:z,args:G}=D.deserializeRequestMixedArgs(W);this.g&&(G=(0,d.$nn)(G,this.g)),this.M(C,q,R,z,G,V===4);break}case 5:{this.f?.logIncoming(C,q,0,"ack"),this.G(q);break}case 6:{this.N(C,q);break}case 7:{this.O(C,q,void 0);break}case 9:{let R=D.deserializeReplyOKJSON(W);this.g&&(R=(0,d.$nn)(R,this.g)),this.O(C,q,R);break}case 10:{const R=D.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(C,q,R);break}case 8:{const R=D.deserializeReplyOKVSBuffer(W);this.O(C,q,R);break}case 11:{let R=D.deserializeReplyErrError(W);this.g&&(R=(0,d.$nn)(R,this.g)),this.P(C,q,R);break}case 12:{this.P(C,q,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,C,W,V,q,R){this.f?.logIncoming(P,C,1,`receiveRequest ${(0,F.$dw)(W)}.${V}(`,q);const z=String(C);let G,ie;if(R){const De=new M.$ee;q.push(De.token),G=this.Q(W,V,q),ie=()=>De.cancel()}else G=this.Q(W,V,q),ie=t;this.u[z]=ie;const fe=D.serializeAcknowledged(C);this.f?.logOutgoing(fe.byteLength,C,1,"ack"),this.c.send(fe),G.then(De=>{delete this.u[z];const we=D.serializeReplyOK(C,De,this.h);this.f?.logOutgoing(we.byteLength,C,1,"reply:",De),this.c.send(we)},De=>{delete this.u[z];const we=D.serializeReplyErr(C,De);this.f?.logOutgoing(we.byteLength,C,1,"replyErr:",De),this.c.send(we)})}N(P,C){this.f?.logIncoming(P,C,1,"receiveCancel");const W=String(C);this.u[W]?.()}O(P,C,W){this.f?.logIncoming(P,C,0,"receiveReply:",W);const V=String(C);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(P,C,W){this.f?.logIncoming(P,C,0,"receiveReplyErr:",W);const V=String(C);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let R;W&&(W.$isError?(R=new Error,R.name=W.name,R.message=W.message,R.stack=W.stack):R=W),q.resolveErr(R)}Q(P,C,W){try{return Promise.resolve(this.S(P,C,W))}catch(V){return Promise.reject(V)}}S(P,C,W){const V=this.m[P];if(!V)throw new Error("Unknown actor "+(0,F.$dw)(P));const q=V[C];if(typeof q!="function")throw new Error("Unknown method "+C+" on actor "+(0,F.$dw)(P));return q.apply(V,W)}U(P,C,W){if(this.j)return new k.$70b;let V=null;if(W.length>0&&M.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(N.$6());const q=D.serializeRequestArguments(W,this.h),R=++this.t,z=String(R),G=new k.$60b,ie=new m.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const De=D.serializeCancel(R);this.f?.logOutgoing(De.byteLength,R,0,"cancel"),this.c.send(D.serializeCancel(R))})),this.w[z]=new w(G,ie),this.F(R);const fe=D.serializeRequest(R,P,C,q,!!V);return this.f?.logOutgoing(fe.byteLength,R,0,`request: ${(0,F.$dw)(P)}.${C}(`,W),this.c.send(fe),G}}e.$00b=$;class w{constructor(P,C){this.a=P,this.b=C}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class v{static alloc(P,C,W){const V=new v(O.$ue.alloc(W+1+4),0);return V.writeUInt8(P),V.writeUInt32(C),V}static read(P,C){return new v(P,C)}get buffer(){return this.a}constructor(P,C){this.a=P,this.b=C}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const C=this.a.slice(this.b,this.b+P);return this.b+=P,C}static sizeMixedArray(P){let C=0;C+=1;for(let W=0,V=P.length;W<V;W++){const q=P[W];switch(C+=1,q.type){case 1:C+=this.sizeLongString(q.value);break;case 2:C+=this.sizeVSBuffer(q.value);break;case 3:C+=this.sizeUInt32,C+=this.sizeLongString(q.value);for(let R=0;R<q.buffers.length;++R)C+=this.sizeVSBuffer(q.buffers[R]);break;case 4:break}}return C}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let C=0,W=P.length;C<W;C++){const V=P[C];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const C=new Array(P);for(let W=0;W<P;W++)switch(this.readUInt8()){case 1:C[W]=this.readLongString();break;case 2:C[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),R=this.readLongString(),z=[];for(let G=0;G<q;++G)z.push(this.readVSBuffer());C[W]=new F.$ew(s(R,z,null));break}case 4:C[W]=void 0;break}return C}}var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class D{static a(P){for(let C=0,W=P.length;C<W;C++)if(P[C]instanceof O.$ue||P[C]instanceof F.$ew||typeof P[C]>"u")return!0;return!1}static serializeRequestArguments(P,C){if(this.a(P)){const W=[];for(let V=0,q=P.length;V<q;V++){const R=P[V];if(R instanceof O.$ue)W[V]={type:2,value:R};else if(typeof R>"u")W[V]={type:4};else if(R instanceof F.$ew){const{jsonString:z,referencedBuffers:G}=o(R.value,C);W[V]={type:3,value:O.$ue.fromString(z),buffers:G}}else W[V]={type:1,value:O.$ue.fromString(n(R,C))}}return{type:1,args:W}}return{type:0,args:n(P,C)}}static serializeRequest(P,C,W,V,q){switch(V.type){case 0:return this.b(P,C,W,V.args,q);case 1:return this.c(P,C,W,V.args,q)}}static b(P,C,W,V,q){const R=O.$ue.fromString(W),z=O.$ue.fromString(V);let G=0;G+=v.sizeUInt8(),G+=v.sizeShortString(R),G+=v.sizeLongString(z);const ie=v.alloc(q?2:1,P,G);return ie.writeUInt8(C),ie.writeShortString(R),ie.writeLongString(z),ie.buffer}static deserializeRequestJSONArgs(P){const C=P.readUInt8(),W=P.readShortString(),V=P.readLongString();return{rpcId:C,method:W,args:JSON.parse(V)}}static c(P,C,W,V,q){const R=O.$ue.fromString(W);let z=0;z+=v.sizeUInt8(),z+=v.sizeShortString(R),z+=v.sizeMixedArray(V);const G=v.alloc(q?4:3,P,z);return G.writeUInt8(C),G.writeShortString(R),G.writeMixedArray(V),G.buffer}static deserializeRequestMixedArgs(P){const C=P.readUInt8(),W=P.readShortString(),V=P.readMixedArray(),q=new Array(V.length);for(let R=0,z=V.length;R<z;R++){const G=V[R];typeof G=="string"?q[R]=JSON.parse(G):q[R]=G}return{rpcId:C,method:W,args:q}}static serializeAcknowledged(P){return v.alloc(5,P,0).buffer}static serializeCancel(P){return v.alloc(6,P,0).buffer}static serializeReplyOK(P,C,W){if(typeof C>"u")return this.d(P);if(C instanceof O.$ue)return this.e(P,C);if(C instanceof F.$ew){const{jsonString:V,referencedBuffers:q}=o(C.value,W,!0);return this.g(P,V,q)}else return this.f(P,u(C,W))}static d(P){return v.alloc(7,P,0).buffer}static e(P,C){let W=0;W+=v.sizeVSBuffer(C);const V=v.alloc(8,P,W);return V.writeVSBuffer(C),V.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,C){const W=O.$ue.fromString(C);let V=0;V+=v.sizeLongString(W);const q=v.alloc(9,P,V);return q.writeLongString(W),q.buffer}static g(P,C,W){const V=O.$ue.fromString(C);let q=0;q+=v.sizeUInt32,q+=v.sizeLongString(V);for(const z of W)q+=v.sizeVSBuffer(z);const R=v.alloc(10,P,q);R.writeUInt32(W.length),R.writeLongString(V);for(const z of W)R.writeBuffer(z);return R.buffer}static deserializeReplyOKJSON(P){const C=P.readLongString();return JSON.parse(C)}static deserializeReplyOKJSONWithBuffers(P,C){const W=P.readUInt32(),V=P.readLongString(),q=[];for(let R=0;R<W;++R)q.push(P.readVSBuffer());return new F.$ew(s(V,q,C))}static serializeReplyErr(P,C){const W=C?u(N.$3(C),null):void 0;if(typeof W!="string")return this.h(P);const V=O.$ue.fromString(W);let q=0;q+=v.sizeLongString(V);const R=v.alloc(11,P,q);return R.writeLongString(V),R.buffer}static deserializeReplyErrError(P){const C=P.readLongString();return JSON.parse(C)}static h(P){return v.alloc(12,P,0).buffer}}var g;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var S;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(S||(S={}))}),define(Ce[244],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;const I=function(N){const A=m=>{globalThis.removeEventListener("message",A);const d=m.data;Object.defineProperties(globalThis,{postMessage:{value(k,F){d.postMessage(k,F)}},onmessage:{get(){return d.onmessage},set(k){d.onmessage=k}}}),d.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),d.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",A)}.toString();class O extends EventTarget{constructor(N,A,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const d=`((${I})('${A}'))`,k=new Blob([d],{type:"application/javascript"}),F=URL.createObjectURL(k),E=new MessageChannel,u=F,b={type:"_newWorker",id:u,port:E.port2,url:F,options:m};N(b,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{N({type:"_terminateWorker",id:u}),URL.revokeObjectURL(F),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(f){E.port1.onmessage=f}},onmessageerror:{get(){return E.port1.onmessageerror},set(f){E.port1.onmessageerror=f}}}),E.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),E.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),E.port1.start()}}e.$pnc=O}),define(Ce[245],Pe([1,0,22,28,12,54,3]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$1J=void 0,e.$2J=F,e.$3J=E,e.$1J=(0,A.$ii)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${m.join("")}]+`),k=7;function F(b){if(b.scheme!==M.Schemas.vscodeNotebookCell)return;const f=b.fragment.indexOf("s");if(f<0)return;const r=parseInt(b.fragment.substring(0,f).replace(d,""),k),o=(0,I.$Ne)(b.fragment.substring(f+1)).toString();if(!isNaN(r))return{handle:r,notebook:b.with({scheme:o,fragment:null})}}function E(b,f){const r=f.toString(k),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,I.$Oe)(I.$ue.fromString(b.scheme),!0,!0)}`;return b.with({scheme:M.Schemas.vscodeNotebookCell,fragment:s})}class u{constructor(){this.a=new O.$Bc}getNotebook(f){if(f.scheme===M.Schemas.vscodeNotebookCell){const r=F(f);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$4J=u,(0,N.$gs)(e.$1J,u,1)}),define(Ce[83],Pe([1,0,22,35,39,69,12,19,21,33,245]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.$iK=e.CellStatusbarAlignment=e.$hK=e.NotebookEditorPriority=e.$eK=e.$dK=e.$bK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aK=e.$_J=e.$$J=e.$0J=e.CellKind=e.$9J=e.$8J=e.$7J=void 0,e.$cK=p,e.$fK=$,e.$gK=w,e.$jK=D,e.$kK=S,e.$7J="workbench.editor.notebook",e.$8J="workbench.editor.notebookTextDiffEditor",e.$9J="workbench.editor.interactive";var E;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(E||(e.CellKind=E={})),e.$0J=["application/json","application/javascript","text/html","image/svg+xml",N.$zs.latex,N.$zs.markdown,"image/png","image/jpeg",N.$zs.text],e.$$J=[N.$zs.latex,N.$zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$zs.text],e.$_J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aK="_notAvailable";var u;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var b;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var f;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var r;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(G){G.scheme=A.Schemas.vscodeNotebookCell;function ie(ne,Se){return(0,F.$3J)(ne,Se)}G.generate=ie;function fe(ne){return(0,F.$2J)(ne)}G.parse=fe;function De(ne,Se){return ne.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Se??""},${ne.scheme!==A.Schemas.file?ne.scheme:""}`})}G.generateCellOutputUri=De;function we(ne){if(ne.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!Se)return;const Le=Se[1]&&Se[1]!==""?Se[1]:void 0,re=Se[2];return{outputId:Le,notebook:ne.with({scheme:re||A.Schemas.file,fragment:null})}}G.parseCellOutputUri=we;function oe(ne,Se,Le){return G.generate(ne,Se).with({scheme:Le})}G.generateCellPropertyUri=oe;function $e(ne,Se){if(ne.scheme===Se)return G.parse(ne.with({scheme:G.scheme}))}G.parseCellPropertyUri=$e})(a||(e.CellUri=a={}));const h=G=>d.$i?G.replace(/\//g,"\\"):G;class t{constructor(ie=[],fe=e.$0J){this.e=fe,this.d=[...new Set(ie)].map(De=>({pattern:De,matches:O.$ck(h(De))}))}sort(ie){const fe=new Map(M.Iterable.map(ie,we=>[we,h(we)]));let De=[];for(const{matches:we}of this.d)for(const[oe,$e]of fe)if(we($e)){De.push(oe),fe.delete(oe);break}return fe.size&&(De=De.concat([...fe.keys()].sort((we,oe)=>this.e.indexOf(we)-this.e.indexOf(oe)))),De}prioritize(ie,fe){const De=this.f(ie);if(De===-1){this.d.unshift({pattern:ie,matches:O.$ck(h(ie))});return}const we=new Set(fe.map($e=>this.f($e,De)));we.delete(-1);const oe=Array.from(we).sort();this.d.splice(De+1,0,...oe.map($e=>this.d[$e]));for(let $e=oe.length-1;$e>=0;$e--)this.d.splice(oe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,fe=this.d.length){const De=h(ie);for(let we=0;we<fe;we++)if(this.d[we].matches(De))return we;return-1}}e.$bK=t;function p(G,ie,fe,De=(we,oe)=>we===oe){const we=[];function oe(Se,Le,re){if(Le===0&&re.length===0)return;const L=we[we.length-1];L&&L.start+L.deleteCount===Se?(L.deleteCount+=Le,L.toInsert.push(...re)):we.push({start:Se,deleteCount:Le,toInsert:re})}let $e=0,ne=0;for(;;){if($e===G.length){oe($e,0,ie.slice(ne));break}if(ne===ie.length){oe($e,G.length-$e,[]);break}const Se=G[$e],Le=ie[ne];if(De(Se,Le)){$e+=1,ne+=1;continue}fe(Le)?(oe($e,1,[]),$e+=1):(oe($e,0,[Le]),ne+=1)}return we}e.$dK=new k.$zj("notebookEditorCursorAtBoundary","none"),e.$eK=new k.$zj("notebookEditorCursorAtLineBoundary","none");var c;(function(G){G.default="default",G.option="option"})(c||(e.NotebookEditorPriority=c={}));function $(G){const ie=G;return!!((typeof ie.include=="string"||O.$dk(ie.include))&&(typeof ie.exclude=="string"||O.$dk(ie.exclude)))}function w(G,ie,fe){if(Array.isArray(G.viewType)&&G.viewType.indexOf(ie)>=0||G.viewType===ie)return!0;if(G.filenamePattern){const De=$(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,we=$(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(O.$bk(De,(0,m.$oc)(fe.fsPath).toLowerCase()))return!(we&&O.$bk(we,(0,m.$oc)(fe.fsPath).toLowerCase()))}return!1}e.$hK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.experimental.cellFailureDiagnostics"};var v;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class l{static{this.d="notebook/"}static create(ie){return`${l.d}${ie}`}static parse(ie){if(ie.startsWith(l.d))return ie.substring(l.d.length)}}e.$iK=l;function D(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}const g=new TextDecoder;function S(G){const ie=[];let fe=!1;for(const $e of G)(ie.length===0||fe)&&(ie.push($e),fe=!0);let De=C(ie);const we=I.$ue.concat(ie.map($e=>I.$ue.wrap($e))),oe=z(we);return De=De||oe.byteLength!==we.byteLength,{data:oe,didCompression:De}}e.$lK="\x1B[A";const y=e.$lK.split("").map(G=>G.charCodeAt(0)),P=10;function C(G){let ie=!1;return G.forEach((fe,De)=>{if(De===0||fe.length<e.$lK.length)return;const we=G[De-1],oe=fe.subarray(0,e.$lK.length);if(oe[0]===y[0]&&oe[1]===y[1]&&oe[2]===y[2]){const $e=we.lastIndexOf(P);if($e===-1)return;ie=!0,G[De-1]=we.subarray(0,$e),G[De]=fe.subarray(e.$lK.length)}}),ie}function W(G){let ie=G;do G=ie,ie=G.replace(/[^\n]\x08/gm,"");while(ie.length<G.length);return G}function V(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const ie=G.match(/^(.*)\r+/m)[1];let fe=G.match(/\r+(.*)$/m)[1];fe=fe+ie.slice(fe.length,ie.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,fe)}return G}const q=8,R=13;function z(G){return!G.buffer.includes(q)&&!G.buffer.includes(R)?G:I.$ue.fromString(V(W(g.decode(G.buffer))))}}),define(Ce[7],Pe([1,0,18,14,53,28,69,15,16,2,34,20,43,102,83]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f){"use strict";var r,o,s,n,i,a,h,t,p,c,$,w,v,l,D,g,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$vO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$uO=e.$tO=e.$sO=e.$rO=e.ChatLocation=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$iO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.TestRunProfileKind=e.TestResultState=e.$ZN=e.$YN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$XN=e.NotebookVariablesRequestKind=e.$WN=e.$VN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$UN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.ColorThemeKind=e.$ON=e.$NN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$MN=e.$LN=e.DebugConsoleMode=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$FN=e.$EN=e.FileChangeType=e.$DN=e.NewSymbolNameTag=e.$CN=e.$BN=e.$AN=e.$zN=e.InlineCompletionTriggerKind=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$mN=e.ConfigurationTarget=e.$lN=e.$kN=e.$jN=e.$iN=e.DocumentPasteTriggerKind=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$bN=e.ViewBadge=e.ProgressLocation=e.$aN=e.$_M=e.TaskScope=e.ShellQuoting=e.$$M=e.$0M=e.$9M=e.TaskPanelKind=e.TaskRevealKind=e.$8M=e.TerminalLocation=e.$7M=e.$6M=e.$5M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$4M=e.$3M=e.$2M=e.$1M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$YM=e.$XM=e.$WM=e.$VM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$UM=e.$TM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.LanguageStatusSeverity=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.CodeActionTriggerKind=e.$HM=e.$GM=e.SymbolTag=e.SymbolKind=e.$FM=e.$EM=e.DocumentHighlightKind=e.$DM=e.$CM=e.$BM=e.$AM=e.DiagnosticSeverity=e.DiagnosticTag=e.$zM=e.$yM=e.FileEditType=e.$xM=e.$wM=e.$vM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$ZM=dt,e.$nN=Q;function y(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...Ge]=te;return Reflect.construct(B,Ge,Ee.constructor)}}})}var P;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var C;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(C||(e.TerminalQuickFixType=C={}));let W=r=class{static from(...T){let te=T;return new r(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$oM=W,e.$oM=W=r=Je([y],W);let V=o=class{static Min(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Ee=1;Ee<T.length;Ee++){const Ge=T[Ee];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Ee=1;Ee<T.length;Ee++){const Ge=T[Ee];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(T){if(!T)return!1;if(T instanceof o)return!0;const{line:te,character:Ee}=T;return typeof te=="number"&&typeof Ee=="number"}static of(T){if(T instanceof o)return T;if(this.isPosition(T))return new o(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,te){if(T<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=T,this.e=te}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,te=0){if(T===null||te===null)throw(0,O.$7)();let Ee;return typeof T>"u"?Ee=0:typeof T=="number"?Ee=T:(Ee=typeof T.lineDelta=="number"?T.lineDelta:0,te=typeof T.characterDelta=="number"?T.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(T,te=this.character){if(T===null||te===null)throw(0,O.$7)();let Ee;return typeof T>"u"?Ee=this.line:typeof T=="number"?Ee=T:(Ee=typeof T.line=="number"?T.line:this.line,te=typeof T.character=="number"?T.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$pM=V,e.$pM=V=o=Je([y],V);let q=s=class{static isRange(T){return T instanceof s?!0:T?V.isPosition(T.start)&&V.isPosition(T.end):!1}static of(T){if(T instanceof s)return T;if(this.isRange(T))return new s(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,te,Ee,Ge){let _e,lt;if(typeof T=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(_e=new V(T,te),lt=new V(Ee,Ge)):V.isPosition(T)&&V.isPosition(te)&&(_e=V.of(T),lt=V.of(te)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(T){return s.isRange(T)?this.contains(T.start)&&this.contains(T.end):V.isPosition(T)?!(V.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const te=V.Max(T.start,this.c),Ee=V.Min(T.end,this.e);if(!te.isAfter(Ee))return new s(te,Ee)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const te=V.Min(T.start,this.c),Ee=V.Max(T.end,this.end);return new s(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,te=this.end){if(T===null||te===null)throw(0,O.$7)();let Ee;return T?V.isPosition(T)?Ee=T:(Ee=T.start||this.start,te=T.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new s(Ee,te)}toJSON(){return[this.start,this.end]}};e.$qM=q,e.$qM=q=s=Je([y],q);let R=n=class extends q{static isSelection(T){return T instanceof n?!0:T?q.isRange(T)&&V.isPosition(T.anchor)&&V.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,te,Ee,Ge){let _e,lt;if(typeof T=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(_e=new V(T,te),lt=new V(Ee,Ge)):V.isPosition(T)&&V.isPosition(te)&&(_e=V.of(T),lt=V.of(te)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$rM=R,e.$rM=R=n=Je([y],R);const z=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,O.$7)("connectionToken")};class G{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te,Ee){if(typeof T!="string"||T.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof Ee<"u"&&z(Ee),this.host=T,this.port=Math.round(te),this.connectionToken=Ee}}e.$sM=G;class ie{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te){this.makeConnection=T,this.connectionToken=te,typeof te<"u"&&z(te)}}e.$tM=ie;class fe extends Error{static NotAvailable(T,te){return new fe(T,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(T){return new fe(T,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,te=b.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(T),this._message=T,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,fe.prototype)}}e.$uM=fe;var De;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(De||(e.EndOfLine=De={}));var we;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(we||(e.EnvironmentVariableMutatorType=we={}));let oe=i=class{static isTextEdit(T){return T instanceof i?!0:T?q.isRange(T)&&typeof T.newText=="string":!1}static replace(T,te){return new i(T,te)}static insert(T,te){return i.replace(new q(T,T),te)}static delete(T){return i.replace(T,"")}static setEndOfLine(T){const te=new i(new q(new V(0,0),new V(0,0)),"");return te.newEol=T,te}get range(){return this.c}set range(T){if(T&&!q.isRange(T))throw(0,O.$7)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,O.$7)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,O.$7)("newEol");this.f=T}constructor(T,te){this.c=T,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$vM=oe,e.$vM=oe=i=Je([y],oe);let $e=a=class{static isNotebookCellEdit(T){return T instanceof a?!0:T?Te.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,te){return new a(T,te)}static insertCells(T,te){return new a(new Te(T,T),te)}static deleteCells(T){return new a(T,[])}static updateCellMetadata(T,te){const Ee=new a(new Te(T,T),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(T){const te=new a(new Te(0,0),[]);return te.newNotebookMetadata=T,te}constructor(T,te){this.range=T,this.newCells=te}};e.$wM=$e,e.$wM=$e=a=Je([y],$e);class ne{static isSnippetTextEdit(T){return T instanceof ne?!0:T?q.isRange(T.range)&&re.isSnippetString(T.snippet):!1}static replace(T,te){return new ne(T,te)}static insert(T,te){return ne.replace(new q(T,T),te)}constructor(T,te){this.range=T,this.snippet=te}}e.$xM=ne;var Se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let Le=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,te,Ee,Ge){this.c.push({_type:1,from:T,to:te,options:Ee,metadata:Ge})}createFile(T,te,Ee){this.c.push({_type:1,from:void 0,to:T,options:te,metadata:Ee})}deleteFile(T,te,Ee){this.c.push({_type:1,from:T,to:void 0,options:te,metadata:Ee})}e(T,te,Ee){this.c.push({_type:3,metadata:Ee,uri:T,edit:{editType:5,metadata:te},notebookMetadata:te})}f(T,te,Ee,Ge){const _e=te.start,lt=te.end;(_e!==lt||Ee.length>0)&&this.c.push({_type:5,uri:T,index:_e,count:lt-_e,cells:Ee,metadata:Ge})}g(T,te,Ee,Ge){this.c.push({_type:3,metadata:Ge,uri:T,edit:{editType:3,index:te,metadata:Ee}})}replace(T,te,Ee,Ge){this.c.push({_type:2,uri:T,edit:new oe(te,Ee),metadata:Ge})}insert(T,te,Ee,Ge){this.replace(T,new q(te,te),Ee,Ge)}delete(T,te,Ee){this.replace(T,te,"",Ee)}has(T){return this.c.some(te=>te._type===2&&te.uri.toString()===T.toString())}set(T,te){if(te)for(const Ee of te){if(!Ee)continue;let Ge,_e;Array.isArray(Ee)?(Ge=Ee[0],_e=Ee[1]):Ge=Ee,$e.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(T,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(T,Ge.newNotebookMetadata,_e):this.f(T,Ge.range,Ge.newCells,_e):ne.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:T,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:T,edit:Ge,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ge=this.c[Ee];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===T.toString()&&(this.c[Ee]=void 0);break}}(0,I.$Ib)(this.c)}}get(T){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===T.toString()&&te.push(Ee.edit);return te}entries(){const T=new N.$Bc;for(const te of this.c)if(te._type===2){let Ee=T.get(te.uri);Ee||(Ee=[te.uri,[]],T.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$yM=Le,e.$yM=Le=Je([y],Le);let re=h=class{static isSnippetString(T){return T instanceof h?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=h.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,te=this.e++){if(typeof T=="function"){const Ee=new h;Ee.e=this.e,T(Ee),this.e=Ee.e,T=Ee.value}else T=h.c(T);return this.value+="${",this.value+=te,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,te=this.e++){const Ee=T.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(T,te){if(typeof te=="function"){const Ee=new h;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$zM=re,e.$zM=re=h=Je([y],re);var L;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(L||(e.DiagnosticTag=L={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=t=class{static isLocation(T){return T instanceof t?!0:T?q.isRange(T.range)&&k.URI.isUri(T.uri):!1}constructor(T,te){if(this.uri=T,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$AM=ve,e.$AM=ve=t=Je([y],ve);let Oe=class{static is(T){return T?typeof T.message=="string"&&T.location&&q.isRange(T.location.range)&&k.URI.isUri(T.location.uri):!1}constructor(T,te){this.location=T,this.message=te}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.location.range.isEqual(te.location.range)&&T.location.uri.toString()===te.location.uri.toString()}};e.$BM=Oe,e.$BM=Oe=Je([y],Oe);let ye=class{constructor(T,te,Ee=x.Error){if(!q.isRange(T))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=T,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.severity===te.severity&&T.code===te.code&&T.severity===te.severity&&T.source===te.source&&T.range.isEqual(te.range)&&(0,I.$ub)(T.tags,te.tags)&&(0,I.$ub)(T.relatedInformation,te.relatedInformation,Oe.isEqual)}};e.$CM=ye,e.$CM=ye=Je([y],ye);let pe=class{constructor(T,te){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=te}};e.$DM=pe,e.$DM=pe=Je([y],pe);var de;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(de||(e.DocumentHighlightKind=de={}));let J=class{constructor(T,te=de.Text){this.range=T,this.kind=te}toJSON(){return{range:this.range,kind:de[this.kind]}}};e.$EM=J,e.$EM=J=Je([y],J);let Y=class{constructor(T,te){this.uri=T,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(T=>T.toJSON())}}};e.$FM=Y,e.$FM=Y=Je([y],Y);var ue;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ue||(e.SymbolKind=ue={}));var he;(function(B){B[B.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let Ne=p=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,te,Ee,Ge,_e){this.name=T,this.kind=te,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),Ge instanceof ve?this.location=Ge:Ee instanceof q&&(this.location=new ve(Ge,Ee)),p.validate(this)}toJSON(){return{name:this.name,kind:ue[this.kind],location:this.location,containerName:this.containerName}}};e.$GM=Ne,e.$GM=Ne=p=Je([y],Ne);let le=c=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(c.validate)}constructor(T,te,Ee,Ge,_e){this.name=T,this.detail=te,this.kind=Ee,this.range=Ge,this.selectionRange=_e,this.children=[],c.validate(this)}};e.$HM=le,e.$HM=le=c=Je([y],le);var Ie;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let Re=class{constructor(T,te){this.title=T,this.kind=te}};e.$IM=Re,e.$IM=Re=Je([y],Re);let je=class{static{$=this}static{this.c="."}constructor(T){this.value=T}append(T){return new $(this.value?this.value+$.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+$.c)}};e.$JM=je,e.$JM=je=$=Je([y],je),je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorMove=je.Refactor.append("move"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll"),je.Notebook=je.Empty.append("notebook");let U=class{constructor(T,te){if(this.range=T,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$KM=U,e.$KM=U=Je([y],U);class j{constructor(T,te,Ee,Ge,_e,lt){this.kind=T,this.name=te,this.detail=Ee,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$LM=j;class K{constructor(T,te){this.fromRanges=te,this.from=T}}e.$MM=K;class H{constructor(T,te){this.fromRanges=te,this.to=T}}e.$NM=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(T,te){this.range=T,this.command=te}get isResolved(){return!!this.command}};e.$OM=se,e.$OM=se=Je([y],se);let Fe=w=class{#e;static isMarkdownString(T){return T instanceof w?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,te=!1){this.#e=new M.$Fk(T,{supportThemeIcons:te})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,te){return this.#e.appendCodeblock(te??"",T),this}};e.$PM=Fe,e.$PM=Fe=w=Je([y],Fe);let Ve=class{constructor(T,te){this.label=T,this.documentation=te}};e.$QM=Ve,e.$QM=Ve=Je([y],Ve);let Qe=class{constructor(T,te){this.label=T,this.documentation=te,this.parameters=[]}};e.$RM=Qe,e.$RM=Qe=Je([y],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$SM=xe,e.$SM=xe=Je([y],xe);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var at;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let it=class{constructor(T){this.value=T}};e.$TM=it,e.$TM=it=Je([y],it);let nt=class{constructor(T,te,Ee){this.position=T,this.label=te,this.kind=Ee}};e.$UM=nt,e.$UM=nt=Je([y],nt);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ft;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var Ue;(function(B){B[B.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let ot=class{constructor(T,te){this.label=T,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$VM=ot,e.$VM=ot=Je([y],ot);let Z=class{constructor(T=[],te=!1){this.items=T,this.isIncomplete=te}};e.$WM=Z,e.$WM=Z=Je([y],Z);let X=class{constructor(T,te,Ee){this.insertText=T,this.range=te,this.command=Ee}};e.$XM=X,e.$XM=X=Je([y],X);let me=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$YM=me,e.$YM=me=Je([y],me);var qe;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(qe||(e.PartialAcceptTriggerKind=qe={}));var Xe;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Xe||(e.ViewColumn=Xe={}));var Me;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Me||(e.StatusBarAlignment=Me={}));function dt(B,T){return`${E.$Dm.toKey(B)}.${T}`}var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var zt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var xt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(xt||(e.TextEditorRevealType=xt={}));var Jt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Et;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Et||(e.DecorationRangeBehavior=Et={})),function(B){function T(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=T}(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var Qt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Qt||(e.SyntaxTokenType=Qt={})),function(B){function T(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=T}(Qt||(e.SyntaxTokenType=Qt={}));let Vt=class{constructor(T,te){if(te&&!k.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(T)||T.isEmpty)throw(0,O.$7)("range");this.range=T,this.target=te}};e.$1M=Vt,e.$1M=Vt=Je([y],Vt);let ai=class{constructor(T,te,Ee,Ge){this.red=T,this.green=te,this.blue=Ee,this.alpha=Ge}};e.$2M=ai,e.$2M=ai=Je([y],ai);let Ye=class{constructor(T,te){if(te&&!(te instanceof ai))throw(0,O.$7)("color");if(!q.isRange(T)||T.isEmpty)throw(0,O.$7)("range");this.range=T,this.color=te}};e.$3M=Ye,e.$3M=Ye=Je([y],Ye);let ei=class{constructor(T){if(!T||typeof T!="string")throw(0,O.$7)("label");this.label=T}};e.$4M=ei,e.$4M=ei=Je([y],ei);var ti;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ht;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ht||(e.SourceControlInputBoxValidationType=ht={}));var vt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(vt||(e.TerminalExitReason=vt={}));class si{constructor(T,te,Ee){if(this.startIndex=T,this.length=te,this.tooltip=Ee,typeof T!="number"||T<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,O.$7)("tooltip")}}e.$5M=si;class ii{constructor(T){this.uri=T}}e.$6M=ii;class Ft{constructor(T){this.terminalCommand=T}}e.$7M=Ft;var mt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(mt||(e.TerminalLocation=mt={}));class Mt{constructor(T){if(this.options=T,typeof T!="object")throw(0,O.$7)("options")}}e.$8M=Mt;var Wt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Wt||(e.TaskRevealKind=Wt={}));var Xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Xt||(e.TaskPanelKind=Xt={}));let Ke=class{static{v=this}static{this.Clean=new v("clean","Clean")}static{this.Build=new v("build","Build")}static{this.Rebuild=new v("rebuild","Rebuild")}static{this.Test=new v("test","Test")}static from(T){switch(T){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(T,te){if(this.label=te,typeof T!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=T}get id(){return this.c}};e.$9M=Ke,e.$9M=Ke=v=Je([y],Ke);function Zt(B){let T="";for(let te=0;te<B.length;te++)T+=B[te].replace(/,/g,",,")+",";return T}let jt=class{constructor(T,te,Ee){if(typeof T!="string")throw(0,O.$7)("process");this.e=[],this.c=T,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,O.$7)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const te of this.e)T.push(te);return Zt(T)}};e.$0M=jt,e.$0M=jt=Je([y],jt);let Ut=class{constructor(T,te,Ee){if(this.f=[],Array.isArray(te)){if(!T)throw(0,O.$7)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,O.$7)("command");this.e=T,this.f=te,this.g=Ee}else{if(typeof T!="string")throw(0,O.$7)("commandLine");this.c=T,this.g=te}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,O.$7)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,O.$7)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)T.push(typeof te=="string"?te:te.value);return Zt(T)}};e.$$M=Ut,e.$$M=Ut=Je([y],Ut);var $t;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var Tt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Tt||(e.TaskScope=Tt={}));class Rt{constructor(T){this.c=T}computeId(){return"customExecution"+(0,F.$Eg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$_M=Rt;let Lt=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,te,Ee,Ge,_e,lt){this.k=!1,this.l=this.definition=T;let gt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ge,gt=_e,this.k=!0):te===Tt.Global||te===Tt.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ge,this.execution=_e,gt=lt):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ge,this.execution=_e,gt=lt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(T){this.j=T}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof jt?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof Ut?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,F.$Eg)()}}get definition(){return this.l}set definition(T){if(T==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=T}get scope(){return this.m}set target(T){this.B(),this.m=T}get name(){return this.o}set name(T){if(typeof T!="string")throw(0,O.$7)("name");this.B(),this.o=T}get execution(){return this.q}set execution(T){T===null&&(T=void 0),this.B(),this.q=T;const te=this.l.type;(l.g===te||l.e===te||l.f===te||l.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(T){if(Array.isArray(T))this.B(),this.r=T,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.B(),this.u=T}get source(){return this.w}set source(T){if(typeof T!="string"||T.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=T}get group(){return this.x}set group(T){T===null&&(T=void 0),this.B(),this.x=T}get detail(){return this.A}set detail(T){T===null&&(T=void 0),this.A=T}get presentationOptions(){return this.y}set presentationOptions(T){T==null&&(T=Object.create(null)),this.B(),this.y=T}get runOptions(){return this.z}set runOptions(T){T==null&&(T=Object.create(null)),this.B(),this.z=T}};e.$aN=Lt,e.$aN=Lt=l=Je([y],Lt);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var oi;(function(B){function T(te){const Ee=te;return(0,d.$Zf)(Ee.value)?Ee.tooltip&&!(0,d.$Vf)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=T})(oi||(e.ViewBadge=oi={}));let qt=D=class{static isTreeItem(T,te){const Ee=T;if(Ee.checkboxState!==void 0){const Ge=(0,d.$Zf)(Ee.checkboxState)?Ee.checkboxState:(0,d.$Xf)(Ee.checkboxState)&&(0,d.$Zf)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,d.$Zf)(Ee.checkboxState)&&(0,d.$Xf)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Dt.Checked&&Ge!==Dt.Unchecked||_e!==void 0&&!(0,d.$Vf)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(T instanceof D)return!0;if(Ee.label!==void 0&&!(0,d.$Vf)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,d.$Vf)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,d.$Vf)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,d.$Vf)(Ee.iconPath.id))){const Ge=Ee.iconPath;if(!Ge||!(0,d.$Vf)(Ge.light)&&!k.URI.isUri(Ge.light)&&!(0,d.$Vf)(Ge.dark)&&!k.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,d.$Vf)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,d.$Vf)(Ee.tooltip)&&!(Ee.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<It.None&&Ee.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,d.$Vf)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(T,te=It.None){this.collapsibleState=te,k.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$bN=qt,e.$bN=qt=D=Je([y],qt);var It;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var Dt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let Ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$cN=Ht,e.$cN=Ht=Je([y],Ht);class Ct extends Ht{}e.$dN=Ct;class wt extends Ct{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$eN=wt;class St{constructor(T,te,Ee,Ge){this.name=T,this.uri=te,this._itemId=Ee,this.c=Ge}data(){return this.c()}}e.$fN=St;let kt=class{#e=new Map;constructor(T){for(const[te,Ee]of T??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,te){this.#e.set(this.#t(T),[te])}forEach(T,te){for(const[Ee,Ge]of this.#e)for(const _e of Ge)T.call(te,_e,Ee,this)}*[Symbol.iterator](){for(const[T,te]of this.#e)for(const Ee of te)yield[T,Ee]}#t(T){return T.toLowerCase()}};e.$gN=kt,e.$gN=kt=Je([y],kt);let ui=class{constructor(T,te,Ee){this.insertText=T,this.title=te,this.kind=Ee}};e.$hN=ui,e.$hN=ui=Je([y],ui);var ri;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(ri||(e.DocumentPasteTriggerKind=ri={}));class li{static{this.c="."}constructor(T){this.value=T}append(...T){return new li((this.value?[this.value,...T]:T).join(li.c))}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+li.c)}}e.$iN=li,li.Empty=new li("");let di=class{constructor(T,te,Ee){this.title=te,this.insertText=T,this.kind=Ee}};e.$jN=di,e.$jN=di=Je([y],di);let Yt=class{constructor(T,te){this.id=T,this.color=te}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$kN=Yt,e.$kN=Yt=Je([y],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let At=class{constructor(T){this.id=T}};e.$lN=At,e.$lN=At=Je([y],At);var be;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(be||(e.ConfigurationTarget=be={}));let Ae=class{get base(){return this.c}set base(T){this.c=T,this.e=k.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,te){if(typeof T!="string"&&(!T||!k.URI.isUri(T)&&!k.URI.isUri(T.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof T=="string"?this.baseUri=k.URI.file(T):k.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$mN=Ae,e.$mN=Ae=Je([y],Ae);const ae=new WeakMap;function Q(B,T){ae.set(B,T)}let ke=class{constructor(T,te,Ee,Ge,_e){this.enabled=typeof T=="boolean"?T:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ge=="string"&&(this.logMessage=Ge),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=ae.get(this)??(0,F.$Eg)()),this.c}};e.$oN=ke,e.$oN=ke=Je([y],ke);let Be=class extends ke{constructor(T,te,Ee,Ge,_e,lt){if(super(te,Ee,Ge,_e,lt),T===null)throw(0,O.$7)("location");this.location=T}};e.$pN=Be,e.$pN=Be=Je([y],Be);let Ze=class extends ke{constructor(T,te,Ee,Ge,_e,lt){super(te,Ee,Ge,_e,lt),this.functionName=T}};e.$qN=Ze,e.$qN=Ze=Je([y],Ze);let He=class extends ke{constructor(T,te,Ee,Ge,_e,lt,gt,Gt){if(super(Ge,_e,lt,gt,Gt),!te)throw(0,O.$7)("dataId");this.label=T,this.dataId=te,this.canPersist=Ee}};e.$rN=He,e.$rN=He=Je([y],He);let rt=class{constructor(T,te,Ee){this.command=T,this.args=te||[],this.options=Ee}};e.$sN=rt,e.$sN=rt=Je([y],rt);let yt=class{constructor(T,te){this.port=T,this.host=te}};e.$tN=yt,e.$tN=yt=Je([y],yt);let Kt=class{constructor(T){this.path=T}};e.$uN=Kt,e.$uN=Kt=Je([y],Kt);let Bt=class{constructor(T){this.implementation=T}};e.$vN=Bt,e.$vN=Bt=Je([y],Bt);class Ot{constructor(T,te,Ee){this.session=T,this.threadId=te,this.frameId=Ee}}e.$wN=Ot;class ut{constructor(T,te){this.session=T,this.threadId=te}}e.$xN=ut;let Ci=class{constructor(T,te){this.range=T,this.expression=te}};e.$yN=Ci,e.$yN=Ci=Je([y],Ci);var gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let $i=class{constructor(T,te){this.range=T,this.text=te}};e.$zN=$i,e.$zN=$i=Je([y],$i);let wi=class{constructor(T,te,Ee=!0){this.range=T,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$AN=wi,e.$AN=wi=Je([y],wi);let Pi=class{constructor(T,te){this.range=T,this.expression=te}};e.$BN=Pi,e.$BN=Pi=Je([y],Pi);let Mi=class{constructor(T,te){this.frameId=T,this.stoppedLocation=te}};e.$CN=Mi,e.$CN=Mi=Je([y],Mi);var Vi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Vi||(e.NewSymbolNameTag=Vi={}));class Wi{constructor(T,te){this.newSymbolName=T,this.tags=te}}e.$DN=Wi;var qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let yi=g=class extends Error{static FileExists(T){return new g(T,u.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(T){return new g(T,u.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(T){return new g(T,u.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(T){return new g(T,u.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(T){return new g(T,u.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(T){return new g(T,u.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(T,te=u.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(T)?T.toString(!0):T),this.code=Ee?.name??"Unknown",(0,u.$4k)(this,te),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$EN=yi,e.$EN=yi=g=Je([y],yi);let Ri=class{constructor(T,te,Ee){this.start=T,this.end=te,this.kind=Ee}};e.$FN=Ri,e.$FN=Ri=Je([y],Ri);var ki;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var Ei;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Hi||(e.CommentMode=Hi={}));var Ki;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ki||(e.CommentState=Ki={}));var vi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));var Gi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Gi||(e.CommentThreadApplicability=Gi={}));class gn{constructor(T,te=[]){this.tokenTypes=T,this.tokenModifiers=te}}e.$GN=gn;function mn(B){return typeof B>"u"||(0,d.$Wf)(B)}class Ai{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,T){this.m=!0;for(let te=0,Ee=T.tokenTypes.length;te<Ee;te++)this.k.set(T.tokenTypes[te],te);for(let te=0,Ee=T.tokenModifiers.length;te<Ee;te++)this.l.set(T.tokenModifiers[te],te)}}push(T,te,Ee,Ge,_e){if(typeof T=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(T,te,Ee,Ge,_e);if(q.isRange(T)&&typeof te=="string"&&mn(Ee))return this.o(T,te,Ee);throw(0,O.$7)()}o(T,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=T.start.line,_e=T.start.character,lt=T.end.character-T.start.character,gt=this.k.get(te);let Gt=0;if(Ee)for(const hi of Ee){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(hi);Gt|=1<<fi>>>0}this.q(Ge,_e,lt,gt,Gt)}q(T,te,Ee,Ge,_e){if(this.f&&(T<this.c||T===this.c&&te<this.e)){this.f=!1;const Gt=this.g.length/5|0;let hi=0,fi=0;for(let mi=0;mi<Gt;mi++){let pi=this.g[5*mi],Ui=this.g[5*mi+1];pi===0?(pi=hi,Ui+=fi):pi+=hi,this.g[5*mi]=pi,this.g[5*mi+1]=Ui,hi=pi,fi=Ui}}let lt=T,gt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=Ee,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=T,this.e=te}static r(T){const te=[],Ee=T.length/5|0;for(let gt=0;gt<Ee;gt++)te[gt]=gt;te.sort((gt,Gt)=>{const hi=T[5*gt],fi=T[5*Gt];if(hi===fi){const mi=T[5*gt+1],pi=T[5*Gt+1];return mi-pi}return hi-fi});const Ge=new Uint32Array(T.length);let _e=0,lt=0;for(let gt=0;gt<Ee;gt++){const Gt=5*te[gt],hi=T[Gt+0],fi=T[Gt+1],mi=T[Gt+2],pi=T[Gt+3],Ui=T[Gt+4],Fn=hi-_e,sr=Fn===0?fi-lt:fi,Bi=5*gt;Ge[Bi+0]=Fn,Ge[Bi+1]=sr,Ge[Bi+2]=mi,Ge[Bi+3]=pi,Ge[Bi+4]=Ui,_e=hi,lt=fi}return Ge}build(T){return this.f?new Oi(new Uint32Array(this.g),T):new Oi(Ai.r(this.g),T)}}e.$HN=Ai;class Oi{constructor(T,te){this.resultId=te,this.data=T}}e.$IN=Oi;class Ji{constructor(T,te,Ee){this.start=T,this.deleteCount=te,this.data=Ee}}e.$JN=Ji;class Qi{constructor(T,te){this.resultId=te,this.edits=T}}e.$KN=Qi;var Xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class Zi{constructor(T){this.name=T}}e.$LN=Zi;let Di=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$MN=Di,e.$MN=Di=Je([y],Di);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var _i;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(T){if(typeof T.badge=="string"){let te=(0,m.$vf)(T.badge,0);if(te<T.badge.length&&(te+=(0,m.$vf)(T.badge,te)),T.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Yt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,te,Ee){this.badge=T,this.tooltip=te,this.color=Ee}}e.$NN=$n;let bi=class{constructor(T){this.kind=T}};e.$ON=bi,e.$ON=bi=Je([y],bi);var Fi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Fi||(e.ColorThemeKind=Fi={}));class Te{static isNotebookRange(T){return T instanceof Te?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,te){if(T<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");T<=te?(this.c=T,this.e=te):(this.c=te,this.e=T)}with(T){let te=this.c,Ee=this.e;return T.start!==void 0&&(te=T.start),T.end!==void 0&&(Ee=T.end),te===this.c&&Ee===this.e?this:new Te(te,Ee)}}e.$PN=Te;class ci{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(te=>ci.isNotebookCellData(te))}static isNotebookCellData(T){return!0}constructor(T,te,Ee,Ge,_e,lt,gt){this.kind=T,this.value=te,this.languageId=Ee,this.mime=Ge,this.outputs=_e??[],this.metadata=lt,this.executionSummary=gt,ci.validate(this)}}e.$QN=ci;class en{constructor(T){this.cells=T}}e.$RN=en;class et{static isNotebookCellOutputItem(T){return T instanceof et?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const te={name:T.name,message:T.message,stack:T.stack};return et.json(te,"application/vnd.code.notebook.error")}static stdout(T){return et.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return et.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,te="application/octet-stream"){return new et(T,te)}static#e=new TextEncoder;static text(T,te=A.$zs.text){const Ee=et.#e.encode(String(T));return new et(Ee,te)}static json(T,te="text/x-json"){const Ee=JSON.stringify(T,void 0,"	");return et.text(Ee,te)}constructor(T,te){this.data=T,this.mime=te;const Ee=(0,A.$Ds)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$SN=et;class pt{static isNotebookCellOutput(T){return T instanceof pt?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,te=!1){const Ee=new Set,Ge=new Set;for(let _e=0;_e<T.length;_e++){const lt=T[_e],gt=(0,A.$Ds)(lt.mime);if(!Ee.has(gt)||(0,f.$jK)(gt)){Ee.add(gt);continue}Ge.add(_e),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?T:T.filter((_e,lt)=>!Ge.has(lt))}constructor(T,te,Ee){this.items=pt.ensureUniqueMimeTypes(T,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,F.$Eg)(),this.metadata=te??Ee)}}e.$TN=pt;var tn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Ni;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ni||(e.NotebookCellStatusBarAlignment=Ni={}));var rn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class Si{constructor(T,te){this.text=T,this.alignment=te}}e.$UN=Si;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(T,te=[]){this.uri=T,this.provides=(0,I.$3b)(te)}}e.$VN=pn;class an{constructor(T){this.label=T}}e.$WN=an;var cn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ti=class{constructor(T,te){this.label=T,this.timestamp=te}};e.$XN=Ti,e.$XN=Ti=Je([y],Ti);var un;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class vn{constructor(T,te){this.ranges=T,this.wordPattern=te}}e.$YN=vn;class bn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$ZN=bn;var dn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var fn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Li=class{constructor(T=void 0,te=void 0,Ee=void 0,Ge=!1){this.include=T,this.exclude=te,this.profile=Ee,this.continuous=Ge}};e.$1N=Li,e.$1N=Li=Je([y],Li);let ji=S=class{static diff(T,te,Ee){const Ge=new S(T);return Ge.expectedOutput=te,Ge.actualOutput=Ee,Ge}constructor(T){this.message=T}};e.$2N=ji,e.$2N=ji=S=Je([y],ji);let _=class{constructor(T){this.id=T}};e.$3N=_,e.$3N=_=Je([y],_);class ce{constructor(T,te){this.covered=T,this.total=te}}e.$4N=ce;const ze=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class st{static fromDetails(T,te){const Ee=new ce(0,0),Ge=new ce(0,0),_e=new ce(0,0);for(const gt of te)if("branches"in gt){Ee.total+=1,Ee.covered+=gt.executed?1:0;for(const Gt of gt.branches)Ge.total+=1,Ge.covered+=Gt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const lt=new st(T,Ee,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=te,lt}constructor(T,te,Ee,Ge){this.uri=T,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ge,ze(te),ze(Ee),ze(Ge)}}e.$5N=st;class bt{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Ee=[]){this.executed=T,this.location=te,this.branches=Ee}}e.$6N=bt;class Nt{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Ee){this.executed=T,this.location=te,this.label=Ee}}e.$7N=Nt;class zi{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Ee){this.name=T,this.executed=te,this.location=Ee}}e.$8N=zi;var wn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(wn||(e.ExternalUriOpenerPriority=wn={}));var yn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Nn{constructor(T,te,Ee,Ge,_e,lt){this.kind=T,this.name=te,this.detail=Ee,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$9N=Nn;class Tn{constructor(T){this.uri=T}}e.$0N=Tn;class Ln{constructor(T,te){this.original=T,this.modified=te}}e.$$N=Ln;class jn{constructor(T,te,Ee,Ge){this.base=T,this.input1=te,this.input2=Ee,this.result=Ge}}e.$_N=jn;class zn{constructor(T,te){this.uri=T,this.viewType=te}}e.$aO=zn;class Un{constructor(T){this.viewType=T}}e.$bO=Un;class Bn{constructor(T,te){this.uri=T,this.notebookType=te}}e.$cO=Bn;class Vn{constructor(T,te,Ee){this.original=T,this.modified=te,this.notebookType=Ee}}e.$dO=Vn;class Wn{constructor(){}}e.$eO=Wn;class qn{constructor(T,te){this.uri=T,this.inputBoxUri=te}}e.$fO=qn;class Hn{constructor(T){this.providerId=T}}e.$gO=Hn;class Kn{constructor(T){this.textDiffs=T}}e.$hO=Kn;var En;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Dn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Dn||(e.ChatCopyKind=Dn={}));var Sn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Gn{constructor(T,te){this.label=T,this.values=te}}e.$iO=Gn;var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Jn{constructor(T){this.value=typeof T=="string"?new Fe(T):T}}e.$jO=Jn;class Qn{constructor(T,te){this.value=T,this.baseUri=te}}e.$kO=Qn;class Xn{constructor(T,te){this.value=T,this.title=te}}e.$lO=Xn;class Zn{constructor(T){this.value=T}}e.$mO=Zn;class Yn{constructor(T){this.value=T}}e.$nO=Yn;class xn{constructor(T){this.value=T}}e.$oO=xn;class _n{constructor(T,te,Ee,Ge){this.prompt=T,this.command=te,this.variables=Ee,this.participant=Ge}}e.$pO=_n;class er{constructor(T,te,Ee,Ge){this.response=T,this.result=te,this.participant=Ee,this.command=Ge}}e.$qO=er;var Pn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook"})(Pn||(e.ChatLocation=Pn={}));class tr{constructor(T){this.content=T}}e.$rO=tr;class ir{constructor(T,te){this.content=T,this.name=te}}e.$sO=ir;class nr{constructor(T){this.content=T}}e.$tO=nr;class Ii extends Error{static NotFound(T){return new Ii(T,Ii.NotFound.name)}static NoPermissions(T){return new Ii(T,Ii.NoPermissions.name)}constructor(T,te,Ee){super(T,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$uO=Ii;var Mn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Mn||(e.RelatedInformationType=Mn={}));var Rn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class rr{constructor(T,te){this.text=T,this.range=te}}e.$vO=rr;var On;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(Ce[246],Pe([1,0,4,7]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$mM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,d){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(A);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(m,d)??[]}getRelatedInformation(A,m,d){return this.c.$getAiRelatedInformation(m,d)}registerRelatedInformationProvider(A,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiRelatedInformationProvider(k,m),new O.$oM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$8ic=M}),define(Ce[84],Pe([1,0,5,4,7,20,106,3,17]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=e.$gjc=void 0,e.$gjc=(0,m.$ii)("IExtHostAuthentication");let k=class{constructor(u){this.b=new Map,this.c=new I.$7d,this.onDidChangeSessions=this.c.event,this.d=new F,this.f=new F,this.a=u.getProxy(O.$mM.MainThreadAuthentication)}async getSession(u,b,f,r={}){const o=N.$Dm.toKey(u.identifier),s=[...f].sort().join(" ");return await this.d.getOrCreate(`${o} ${b} ${s}`,async()=>{await this.a.$ensureProvider(b);const n=u.displayName||u.name;return this.a.$getSession(b,f,o,n,r)})}async getSessions(u,b,f){const r=N.$Dm.toKey(u.identifier),o=[...f].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(b);const s=u.displayName||u.name;return this.a.$getSessions(b,f,r,s)})}async removeSession(u,b){const f=this.b.get(u);return f?f.provider.removeSession(b):this.a.$removeSession(u,b)}registerAuthenticationProvider(u,b,f,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:b,provider:f,options:r??{supportsMultipleAccounts:!1}});const o=f.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(u,s));return this.a.$registerAuthenticationProvider(u,b,r?.supportsMultipleAccounts??!1),new M.$oM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,b,f){const r=this.b.get(u);if(r)return Promise.resolve(r.provider.createSession(b,f));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,b){const f=this.b.get(u);if(f)return Promise.resolve(f.provider.removeSession(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,b){const f=this.b.get(u);if(f)return Promise.resolve(f.provider.getSessions(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,b){return u.startsWith(A.$oL)||this.c.fire({provider:{id:u,label:b}}),Promise.resolve()}};e.$hjc=k,e.$hjc=k=Je([We(0,d.$HO)],k);class F{constructor(){this.a=new Map}getOrCreate(u,b){const f=this.a.get(u);if(f)return f;const r=b().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Ce[110],Pe([1,0,2,4,7,3,17,13,18,15,19,25]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(O.$mM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=u.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const a=(0,d.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,k.$1e)(c.path,"/")})),t=(0,d.$zb)(h,(c,$)=>c.rank-$.rank||(0,k.$ef)(c.uri.path,$.uri.path)),p=[];e:for(const c of t){let $;for(const w of c){const v=(0,F.$nc)(w.uri.path);if($!==v&&($=v,p.push(w.uri)>=u.d))break e}}this.g.$onDidChange(s,p)});return new M.$oM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:t,id:p}=h,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{M.$NN.validate(c),c.badge&&typeof c.badge!="string"&&(0,E.$0F)(a,"codiconDecoration"),n[p]=[c.propagate,c.tooltip,c.badge,c.color]}catch($){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),n}};e.$hkc=b,e.$hkc=b=u=Je([We(0,A.$HO),We(1,m.$Oj)],b),e.$ikc=(0,N.$ii)("IExtHostDecorations")}),define(Ce[247],Pe([1,0,14,2,7,4,12,24,15]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;class k{static{this.a=0}constructor(E,u,b){this.d=u,this.e=b,this.b=new Map,this.c=E.getProxy(N.$mM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(A.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const b=k.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,E);let f;if(typeof u.onDidChange=="function"){let r;f=u.onDidChange(async o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(b,o).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,d.$$e)(n);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,n)}).catch(I.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new M.$oM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(E,u){const b=this.b.get(E);return b?Promise.resolve(b.provideTextDocumentContent(O.URI.revive(u),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$kkc=k}),define(Ce[111],Pe([1,0,55,12,15,303,151,7,18]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=void 0,e.$JO=F;const k=new Map;function F(f,r){r?k.set(f,r):k.delete(f)}function E(f){return k.get(f)}class u extends N.$Hv{constructor(r,o,s,n,i,a,h){super(o,s,n,i),this.c=r,this.m=a,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,d.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===O.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,I.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,I.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,n=o.start.line,i=o.end.line,a=[];a.push(this.f[n].substring(o.start.character));for(let h=n+1;h<i;h++)a.push(this.f[h]);return a.push(this.f[i].substring(0,o.end.character)),a.join(s)}t(r){let o;if(r instanceof m.$pM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new m.$pM(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof m.$qM))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new m.$qM(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof m.$pM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,n=!0;else{const i=this.f[o].length;s<0?(s=0,n=!0):s>i&&(s=i,n=!0)}return n?new m.$pM(o,s):r}y(r,o){const s=this.x(r);if(!o)o=E(this.m);else if((0,M.$0e)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,A.$Rs)(s.character+1,(0,A.$Ps)(o),this.f[s.line],0);if(n)return new m.$qM(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$KO=u;class b{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$qM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$qM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$LO=b}),define(Ce[248],Pe([1,0,4,7]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$mM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,d){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(A);if(!k)throw new Error("Embedding vector provider not found");const F=await k.provideEmbeddingVector(m,d);if(!F)throw new Error("Embedding vector provider returned undefined");return F}registerEmbeddingVectorProvider(A,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiEmbeddingVectorProvider(m,k),new O.$oM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$mkc=M}),define(Ce[63],Pe([1,0,4,43,7,22,3,17,44,6,11,23,12]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=e.$zjc=void 0;let f=b=class{constructor(o,s){this.b=new Map,this.c=new F.$rh,this.a=o.getProxy(I.$mM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let a;const h=n.b.get(i.scheme);return h?(await n.a.$ensureActivation(i.scheme),a=await h.impl.stat(i)):a=await n.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===O.FilePermission.Readonly?1:void 0}}catch(a){b.e(a)}},async readDirectory(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(a){return b.e(a)}},async createDirectory(i){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(a.impl,a.extUri,i)):await n.a.$mkdir(i)}catch(a){return b.e(a)}},async readFile(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(a){return b.e(a)}},async writeFile(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,N.$ue.wrap(a))}catch(h){return b.e(h)}},async delete(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await n.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...a})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return b.e(h)}},async rename(i,a,h){try{return await n.a.$rename(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},async copy(i,a,h){try{return await n.a.$copy(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,s,n){const i=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&O.FileType.Directory))throw M.$EN.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(O.$5k(a)!==O.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(n)),n=s.dirname(n)}for(let a=i.length-1;a>=0;a--){n=s.joinPath(n,i[a]);try{await o.createDirectory(n)}catch(h){if(O.$5k(h)!==O.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof M.$EN)throw o;if(o instanceof O.$1k)switch(o.code){case O.FileSystemProviderErrorCode.FileExists:throw M.$EN.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$EN.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$EN.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$EN.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$EN.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$EN.Unavailable(o.message);default:throw new M.$EN(o.message,o.name)}if(!(o instanceof Error))throw new M.$EN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw M.$EN.Unavailable(o.message);switch(o.name){case O.FileSystemProviderErrorCode.FileExists:throw M.$EN.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$EN.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$EN.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$EN.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$EN.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$EN.Unavailable(o.message);default:throw new M.$EN(o.message,o.name)}}addFileSystemProvider(o,s,n){return this.b.set(o,{impl:s,extUri:n?.isCaseSensitive?E.$Lg:E.$Ng,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??E.$Lg}};e.$zjc=f,e.$zjc=f=b=Je([We(0,m.$HO),We(1,d.$ajc)],f),e.$Ajc=(0,A.$ii)("IExtHostConsumerFileSystem")}),define(Ce[249],Pe([1,0,4,7]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;class M{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(I.$mM.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const d=this.a.get(A);if(!d)throw new Error("Issue request handler not found");const k=await d.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueData(m);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueTemplate(m);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(A,m){const d=A.identifier.value;return this.a.set(d,m),this.c.$registerIssueUriRequestHandler(d),new O.$oM(()=>{this.c.$unregisterIssueUriRequestHandler(d),this.a.delete(d)})}registerIssueDataProvider(A,m){const d=A.identifier.value;return this.b.set(d,m),this.c.$registerIssueDataProvider(d),new O.$oM(()=>{this.c.$unregisterIssueDataProvider(d),this.b.delete(d)})}}e.$Dkc=M}),define(Ce[85],Pe([1,0,3,27,13,63,2]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=e.$Bjc=void 0,e.$Bjc=(0,I.$ii)("IExtensionStoragePaths");let m=class{constructor(k,F,E){this.d=F,this.f=E,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(k){return A.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,F=await this.g(k);try{return await this.f.value.stat(F),this.d.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",F),await this.f.value.createDirectory(F),await this.f.value.writeFile(A.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),F}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(k){if(this.c)return A.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return A.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Cjc=m,e.$Cjc=m=Je([We(0,O.$XO),We(1,M.$Oj),We(2,N.$Ajc)],m)}),define(Ce[250],Pe([1,0,7,17,5]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=void 0;let N=class{constructor(m){this.a=new I.$ON(I.ColorThemeKind.Dark),this.b=new M.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let d;switch(m){case"light":d=I.ColorThemeKind.Light;break;case"hcDark":d=I.ColorThemeKind.HighContrast;break;case"hcLight":d=I.ColorThemeKind.HighContrastLight;break;default:d=I.ColorThemeKind.Dark}this.a=new I.$ON(d),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$7kc=N,e.$7kc=N=Je([We(0,O.$HO)],N)}),define(Ce[86],Pe([1,0,24,5,6,173,3,13,202,4,27,17,7]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UBb=e.$TBb=e.TunnelDtoConverter=void 0;class b extends d.$7v{}var f;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?d.TunnelPrivacyId.Public:d.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==d.TunnelPrivacyId.ConstantPrivate&&i.privacy!==d.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=n})(f||(e.TunnelDtoConverter=f={})),e.$TBb=(0,A.$ii)("IExtHostTunnelService");let r=class extends M.$Uc{constructor(s,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(k.$mM.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,s.displayName);if(i){const a=new b(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,i),new u.$oM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,n,i,a,h){const t=[];for(const c of s){const $=this.r.get(c);if(!$)return[];t.push(...await Promise.all(n.map(async w=>{let v;try{v=await $.provider.providePortAttributes({port:w,pid:i,commandLine:a},h)}catch{v=await $.provider.providePortAttributes(w,i,a,h)}return{providedAttributes:v,port:w}})))}const p=t.filter(c=>!!c.providedAttributes);return p.length>0?p.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await s.provideTunnel(a,h,I.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(n&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:h}),f.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),i=s.filter((a,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$UBb=r,e.$UBb=r=Je([We(0,E.$HO),We(1,F.$XO),We(2,m.$Oj)],r)}),define(Ce[8],Pe([1,0,18,22,131,251,53,28,123,52,69,26,126,23,16,2,29,87,100,105,104,212,83,49,60,223,25,7]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p,c,$,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$EO=G,e.$FO=fe,e.$GO=De;var l;(function(be){function Ae(Q){const{selectionStartLineNumber:ke,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:He}=Q,rt=new v.$pM(ke-1,Be-1),yt=new v.$pM(Ze-1,He-1);return new v.$rM(rt,yt)}be.to=Ae;function ae(Q){const{anchor:ke,active:Be}=Q;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}be.from=ae})(l||(e.Selection=l={}));var D;(function(be){function Ae(Q){if(!Q)return;const{start:ke,end:Be}=Q;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}be.from=Ae;function ae(Q){if(!Q)return;const{startLineNumber:ke,startColumn:Be,endLineNumber:Ze,endColumn:He}=Q;return new v.$qM(ke-1,Be-1,Ze-1,He-1)}be.to=ae})(D||(e.Range=D={}));var g;(function(be){function Ae(Q){return{uri:Q.uri,range:D.from(Q.range)}}be.from=Ae;function ae(Q){return new v.$AM(r.URI.revive(Q.uri),D.to(Q.range))}be.to=ae})(g||(e.Location=g={}));var S;(function(be){function Ae(ae){switch(ae){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 3:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}be.to=Ae})(S||(e.TokenType=S={}));var y;(function(be){function Ae(Q){return new v.$pM(Q.lineNumber-1,Q.column-1)}be.to=Ae;function ae(Q){return{lineNumber:Q.line+1,column:Q.character+1}}be.from=ae})(y||(e.Position=y={}));var P;(function(be){function Ae(ke,Be,Ze){return(0,I.$Hb)((0,I.$3b)(ke).map(He=>ae(He,Be,Ze)))}be.from=Ae;function ae(ke,Be,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:Q(ke.scheme,Be),pattern:me.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function Q(ke,Be){return Be&&typeof ke=="string"?Be.transformOutgoingScheme(ke):ke}})(P||(e.DocumentSelector=P={}));var C;(function(be){function Ae(Q){switch(Q){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}be.from=Ae;function ae(Q){switch(Q){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}be.to=ae})(C||(e.DiagnosticTag=C={}));var W;(function(be){function Ae(Q){let ke;return Q.code&&((0,f.$Vf)(Q.code)||(0,f.$Zf)(Q.code)?ke=String(Q.code):ke={value:String(Q.code.value),target:Q.code.target}),{...D.from(Q.range),message:Q.message,source:Q.source,code:ke,severity:q.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(V.from),tags:Array.isArray(Q.tags)?(0,I.$Hb)(Q.tags.map(C.from)):void 0}}be.from=Ae;function ae(Q){const ke=new v.$CM(D.to(Q),Q.message,q.to(Q.severity));return ke.source=Q.source,ke.code=(0,f.$Vf)(Q.code)?Q.code:Q.code?.value,ke.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(V.to),ke.tags=Q.tags&&(0,I.$Hb)(Q.tags.map(C.to)),ke}be.to=ae})(W||(e.Diagnostic=W={}));var V;(function(be){function Ae(Q){return{...D.from(Q.location.range),message:Q.message,resource:Q.location.uri}}be.from=Ae;function ae(Q){return new v.$BM(new v.$AM(Q.resource,D.to(Q)),Q.message)}be.to=ae})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(be){function Ae(Q){switch(Q){case v.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}be.from=Ae;function ae(Q){switch(Q){case n.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}be.to=ae})(q||(e.DiagnosticSeverity=q={}));var R;(function(be){function Ae(Q){return typeof Q=="number"&&Q>=v.ViewColumn.One?Q-1:Q===v.ViewColumn.Beside?$.$CD:$.$BD}be.from=Ae;function ae(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(R||(e.ViewColumn=R={}));function z(be){return typeof be.range<"u"}function G(be){return be.length===0?!0:!!z(be[0])}var ie;(function(be){function Ae(He){return He.map(be.from)}be.fromMany=Ae;function ae(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function Q(He){let rt;if(ae(He)){const{language:Ot,value:ut}=He;rt={value:"```"+Ot+`
`+ut+"\n```\n"}}else v.$PM.isMarkdownString(He)?rt={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?rt={value:He}:rt={value:""};const yt=Object.create(null);rt.uris=yt;const Kt=Ot=>{try{let ut=r.URI.parse(Ot,!0);ut=ut.with({query:ke(ut.query,yt)}),yt[Ot]=ut}catch{}return""},Bt=new d.marked.Renderer;return Bt.link=Kt,Bt.image=Ot=>typeof Ot=="string"?Kt(A.$Nk(Ot).href):"",(0,d.marked)(rt.value,{renderer:Bt}),rt}be.from=Q;function ke(He,rt){if(!He)return He;let yt;try{yt=(0,k.$Qh)(He)}catch{}if(!yt)return He;let Kt=!1;return yt=(0,E.$Qn)(yt,Bt=>{if(r.URI.isUri(Bt)){const Ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Ot]=Bt,Kt=!0,Ot}else return}),Kt?JSON.stringify(yt):He}function Be(He){const rt=new v.$PM(He.value,He.supportThemeIcons);return rt.isTrusted=He.isTrusted,rt.supportHtml=He.supportHtml,rt.baseUri=He.baseUri?r.URI.from(He.baseUri):void 0,rt}be.to=Be;function Ze(He){if(He)return typeof He=="string"?He:be.from(He)}be.fromStrict=Ze})(ie||(e.MarkdownString=ie={}));function fe(be){return G(be)?be.map(Ae=>({range:D.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?ie.fromMany(Ae.hoverMessage):Ae.hoverMessage?ie.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):be.map(Ae=>({range:D.from(Ae)}))}function De(be){return typeof be>"u"?be:typeof be=="string"?r.URI.file(be):be}var we;(function(be){function Ae(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?De(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Ae})(we||(e.ThemableDecorationAttachmentRenderOptions=we={}));var oe;(function(be){function Ae(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?De(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?we.from(ae.before):void 0,after:ae.after?we.from(ae.after):void 0}}be.from=Ae})(oe||(e.ThemableDecorationRenderOptions=oe={}));var $e;(function(be){function Ae(ae){if(typeof ae>"u")return ae;switch(ae){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Ae})($e||(e.DecorationRangeBehavior=$e={}));var ne;(function(be){function Ae(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?$e.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?oe.from(ae.light):void 0,dark:ae.dark?oe.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?De(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?we.from(ae.before):void 0,after:ae.after?we.from(ae.after):void 0}}be.from=Ae})(ne||(e.DecorationRenderOptions=ne={}));var Se;(function(be){function Ae(Q){return{text:Q.newText,eol:Q.newEol&&ft.from(Q.newEol),range:D.from(Q.range)}}be.from=Ae;function ae(Q){const ke=new v.$vM(D.to(Q.range),Q.text);return ke.newEol=typeof Q.eol>"u"?void 0:ft.to(Q.eol),ke}be.to=ae})(Se||(e.TextEdit=Se={}));var Le;(function(be){function Ae(Q,ke){const Be={edits:[]};if(Q instanceof v.$yM){const Ze=new m.$Cc;for(const He of Q._allEntries())He._type===1&&r.URI.isUri(He.to)&&He.from===void 0&&Ze.add(He.to);for(const He of Q._allEntries())if(He._type===1){let rt;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?rt={type:"base64",value:(0,O.$Oe)(O.$ue.wrap(He.options.contents))}:rt={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:rt},metadata:He.metadata})}else He._type===2?Be.edits.push({resource:He.uri,textEdit:Se.from(He.edit),versionId:Ze.has(He.uri)?void 0:ke?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?Be.edits.push({resource:He.uri,textEdit:{range:D.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ze.has(He.uri)?void 0:ke?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(He.uri)}):He._type===5&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:ke?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(Jt.from)}})}return Be}be.from=Ae;function ae(Q){const ke=new v.$yM,Be=new m.$Bc;for(const Ze of Q.edits)if(Ze.textEdit){const He=Ze,rt=r.URI.revive(He.resource),yt=D.to(He.textEdit.range),Kt=He.textEdit.text,Bt=He.textEdit.insertAsSnippet;let Ot;Bt?Ot=v.$xM.replace(yt,new v.$zM(Kt)):Ot=v.$vM.replace(yt,Kt);const ut=Be.get(rt);ut?ut.push(Ot):Be.set(rt,[Ot])}else ke.renameFile(r.URI.revive(Ze.oldResource),r.URI.revive(Ze.newResource),Ze.options);for(const[Ze,He]of Be)ke.set(Ze,He);return ke}be.to=ae})(Le||(e.WorkspaceEdit=Le={}));var re;(function(be){const Ae=Object.create(null);Ae[v.SymbolKind.File]=0,Ae[v.SymbolKind.Module]=1,Ae[v.SymbolKind.Namespace]=2,Ae[v.SymbolKind.Package]=3,Ae[v.SymbolKind.Class]=4,Ae[v.SymbolKind.Method]=5,Ae[v.SymbolKind.Property]=6,Ae[v.SymbolKind.Field]=7,Ae[v.SymbolKind.Constructor]=8,Ae[v.SymbolKind.Enum]=9,Ae[v.SymbolKind.Interface]=10,Ae[v.SymbolKind.Function]=11,Ae[v.SymbolKind.Variable]=12,Ae[v.SymbolKind.Constant]=13,Ae[v.SymbolKind.String]=14,Ae[v.SymbolKind.Number]=15,Ae[v.SymbolKind.Boolean]=16,Ae[v.SymbolKind.Array]=17,Ae[v.SymbolKind.Object]=18,Ae[v.SymbolKind.Key]=19,Ae[v.SymbolKind.Null]=20,Ae[v.SymbolKind.EnumMember]=21,Ae[v.SymbolKind.Struct]=22,Ae[v.SymbolKind.Event]=23,Ae[v.SymbolKind.Operator]=24,Ae[v.SymbolKind.TypeParameter]=25;function ae(ke){return typeof Ae[ke]=="number"?Ae[ke]:6}be.from=ae;function Q(ke){for(const Be in Ae)if(Ae[Be]===ke)return Number(Be);return v.SymbolKind.Property}be.to=Q})(re||(e.SymbolKind=re={}));var L;(function(be){function Ae(Q){switch(Q){case v.SymbolTag.Deprecated:return 1}}be.from=Ae;function ae(Q){switch(Q){case 1:return v.SymbolTag.Deprecated}}be.to=ae})(L||(e.SymbolTag=L={}));var x;(function(be){function Ae(Q){return{name:Q.name,kind:re.from(Q.kind),tags:Q.tags&&Q.tags.map(L.from),containerName:Q.containerName,location:de.from(Q.location)}}be.from=Ae;function ae(Q){const ke=new v.$GM(Q.name,re.to(Q.kind),Q.containerName,de.to(Q.location));return ke.tags=Q.tags&&Q.tags.map(L.to),ke}be.to=ae})(x||(e.WorkspaceSymbol=x={}));var ve;(function(be){function Ae(Q){const ke={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),kind:re.from(Q.kind),tags:Q.tags?.map(L.from)??[]};return Q.children&&(ke.children=Q.children.map(Ae)),ke}be.from=Ae;function ae(Q){const ke=new v.$HM(Q.name,Q.detail,re.to(Q.kind),D.to(Q.range),D.to(Q.selectionRange));return(0,I.$Lb)(Q.tags)&&(ke.tags=Q.tags.map(L.to)),Q.children&&(ke.children=Q.children.map(ae)),ke}be.to=ae})(ve||(e.DocumentSymbol=ve={}));var Oe;(function(be){function Ae(Q){const ke=new v.$LM(re.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return ke._sessionId=Q._sessionId,ke._itemId=Q._itemId,ke}be.to=Ae;function ae(Q,ke,Be){if(ke=ke??Q._sessionId,Be=Be??Q._itemId,ke===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Be,name:Q.name,detail:Q.detail,kind:re.from(Q.kind),uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(L.from)}}be.from=ae})(Oe||(e.CallHierarchyItem=Oe={}));var ye;(function(be){function Ae(ae){return new v.$MM(Oe.to(ae.from),ae.fromRanges.map(Q=>D.to(Q)))}be.to=Ae})(ye||(e.CallHierarchyIncomingCall=ye={}));var pe;(function(be){function Ae(ae){return new v.$NM(Oe.to(ae.to),ae.fromRanges.map(Q=>D.to(Q)))}be.to=Ae})(pe||(e.CallHierarchyOutgoingCall=pe={}));var de;(function(be){function Ae(Q){return{range:Q.range&&D.from(Q.range),uri:Q.uri}}be.from=Ae;function ae(Q){return new v.$AM(r.URI.revive(Q.uri),D.to(Q.range))}be.to=ae})(de||(e.location=de={}));var J;(function(be){function Ae(Q){const ke=Q,Be=Q;return{originSelectionRange:ke.originSelectionRange?D.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Be.uri,range:D.from(ke.targetRange?ke.targetRange:Be.range),targetSelectionRange:ke.targetSelectionRange?D.from(ke.targetSelectionRange):void 0}}be.from=Ae;function ae(Q){return{targetUri:r.URI.revive(Q.uri),targetRange:D.to(Q.range),targetSelectionRange:Q.targetSelectionRange?D.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?D.to(Q.originSelectionRange):void 0}}be.to=ae})(J||(e.DefinitionLink=J={}));var Y;(function(be){function Ae(Q){return{range:D.from(Q.range),contents:ie.fromMany(Q.contents)}}be.from=Ae;function ae(Q){return new v.$DM(Q.contents.map(ie.to),D.to(Q.range))}be.to=ae})(Y||(e.Hover=Y={}));var ue;(function(be){function Ae(Q){return{range:D.from(Q.range),expression:Q.expression}}be.from=Ae;function ae(Q){return new v.$yN(D.to(Q.range),Q.expression)}be.to=ae})(ue||(e.EvaluatableExpression=ue={}));var he;(function(be){function Ae(Q){if(Q instanceof v.$zN)return{type:"text",range:D.from(Q.range),text:Q.text};if(Q instanceof v.$AN)return{type:"variable",range:D.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof v.$BN)return{type:"expression",range:D.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Ae;function ae(Q){switch(Q.type){case"text":return{range:D.to(Q.range),text:Q.text};case"variable":return{range:D.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:D.to(Q.range),expression:Q.expression}}}be.to=ae})(he||(e.InlineValue=he={}));var Ne;(function(be){function Ae(Q){return{frameId:Q.frameId,stoppedLocation:D.from(Q.stoppedLocation)}}be.from=Ae;function ae(Q){return new v.$CN(Q.frameId,D.to(Q.stoppedLocation))}be.to=ae})(Ne||(e.InlineValueContext=Ne={}));var le;(function(be){function Ae(Q){return{range:D.from(Q.range),kind:Q.kind}}be.from=Ae;function ae(Q){return new v.$EM(D.to(Q.range),Q.kind)}be.to=ae})(le||(e.DocumentHighlight=le={}));var Ie;(function(be){function Ae(Q){return{uri:Q.uri,highlights:Q.highlights.map(le.from)}}be.from=Ae;function ae(Q){return new v.$FM(r.URI.revive(Q.uri),Q.highlights.map(le.to))}be.to=ae})(Ie||(e.MultiDocumentHighlight=Ie={}));var Re;(function(be){function Ae(ae){switch(ae){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}be.to=Ae})(Re||(e.CompletionTriggerKind=Re={}));var je;(function(be){function Ae(ae){return{triggerKind:Re.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Ae})(je||(e.CompletionContext=je={}));var U;(function(be){function Ae(Q){switch(Q){case v.CompletionItemTag.Deprecated:return 1}}be.from=Ae;function ae(Q){switch(Q){case 1:return v.CompletionItemTag.Deprecated}}be.to=ae})(U||(e.CompletionItemTag=U={}));var j;(function(be){const Ae=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ae(Be){return Ae.get(Be)??9}be.from=ae;const Q=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function ke(Be){return Q.get(Be)??v.CompletionItemKind.Property}be.to=ke})(j||(e.CompletionItemKind=j={}));var K;(function(be){function Ae(ae,Q){const ke=new v.$VM(ae.label);return ke.insertText=ae.insertText,ke.kind=j.to(ae.kind),ke.tags=ae.tags?.map(U.to),ke.detail=ae.detail,ke.documentation=A.$Hk(ae.documentation)?ie.to(ae.documentation):ae.documentation,ke.sortText=ae.sortText,ke.filterText=ae.filterText,ke.preselect=ae.preselect,ke.commitCharacters=ae.commitCharacters,o.$ct.isIRange(ae.range)?ke.range=D.to(ae.range):typeof ae.range=="object"&&(ke.range={inserting:D.to(ae.range.insert),replacing:D.to(ae.range.replace)}),ke.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?ke.insertText=new v.$zM(ae.insertText):(ke.insertText=ae.insertText,ke.textEdit=ke.range instanceof v.$qM?new v.$vM(ke.range,ke.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ke.additionalTextEdits=ae.additionalTextEdits.map(Be=>Se.to(Be))),ke.command=Q&&ae.command?Q.fromInternal(ae.command):void 0,ke}be.to=Ae})(K||(e.CompletionItem=K={}));var H;(function(be){function Ae(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:ie.fromStrict(Q.documentation)}}be.from=Ae;function ae(Q){return{label:Q.label,documentation:A.$Hk(Q.documentation)?ie.to(Q.documentation):Q.documentation}}be.to=ae})(H||(e.ParameterInformation=H={}));var ee;(function(be){function Ae(Q){return{label:Q.label,documentation:ie.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.from):[],activeParameter:Q.activeParameter}}be.from=Ae;function ae(Q){return{label:Q.label,documentation:A.$Hk(Q.documentation)?ie.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.to):[],activeParameter:Q.activeParameter}}be.to=ae})(ee||(e.SignatureInformation=ee={}));var se;(function(be){function Ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ee.from):[]}}be.from=Ae;function ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ee.to):[]}}be.to=ae})(se||(e.SignatureHelp=se={}));var Fe;(function(be){function Ae(ae,Q){const ke=new v.$UM(y.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Ve.to.bind(void 0,ae)),Q.kind&&Qe.to(Q.kind));return ke.textEdits=Q.textEdits&&Q.textEdits.map(Se.to),ke.tooltip=A.$Hk(Q.tooltip)?ie.to(Q.tooltip):Q.tooltip,ke.paddingLeft=Q.paddingLeft,ke.paddingRight=Q.paddingRight,ke}be.to=Ae})(Fe||(e.InlayHint=Fe={}));var Ve;(function(be){function Ae(ae,Q){const ke=new v.$TM(Q.label);return ke.tooltip=A.$Hk(Q.tooltip)?ie.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(ke.command=ae.fromInternal(Q.command)),Q.location&&(ke.location=de.to(Q.location)),ke}be.to=Ae})(Ve||(e.InlayHintLabelPart=Ve={}));var Qe;(function(be){function Ae(Q){return Q}be.from=Ae;function ae(Q){return Q}be.to=ae})(Qe||(e.InlayHintKind=Qe={}));var xe;(function(be){function Ae(Q){return{range:D.from(Q.range),url:Q.target,tooltip:Q.tooltip}}be.from=Ae;function ae(Q){let ke;if(Q.url)try{ke=typeof Q.url=="string"?r.URI.parse(Q.url,!0):r.URI.revive(Q.url)}catch{}return new v.$1M(D.to(Q.range),ke)}be.to=ae})(xe||(e.DocumentLink=xe={}));var tt;(function(be){function Ae(Q){const ke=new v.$4M(Q.label);return Q.textEdit&&(ke.textEdit=Se.to(Q.textEdit)),Q.additionalTextEdits&&(ke.additionalTextEdits=Q.additionalTextEdits.map(Be=>Se.to(Be))),ke}be.to=Ae;function ae(Q){return{label:Q.label,textEdit:Q.textEdit?Se.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(ke=>Se.from(ke)):void 0}}be.from=ae})(tt||(e.ColorPresentation=tt={}));var at;(function(be){function Ae(Q){return new v.$2M(Q[0],Q[1],Q[2],Q[3])}be.to=Ae;function ae(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}be.from=ae})(at||(e.Color=at={}));var it;(function(be){function Ae(Q){return{range:D.from(Q.range)}}be.from=Ae;function ae(Q){return new v.$KM(D.to(Q.range))}be.to=ae})(it||(e.SelectionRange=it={}));var nt;(function(be){function Ae(ae){switch(ae){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}be.to=Ae})(nt||(e.TextDocumentSaveReason=nt={}));var ct;(function(be){function Ae(Q){switch(Q){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.Interval:return 3;case v.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Ae;function ae(Q){switch(Q){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 3:return v.TextEditorLineNumbersStyle.Interval;case 1:default:return v.TextEditorLineNumbersStyle.On}}be.to=ae})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ft;(function(be){function Ae(Q){if(Q===v.EndOfLine.CRLF)return 1;if(Q===v.EndOfLine.LF)return 0}be.from=Ae;function ae(Q){if(Q===1)return v.EndOfLine.CRLF;if(Q===0)return v.EndOfLine.LF}be.to=ae})(ft||(e.EndOfLine=ft={}));var Ue;(function(be){function Ae(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Ae})(Ue||(e.ProgressLocation=Ue={}));var ot;(function(be){function Ae(Q){const ke={start:Q.start+1,end:Q.end+1};return Q.kind&&(ke.kind=Z.from(Q.kind)),ke}be.from=Ae;function ae(Q){const ke={start:Q.start-1,end:Q.end-1};return Q.kind&&(ke.kind=Z.to(Q.kind)),ke}be.to=ae})(ot||(e.FoldingRange=ot={}));var Z;(function(be){function Ae(Q){if(Q)switch(Q){case v.FoldingRangeKind.Comment:return s.$7t.Comment;case v.FoldingRangeKind.Imports:return s.$7t.Imports;case v.FoldingRangeKind.Region:return s.$7t.Region}}be.from=Ae;function ae(Q){if(Q)switch(Q.value){case s.$7t.Comment.value:return v.FoldingRangeKind.Comment;case s.$7t.Imports.value:return v.FoldingRangeKind.Imports;case s.$7t.Region.value:return v.FoldingRangeKind.Region}}be.to=ae})(Z||(e.FoldingRangeKind=Z={}));var X;(function(be){function Ae(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?D.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.$5E.id:void 0}}be.from=Ae})(X||(e.TextEditorOpenOptions=X={}));var me;(function(be){function Ae(Be){return Be instanceof v.$mN?Be.toJSON():typeof Be=="string"?Be:ae(Be)||Q(Be)?new v.$mN(Be.baseUri??Be.base,Be.pattern).toJSON():Be}be.from=Ae;function ae(Be){const Ze=Be;return Ze?r.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Q(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(Be){return typeof Be=="string"?Be:new v.$mN(r.URI.revive(Be.baseUri),Be.pattern)}be.to=ke})(me||(e.GlobPattern=me={}));var qe;(function(be){function Ae(ae){if(ae){if(Array.isArray(ae))return ae.map(Ae);if(typeof ae=="string")return ae;{const Q=ae;return{language:Q.language,scheme:Q.scheme,pattern:me.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}be.from=Ae})(qe||(e.LanguageSelector=qe={}));var Xe;(function(be){function Ae(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(ke=>Array.isArray(ke)&&ke.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&r.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ze=>Ze instanceof v.$qM)))}be.is=Ae;function ae(Q){return{documents:Q.documents.map(ke=>ke.map(Be=>({uri:r.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>D.from(Ze))})))}}be.from=ae})(Xe||(e.MappedEditsContext=Xe={}));var Me;(function(be){function Ae(Q){return{start:Q.start,end:Q.end}}be.from=Ae;function ae(Q){return new v.$PN(Q.start,Q.end)}be.to=ae})(Me||(e.NotebookRange=Me={}));var dt;(function(be){function Ae(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}be.to=Ae;function ae(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}be.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(be){function Ae(ae){if(ae===t.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ae===t.NotebookCellExecutionState.Pending)return;if(ae===t.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}be.to=Ae})(Pt||(e.NotebookCellExecutionState=Pt={}));var zt;(function(be){function Ae(Q){switch(Q){case v.NotebookCellKind.Markup:return t.CellKind.Markup;case v.NotebookCellKind.Code:default:return t.CellKind.Code}}be.from=Ae;function ae(Q){switch(Q){case t.CellKind.Markup:return v.NotebookCellKind.Markup;case t.CellKind.Code:default:return v.NotebookCellKind.Code}}be.to=ae})(zt||(e.NotebookCellKind=zt={}));var xt;(function(be){function Ae(Q){const ke={metadata:Q.metadata??Object.create(null),cells:[]};for(const Be of Q.cells)v.$QN.validate(Be),ke.cells.push(Jt.from(Be));return ke}be.from=Ae;function ae(Q){const ke=new v.$RN(Q.cells.map(Jt.to));return(0,f.$9f)(Q.metadata)||(ke.metadata=Q.metadata),ke}be.to=ae})(xt||(e.NotebookData=xt={}));var Jt;(function(be){function Ae(Q){return{cellKind:zt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:dt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Et.from):[]}}be.from=Ae;function ae(Q){return new v.$QN(zt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Et.to):void 0,Q.metadata,Q.internalMetadata?dt.to(Q.internalMetadata):void 0)}be.to=ae})(Jt||(e.NotebookCellData=Jt={}));var _t;(function(be){function Ae(Q){return{mime:Q.mime,valueBytes:O.$ue.wrap(Q.data)}}be.from=Ae;function ae(Q){return new v.$SN(Q.valueBytes.buffer,Q.mime)}be.to=ae})(_t||(e.NotebookCellOutputItem=_t={}));var Et;(function(be){function Ae(Q){return{outputId:Q.id,items:Q.items.map(_t.from),metadata:Q.metadata}}be.from=Ae;function ae(Q){const ke=Q.items.map(_t.to);return new v.$TN(ke,Q.outputId,Q.metadata)}be.to=ae})(Et||(e.NotebookCellOutput=Et={}));var Qt;(function(be){function Ae(ke){return Q(ke)?{include:me.from(ke.include)??void 0,exclude:me.from(ke.exclude)??void 0}:me.from(ke)??void 0}be.from=Ae;function ae(ke){return Q(ke)?{include:me.to(ke.include),exclude:me.to(ke.exclude)}:me.to(ke)}be.to=ae;function Q(ke){const Be=ke;return Be?!(0,f.$5f)(Be.include)&&!(0,f.$5f)(Be.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(be){function Ae(ae,Q,ke){const Be=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Be,ke),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Ae})(Vt||(e.NotebookStatusBarItem=Vt={}));var ai;(function(be){function Ae(ae,Q,ke){const Be=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:Q.toInternal(Be,ke),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}be.from=Ae})(ai||(e.NotebookKernelSourceAction=ai={}));var Ye;(function(be){function Ae(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}be.from=Ae})(Ye||(e.NotebookDocumentContentOptions=Ye={}));var ei;(function(be){function Ae(Q){return{uri:Q.uri,provides:Q.provides}}be.from=Ae;function ae(Q){return new v.$VN(r.URI.revive(Q.uri),Q.provides)}be.to=ae})(ei||(e.NotebookRendererScript=ei={}));var ti;(function(be){function Ae(Q){return{message:ie.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:D.from(Q.location.range),uri:Q.location.uri}}}be.from=Ae;function ae(Q){const ke=new v.$2N(typeof Q.message=="string"?Q.message:ie.to(Q.message));return ke.actualOutput=Q.actual,ke.expectedOutput=Q.expected,ke.contextValue=Q.contextValue,ke.location=Q.location?de.to(Q.location):void 0,ke}be.to=ae})(ti||(e.TestMessage=ti={}));var ht;(function(be){be.namespace=c.$dL,be.denamespace=c.$eL})(ht||(e.TestTag=ht={}));var vt;(function(be){function Ae(Q){const ke=(0,i.$DO)(Q).controllerId;return{extId:p.$$K.fromExtHostTestItem(Q,ke).toString(),label:Q.label,uri:r.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Be=>ht.namespace(ke,Be.id)),range:o.$ct.lift(D.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&ie.fromStrict(Q.error)||null}}be.from=Ae;function ae(Q){return{parent:void 0,error:void 0,id:p.$$K.fromString(Q.extId).localId,label:Q.label,uri:r.URI.revive(Q.uri),tags:(Q.tags||[]).map(ke=>{const{tagId:Be}=ht.denamespace(ke);return new v.$3N(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}be.toPlain=ae})(vt||(e.TestItem=vt={})),function(be){function Ae(Q){return{id:Q.id}}be.from=Ae;function ae(Q){return new v.$3N(Q.id)}be.to=ae}(ht||(e.TestTag=ht={}));var si;(function(be){const Ae=(Q,ke)=>{const Be=Q.value;if(!Be)return;const Ze={...vt.toPlain(Be.item),parent:ke,taskStates:Be.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(rt=>rt.type===0).map(ti.to)})),children:[]};if(Q.children)for(const He of Q.children.values()){const rt=Ae(He,Ze);rt&&Ze.children.push(rt)}return Ze};function ae(Q){const ke=new u.$wO;for(const He of Q.items)ke.insert(p.$$K.fromString(He.item.extId).path,He);const Be=[ke.nodes],Ze=[];for(;Be.length;)for(const He of Be.pop())He.value?Ze.push(He):He.children&&Be.push(He.children.values());return{completedAt:Q.completedAt,results:Ze.map(He=>Ae(He)).filter(f.$4f)}}be.to=ae})(si||(e.TestResults=si={}));var ii;(function(be){function Ae(Be){return{covered:Be.covered,total:Be.total}}function ae(Be){return"line"in Be?y.from(Be):D.from(Be)}function Q(Be){return"branches"in Be?{count:Be.executed,location:ae(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:ae(Be.location)}}be.fromDetails=Q;function ke(Be,Ze){return{id:Be,uri:Ze.uri,statement:Ae(Ze.statementCoverage),branch:Ze.branchCoverage&&Ae(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Ae(Ze.declarationCoverage)}}be.fromFile=ke})(ii||(e.TestCoverage=ii={}));var Ft;(function(be){function Ae(ae){switch(ae){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}be.to=Ae})(Ft||(e.CodeActionTriggerKind=Ft={}));var mt;(function(be){function Ae(Q){const ke=new v.$9N(re.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return ke._sessionId=Q._sessionId,ke._itemId=Q._itemId,ke}be.to=Ae;function ae(Q,ke,Be){if(ke=ke??Q._sessionId,Be=Be??Q._itemId,ke===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Be,kind:re.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(L.from)}}be.from=ae})(mt||(e.TypeHierarchyItem=mt={}));var Mt;(function(be){function Ae(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}be.from=Ae})(Mt||(e.ViewBadge=Mt={}));var Wt;(function(be){function Ae(Be,Ze,He){const rt=Ze.fileData;return rt?new v.$eN(new v.$fN(rt.name,r.URI.revive(rt.uri),rt.id,(0,N.$db)(()=>He(rt.id)))):Be===F.$zs.uriList&&Ze.uriListData?new v.$dN(ke(Ze.uriListData)):new v.$dN(Ze.asString)}be.to=Ae;async function ae(Be,Ze){const He=await Ze.asString();if(Be===F.$zs.uriList)return{asString:He,fileData:void 0,uriListData:Q(He)};const rt=Ze.asFile();return{asString:He,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}be.from=ae;function Q(Be){return M.$Lt.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return r.URI.parse(Ze)}catch{}return Ze})}function ke(Be){return M.$Lt.create(Be.map(Ze=>typeof Ze=="string"?Ze:r.URI.revive(Ze)))}})(Wt||(e.DataTransferItem=Wt={}));var Xt;(function(be){function Ae(Q,ke){const Be=Q.items.map(([Ze,He])=>[Ze,Wt.to(Ze,He,ke)]);return new v.$gN(Be)}be.toDataTransfer=Ae;async function ae(Q){const ke={items:[]},Be=[];for(const[Ze,He]of Q)Be.push((async()=>{ke.items.push([Ze,await Wt.from(Ze,He)])})());return await Promise.all(Be),ke}be.from=ae})(Xt||(e.DataTransfer=Xt={}));var Ke;(function(be){function Ae(Q,ke){return{kind:"reply",agentId:Q.participant??ke?.agentId??"",subCommand:Q.command??ke?.command,message:Q.prompt,title:Q.label}}be.from=Ae;function ae(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}be.to=ae})(Ke||(e.ChatFollowup=Ke={}));var Zt;(function(be){function Ae(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}be.from=Ae})(Zt||(e.ChatInlineFollowup=Zt={}));var jt;(function(be){function Ae(Q){switch(Q.role){case 0:return new v.$rO(Q.content);case 1:return new v.$sO(Q.content);case 2:return new v.$tO(Q.content)}}be.to=Ae;function ae(Q){if(Q instanceof v.$rO)return{role:0,content:Q.content};if(Q instanceof v.$sO)return{role:1,content:Q.content};if(Q instanceof v.$tO)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}be.from=ae})(jt||(e.LanguageModelMessage=jt={}));var Ut;(function(be){function Ae(ke){const Be={};for(const Ze of Object.keys(ke))Be[Ze]=ke[Ze].map(be.to);return Be}be.objectTo=Ae;function ae(ke){return{level:$t.to(ke.level),kind:ke.kind,value:(0,r.$wc)(ke.value)?r.URI.revive(ke.value):ke.value,description:ke.description}}be.to=ae;function Q(ke){return{level:$t.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}be.from=Q})(Ut||(e.ChatVariable=Ut={}));var $t;(function(be){function Ae(Q){switch(Q){case"short":return v.ChatVariableLevel.Short;case"medium":return v.ChatVariableLevel.Medium;case"full":default:return v.ChatVariableLevel.Full}}be.to=Ae;function ae(Q){switch(Q){case v.ChatVariableLevel.Short:return"short";case v.ChatVariableLevel.Medium:return"medium";case v.ChatVariableLevel.Full:default:return"full"}}be.from=ae})($t||(e.ChatVariableLevel=$t={}));var Tt;(function(be){function Ae(ae){switch(ae){case 1:return v.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return v.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return v.InteractiveEditorResponseFeedbackKind.Undone;case 3:return v.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return v.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Ae})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Rt;(function(be){function Ae(Q){return{kind:"markdownContent",content:ie.from(Q.value)}}be.to=Ae;function ae(Q){return new v.$jO(ie.to(Q.content))}be.from=ae})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Lt;(function(be){function Ae(Q){const{value:ke,baseUri:Be}=Q;function Ze(He,rt){return He.map(yt=>{const Kt=r.URI.joinPath(rt,yt.name);return{label:yt.name,uri:Kt,children:yt.children&&Ze(yt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,b.$Sg)(Be),uri:Be,children:Ze(ke,Be)}}}be.to=Ae;function ae(Q){const ke=(0,k.$Rh)(Q.treeData);function Be(rt){return rt.map(yt=>({name:yt.label,children:yt.children&&Be(yt.children)}))}const Ze=ke.uri,He=ke.children?Be(ke.children):[];return new v.$kO(He,Ze)}be.from=ae})(Lt||(e.ChatResponseFilesPart=Lt={}));var ni;(function(be){function Ae(Q){return{kind:"inlineReference",name:Q.title,inlineReference:r.URI.isUri(Q.value)?Q.value:g.from(Q.value)}}be.to=Ae;function ae(Q){const ke=(0,k.$Rh)(Q);return new v.$lO(r.URI.isUri(ke.inlineReference)?ke.inlineReference:g.to(ke.inlineReference),Q.name)}be.from=ae})(ni||(e.ChatResponseAnchorPart=ni={}));var oi;(function(be){function Ae(Q){return{kind:"progressMessage",content:ie.from(Q.value)}}be.to=Ae;function ae(Q){return new v.$mO(Q.content.value)}be.from=ae})(oi||(e.ChatResponseProgressPart=oi={}));var qt;(function(be){function Ae(Q,ke,Be){return{kind:"command",command:ke.toInternal(Q.value,Be)??{command:Q.value.command,title:Q.value.title}}}be.to=Ae;function ae(Q,ke){return new v.$nO(ke.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}be.from=ae})(qt||(e.ChatResponseCommandButtonPart=qt={}));var It;(function(be){function Ae(Q){return{kind:"reference",reference:r.URI.isUri(Q.value)?Q.value:g.from(Q.value)}}be.to=Ae;function ae(Q){const ke=(0,k.$Rh)(Q);return new v.$oO(r.URI.isUri(ke.reference)?ke.reference:g.to(ke.reference))}be.from=ae})(It||(e.ChatResponseReferencePart=It={}));var Dt;(function(be){function Ae(ke){return ke instanceof v.$jO?Rt.to(ke):ke instanceof v.$lO?ni.to(ke):ke instanceof v.$oO?It.to(ke):ke instanceof v.$mO?oi.to(ke):ke instanceof v.$kO?Lt.to(ke):{kind:"content",content:""}}be.to=Ae;function ae(ke,Be){switch(ke.kind){case"reference":return It.from(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(ke,Be)}}be.from=ae;function Q(ke,Be){switch(ke.kind){case"markdownContent":return Rt.from(ke);case"inlineReference":return ni.from(ke);case"progressMessage":return;case"treeData":return Lt.from(ke);case"command":return qt.from(ke,Be)}}be.fromContent=Q})(Dt||(e.ChatResponsePart=Dt={}));var Ht;(function(be){function Ae(ke,Be){return"markdownContent"in Be?((0,w.$0F)(ke,"chatParticipantAdditions"),{content:ie.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,w.$0F)(ke,"chatParticipantAdditions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,w.$0F)(ke,"chatParticipantAdditions"),{content:ie.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(He=>D.from(He))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:D.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:D.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"participant"in Be?((0,w.$0F)(ke,"chatParticipantAdditions"),{agentName:Be.participant,command:Be.command,kind:"agentDetection"}):"message"in Be?{content:ie.from(Be.message),kind:"progressMessage"}:void 0}be.from=Ae;function ae(ke){switch(ke.kind){case"markdownContent":case"inlineReference":case"treeData":return be.to(ke);case"content":return{content:ke.content};case"usedContext":return{documents:ke.documents.map(Be=>({uri:r.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>D.to(Ze))}))};case"reference":return{reference:(0,r.$wc)(ke.reference)?r.URI.revive(ke.reference):g.to(ke.reference)};case"agentDetection":return;case"progressMessage":return{message:ke.content.value};case"vulnerability":return{content:ke.content,vulnerabilities:ke.vulnerabilities};default:return}}be.to=ae;function Q(ke,Be){switch(ke.kind){case"markdownContent":return{content:ke.content.value};case"inlineReference":return{inlineReference:(0,r.$wc)(ke.inlineReference)?r.URI.revive(ke.inlineReference):g.to(ke.inlineReference),title:ke.name};case"command":return{command:Be.fromInternal(ke.command)??{command:ke.command.id,title:ke.command.title}};default:return}}be.toProgressContent=Q})(Ht||(e.ChatResponseProgress=Ht={}));var Ct;(function(be){function Ae(ae){return{prompt:ae.message,command:ae.command,variables:ae.variables.variables.map(St.to),location:wt.to(ae.location)}}be.to=Ae})(Ct||(e.ChatAgentRequest=Ct={}));var wt;(function(be){function Ae(ae){switch(ae){case h.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return v.ChatLocation.Panel}}be.to=Ae})(wt||(e.ChatLocation=wt={}));var St;(function(be){function Ae(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(Ut.to)}}be.to=Ae})(St||(e.ChatAgentResolvedVariable=St={}));var kt;(function(be){function Ae(ae){return{label:ae.label,values:ae.values.map(Ut.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}be.from=Ae})(kt||(e.ChatAgentCompletionItem=kt={}));var ui;(function(be){function Ae(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}be.to=Ae})(ui||(e.ChatAgentResult=ui={}));var ri;(function(be){function Ae(ae,Q,ke){if(Q.action.kind==="vote")return;const Be=ui.to(ae);return Q.action.kind==="command"?{action:{kind:"command",commandButton:Ht.toProgressContent(Q.action.commandButton,ke)},result:Be}:Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Ke.to(Q.action.followup)},result:Be}:{action:Q.action,result:Be}}be.to=Ae})(ri||(e.ChatAgentUserActionEvent=ri={}));var li;(function(be){function Ae(ae,Q,ke){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:Q.toInternal(ae,ke)}be.from=Ae})(li||(e.TerminalQuickFix=li={}));var di;(function(be){function Ae(ae){return{kind:Yt.to(ae.kind)}}be.to=Ae})(di||(e.PartialAcceptInfo=di={}));var Yt;(function(be){function Ae(ae){switch(ae){case 0:return v.PartialAcceptTriggerKind.Word;case 1:return v.PartialAcceptTriggerKind.Line;case 2:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}be.to=Ae})(Yt||(e.PartialAcceptTriggerKind=Yt={}));var At;(function(be){function Ae(ae,Q){return{id:Q,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}be.from=Ae})(At||(e.DebugTreeItem=At={}))}),define(Ce[252],Pe([1,0,4,17,8]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;let N=class{constructor(m,d){this.a=m.getProxy(I.$mM.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>d.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,d,k){const F=M.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(F,void 0,k?.isRefactoring??!1)}};e.$ijc=N,e.$ijc=N=Je([We(0,O.$HO)],N)}),define(Ce[253],Pe([1,0,18,11,42,5,39,6,64,16,2,162,20,4,8,7,213,25]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class n{constructor(t,p,c,$,w,v){this.i=t,this.j=p,this.k=c,this.l=$,this.m=w,this.n=v,this.b=d.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let p=function($){if(t.c){const w=new Error("Response stream has been closed");throw Error.captureStackTrace(w,$),w}};const t=this;this.b.reset();const c=$=>{typeof this.d>"u"&&"content"in $&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,$)};this.g={markdown($){p(this.markdown);const w=new r.$jO($),v=f.ChatResponseMarkdownPart.to(w);return c(v),this},filetree($,w){p(this.filetree);const v=new r.$kO($,w),l=f.ChatResponseFilesPart.to(v);return c(l),this},anchor($,w){p(this.anchor);const v=new r.$lO($,w),l=f.ChatResponseAnchorPart.to(v);return c(l),this},button($){p(this.anchor);const w=new r.$nO($),v=f.ChatResponseCommandButtonPart.to(w,t.m,t.n);return c(v),this},progress($){p(this.progress);const w=new r.$mO($),v=f.ChatResponseProgressPart.to(w);return c(v),this},reference($){p(this.reference);const w=new r.$oO($),v=f.ChatResponseReferencePart.to(w);return c(v),this},push($){p(this.push);const w=f.ChatResponsePart.to($);return c(w),this},report($){if(p(this.report),"placeholder"in $&&"resolvedContent"in $)return;const w=f.ChatResponseProgress.from(t.i,$);if(!w){t.l.error("Unknown progress type: "+JSON.stringify($));return}return c(w),this}}}return this.g}}class i{static{this.b=0}constructor(t,p,c){this.i=p,this.j=c,this.c=new Map,this.g=new m.$4c,this.d=t.getProxy(b.$mM.MainThreadChatAgents2)}createChatAgent(t,p,c){const $=i.b++,w=new a(t,p,this.d,$,c);return this.c.set($,w),this.d.$registerAgent($,t.identifier,p,{},(0,s.$9F)(t,"chatParticipantAdditions")),w.apiAgent}async $invokeAgent(t,p,c,$){const w=this.c.get(t);if(!w)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let v=this.g.get(p.sessionId);v||(v=new m.$Tc,this.g.set(p.sessionId,v));const l=new n(w.extension,p,this.d,this.i,this.j.converter,v);try{const D=await this.k(p.agentId,c),g=w.invoke(f.ChatAgentRequest.to(p),{history:D},l.apiObject,$);return await(0,O.$9g)(Promise.resolve(g).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(y){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${w.extension.identifier.value}] [@${w.id}] ${P}`,w.extension),{errorDetails:{message:P},timings:l.timings}}return{errorDetails:S?.errorDetails,timings:l.timings,metadata:S?.metadata}}),$)}catch(D){return this.i.error(D,w.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,M.$6i)(D)),responseIsIncomplete:!0}}}finally{l.close()}}async k(t,p){const c=[];for(const $ of p.history){const w=f.ChatAgentResult.to($.result),v=t===$.request.agentId?w:{...w,metadata:void 0};c.push(new r.$pO($.request.message,$.request.command,$.request.variables.variables.map(f.ChatAgentResolvedVariable.to),{extensionId:"",name:$.request.agentId}));const l=(0,I.$Hb)($.response.map(D=>f.ChatResponsePart.fromContent(D,this.j.converter)));c.push(new r.$qO(l,v,{extensionId:"",name:$.request.agentId},$.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,p,c,$,w){const v=this.c.get(p);if(!v)return Promise.resolve([]);const l=await this.k(v.id,$),D=f.ChatAgentResult.to(c);return(await v.provideFollowups(D,{history:l},w)).filter(g=>{const S=!g.participant||A.Iterable.some(this.c.values(),y=>y.id===g.participant&&u.$Dm.equals(y.extension.identifier,v.extension.identifier));return S||this.i.warn(`[@${v.id}] ChatFollowup refers to an unknown participant: ${g.participant}`),S}).map(g=>f.ChatFollowup.from(g,t))}$acceptFeedback(t,p,c,$){const w=this.c.get(t);if(!w)return;const v=f.ChatAgentResult.to(p);let l;switch(c){case o.InteractiveSessionVoteDirection.Down:l=r.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:l=r.ChatResultFeedbackKind.Helpful;break}w.acceptFeedback(Object.freeze($?{result:v,kind:l,reportIssue:$}:{result:v,kind:l}))}$acceptAction(t,p,c){const $=this.c.get(t);if(!$||c.action.kind==="vote")return;const w=f.ChatAgentUserActionEvent.to(p,c,this.j.converter);w&&$.acceptAction(Object.freeze(w))}async $invokeCompletionProvider(t,p,c){const $=this.c.get(t);return $?(await $.invokeCompletionProvider(p,c)).map(f.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,p){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(p)}async $provideSampleQuestions(t,p){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(p)).map($=>f.ChatFollowup.from($,void 0))}}e.$kjc=i;class a{constructor(t,p,c,$,w){this.extension=t,this.id=p,this.x=c,this.y=$,this.z=w,this.o=new N.$7d,this.p=new N.$7d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,p){return this.s?await this.s.provider.provideCompletionItems(t,p)??[]:[]}async provideFollowups(t,p,c){if(!this.b)return[];const $=await this.b.provideFollowups(t,p,c);return $?$.filter(w=>!(w&&"commandId"in w)).filter(w=>!(w&&"message"in w)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const p=await this.t.provideWelcomeMessage(t);return p?p.map(c=>typeof c=="string"?c:f.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const p=await this.t.provideSampleQuestions(t);return p||[]}get apiAgent(){let t=!1,p=!1;const c=()=>{t||p||(p=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof F.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof r.$kN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:f.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:f.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),p=!1}))},$=this;return{get name(){return $.id},get description(){return $.c??""},set description(w){$.c=w,c()},get fullName(){return(0,s.$0F)($.extension,"defaultChatParticipant"),$.d??$.extension.displayName??$.extension.name},set fullName(w){(0,s.$0F)($.extension,"defaultChatParticipant"),$.d=w,c()},get iconPath(){return $.g},set iconPath(w){$.g=w,c()},get requestHandler(){return $.z},set requestHandler(w){(0,k.$6f)(typeof w=="function","Invalid request handler"),$.z=w},get followupProvider(){return $.b},set followupProvider(w){$.b=w,c()},get isDefault(){return(0,s.$0F)($.extension,"defaultChatParticipant"),$.i},set isDefault(w){(0,s.$0F)($.extension,"defaultChatParticipant"),$.i=w,c()},get helpTextPrefix(){return(0,s.$0F)($.extension,"defaultChatParticipant"),$.j},set helpTextPrefix(w){(0,s.$0F)($.extension,"defaultChatParticipant"),$.j=w,c()},get helpTextVariablesPrefix(){return(0,s.$0F)($.extension,"defaultChatParticipant"),$.k},set helpTextVariablesPrefix(w){(0,s.$0F)($.extension,"defaultChatParticipant"),$.k=w,c()},get helpTextPostfix(){return(0,s.$0F)($.extension,"defaultChatParticipant"),$.l},set helpTextPostfix(w){(0,s.$0F)($.extension,"defaultChatParticipant"),$.l=w,c()},get isSecondary(){return(0,s.$0F)($.extension,"defaultChatParticipant"),$.n},set isSecondary(w){(0,s.$0F)($.extension,"defaultChatParticipant"),$.n=w,c()},get sampleRequest(){return $.m},set sampleRequest(w){$.m=w,c()},get supportIssueReporting(){return(0,s.$0F)($.extension,"chatParticipantAdditions"),$.q},set supportIssueReporting(w){(0,s.$0F)($.extension,"chatParticipantAdditions"),$.q=w,c()},get onDidReceiveFeedback(){return $.o.event},set participantVariableProvider(w){if((0,s.$0F)($.extension,"chatParticipantAdditions"),$.s=w,w){if(!w.triggerCharacters.length)throw new Error("triggerCharacters are required");$.x.$registerAgentCompletionsProvider($.y,w.triggerCharacters)}else $.x.$unregisterAgentCompletionsProvider($.y)},get participantVariableProvider(){return(0,s.$0F)($.extension,"chatParticipantAdditions"),$.s},set welcomeMessageProvider(w){(0,s.$0F)($.extension,"defaultChatParticipant"),$.t=w,c()},get welcomeMessageProvider(){return(0,s.$0F)($.extension,"defaultChatParticipant"),$.t},onDidPerformAction:(0,s.$9F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return $.u},set isSticky(w){$.u=w,c()},set requester(w){$.w=w,c()},get requester(){return $.w},dispose(){t=!0,$.b=void 0,$.o.dispose(),$.x.$unregisterAgent($.y)}}}invoke(t,p,c,$){return this.z(t,p,c,$)}}}),define(Ce[254],Pe([1,0,14,6,4,8,7,25]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;class d{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(M.$mM.MainThreadChatVariables)}async $resolveVariable(E,u,b,f){const r=this.b.get(E);if(r)try{if(r.resolver.resolve2){(0,m.$0F)(r.extension,"chatParticipantAdditions");const o=new k(u,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:b},o.apiObject,f);if(s)return s.map(N.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:b},f);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(E,u,b,f){const r=d.a++;return this.b.set(r,{extension:E,data:{name:u,description:b},resolver:f}),this.c.$registerVariable(r,{name:u,description:b}),(0,O.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$njc=d;class k{constructor(E,u){this.c=E,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(f){if(E.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,f),r}};const E=this,b=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){u(this.progress);const r=new A.$mO(f),o=N.ChatResponseProgressPart.to(r);return b(o),this},reference(f){u(this.reference);const r=new A.$oO(f),o=N.ChatResponseReferencePart.to(r);return b(o),this},push(f){u(this.push);const r=N.ChatResponsePart.to(f);return b(r),this}}}return this.b}}}),define(Ce[255],Pe([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=b;function b(f,r,o){const s=f.getProxy(E.$mM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new d.$Fm,r.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=l,g=this.b.get(D.commentControlHandle);if(!g)return D;const S=g.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);return g?l.$mid===8?g.value:{thread:g.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.commentUniqueId,y=g.getCommentByUniqueId(S);return y||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.text,y=l.commentUniqueId,P=g.getCommentByUniqueId(y);return P?(typeof P.body=="string"?P.body=S:P.body=new F.$PM(S),P):l}return l}})}createCommentController(l,D,g){const S=n.a++,y=new a(l,S,D,g);this.b.set(y.handle,y);const P=this.c.get(l.identifier)||[];return P.push(y),this.c.set(l.identifier,P),y.value}async $createCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$createCommentThreadTemplate(D,g)}async $setActiveComment(l,D){const g=this.b.get(l);g&&g.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$updateCommentThreadTemplate(D,g)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}async $provideCommentingRanges(l,D,g){const S=this.b.get(l);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(A.URI.revive(D));return(0,I.$ah)(async()=>{const P=await S.commentingRangeProvider.provideCommentingRanges(y.document,g);let C;return Array.isArray(P)?C={ranges:P,fileComments:!1}:P?C={ranges:P.ranges||[],fileComments:P.fileComments||!1}:C=P??void 0,C}).then(P=>{let C;return P&&(C={ranges:P.ranges.map(W=>k.Range.from(W)),fileComments:P.fileComments}),C})}$toggleReaction(l,D,g,S,y){const P=this.b.get(l);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,I.$ah)(()=>{const C=P.getCommentThread(D);if(C){const W=C.getCommentByUniqueId(S.uniqueIdInThread);if(P!==void 0&&W&&P.reactionHandler)return P.reactionHandler(W,p(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,u.$0F)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,g,S,y,P,C,W){this.m=D,this.n=g,this.o=S,this.p=y,this.q=P,this.extensionDescription=C,this.r=W,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(D,this.handle,this.n,this.o,k.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{s.$deleteCommentThread(D,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const l=g=>Object.prototype.hasOwnProperty.call(this.b,g),D={};l("range")&&(D.range=k.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(g=>h(this,g,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=$(this.h)),l("applicability")&&(D.applicability=w(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const g=D[0],S=D[1];if(l===S)return g}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,O.$Nh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,u.$0F)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$0F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$0F)(this.h,"activeComment"),this.f}constructor(l,D,g,S){this.h=l,this.i=D,this.j=g,this.k=S,this.a=new Map,s.$registerCommentController(this.handle,g,S,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(P){y.options=P},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(P){y.commentingRangeProvider=P},get reactionHandler(){return y.reactionHandler},set reactionHandler(P){y.reactionHandler=P},get activeCommentThread(){return y.activeCommentThread},createCommentThread(P,C,W){return y.createCommentThread(P,C,W).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,g){D===void 0&&(0,u.$0F)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,l,D,g,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const D=this.a.get(l.commentThreadHandle);D&&(this.e=l.uniqueIdInThread?D.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(l,D){const g=new i(this.id,this.handle,void 0,A.URI.revive(l),k.Range.to(D),[],this.h,!0);return g.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(l,D){const g=this.a.get(l);g&&(g.range=k.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(v,l,D,g){let S=D.get(l);return S||(S=++v.commentHandle,D.set(l,S)),l.state!==void 0&&(0,u.$0F)(g,"commentsDraftState"),l.reactions?.some(y=>y.reactors!==void 0)&&(0,u.$0F)(g,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:S,body:typeof l.body=="string"?l.body:k.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(y=>t(y)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?k.$GO(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(l=>l.name):v.reactors}}function p(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?A.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(l=>({name:l}))}}function c(v){if(v!==void 0)switch(v){case F.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function $(v){let l;if(typeof v=="object"?l=v.resolved:l=v,l!==void 0)switch(l){case F.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case F.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function w(v){let l;if(typeof v=="object"&&(l=v.applicability),l!==void 0)switch(l){case F.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case F.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new n}}),define(Ce[256],Pe([1,0,24,99,6,12,23,2,8,62,74,4,7]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;class b{constructor(p,c){this.document=p,this.b=c,this.a=1,this.c=new F.$7ic("custom documents")}addEdit(p){return this.c.add([p])}async undo(p,c){await this.f(p).undo(),c||this.disposeBackup()}async redo(p,c){await this.f(p).redo(),c||this.disposeBackup()}disposeEdits(p){for(const c of p)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const p=h(this.document.uri)+this.a++;return(0,A.$Vg)(this.b,p)}updateBackup(p){this.d?.delete(),this.d=p}disposeBackup(){this.d?.delete(),this.d=void 0}f(p){const c=this.c.get(p,0);if(!c)throw new Error("No edit found");return c}}class f{constructor(){this.a=new Map}get(p,c){return this.a.get(this.b(p,c))}add(p,c,$){const w=this.b(p,c.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${p} resource:${c.uri}`);const v=new b(c,$);return this.a.set(w,v),v}delete(p,c){const $=this.b(p,c.uri);this.a.delete($)}b(p,c){return`${p}@@@${c}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(p,c,$){return this.b(0,p,c,$)}addCustomProvider(p,c,$){return this.b(1,p,c,$)}get(p){return this.a.get(p)}b(p,c,$,w){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:p,extension:$,provider:w}),new u.$oM(()=>this.a.delete(c))}}class s{constructor(p,c,$,w,v){this.d=c,this.f=$,this.g=w,this.h=v,this.b=new o,this.c=new f,this.a=p.getProxy(E.$mM.MainThreadCustomEditors)}registerCustomEditorProvider(p,c,$,w){const v=new M.$Tc;return i($)?(v.add(this.b.addTextProvider(c,p,$)),this.a.$registerTextEditorProvider((0,k.$Gjc)(p),c,w.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,k.$Ejc)(p))):(v.add(this.b.addCustomProvider(c,p,$)),n($)&&v.add($.onDidChangeCustomDocument(l=>{const D=this.i(c,l.document.uri);if(a(l)){const g=D.addEdit(l);this.a.$onDidEdit(l.document.uri,c,g,l.label)}else this.a.$onContentChange(l.document.uri,c)})),this.a.$registerCustomEditorProvider((0,k.$Gjc)(p),c,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,k.$Ejc)(p))),u.$oM.from(v,new u.$oM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(p,c,$,w,v){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=m.URI.revive(p),g=await l.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:w?.buffer},v);let S;return n(l.provider)&&this.f&&(S=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(c,g,S),{editable:n(l.provider)}}async $disposeCustomDocument(p,c){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provider type for '${c}'`);const w=m.URI.revive(p),{document:v}=this.i(c,w);this.c.delete(c,v),v.dispose()}async $resolveCustomEditor(p,c,$,w,v,l){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const g=d.ViewColumn.to(v),S=this.g.createNewWebview(c,w.contentOptions,D.extension),y=this.h.createNewWebviewPanel(c,$,w.title,g,w.options,S,w.active),P=m.URI.revive(p);switch(D.type){case 1:{const{document:C}=this.i($,P);return D.provider.resolveCustomEditor(C,y,l)}case 0:{const C=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(C,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(p,c,$){this.i(c,p).disposeEdits($)}async $onMoveCustomEditor(p,c,$){const w=this.b.get($);if(!w)throw new Error(`No provider found for '${$}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const v=this.h.getWebviewPanel(p);if(!v)throw new Error("No webview found");const l=m.URI.revive(c),D=this.d.getDocument(l);await w.provider.moveCustomTextEditor(D,v,I.CancellationToken.None)}async $undo(p,c,$,w){return this.i(c,p).undo($,w)}async $redo(p,c,$,w){return this.i(c,p).redo($,w)}async $revert(p,c,$){const w=this.i(c,p);await this.j(c).revertCustomDocument(w.document,$),w.disposeBackup()}async $onSave(p,c,$){const w=this.i(c,p);await this.j(c).saveCustomDocument(w.document,$),w.disposeBackup()}async $onSaveAs(p,c,$,w){const v=this.i(c,p);return this.j(c).saveCustomDocumentAs(v.document,m.URI.revive($),w)}async $backup(p,c,$){const w=this.i(c,p),l=await this.j(c).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},$);return w.updateBackup(l),l.id}i(p,c){const $=this.c.get(p,m.URI.revive(c));if(!$)throw new Error("No custom document found");return $}j(p){const $=this.b.get(p)?.provider;if(!$||!n($))throw new Error("Custom document is not editable");return $}}e.$Jjc=s;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const p=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.$9i)(p)+""}}),define(Ce[257],Pe([1,0,163,100,2,4,7,8,5,13,28,44]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=e.$bjc=void 0;class b{#e;#t;#i;constructor(o,s,n,i,a,h,t,p){this.d=o,this.e=s,this.f=n,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,n),this.#i=new F.$Bc(c=>h.getComparisonKey(c)),this.#e=t,this.#t=p}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let n=[];if(M.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(b.k);for(const t of o){const[p,c]=t;if((!h||p.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=p,n.push(p),this.#i.set(p,[])),c)this.#i.get(p)?.push(...c);else{const $=this.#i.get(p);$&&($.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let a=0;for(const h of n){let t=[];const p=this.#i.get(h);if(p)if(p.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const w of p)if(w.severity===c[$]&&t.push({...m.Diagnostic.from(w),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,I.localize)(0,null,p.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=p.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(h)}));if(i.push([h,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[n,i]of this)o.call(s,n,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$bjc=b;let f=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const s=new F.$Bc;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,i){this.j=s,this.k=n,this.l=i,this.g=new Map,this.h=new d.$$d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=d.Event.map(this.h.event,u._mapper),this.f=o.getProxy(N.$mM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:n,f:i,h:a,j:h,k:t,l:p}=this,c=new class{$changeMany(v,l){i.$changeMany(v,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,v,l.length===0?"CLEARING":l)}$clear(v){i.$clear(v),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,v)}dispose(){i.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,$=s;else if(!n.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+u.c++;while(n.has($))}return new class extends b{constructor(){super(s,$,u.e,u.d,v=>p.getDocument(v)?.version,t.extUri,c,a),n.set($,this)}dispose(){super.dispose(),n.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,n=[];for(const i of this.g.values())i.forEach((a,h)=>{let t=s.get(a.toString());typeof t>"u"&&(t=n.length,s.set(a.toString(),t),n.push([a,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(o){let s=[];for(const n of this.g.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",n=new b(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of o)this.n.set(M.URI.revive(s),n.map(m.Diagnostic.to))}};e.$cjc=f,e.$cjc=f=u=Je([We(1,k.$Oj),We(2,E.$ajc)],f)}),define(Ce[258],Pe([1,0,2,14,7,8,191]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=void 0;class m{constructor(k,F,E,u={timeout:1500,errors:3}){this.c=k,this.d=F,this.f=E,this.g=u,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(F,E,u)=>{const f={dispose:this.a.push([F,E,k])};return Array.isArray(u)&&u.push(f),f}}async $participateInSave(k,F){const E=I.URI.revive(k);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),f=[];try{for(const r of[...this.a]){if(u)break;const o=this.d.getDocument(E),s=await this.h(r,{document:o,reason:N.TextDocumentSaveReason.to(F)});f.push(s)}}finally{clearTimeout(b)}return f}h([k,F,E],u){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(E,k,F,u).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const r=this.b.get(k);this.b.set(k,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,F,E,u){const b=[],f=Date.now(),{document:r,reason:o}=u,{version:s}=r,n=Object.freeze({document:r,reason:o,waitUntil(i){if(Object.isFrozen(b))throw(0,O.$8)("waitUntil can not be called async");b.push(Promise.resolve(i))}});try{F.apply(E,[n])}catch(i){return Promise.reject(i)}return Object.freeze(b),new Promise((i,a)=>{const h=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(h),i(t)}).catch(t=>{clearTimeout(h),a(t)})}).then(i=>{const a={edits:[]};for(const h of i)if(Array.isArray(h)&&h.every(t=>t instanceof M.$vM))for(const{newText:t,newEol:p,range:c}of h)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:c&&N.Range.from(c),text:t,eol:p&&N.EndOfLine.from(p)}});if(a.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$lkc=m}),define(Ce[259],Pe([1,0,5,6,2,4,111,8,16,26,7]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class E{constructor(b,f){this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=b.getProxy(N.$mM.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let r=this.h.get(b.toString());return r||(r=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const s=M.URI.revive(o);return(0,d.$7f)(this.g.getDocument(s))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),r)),r}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>M.URI.revive(f))}$acceptModelLanguageChanged(b,f){const r=M.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(b){const f=M.URI.revive(b),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(b,f){const r=M.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,r){const o=M.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(f);let n;f.isUndoing?n=F.TextDocumentChangeReason.Undo:f.isRedoing&&(n=F.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Pn)({document:s.document,contentChanges:f.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(b,f){(0,A.$JO)(b,f)}}e.$djc=E}),define(Ce[65],Pe([1,0,260,5,16,2,3,4,17,8,7]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,A.$ii)("IExtHostEditorTabs");class E{constructor(o,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new F.$0N(N.URI.revive(this.b.input.uri));case 2:return new F.$$N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new F.$_N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new F.$aO(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new F.$bO(this.b.input.viewType);case 4:return new F.$cO(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new F.$dO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new F.$eO;case 9:return new F.$fO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new F.$gO(this.b.input.providerId);case 11:return new F.$hO(this.b.input.diffEditors.map(o=>new F.$$N(N.URI.revive(o.original),N.URI.revive(o.modified))));default:return}}}class u{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new E(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new E(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const s=this.c.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new O.$7d,this.c=new O.$7d,this.e=[],this.a=o.getProxy(m.$mM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,M.$7f)(o.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,i)=>{const a=Array.isArray(n)?n:[n];return a.length?f(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(c=>c.groupId)),n=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(s,n),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const $=new u(c,()=>this.d);return i.added.includes($.groupId)?h.push($.apiObject):t.push($.apiObject),$});const p=(0,M.$7f)(o.find(c=>c.isActive===!0)?.groupId);p!==void 0&&this.d!==p&&(this.d=p),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const n=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,s)}async j(o,s){const n=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,s)}};e.$Ljc=b,e.$Ljc=b=Je([We(0,d.$HO)],b);function f(r){return r.tabs!==void 0}}),define(Ce[261],Pe([1,0,2,4,6,7,8,304,15,22,25,53]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0;class u{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,n,i=14,a=14;for(const h of r){let t=s?(0,d.$nf)(s,h):0;for(t===0?n=1:n=a;t<h.length;t++)t+1===h.length?(i=a,a=9):a+=1,o.push([n,h.toUpperCase().charCodeAt(t),a]),o.push([n,h.toLowerCase().charCodeAt(t),a]),n=a;s=h,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$q2(o)}}provideDocumentLinks(r){this.c();const o=[],s=m.$r2.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of s){const i=A.DocumentLink.to(n);i.target&&o.push(i)}return o}}class b{constructor(r,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(O.$mM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,n={}){if(b.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,F.$0F)(r,"fsChunks"),a+=4);let h;n.isReadonly&&(0,E.$Hk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,h).catch(p=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(p)});const t=s.onDidChangeFile(p=>{const c=[];for(const $ of p){const{uri:w,type:v}=$;if(w.scheme!==o)continue;let l;switch(v){case N.FileChangeType.Changed:l=0;break;case N.FileChangeType.Created:l=1;break;case N.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:w,type:l})}this.a.$onFileSystemChange(i,c)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:n,size:i,permissions:a}=r;return{type:o,ctime:s,mtime:n,size:i,permissions:a}}$stat(r,o){return Promise.resolve(this.l(r).stat(I.URI.revive(o))).then(s=>b.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(I.URI.revive(o))).then(s=>k.$ue.wrap(s))}$writeFile(r,o,s,n){return Promise.resolve(this.l(r).writeFile(I.URI.revive(o),s.buffer,n))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(I.URI.revive(o),s))}$rename(r,o,s,n){return Promise.resolve(this.l(r).rename(I.URI.revive(o),I.URI.revive(s),n))}$copy(r,o,s,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(s),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,n){const i=this.l(r).watch(I.URI.revive(s),n);this.f.set(o,i)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=k.$ue.alloc(n);return Promise.resolve(i.read(o,s,a.buffer,0,n)).then(h=>a.slice(0,h))}$write(r,o,s,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$nkc=b}),define(Ce[262],Pe([1,0,5,35,2,4,8,7,40]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,f,r,o,s,n){this.a=Math.random(),this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$ck)(s),a=typeof s=="string",h=n?.correlate,t=o(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(h&&typeof p.session>"u")){if(!n?.ignoreCreateEvents)for(const c of p.created){const $=M.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const c of p.changed){const $=M.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const c of p.deleted){const $=M.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=m.$oM.from(this.i(b,r,s,n,n?.correlate),this.b,this.c,this.d,t)}i(b,f,r,o,s){const n=m.$oM.from();if(typeof r=="string")return n;const i=b.getProxy(N.$mM.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(O.$$j)||r.pattern.includes(O.$_j))&&(a=!0),i.$watch(f.identifier.value,this.a,r.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),m.$oM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class F{constructor(b){this.a=b,this.session=this.a.session,this.b=new d.$V(()=>this.a.created.map(M.URI.revive)),this.c=new d.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new d.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class E{constructor(b,f,r){this.j=b,this.k=f,this.l=r,this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.g=new I.$9d,this.h=new I.$9d,this.i=new I.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,f,r,o){return new k(this.j,b,f,this.a.event,A.GlobPattern.from(r),o)}$onFileEvent(b){this.a.fire(new F(b))}$onDidRunFileOperation(b,f){switch(b){case 2:this.b.fire(Object.freeze({files:f.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(r=>M.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(r=>M.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,f){return(r,o,s)=>{const n=function(a){r.call(o,a)};return n.extension=b,f.event(n,void 0,s)}}async $onWillRunFileOperation(b,f,r,o){switch(b){case 2:return await this.n(this.g,{files:f.map(s=>({oldUri:M.URI.revive(s.source),newUri:M.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:f.map(s=>M.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:f.map(s=>M.URI.revive(s.target))},r,o)}}async n(b,f,r,o){const s=new Set,n=[];if(await b.fireAsync(f,o,async(a,h)=>{const t=Date.now(),p=await Promise.resolve(a);p instanceof m.$yM&&(n.push([h.extension,p]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,a]of n){const{edits:h}=A.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$okc=E}),define(Ce[263],Pe([1,0,18,11,24,14,90,6,26,64,15,16,2,29,305,87,97,165,20,8,7,25,74,4]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class c{constructor(U,j){this.d=U,this.e=j}async provideDocumentSymbols(U,j){const K=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(K,j);if(!(0,I.$Kb)(H))return H[0]instanceof a.$HM?H.map(i.DocumentSymbol.from):c.f(H)}static f(U){U=U.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const j=[],K=[];for(const H of U){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ee),j.push(ee);break}const se=K[K.length-1];if(b.$ct.containsRange(se.range,ee.range)&&!b.$ct.equalsRange(se.range,ee.range)){se.children?.push(ee),K.push(ee);break}K.pop()}}return j}}class ${constructor(U,j,K,H,ee,se){this.f=U,this.g=j,this.h=K,this.j=H,this.k=ee,this.l=se,this.d=new t.$7ic("CodeLens"),this.e=new Map}async provideCodeLenses(U,j){const K=this.f.getDocument(U),H=await this.h.provideCodeLenses(K,j);if(!H||j.isCancellationRequested)return;const ee=this.d.add(H),se=new m.$Tc;this.e.set(ee,se);const Fe={cacheId:ee,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Fe.lenses.push({cacheId:[ee,Ve],range:i.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,se)});return Fe}async resolveCodeLens(U,j){const K=U.cacheId&&this.d.get(...U.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,j),H||(H=K),j.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return U.command=this.g.toInternal(H.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function w(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class v{constructor(U,j){this.d=U,this.e=j}async provideDefinition(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideDefinition(H,ee,K);return w(se)}}class l{constructor(U,j){this.d=U,this.e=j}async provideDeclaration(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideDeclaration(H,ee,K);return w(se)}}class D{constructor(U,j){this.d=U,this.e=j}async provideImplementation(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideImplementation(H,ee,K);return w(se)}}class g{constructor(U,j){this.d=U,this.e=j}async provideTypeDefinition(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideTypeDefinition(H,ee,K);return w(se)}}class S{constructor(U,j){this.d=U,this.e=j}async provideHover(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideHover(H,ee,K);if(!(!se||(0,I.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new a.$qM(ee,ee)),i.Hover.from(se)}}class y{constructor(U,j){this.d=U,this.e=j}async provideEvaluatableExpression(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideEvaluatableExpression(H,ee,K);if(se)return i.EvaluatableExpression.from(se)}}class P{constructor(U,j){this.d=U,this.e=j}async provideInlineValues(U,j,K,H){const ee=this.d.getDocument(U),se=await this.e.provideInlineValues(ee,i.Range.to(j),i.InlineValueContext.to(K),H);if(Array.isArray(se))return se.map(Fe=>i.InlineValue.from(Fe))}}class C{constructor(U,j){this.d=U,this.e=j}async provideDocumentHighlights(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideDocumentHighlights(H,ee,K);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class W{constructor(U,j){this.d=U,this.e=j}async provideMultiDocumentHighlights(U,j,K,H){const ee=this.d.getDocument(U),se=K.map(Qe=>this.d.getDocument(Qe)),Fe=i.Position.to(j),Ve=await this.e.provideMultiDocumentHighlights(ee,Fe,se,H);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class V{constructor(U,j){this.d=U,this.e=j}async provideLinkedEditingRanges(U,j,K){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideLinkedEditingRanges(H,ee,K);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class q{constructor(U,j){this.d=U,this.e=j}async provideReferences(U,j,K,H){const ee=this.d.getDocument(U),se=i.Position.to(j),Fe=await this.e.provideReferences(ee,se,K,H);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class R{static{this.d=1e3}constructor(U,j,K,H,ee,se,Fe){this.g=U,this.h=j,this.j=K,this.k=H,this.l=ee,this.m=se,this.n=Fe,this.e=new t.$7ic("CodeAction"),this.f=new Map}async provideCodeActions(U,j,K,H){const ee=this.g.getDocument(U),se=f.$et.isISelection(j)?i.Selection.to(j):i.Range.to(j),Fe=[];for(const it of this.j.getDiagnostics(U))if(se.intersection(it.range)&&Fe.push(it)>R.d)break;const Ve={diagnostics:Fe,only:K.only?new a.$JM(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Qe=await this.k.provideCodeActions(ee,se,Ve,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const xe=this.e.add(Qe),tt=new m.$Tc;this.f.set(xe,tt);const at=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(R.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,tt)});else{Ve.only&&(nt.kind?Ve.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];at.push({cacheId:[xe,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,tt),diagnostics:nt.diagnostics&&nt.diagnostics.map(i.Diagnostic.from),edit:nt.edit&&i.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$9F)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$9F)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(i.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:xe,actions:at}}async resolveCodeAction(U,j){const[K,H]=U,ee=this.e.get(K,H);if(!ee||R.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,j)??ee;let Fe;se.edit&&(Fe=i.WorkspaceEdit.from(se.edit,void 0));let Ve;if(se.command){const Qe=this.f.get(K);Qe&&(Ve=this.h.toInternal(se.command,Qe))}return{edit:Fe,command:Ve}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class z{constructor(U,j,K,H,ee){this.e=U,this.f=j,this.g=K,this.h=H,this.j=ee,this.d=new t.$7ic("DocumentPasteEdit")}async prepareDocumentPaste(U,j,K,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),se=j.map(Qe=>i.Range.to(Qe)),Fe=i.DataTransfer.toDataTransfer(K,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,se,Fe,H),H.isCancellationRequested)return;const Ve=Array.from(Fe).filter(([,Qe])=>!(Qe instanceof a.$dN));return i.DataTransfer.from(Ve)}async providePasteEdits(U,j,K,H,ee,se){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(j),Ve=K.map(at=>i.Range.to(at)),Qe=i.DataTransfer.toDataTransfer(H,async at=>(await this.e.$resolvePasteFileData(this.h,U,at)).buffer),xe=await this.g.provideDocumentPasteEdits(Fe,Ve,Qe,{only:ee.only?new a.$iN(ee.only):void 0,triggerKind:ee.triggerKind},se);if(!xe||se.isCancellationRequested)return[];const tt=this.d.add(xe);return xe.map((at,it)=>({_cacheId:[tt,it],title:at.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(nt=>nt.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,j){const[K,H]=U,ee=this.d.get(K,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(ee,j)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class G{constructor(U,j){this.d=U,this.e=j}async provideDocumentFormattingEdits(U,j,K){const H=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(H,j,K);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeFormattingEdits(U,j,K,H){const ee=this.d.getDocument(U),se=i.Range.to(j),Fe=await this.e.provideDocumentRangeFormattingEdits(ee,se,K,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,j,K,H){(0,E.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),se=j.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(ee,se,K,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class fe{constructor(U,j){this.d=U,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,j,K,H,ee){const se=this.d.getDocument(U),Fe=i.Position.to(j),Ve=await this.e.provideOnTypeFormattingEdits(se,Fe,K,H,ee);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class De{constructor(U,j){this.e=U,this.f=j,this.d=new t.$7ic("WorkspaceSymbols")}async provideWorkspaceSymbols(U,j){const K=await this.e.provideWorkspaceSymbols(U,j);if(!(0,I.$Lb)(K))return{symbols:[]};const H=this.d.add(K),ee={cacheId:H,symbols:[]};for(let se=0;se<K.length;se++){const Fe=K[se];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(U,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const K=this.d.get(...U.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,j);return H&&(0,d.$Rn)(U,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class we{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,j,K){this.d=U,this.e=j,this.f=K}async provideRenameEdits(U,j,K,H){const ee=this.d.getDocument(U),se=i.Position.to(j);try{const Fe=await this.e.provideRenameEdits(ee,se,K,H);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Ve=we.g(Fe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(U,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ee=i.Position.to(j);try{const se=await this.e.prepareRename(H,ee,K);let Fe,Ve;if(a.$qM.isRange(se)?(Fe=se,Ve=H.getText(se)):(0,E.$Xf)(se)&&(Fe=se.range,Ve=se.placeholder),!Fe||!Ve)return;if(Fe.start.line>ee.line||Fe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Ve}}catch(se){const Fe=we.g(se);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(se)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class oe{constructor(U,j,K){this.d=U,this.e=j,this.f=K}async provideNewSymbolNames(U,j,K){const H=this.d.getDocument(U),ee=i.Range.to(j);try{const se=await this.e.provideNewSymbolNames(H,ee,K);return se?se.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(se){this.f.error(oe.g(se)??JSON.stringify(se,null,"	"));return}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class $e{constructor(U,j){this.resultId=U,this.tokens=j}}class ne{constructor(U,j){this.f=U,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,j,K){const H=this.f.getDocument(U),ee=j!==0?this.d.get(j):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ee&&this.d.delete(j),se?(se=ne.h(se),this.o(ne.n(ee,se),se)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return ne.j(U)?ne.k(U)?U:new a.$IN(new Uint32Array(U.data),U.resultId):ne.l(U)?ne.m(U)?U:new a.$KN(U.edits.map(j=>new a.$JN(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const j of U.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(U,j){if(!ne.j(j)||!U||!U.tokens)return j;const K=U.tokens,H=K.length,ee=j.data,se=ee.length;let Fe=0;const Ve=Math.min(H,se);for(;Fe<Ve&&K[Fe]===ee[Fe];)Fe++;if(Fe===H&&Fe===se)return new a.$KN([],j.resultId);let Qe=0;const xe=Ve-Fe;for(;Qe<xe&&K[H-Qe-1]===ee[se-Qe-1];)Qe++;return new a.$KN([{start:Fe,deleteCount:H-Fe-Qe,data:ee.subarray(Fe,se-Qe)}],j.resultId)}o(U,j){if(ne.j(U)){const K=this.e++;return this.d.set(K,new $e(U.resultId,U.data)),(0,o.$Iab)({id:K,type:"full",data:U.data})}if(ne.l(U)){const K=this.e++;return ne.j(j)?this.d.set(K,new $e(j.resultId,j.data)):this.d.set(K,new $e(U.resultId)),(0,o.$Iab)({id:K,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Se{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeSemanticTokens(U,j,K){const H=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(j),K);return ee?this.f(ee):null}f(U){return(0,o.$Iab)({id:0,type:"full",data:U.data})}}class Le{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,j,K,H,ee){this.f=U,this.g=j,this.h=K,this.j=H,this.k=ee,this.d=new t.$7ic("CompletionItem"),this.e=new Map}async provideCompletionItems(U,j,K,H){const ee=this.f.getDocument(U),se=i.Position.to(j),Fe=ee.getWordRangeAtPosition(se)||new a.$qM(se,se),Ve=Fe.with({end:se}),Qe=new k.$3d,xe=await this.h.provideCompletionItems(ee,se,H,i.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const tt=Array.isArray(xe)?new a.$WM(xe):xe,at=Le.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new m.$Tc;this.e.set(at,it);const nt=[],ct={x:at,b:nt,a:{replace:i.Range.from(Fe),insert:i.Range.from(Ve)},c:tt.isIncomplete||void 0,d:Qe.elapsed()};for(let ft=0;ft<tt.items.length;ft++){const Ue=tt.items[ft],ot=this.l(Ue,[at,ft],Ve,Fe);nt.push(ot)}return ct}async resolveCompletionItem(U,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...U);if(!K)return;const H=this.l(K,U),ee=await this.h.resolveCompletionItem(K,j);if(!ee)return;const se=this.l(ee,U);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,d.$Sn)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j,K,H){const ee=this.e.get(j[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(U.command,ee),Fe={x:j,a:U.label,b:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(i.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=U.textEdit.newText):typeof U.insertText=="string"?Fe.h=U.insertText:U.insertText instanceof a.$zM&&(Fe.h=U.insertText.value,Fe.i|=4);let Ve;return U.textEdit?Ve=U.textEdit.range:U.range&&(Ve=U.range),a.$qM.isRange(Ve)?Fe.j=i.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Fe.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Fe}}class re{async provideInlineCompletions(U,j,K,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,j,K){}handlePartialAccept(U,j,K,H){}}class L extends re{constructor(U,j,K,H){super(),this.f=U,this.g=j,this.h=K,this.j=H,this.d=new ve,this.e=(0,h.$9F)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$9F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,j,K,H){const ee=this.g.getDocument(U),se=i.Position.to(j),Fe=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Fe||H.isCancellationRequested)return;const Ve=Array.isArray(Fe)?Fe:Fe.items,Qe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],xe=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ve}),items:Ve.map((it,nt)=>{let ct;it.command&&(tt||(tt=new m.$Tc),ct=this.j.toInternal(it.command,tt));const ft=it.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(tt||(tt=new m.$Tc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,j,K){const H=this.d.get(U)?.items[j];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(U,j,K,H){const ee=this.d.get(U)?.items[j];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,K),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(U,j,K){const H=this.f.getDocument(U),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[j.triggerKind]},K);if(!ee||K.isCancellationRequested)return;let se;const Fe=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let Ve;ee.accepted&&(se||(se=new m.$Tc),Ve=this.h.toInternal(ee.accepted,se));let Qe;return ee.rejected&&(se||(se=new m.$Tc),Qe=this.h.toInternal(ee.rejected,se)),{pid:Fe,text:ee.text,range:i.Range.from(ee.range),accepted:Ve,rejected:Qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,j,K,H){this.f=j,this.g=K,this.h=H,this.d=new ve,this.e={[r.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const j=this.e++;return this.d.set(j,U),j}disposeReferenceId(U){const j=this.d.get(U);return this.d.delete(U),j}get(U){return this.d.get(U)}}class Oe{constructor(U,j){this.e=U,this.f=j,this.d=new t.$7ic("SignatureHelp")}async provideSignatureHelp(U,j,K,H){const ee=this.e.getDocument(U),se=i.Position.to(j),Fe=this.g(K),Ve=await this.f.provideSignatureHelp(ee,se,H,Fe);if(Ve){const Qe=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Qe}}}g(U){let j;if(U.activeSignatureHelp){const K=i.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(j=H,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...U,activeSignatureHelp:j}}releaseSignatureHelp(U){this.d.delete(U)}}class ye{constructor(U,j,K,H,ee){this.f=U,this.g=j,this.h=K,this.j=H,this.k=ee,this.d=new t.$7ic("InlayHints"),this.e=new Map}async provideInlayHints(U,j,K){const H=this.f.getDocument(U),ee=i.Range.to(j),se=await this.h.provideInlayHints(H,ee,K);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Fe=this.d.add(se);this.e.set(Fe,new m.$Tc);const Ve={hints:[],cacheId:Fe};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],ee)&&Ve.hints.push(this.m(se[Qe],[Fe,Qe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ve}async resolveInlayHint(U,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...U);if(!K)return;const H=await this.h.resolveInlayHint(K,j);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j){return U.label.length===0||Array.isArray(U.label)&&U.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(j&&!j.contains(U.position))}m(U,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ee=[];H.label=ee;for(const se of U.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.$AM.isLocation(se.location)&&(Fe.location=i.location.from(se.location)),se.command&&(Fe.command=this.g.toInternal(se.command,K)),ee.push(Fe)}}return H}}class pe{constructor(U,j){this.e=U,this.f=j,this.d=new t.$7ic("DocumentLink")}async provideLinks(U,j){const K=this.e.getDocument(U),H=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(H)||H.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(pe.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Fe=0;Fe<H.length;Fe++){if(!pe.g(H[Fe]))continue;const Ve=i.DocumentLink.from(H[Fe]);Ve.cacheId=[ee,Fe],se.links.push(Ve)}return se}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...U);if(!K)return;const H=await this.f.resolveDocumentLink(K,j);if(!(!H||!pe.g(H)))return i.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class de{constructor(U,j){this.d=U,this.e=j}async provideColors(U,j){const K=this.d.getDocument(U),H=await this.e.provideDocumentColors(K,j);return Array.isArray(H)?H.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(U,j,K){const H=this.d.getDocument(U),ee=i.Range.to(j.range),se=i.Color.to(j.color),Fe=await this.e.provideColorPresentations(se,{document:H,range:ee},K);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class J{constructor(U,j){this.d=U,this.e=j}async provideFoldingRanges(U,j,K){const H=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(H,j,K);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(U,j,K){this.d=U,this.e=j,this.f=K}async provideSelectionRanges(U,j,K){const H=this.d.getDocument(U),ee=j.map(i.Position.to),se=await this.e.provideSelectionRanges(H,ee,K);if(!(0,I.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Ve=0;Ve<ee.length;Ve++){const Qe=[];Fe.push(Qe);let xe=ee[Ve],tt=se[Ve];for(;;){if(!tt.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;xe=tt.range,tt=tt.parent}}return Fe}}class ue{constructor(U,j){this.f=U,this.g=j,this.d=new A.$MO(""),this.e=new Map}async prepareSession(U,j,K){const H=this.f.getDocument(U),ee=i.Position.to(j),se=await this.g.prepareCallHierarchy(H,ee,K);if(!se)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(se)?se.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,se)]}async provideCallsTo(U,j,K){const H=this.j(U,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ee)return ee.map(se=>({from:this.h(U,se.from),fromRanges:se.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(U,j,K){const H=this.j(U,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ee)return ee.map(se=>({to:this.h(U,se.to),fromRanges:se.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(U){this.e.delete(U)}h(U,j){const K=this.e.get(U),H=i.CallHierarchyItem.from(j,U,K.size.toString(36));return K.set(H._itemId,j),H}j(U,j){return this.e.get(U)?.get(j)}}class he{constructor(U,j){this.f=U,this.g=j,this.d=new A.$MO(""),this.e=new Map}async prepareSession(U,j,K){const H=this.f.getDocument(U),ee=i.Position.to(j),se=await this.g.prepareTypeHierarchy(H,ee,K);if(!se)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(se)?se.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,se)]}async provideSupertypes(U,j,K){const H=this.j(U,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,K);if(ee)return ee.map(se=>this.h(U,se))}async provideSubtypes(U,j,K){const H=this.j(U,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,K);if(ee)return ee.map(se=>this.h(U,se))}releaseSession(U){this.e.delete(U)}h(U,j){const K=this.e.get(U),H=i.TypeHierarchyItem.from(j,U,K.size.toString(36));return K.set(H._itemId,j),H}j(U,j){return this.e.get(U)?.get(j)}}class Ne{constructor(U,j,K,H,ee){this.d=U,this.e=j,this.f=K,this.g=H,this.h=ee}async provideDocumentOnDropEdits(U,j,K,H,ee){const se=this.e.getDocument(j),Fe=i.Position.to(K),Ve=i.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,xe)).buffer),Qe=await this.f.provideDocumentDropEdits(se,Fe,Ve,ee);if(Qe)return(0,I.$3b)(Qe).map(xe=>({title:xe.title??(0,s.localize)(1,null,this.h.displayName||this.h.name),kind:xe.kind?.value,yieldTo:xe.yieldTo?.map(tt=>tt.value),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?i.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}))}}class le{constructor(U,j){this.d=U,this.e=j}async provideMappedEdits(U,j,K,H){const ee=u.URI.revive(U),se=this.d.getDocument(ee),Fe=K.documents.map(xe=>xe.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(at=>i.Range.to(at))}))),Ve={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,j,Ve,H);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ie{constructor(U,j){this.adapter=U,this.extension=j}}class Re{static{this.d=0}constructor(U,j,K,H,ee,se,Fe,Ve){this.g=j,this.h=K,this.j=H,this.k=ee,this.l=se,this.m=Fe,this.n=Ve,this.f=new Map,this.e=U.getProxy(p.$mM.MainThreadLanguageFeatures)}o(U,j){return i.DocumentSelector.from(U,this.g,j)}p(U){return new a.$oM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Re.d++}async s(U,j,K,H,ee,se=!1){const Fe=this.f.get(U);if(!Fe||!(Fe.adapter instanceof j))return H;const Ve=Date.now();se||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Qe=K(Fe.adapter,Fe.extension);return Promise.resolve(Qe).catch(xe=>{(0,N.$4)(xe)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Fe.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),M.CancellationToken.isCancellationToken(ee)?(0,O.$0g)(Qe,ee):Qe}t(U,j){const K=this.q();return this.f.set(K,new Ie(U,j)),K}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,j,K,H){const ee=this.t(new c(this.h,K),U),se=H&&H.label||Re.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(j,U),se),this.p(ee)}$provideDocumentSymbols(U,j,K){return this.s(U,c,H=>H.provideDocumentSymbols(u.URI.revive(j),K),void 0,K)}registerCodeLensProvider(U,j,K){const H=this.q(),ee=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ie(new $(this.h,this.j.converter,K,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(j,U),ee);let se=this.p(H);if(ee!==void 0){const Fe=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(ee));se=a.$oM.from(se,Fe)}return se}$provideCodeLenses(U,j,K){return this.s(U,$,H=>H.provideCodeLenses(u.URI.revive(j),K),void 0,K)}$resolveCodeLens(U,j,K){return this.s(U,$,H=>H.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(U,j){this.s(U,$,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(U,j,K){const H=this.t(new v(this.h,K),U);return this.e.$registerDefinitionSupport(H,this.o(j,U)),this.p(H)}$provideDefinition(U,j,K,H){return this.s(U,v,ee=>ee.provideDefinition(u.URI.revive(j),K,H),[],H)}registerDeclarationProvider(U,j,K){const H=this.t(new l(this.h,K),U);return this.e.$registerDeclarationSupport(H,this.o(j,U)),this.p(H)}$provideDeclaration(U,j,K,H){return this.s(U,l,ee=>ee.provideDeclaration(u.URI.revive(j),K,H),[],H)}registerImplementationProvider(U,j,K){const H=this.t(new D(this.h,K),U);return this.e.$registerImplementationSupport(H,this.o(j,U)),this.p(H)}$provideImplementation(U,j,K,H){return this.s(U,D,ee=>ee.provideImplementation(u.URI.revive(j),K,H),[],H)}registerTypeDefinitionProvider(U,j,K){const H=this.t(new g(this.h,K),U);return this.e.$registerTypeDefinitionSupport(H,this.o(j,U)),this.p(H)}$provideTypeDefinition(U,j,K,H){return this.s(U,g,ee=>ee.provideTypeDefinition(u.URI.revive(j),K,H),[],H)}registerHoverProvider(U,j,K,H){const ee=this.t(new S(this.h,K),U);return this.e.$registerHoverProvider(ee,this.o(j,U)),this.p(ee)}$provideHover(U,j,K,H){return this.s(U,S,ee=>ee.provideHover(u.URI.revive(j),K,H),void 0,H)}registerEvaluatableExpressionProvider(U,j,K,H){const ee=this.t(new y(this.h,K),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(j,U)),this.p(ee)}$provideEvaluatableExpression(U,j,K,H){return this.s(U,y,ee=>ee.provideEvaluatableExpression(u.URI.revive(j),K,H),void 0,H)}registerInlineValuesProvider(U,j,K,H){const ee=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new P(this.h,K),U);this.e.$registerInlineValuesProvider(se,this.o(j,U),ee);let Fe=this.p(se);if(ee!==void 0){const Ve=K.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Fe=a.$oM.from(Fe,Ve)}return Fe}$provideInlineValues(U,j,K,H,ee){return this.s(U,P,se=>se.provideInlineValues(u.URI.revive(j),K,H,ee),void 0,ee)}registerDocumentHighlightProvider(U,j,K){const H=this.t(new C(this.h,K),U);return this.e.$registerDocumentHighlightProvider(H,this.o(j,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,j,K){const H=this.t(new W(this.h,K),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(j,U)),this.p(H)}$provideDocumentHighlights(U,j,K,H){return this.s(U,C,ee=>ee.provideDocumentHighlights(u.URI.revive(j),K,H),void 0,H)}$provideMultiDocumentHighlights(U,j,K,H,ee){return this.s(U,W,se=>se.provideMultiDocumentHighlights(u.URI.revive(j),K,H.map(Fe=>u.URI.revive(Fe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,j,K){const H=this.t(new V(this.h,K),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(j,U)),this.p(H)}$provideLinkedEditingRanges(U,j,K,H){return this.s(U,V,async ee=>{const se=await ee.provideLinkedEditingRanges(u.URI.revive(j),K,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Re.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,j,K){const H=this.t(new q(this.h,K),U);return this.e.$registerReferenceSupport(H,this.o(j,U)),this.p(H)}$provideReferences(U,j,K,H,ee){return this.s(U,q,se=>se.provideReferences(u.URI.revive(j),K,H,ee),void 0,ee)}registerCodeActionProvider(U,j,K,H){const ee=new m.$Tc,se=this.t(new R(this.h,this.j.converter,this.k,K,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(se,this.o(j,U),{providedKinds:H?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:H?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,ee)}))},Re.u(U),!!K.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(U,j,K,H,ee){return this.s(U,R,se=>se.provideCodeActions(u.URI.revive(j),K,H,ee),void 0,ee)}$resolveCodeAction(U,j,K){return this.s(U,R,H=>H.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(U,j){this.s(U,R,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(U,j,K){const H=this.t(new G(this.h,K),U);return this.e.$registerDocumentFormattingSupport(H,this.o(j,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,j,K,H){return this.s(U,G,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(j),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,j,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,K),U);return this.e.$registerRangeFormattingSupport(ee,this.o(j,U),U.identifier,U.displayName||U.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(U,j,K,H,ee){return this.s(U,ie,se=>se.provideDocumentRangeFormattingEdits(u.URI.revive(j),K,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,j,K,H,ee){return this.s(U,ie,se=>se.provideDocumentRangesFormattingEdits(u.URI.revive(j),K,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,j,K,H){const ee=this.t(new fe(this.h,K),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(j,U),H,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,j,K,H,ee,se){return this.s(U,fe,Fe=>Fe.provideOnTypeFormattingEdits(u.URI.revive(j),K,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(U,j){const K=this.t(new De(j,this.l),U);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(U,j,K){return this.s(U,De,H=>H.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(U,j,K){return this.s(U,De,H=>H.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(U,j){this.s(U,De,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(U,j,K){const H=this.t(new we(this.h,K,this.l),U);return this.e.$registerRenameSupport(H,this.o(j,U),we.supportsResolving(K)),this.p(H)}$provideRenameEdits(U,j,K,H,ee){return this.s(U,we,se=>se.provideRenameEdits(u.URI.revive(j),K,H,ee),void 0,ee)}$resolveRenameLocation(U,j,K,H){return this.s(U,we,ee=>ee.resolveRenameLocation(u.URI.revive(j),K,H),void 0,H)}registerNewSymbolNamesProvider(U,j,K){const H=this.t(new oe(this.h,K,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(j,U)),this.p(H)}$provideNewSymbolNames(U,j,K,H){return this.s(U,oe,ee=>ee.provideNewSymbolNames(u.URI.revive(j),K,H),void 0,H)}registerDocumentSemanticTokensProvider(U,j,K,H){const ee=this.t(new ne(this.h,K),U),se=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(j,U),H,se);let Fe=this.p(ee);if(se){const Ve=K.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Fe=a.$oM.from(Fe,Ve)}return Fe}$provideDocumentSemanticTokens(U,j,K,H){return this.s(U,ne,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(j),K,H),null,H)}$releaseDocumentSemanticTokens(U,j){this.s(U,ne,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,j,K,H){const ee=this.t(new Se(this.h,K),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(j,U),H),this.p(ee)}$provideDocumentRangeSemanticTokens(U,j,K,H){return this.s(U,Se,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(j),K,H),null,H)}registerCompletionItemProvider(U,j,K,H){const ee=this.t(new Le(this.h,this.j.converter,K,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(j,U),H,Le.supportsResolving(K),U.identifier),this.p(ee)}$provideCompletionItems(U,j,K,H,ee){return this.s(U,Le,se=>se.provideCompletionItems(u.URI.revive(j),K,H,ee),void 0,ee)}$resolveCompletionItem(U,j,K){return this.s(U,Le,H=>H.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(U,j){this.s(U,Le,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(U,j,K,H){const ee=new L(U,this.h,K,this.j.converter),se=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(se,this.o(j,U),ee.supportsHandleEvents,n.$Dm.toKey(U.identifier.value),H?.yieldTo?.map(Fe=>n.$Dm.toKey(Fe))||[]),this.p(se)}$provideInlineCompletions(U,j,K,H,ee){return this.s(U,re,se=>se.provideInlineCompletions(u.URI.revive(j),K,H,ee),void 0,ee)}$handleInlineCompletionDidShow(U,j,K,H){this.s(U,re,async ee=>{ee.handleDidShowCompletionItem(j,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,j,K,H,ee){this.s(U,re,async se=>{se.handlePartialAccept(j,K,H,ee)},void 0,void 0)}$freeInlineCompletionsList(U,j){this.s(U,re,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(U,j,K){const H=new x(U,this.h,K,this.j.converter),ee=this.t(H,U);return this.e.$registerInlineEditProvider(ee,this.o(j,U),U.identifier),this.p(ee)}$provideInlineEdit(U,j,K,H){return this.s(U,x,ee=>ee.provideInlineEdits(u.URI.revive(j),K,H),void 0,H)}$freeInlineEdit(U,j){this.s(U,x,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(U,j,K,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Oe(this.h,K),U);return this.e.$registerSignatureHelpProvider(se,this.o(j,U),ee),this.p(se)}$provideSignatureHelp(U,j,K,H,ee){return this.s(U,Oe,se=>se.provideSignatureHelp(u.URI.revive(j),K,H,ee),void 0,ee)}$releaseSignatureHelp(U,j){this.s(U,Oe,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(U,j,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ye(this.h,this.j.converter,K,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(j,U),typeof K.resolveInlayHint=="function",H,Re.u(U));let se=this.p(ee);if(H!==void 0){const Fe=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));se=a.$oM.from(se,Fe)}return se}$provideInlayHints(U,j,K,H){return this.s(U,ye,ee=>ee.provideInlayHints(u.URI.revive(j),K,H),void 0,H)}$resolveInlayHint(U,j,K){return this.s(U,ye,H=>H.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(U,j){this.s(U,ye,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(U,j,K){const H=this.t(new pe(this.h,K),U);return this.e.$registerDocumentLinkProvider(H,this.o(j,U),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,j,K){return this.s(U,pe,H=>H.provideLinks(u.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(U,j,K){return this.s(U,pe,H=>H.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(U,j){this.s(U,pe,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(U,j,K){const H=this.t(new de(this.h,K),U);return this.e.$registerDocumentColorProvider(H,this.o(j,U)),this.p(H)}$provideDocumentColors(U,j,K){return this.s(U,de,H=>H.provideColors(u.URI.revive(j),K),[],K)}$provideColorPresentations(U,j,K,H){return this.s(U,de,ee=>ee.provideColorPresentations(u.URI.revive(j),K,H),void 0,H)}registerFoldingRangeProvider(U,j,K){const H=this.q(),ee=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ie(new J(this.h,K),U)),this.e.$registerFoldingRangeProvider(H,this.o(j,U),U.identifier,ee);let se=this.p(H);if(ee!==void 0){const Fe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=a.$oM.from(se,Fe)}return se}$provideFoldingRanges(U,j,K,H){return this.s(U,J,ee=>ee.provideFoldingRanges(u.URI.revive(j),K,H),void 0,H)}registerSelectionRangeProvider(U,j,K){const H=this.t(new Y(this.h,K,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(j,U)),this.p(H)}$provideSelectionRanges(U,j,K,H){return this.s(U,Y,ee=>ee.provideSelectionRanges(u.URI.revive(j),K,H),[],H)}registerCallHierarchyProvider(U,j,K){const H=this.t(new ue(this.h,K),U);return this.e.$registerCallHierarchyProvider(H,this.o(j,U)),this.p(H)}$prepareCallHierarchy(U,j,K,H){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(j),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,j,K,H){return this.s(U,ue,ee=>ee.provideCallsTo(j,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,j,K,H){return this.s(U,ue,ee=>ee.provideCallsFrom(j,K,H),void 0,H)}$releaseCallHierarchy(U,j){this.s(U,ue,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(U,j,K){const H=this.t(new he(this.h,K),U);return this.e.$registerTypeHierarchyProvider(H,this.o(j,U)),this.p(H)}$prepareTypeHierarchy(U,j,K,H){return this.s(U,he,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(j),K,H)),void 0,H)}$provideTypeHierarchySupertypes(U,j,K,H){return this.s(U,he,ee=>ee.provideSupertypes(j,K,H),void 0,H)}$provideTypeHierarchySubtypes(U,j,K,H){return this.s(U,he,ee=>ee.provideSubtypes(j,K,H),void 0,H)}$releaseTypeHierarchy(U,j){this.s(U,he,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(U,j,K,H){const ee=this.q();return this.f.set(ee,new Ie(new Ne(this.e,this.h,K,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(j,U),(0,h.$9F)(U,"dropMetadata")?H:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,j,K,H,ee,se){return this.s(U,Ne,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(j,u.URI.revive(K),H,ee,se)),void 0,void 0)}registerMappedEditsProvider(U,j,K){const H=this.t(new le(this.h,K),U);return this.e.$registerMappedEditsProvider(H,this.o(j,U)),this.p(H)}$provideMappedEdits(U,j,K,H,ee){return this.s(U,le,se=>Promise.resolve(se.provideMappedEdits(j,K,H,ee)),null,ee)}registerDocumentPasteEditProvider(U,j,K,H){const ee=this.q();return this.f.set(ee,new Ie(new z(this.e,this.h,K,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(j,U),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,j,K,H,ee){return this.s(U,z,se=>se.prepareDocumentPaste(u.URI.revive(j),K,H,ee),void 0,ee)}$providePasteEdits(U,j,K,H,ee,se,Fe){return this.s(U,z,Ve=>Ve.providePasteEdits(j,u.URI.revive(K),H,ee,se,Fe),void 0,Fe)}$resolvePasteEdit(U,j,K){return this.s(U,z,H=>H.resolvePasteEdit(j,K),{},void 0)}$releasePasteEdits(U,j){this.s(U,z,K=>Promise.resolve(K.releasePasteEdits(j)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Re.w(U.decreaseIndentPattern),increaseIndentPattern:Re.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Re.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Re.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Re.w(U.beforeText),afterText:U.afterText?Re.w(U.afterText):void 0,previousLineText:U.previousLineText?Re.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Re.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(j=>a.SyntaxTokenType.toString(j)):void 0}}static D(U){return U.map(Re.C)}setLanguageConfiguration(U,j,K){const{wordPattern:H}=K;if(H&&(0,F.$0e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(j,H):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),se={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,j,se),this.p(ee)}$setWordDefinitions(U){for(const j of U)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$ejc=Re}),define(Ce[88],Pe([1,0,6,4,8,7,101,20,11,5,166,106,14,3,17,84,13]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=e.$ljc=void 0,e.$ljc=(0,b.$ii)("IExtHostLanguageModels");class n{constructor(t,p){this.option=t,this.stream=new d.$Lh,this.stream=p??new d.$Lh}}class i{constructor(){this.a=new Map,this.b=new d.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let p=this.a.get(t.index);p||(this.a.size===0?p=new n(t.index,this.b):p=new n(t.index),this.a.set(t.index,p)),p.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const p of this.f())p.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{s=this}static{this.a=1}constructor(t,p,c){this.j=p,this.k=c,this.c=new k.$7d,this.d=new k.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Fm,this.i=new Map,this.o=new Set,this.b=t.getProxy(O.$mM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,p,c,$){const w=s.a++;this.f.set(w,{extension:t.identifier,provider:c,languageModelId:p});let v;return $.auth&&(v={providerLabel:t.displayName||t.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(w,p,{extension:t.identifier,identifier:p,model:$.name??"",auth:v}),(0,I.$Sc)(()=>{this.f.delete(w),this.b.$unregisterProvider(w)})}async $provideLanguageModelResponse(t,p,c,$,w,v){const l=this.f.get(t);if(!l)return;const D=new A.$Rv(async g=>{if(v.isCancellationRequested){this.j.warn(`[CHAT](${l.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(p,{index:g.index,part:g.part})});return l.provider.provideLanguageModelResponse2($.map(M.LanguageModelMessage.to),w,m.$Dm.toKey(c),D,v)}$updateLanguageModels(t){const p=[],c=[];if(t.added)for(const $ of t.added)this.g.set($.identifier,$),p.push($.model);if(t.removed)for(const $ of t.removed){this.g.delete($),c.push($);for(const[w,v]of this.i)v.languageModelId===$&&(v.res.reject(new u.$5),this.i.delete(w))}this.d.fire(Object.freeze({added:Object.freeze(p),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const p=new Array;for(const{from:c,to:$,enabled:w}of t){const v=this.h.get(c)??new m.$Em;if(v.has($)!==w){w?v.add($):v.delete($),this.h.set(c,v);const D={from:c,to:$};p.push(D),this.c.fire(D)}}}async sendChatRequest(t,p,c,$,w){const v=t.identifier,l=await this.b.$prepareChatAccess(v,p,$.justification);if(!l||!this.g.has(p))throw N.$uO.NotFound(`Language model '${p}' is unknown.`);if(this.m(v,l)&&(!await this.l(t,{identifier:l.extension,displayName:l.auth.providerLabel},$.justification,$.silent)||!this.h.get(v)?.has(l.extension)))throw N.$uO.NoPermissions(`Language model '${p}' cannot be used by '${v.value}'.`);const D=Math.random()*1e6|0,g=this.b.$fetchResponse(v,p,D,c.map(M.LanguageModelMessage.from),$.modelOptions??{},w),S=new d.$hh,y=new i;this.i.set(D,{languageModelId:p,res:y});let P;if(g.catch(C=>{S.isOpen()?y.reject(C):P=C}).finally(()=>{this.i.delete(D),y.resolve(),S.open()}),await S.wait(),P)throw new N.$uO(`Language model '${p}' errored, check cause for more details`,"Unknown",P);return y.apiObject}async $handleResponseFragment(t,p){const c=this.i.get(t);c&&c.res.handleFragment(p)}async l(t,p,c,$){const w=E.$oL+p.identifier.value;if(await this.k.getSession(t,w,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0;if($)return!1;try{const l=c?(0,F.localize)(0,null,p.displayName,c):(0,F.localize)(1,null,p.displayName);return await this.k.getSession(t,w,[],{forceNewSession:{detail:l}}),this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0}catch{return!1}}m(t,p){return!!p.auth&&!m.$Dm.equals(p.extension,t)}async n(t){for(const p of this.o)try{await this.l(p,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const p=this,c=k.Event.signal(k.Event.filter(this.c.event,w=>m.$Dm.equals(w.from,t.identifier))),$=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(c,$)},canSendRequest(w){const v=p.g.get(w);if(!v)return;if(!p.m(t.identifier,v))return!0;const l=p.h.get(t.identifier);if(l)return l.has(v.extension)}}}};e.$mjc=a,e.$mjc=a=s=Je([We(0,f.$HO),We(1,o.$Oj),We(2,r.$gjc)],a)}),define(Ce[264],Pe([1,0,4,8,7,32,11,6,25]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class k{constructor(E,u,b,f){this.c=u,this.d=b,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(I.$mM.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const b=this.c.getDocumentData(E);if(!b)throw new Error(`document '${E.toString()}' NOT found`);return b.document}async tokenAtPosition(E,u){const b=E.version,f=O.Position.from(u),r=await this.a.$tokensAtPosition(E.uri,f),o={type:M.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new M.$qM(u.line,u.character,u.line,u.character)};if(!r)return o;const s={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!s.range.contains(u)||b!==E.version?o:s}createLanguageStatusItem(E,u,b){const f=this.f++,r=this.a,o=this.g,s=`${E.identifier.value}/${u}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(s);const n={selector:b,id:u,name:E.displayName??E.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new m.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$kh)(()=>{a.clear(),this.a.$setLanguageStatus(f,{id:s,name:n.name??E.displayName??E.name,source:E.displayName??E.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?N.default.Error:n.severity===M.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),r.$removeLanguageStatus(f),o.delete(s)},get id(){return n.id},get name(){return n.name},set name(p){n.name=p,h()},get selector(){return n.selector},set selector(p){n.selector=p,h()},get text(){return n.text},set text(p){n.text=p,h()},set text2(p){(0,d.$0F)(E,"languageStatusText"),n.text=p,h()},get text2(){return(0,d.$0F)(E,"languageStatusText"),n.text},get detail(){return n.detail},set detail(p){n.detail=p,h()},get severity(){return n.severity},set severity(p){n.severity=p,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(p){n.accessibilityInformation=p,h()},get command(){return n.command},set command(p){n.command=p,h()},get busy(){return n.busy},set busy(p){n.busy=p,h()}};return h(),t}}e.$Fkc=k}),define(Ce[265],Pe([1,0,12,2,8,7,83]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=void 0;class m{constructor(E,u,b,f){this.start=E,this.deletedCount=u,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new N.$PN(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class d{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,b){this.notebook=E,this.h=u,this.j=b,this.handle=b.handle,this.uri=O.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(M.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(f){E.g=f},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(b)}return this.f}setOutputs(E){this.a=E.map(M.NotebookCellOutput.to)}setOutputItems(E,u,b){const f=b.map(M.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===E);if(r&&(u||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(o=>A.$jK(o.mime)))){const o=new Map,s=[];r.items.forEach(n=>{let i;o.has(n.mime)?i=o.get(n.mime):(i=[],o.set(n.mime,i),s.push(n.mime)),i.push(n.data)}),r.items.length=0,s.forEach(n=>{const i=A.$kK(o.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$qkc=d;class k{static{this.a=0}constructor(E,u,b,f,r){this.k=E,this.l=u,this.m=b,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===I.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(b){return b=E.n(b),E.b[b].apiCell},getCells(b){return(b?E.p(b):E.b).map(r=>r.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,b){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const s of E.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,f.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,f.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const n=r[s],i=o.get(n.cell);if(i===void 0){const a=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,a-1)}else f.cellChanges[i]={...f.cellChanges[i],...n}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,b=E.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),E.with({start:u,end:b})}p(E){E=this.o(E);const u=[];for(let b=E.start;b<E.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,b){if(this.j)return;const f=[],r=[],o=[];if(E.reverse().forEach(s=>{const i=s[2].map(t=>{const p=new d(this,this.l,t);return u||r.push(d.asModelAddData(t)),p}),a=new m(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),a.deletedItems.push(t.apiCell);f.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),b)for(const s of f)b.push(s.asApiEvent())}s(E,u,b,f){const r=this.b.splice(E,u);this.b.splice(b,0,...r);const o=[new m(E,u,r.map(s=>s.apiCell),[]),new m(b,0,[],r)];for(const s of o)f.push(s.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,b,f){this.b[E].setOutputItems(u,b,f)}v(E,u){const b=this.b[E];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(E,u){const b=this.b[E];b.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$rkc=k}),define(Ce[266],Pe([1,0,5,2,8,7]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=void 0;class A{constructor(d,k,F,E={timeout:1500,errors:3}){this.b=d,this.c=k,this.d=F,this.f=E,this.a=new I.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent(d){return(k,F,E)=>{const u=function(f){k.call(F,f)};return u.extension=d,this.a.event(u,void 0,E)}}async $participateInSave(d,k,F){const E=O.URI.revive(d),u=this.c.getNotebookDocument(E);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:M.TextDocumentSaveReason.to(k)},F,async(r,o)=>{const s=Date.now(),n=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!F.isCancellationRequested&&n&&(n instanceof N.$yM?b.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),F.isCancellationRequested)return!1;if(b.length===0)return!0;const f={edits:[]};for(const r of b){const{edits:o}=M.WorkspaceEdit.from(r);f.edits=f.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(f)}}e.$Hkc=A}),define(Ce[112],Pe([1,0,14,8,7]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,d,k,F,E,u){this.id=m,this.f=d,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=F,this.c=u}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(d){this.selections=[d]},get selections(){return m.a},set selections(d){if(!Array.isArray(d)||!d.every(M.$PN.isNotebookRange))throw(0,I.$7)("selections");m.a=d,m.g(d)},get visibleRanges(){return m.b},revealRange(d,k){m.f.$tryRevealRange(m.id,O.NotebookRange.from(d),k??M.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(O.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$skc=N}),define(Ce[267],Pe([1,0,5,13,8]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;let N=class{constructor(m,d){this.c=m,this.d=d,this.a=new I.$7d,this.b=new I.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,d);const k=this.d.getEditorById(m);d.visibleRanges&&k._acceptVisibleRanges(d.visibleRanges.ranges.map(M.NotebookRange.to)),d.selections&&k._acceptSelections(d.selections.selections.map(M.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const d in m)this.d.getEditorById(d)._acceptViewColumn(M.ViewColumn.to(m[d]))}};e.$Jkc=N,e.$Jkc=N=Je([We(0,O.$Oj)],N)}),define(Ce[268],Pe([1,0,5,4,112]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class N{constructor(m,d){this.c=d,this.a=new Map,this.b=m.getProxy(O.$mM.MainThreadNotebookRenderers)}$postRendererMessage(m,d,k){const F=this.c.getEditorById(m);this.a.get(d)?.fire({editor:F.apiEditor,message:k})}createRendererMessaging(m,d){if(!m.contributes?.notebookRenderer?.some(F=>F.id===d))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${d})`);return{onDidReceiveMessage:(F,E,u)=>this.d(d).event(F,E,u),postMessage:(F,E)=>{M.$skc.apiEditorsToExtHost.has(F)&&([F,E]=[E,F]);const u=E&&M.$skc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,d,F)}}}d(m){let d=this.a.get(m);return d||(d=new I.$7d({onDidRemoveLastListener:()=>{d?.dispose(),this.a.delete(m)}}),this.a.set(m,d),d)}}e.$Mkc=N}),define(Ce[269],Pe([1,0,8,101,24,68,14]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class m{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,b){const f=this.b++,{title:r,location:o,cancellable:s}=u,n={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(f,{location:I.ProgressLocation.from(o),title:r,source:n,cancellable:s},E.isUnderDevelopment?void 0:E.identifier.value).catch(A.$2),this.d(f,b,!!s)}d(E,u,b){let f;b&&(f=new M.$ee,this.c.set(E,f));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),f?.dispose()};let o;try{o=u(new k(this.a,E),b&&f?f.token:M.CancellationToken.None)}catch(s){throw r(E),s}return o.then(s=>r(E),s=>r(E)),o}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$Qkc=m;function d(F,E){return F.message=E.message,typeof E.increment=="number"&&(typeof F.increment=="number"?F.increment+=E.increment:F.increment=E.increment),F}class k extends O.$Rv{constructor(E,u){super(b=>this.throttledReport(b)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,N.$Oh)(100,(F,E)=>d(F,E),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ce[270],Pe([1,0,2,4,11,8]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class A{static{this.a=0}constructor(d,k){this.d=k,this.c=new Map,this.b=d.getProxy(O.$mM.MainThreadQuickDiff)}$provideOriginalResource(d,k,F){const E=I.URI.revive(k),u=this.c.get(d);return u?(0,M.$ah)(()=>u.provideOriginalResource(E,F)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(d,k,F,E){const u=A.a++;return this.c.set(u,k),this.b.$registerQuickDiffProvider(u,N.DocumentSelector.from(d,this.d),F,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Rkc=A}),define(Ce[271],Pe([1,0,24,5,6,4,2,7,14,18,32,41,25,8]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=f;function f(r,o,s){const n=r.getProxy(N.$mM.MainThreadQuickOpen);class i{constructor(l,D){this.e=new Map,this.f=0,this.a=l,this.b=D}showQuickPick(l,D,g,S=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),P=++this.f,C=n.$show(P,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},S),W={},V=C.then(()=>W);return Promise.race([V,y]).then(q=>{if(q===W)return;const R=(0,u.$9F)(l,"quickPickItemTooltip");return y.then(z=>{const G=[];for(let ie=0;ie<z.length;ie++){const fe=z[ie];if(typeof fe=="string")G.push({label:fe,handle:ie});else if(fe.kind===m.QuickPickItemKind.Separator)G.push({type:"separator",label:fe.label});else{fe.tooltip&&!R&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const De=fe.iconPath?c(fe.iconPath):void 0;G.push({label:fe.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:R?b.MarkdownString.fromStrict(fe.tooltip):void 0,handle:ie})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=ie=>{g.onDidSelectItem(z[ie])}),n.$setItems(P,G),C.then(ie=>{if(typeof ie=="number")return z[ie];if(Array.isArray(ie))return ie.map(fe=>z[fe])})})}).then(void 0,q=>{if(!(0,d.$4)(q))return n.$setError(P,q),Promise.reject(q)})}$onItemSelected(l){this.c?.(l)}showInput(l,D=I.CancellationToken.None){return this.d=l?.validateInput,n.$input(l,typeof this.d=="function",D).then(void 0,g=>{if(!(0,d.$4)(g))return Promise.reject(g)})}async $validateInput(l){if(!this.d)return;const D=await this.d(l);if(!D||typeof D=="string")return D;let g;switch(D.severity){case m.InputBoxValidationSeverity.Info:g=F.default.Info;break;case m.InputBoxValidationSeverity.Warning:g=F.default.Warning;break;case m.InputBoxValidationSeverity.Error:g=F.default.Error;break;default:g=D.message?F.default.Error:F.default.Ignore;break}return{content:D.message,severity:g}}async showWorkspaceFolderPick(l,D=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!g)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(y=>y.uri.toString()===g.uri.toString())}createQuickPick(l){const D=new $(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(l){const D=new w(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(l,D){this.e.get(l)?._fireDidChangeValue(D)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeActive(D)}$onDidChangeSelection(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeSelection(D)}$onDidTriggerButton(l,D){this.e.get(l)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(l,D,g){const S=this.e.get(l);S instanceof $&&S._fireDidTriggerItemButton(D,g)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class a{static{this.a=1}constructor(l,D){this.x=l,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$7d,this.q=new O.$7d,this.r=new O.$7d,this.s=new O.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((D,g)=>{const S=D===m.$MN.Back?-1:g;this.o.set(S,D)}),this.z({buttons:l.map((D,g)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===m.$MN.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const D=this.o.get(l);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(l){if(!this.v){for(const D of Object.keys(l)){const g=l[D];this.u[D]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(v){if(v instanceof m.$kN)return{id:v.id};const l=p(v),D=t(v);return{dark:typeof l=="string"?A.URI.file(l):l,light:typeof D=="string"?A.URI.file(D):D}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function p(v){return typeof v=="object"&&"dark"in v?v.dark:v}function c(v){const l=h(v);let D,g;return"id"in l?g=E.ThemeIcon.asClassName(l):D=l,{iconPath:D,iconClass:g}}class $ extends a{constructor(l,D){super(l.identifier,D),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$7d,this.L=[],this.M=new O.$7d,this.N=new O.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((S,y)=>{this.C.set(y,S),this.D.set(S,y)});const D=(0,u.$9F)(this.O,"quickPickItemTooltip"),g=[];for(let S=0;S<l.length;S++){const y=l[S];if(y.kind===m.QuickPickItemKind.Separator)g.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?c(y.iconPath):void 0;g.push({handle:S,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?b.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((C,W)=>({...c(C.iconPath),tooltip:C.tooltip,handle:W}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(l){const D=(0,k.$Hb)(l.map(g=>this.C.get(g)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(l){const D=(0,k.$Hb)(l.map(g=>this.C.get(g)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(l,D){const g=this.C.get(l);if(!g||!g.buttons||!g.buttons.length)return;const S=g.buttons[D];S&&this.N.fire({button:S,item:g})}}class w extends a{constructor(l,D){super(l.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:F.default.Error}):this.z({validationMessage:l.message,severity:l.severity??F.default.Error}):this.z({validationMessage:void 0,severity:F.default.Ignore})}}return new i(o,s)}}),define(Ce[272],Pe([1,0,2,5,68,6,11,4,18,142,13,20,41,8,25,12,21]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=void 0;function n(P){return P instanceof I.URI}function i(P,C){return P.scheme===r.Schemas.file&&C.scheme===r.Schemas.file&&o.$k?P.toString()===C.toString():P.toString().toLowerCase()===C.toString().toLowerCase()}function a(P){if(P)return typeof P.iconPath=="string"?I.URI.file(P.iconPath):I.URI.isUri(P.iconPath)||u.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function h(P){if(P.icon){if(I.URI.isUri(P.icon))return P.icon;if(u.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const C=P.icon;return{light:C.light,dark:C.dark}}}else return}function t(P,C){if(!P.iconPath&&!C.iconPath)return 0;if(P.iconPath){if(!C.iconPath)return 1}else return-1;const W=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,k.$ar)(W,V)}function p(P,C){let W=0;if(P.strikeThrough!==C.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==C.faded)return P.faded?1:-1;if(P.tooltip!==C.tooltip)return(P.tooltip||"").localeCompare(C.tooltip||"");if(W=t(P,C),W!==0)return W;if(P.light&&C.light)W=t(P.light,C.light);else{if(P.light)return 1;if(C.light)return-1}if(W!==0)return W;if(P.dark&&C.dark)W=t(P.dark,C.dark);else{if(P.dark)return 1;if(C.dark)return-1}return W}function c(P,C){if(P.command!==C.command)return P.command<C.command?-1:1;if(P.title!==C.title)return P.title<C.title?-1:1;if(P.tooltip!==C.tooltip){if(P.tooltip!==void 0&&C.tooltip!==void 0)return P.tooltip<C.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(P.arguments===C.arguments)return 0;if(P.arguments)if(C.arguments){if(P.arguments.length!==C.arguments.length)return P.arguments.length-C.arguments.length}else return 1;else return-1;for(let W=0;W<P.arguments.length;W++){const V=P.arguments[W],q=C.arguments[W];if(V!==q&&!(n(V)&&n(q)&&i(V,q)))return V<q?-1:1}return 0}function $(P,C){let W=(0,k.$ar)(P.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(W!==0)return W;if(P.command&&C.command)W=c(P.command,C.command);else{if(P.command)return 1;if(C.command)return-1}if(W!==0)return W;if(P.decorations&&C.decorations)W=p(P.decorations,C.decorations);else{if(P.decorations)return 1;if(C.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&C.multiFileDiffEditorModifiedUri)W=(0,k.$ar)(P.multiFileDiffEditorModifiedUri.fsPath,C.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(C.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&C.multiDiffEditorOriginalUri)W=(0,k.$ar)(P.multiDiffEditorOriginalUri.fsPath,C.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(C.multiDiffEditorOriginalUri)return-1}return W}function w(P,C){for(let W=0;W<P.length;W++)if(P[W]!==C[W])return!1;return!0}function v(P,C){return P.command===C.command&&P.title===C.title&&P.tooltip===C.tooltip&&(P.arguments&&C.arguments?w(P.arguments,C.arguments):P.arguments===C.arguments)}function l(P,C){return(0,d.$ub)(P,C,v)}class D{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.l,C),this.n(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.l,C),this.f=C}get validateInput(){return(0,f.$0F)(this.k,"scmValidation"),this.g}set validateInput(C){if((0,f.$0F)(this.k,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.l,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.l,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.l,C))}get document(){return(0,f.$0F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(C,W,V,q,R){this.k=C,this.l=q,this.m=R,this.d="",this.e=new O.$7d,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(C,W){(0,f.$0F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,C,W)}$onInputBoxValueChange(C){this.n(C)}n(C){this.d=C,this.e.fire(C)}}e.$Tkc=D;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,W,V,q,R,z,G){this.q=C,this.s=W,this.t=V,this.u=q,this.v=R,this.multiDiffEditorEnableViewChanges=z,this.w=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,W){const V=this.h.get(C);return V?(0,A.$ah)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort($),V=(0,d.$Db)(this.o,C,$).map(z=>{const G=z.toInsert.map(ie=>{const fe=this.e++;this.g.set(fe,ie);const De=ie.resourceUri;let we;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const de=new N.$Tc;we=this.s.converter.toInternal(ie.command,de),this.j.set(fe,de)}else this.h.set(fe,ie.command);const oe=(0,f.$9F)(this.w,"scmMultiDiffEditor"),$e=oe?ie.multiDiffEditorOriginalUri:void 0,ne=oe?ie.multiFileDiffEditorModifiedUri:void 0,Se=a(ie.decorations),Le=ie.decorations&&a(ie.decorations.light)||Se,re=ie.decorations&&a(ie.decorations.dark)||Se,L=[Le,re],x=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Oe=ie.decorations&&!!ie.decorations.faded,ye=ie.contextValue||"";return{rawResource:[fe,De,L,x,ve,Oe,ye,we,$e,ne],handle:fe}});return{start:z.start,deleteCount:z.deleteCount,toInsert:G}}),q=V.map(({start:z,deleteCount:G,toInsert:ie})=>[z,G,ie.map(fe=>fe.rawResource)]),R=V.reverse();for(const{start:z,deleteCount:G,toInsert:ie}of R){const fe=ie.map(we=>we.handle),De=this.n.splice(z,G,...fe);for(const we of De)this.g.delete(we),this.h.delete(we),this.j.get(we)?.dispose(),this.j.delete(we)}return this.o=C,q}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.w,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let W;(0,f.$9F)(this.x,"quickDiffProvider")&&(W=C?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!C,quickDiffLabel:W})}get historyProvider(){return(0,f.$0F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(C){(0,f.$0F)(this.x,"scmHistoryProvider"),this.j=C,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!C}),C&&this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(C){C!==this.m&&(this.m=C,this.#e.$updateSourceControl(this.w,{commitTemplate:C}))}get acceptInputCommand(){return this.o}set acceptInputCommand(C){this.n.value=new N.$Tc,this.o=C;const W=this.y.converter.toInternal(C,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,f.$0F)(this.x,"scmActionButton"),this.q}set actionButton(C){(0,f.$0F)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=C;const W=C!==void 0?{command:this.y.converter.toInternal(C.command,this.p.value),secondaryCommands:C.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(C){if(this.t&&C&&l(this.t,C))return;this.s.value=new N.$Tc,this.t=C;const W=(C||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(C,W,V,q,R,z,G){this.x=C,this.y=q,this.z=R,this.A=z,this.B=G,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new O.$7d,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${R}/scm${this.w}/input`,query:G?`rootUri=${encodeURIComponent(G.toString())}`:void 0});this.f=new D(C,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,R,z,G,ie)}createResourceGroup(C,W,V){const q=(0,f.$9F)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,R=new g(this.#e,this.y,this.w,C,W,q,this.x),z=O.Event.once(R.onDidDispose)(()=>this.C.delete(R));return this.C.set(R,z),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const C=[],W=[];for(const[V,q]of this.C){q.dispose();const R=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});O.Event.once(V.onDidDispose)(()=>{this.D.delete(V),R.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),C.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const z=V._takeResourceStateSnapshot();z.length>0&&W.push([V.handle,z]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,C,W),this.C.clear()}eventuallyUpdateResourceStates(){const C=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&C.push([W.handle,V])}),C.length>0&&this.#e.$spliceResourceStates(this.w,C),this.D.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.u=C,this.v.fire(C)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$Nh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$Nh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new E.$Fm,this.j=new O.$7d,this.e=C.getProxy(m.$mM.MainThreadSCM),this.f=C.getProxy(m.$mM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const z=this.g.get(R.sourceControlHandle);if(!z)return R;const G=z.getResourceGroup(R.groupHandle);return G?G.getResourceState(R.handle):R}else if(R&&R.$mid===4){const z=this.g.get(R.sourceControlHandle);return z?z.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const z=this.g.get(R.handle);return z||R}return R}})}createSourceControl(C,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const R=s.d++,z=new S(C,this.m,this.e,this.l,W,V,q);this.g.set(R,z);const G=this.h.get(C.identifier)||[];return G.push(z),this.h.set(C.identifier,G),z}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const W=this.h.get(C.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(C,W,V){const q=I.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",C,q.toString());const R=this.g.get(C);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$ah)(()=>R.quickDiffProvider.provideOriginalResource(q,V)).then(z=>z||null)}$onInputBoxValueChange(C,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const V=this.g.get(C);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(C,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",C,W,V);const R=this.g.get(C);if(!R)return Promise.resolve(void 0);const z=R.getResourceGroup(W);return z?z.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(C,W,V){this.n.trace("ExtHostSCM#$validateInput",C);const q=this.g.get(C);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$ah)(()=>q.inputBox.validateInput(W,V)).then(R=>{if(!R)return Promise.resolve(void 0);const z=b.MarkdownString.fromStrict(R.message);return z?Promise.resolve([z,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(C,W,V,q){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(C,W,V,q){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(W,V,q))?.map(G=>({...G,icon:h(G)}))??void 0}async $provideHistoryItemSummary(C,W,V,q){const R=this.g.get(C)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const z=await R.provideHistoryItemSummary(W,V,q);return z?{...z,icon:h(z)}:void 0}async $provideHistoryItemChanges(C,W,V,q){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$Ukc=y,e.$Ukc=y=s=Je([We(3,F.$Oj)],y)}),define(Ce[273],Pe([1,0,4,8,2]),function(ge,e,I,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class N{static{this.a=0}constructor(m,d){this.d=d,this.c=new Map,this.b=m.getProxy(I.$mM.MainThreadShare)}async $provideShare(m,d,k){return await this.c.get(m)?.provideShare({selection:O.Range.to(d.selection),resourceUri:M.URI.revive(d.resourceUri)},k)??void 0}registerShareProvider(m,d){const k=N.a++;return this.c.set(k,d),this.b.$registerShareProvider(k,O.DocumentSelector.from(m,this.d),d.id,d.label,d.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$Vkc=N}),define(Ce[274],Pe([1,0,7,4,169,6,8,16]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Xkc=void 0;class d{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$lN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$lN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,f,r,o,s=I.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=u,this.#t=b,o&&r){this.c=(0,I.$ZM)(r.identifier,o);const i=f.get(this.c);i&&(s=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(d.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(n)}u(u){if((0,m.$Zf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!d.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,M.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=d.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,r,this.r?.internal,f,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Xkc=d;class k{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new I.$oM(()=>{const f=this.b.indexOf(b);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class F{constructor(u,b){this.e=new Map,this.a=u.getProxy(O.$mM.MainThreadStatusBar),this.b=b,this.c=new k(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,f,r){return new d(this.a,this.b,this.e,u,b,f,r)}setStatusBarMessage(u,b){const f=this.c.setMessage(u);let r;return typeof b=="number"?r=setTimeout(()=>f.dispose(),b):typeof b<"u"&&b.then(()=>f.dispose(),()=>f.dispose()),new I.$oM(()=>{f.dispose(),clearTimeout(r)})}}e.$Ykc=F}),define(Ce[113],Pe([1,0,29,105,49,75,60,8,2]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=e.$VO=e.$UO=e.$TO=void 0;const k=(i,a,h,t)=>{let p=a;return{enumerable:!0,configurable:!1,get(){return p},set(c){if(!h(p,c)){const $=p;p=c,i.listener?.(t(c,$))}}}},F=(i,a)=>i===a,E={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:F,description:F,sortText:F,busy:F,error:F,canResolveChildren:F,tags:(i,a)=>!(i.length!==a.length||i.some(h=>!a.find(t=>h.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),b=(i,a)=>({range:(()=>{let h;const t=u(p=>({range:I.$ct.lift(m.Range.from(p))}));return{enumerable:!0,configurable:!1,get(){return h},set(p){i.listener?.({op:6}),E.range(h,p)||(h=p,i.listener?.(t(p)))}}})(),label:k(i,a,E.label,u(h=>({label:h}))),description:k(i,void 0,E.description,u(h=>({description:h}))),sortText:k(i,void 0,E.sortText,u(h=>({sortText:h}))),canResolveChildren:k(i,!1,E.canResolveChildren,h=>({op:2,state:h})),busy:k(i,!1,E.busy,u(h=>({busy:h}))),error:k(i,void 0,E.error,u(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:k(i,[],E.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),f=i=>{const a=M.$$K.fromString(i.extId),h=new o(a.controllerId,a.localId,i.label,d.URI.revive(i.uri)||void 0);return h.range=m.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>m.TestTag.to({id:(0,A.$eL)(t).tagId})),h},r=i=>{let a;for(const h of i.tests){const t=f(h.item);(0,O.$DO)(t).parent=a,a=t}return a};e.$TO=r;class o{constructor(a,h,t,p){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,O.$CO)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:p,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,N.$BO)(c,O.$DO,o),enumerable:!0,writable:!1},...b(c,t)})}}e.$UO=o;class s extends o{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$VO=s;class n extends N.$xO{constructor(a,h,t){super({controllerId:a,getDocumentVersion:p=>p&&t.getDocument(p)?.version,getApiFor:O.$DO,getChildren:p=>p.children,root:new s(a,h),toITestItem:m.TestItem.from})}}e.$WO=n}),define(Ce[31],Pe([1,0,16,7,8,26,4,18,13,52,29,93,2,6,3,17,113,22,50,42,64,58,61,34]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=void 0;let c=class{#e;#t;#i;constructor(g,S,y){this.b=new Map,this.c=new Map,this.#e=g.getProxy(A.$mM.MainThreadCommands),this.d=S,this.#i=y,this.#t=g.getProxy(A.$mM.MainThreadTelemetry),this.converter=new $(this,P=>{const C=this.c.get(P);return C?.result===v.Void?C:void 0},S),this.f=[{processArgument(P){return(0,k.$Rh)(P)}},{processArgument(P){return(0,N.$Qn)(P,function(C){if(F.$ct.isIRange(C))return M.Range.to(C);if(E.$bt.isIPosition(C))return M.Position.to(C);if(F.$ct.isIRange(C.range)&&u.URI.isUri(C.uri))return M.location.to(C);if(C instanceof s.$ue)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const S=this.registerCommand(!1,g.id,async(...y)=>{const P=g.args.map((W,V)=>{if(!W.validate(y[V]))throw new Error(`Invalid argument '${W.name}' when running '${g.id}', received: ${typeof y[V]=="object"?JSON.stringify(y[V],null,"	"):y[V]} `);return W.convert(y[V])}),C=await this.executeCommand(g.internalId,...P);return g.result.convert(C,y,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new O.$oM(()=>{S.dispose(),this.c.delete(g.id)})}registerCommand(g,S,y,P,C,W){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:y,thisArg:P,metadata:C,extension:W}),g&&this.#e.$registerCommand(S),new O.$oM(()=>{this.b.delete(S)&&g&&this.#e.$unregisterCommand(S)})}executeCommand(g,...S){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,S,!0)}async g(g,S,y){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,S,!1);{let P=!1;const C=(0,N.$Qn)(S,function(W){if(W instanceof O.$pM)return M.Position.from(W);if(W instanceof O.$qM)return M.Range.from(W);if(W instanceof O.$AM)return M.location.from(W);if(O.$PN.isNotebookRange(W))return M.NotebookRange.from(W);if(W instanceof ArrayBuffer)return P=!0,s.$ue.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return P=!0,s.$ue.wrap(W);if(W instanceof s.$ue)return P=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(g,P?new n.$ew(C):C,y);return(0,k.$Rh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(g,S,!1);throw W}}}async h(g,S,y){const P=this.b.get(g);if(!P)throw new Error("Unknown command");const{callback:C,thisArg:W,metadata:V}=P;if(V?.args)for(let R=0;R<V.args.length;R++)try{(0,I.$ag)(S[R],V.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${V.args[R].name}' - ${V.args[R].description}`)}const q=a.$3d.create();try{return await C.apply(W,S)}catch(R){if(g===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...S);z&&(g=z.command)}if(this.d.error(R,g,P.extension?.identifier),!y)throw R;if(P.extension?.identifier){const z=this.#i.onExtensionError(P.extension.identifier,R);this.d.trace("forwarded error to extension?",z,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$6i)(R)),this.id=g,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,g,q.elapsed())}}j(g,S,y){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new h.$4o(S),duration:y})}$executeContributedCommand(g,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const y=this.b.get(g);return y?(S=S.map(P=>this.f.reduce((C,W)=>W.processArgument(C,y.extension?.identifier),P)),this.h(g,S,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(S=>(g&&(S=S.filter(y=>y[0]!=="_")),S))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[S,y]of this.b){const{metadata:P}=y;P&&(g[S]=P)}return Promise.resolve(g)}};e.$3O=c,e.$3O=c=Je([We(0,r.$HO),We(1,d.$Oj),We(2,t.$2O)],c),e.$4O=(0,f.$ii)("IExtHostCommands");class ${constructor(g,S,y){this.d=g,this.f=S,this.g=y,this.delegatingCommandId=`__vsc${(0,p.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,S){if(!g)return;const y={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return y;const P=this.f(g.command);if(P)y.id=P.internalId,y.arguments=P.args.map((C,W)=>C.convert(g.arguments&&g.arguments[W]));else if((0,m.$Lb)(g.arguments)){const C=`${g.command} /${++this.c}`;this.b.set(C,g),S.add((0,b.$Sc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),y.$ident=C,y.id=this.delegatingCommandId,y.arguments=[C],this.g.trace("CommandsConverter#CREATE",g.command,C)}return y}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const S=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$5O=$;class w{static{this.Uri=new w("uri","Uri of a text document",g=>u.URI.isUri(g),g=>g)}static{this.Position=new w("position","A position in a text document",g=>O.$pM.isPosition(g),M.Position.from)}static{this.Range=new w("range","A range in a text document",g=>O.$qM.isRange(g),M.Range.from)}static{this.Selection=new w("selection","A selection in a text document",g=>O.$rM.isSelection(g),M.Selection.from)}static{this.Number=new w("number","",g=>typeof g=="number",g=>g)}static{this.String=new w("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=w.Arr(w.String)}static Arr(g){return new w(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,S=>Array.isArray(S)&&S.every(y=>g.validate(y)),S=>S.map(y=>g.convert(y)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",g=>g instanceof O.$LM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",g=>g instanceof O.$9N,M.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",g=>g instanceof o.$UO,M.TestItem.from)}constructor(g,S,y,P){this.name=g,this.description=S,this.validate=y,this.convert=P}optional(){return new w(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,S){return new w(g??this.name,S??this.description,this.validate,this.convert)}}e.$6O=w;class v{static{this.Void=new v("no result",g=>g)}constructor(g,S){this.description=g,this.convert=S}}e.$7O=v;class l{constructor(g,S,y,P,C){this.id=g,this.internalId=S,this.description=y,this.args=P,this.result=C}}e.$8O=l}),define(Ce[275],Pe([1,0,18,12,2,87,97,33,31,8,7]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;const E=[new d.$8O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of DocumentHighlight-instances.",b(k.DocumentHighlight.to))),new d.$8O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$6O.Uri],new d.$7O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.$Kb)(r))return;class s extends F.$GM{static to(i){const a=new s(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new F.$AM(o[0],k.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=k.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return r.map(s.to)})),new d.$8O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$6O.Uri,new d.$6O("options","Formatting options",r=>!0,r=>r)],new d.$7O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$8O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$6O.Uri,d.$6O.Range,new d.$6O("options","Formatting options",r=>!0,r=>r)],new d.$7O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$8O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$6O.Uri,d.$6O.Position,new d.$6O("ch","Trigger character",r=>typeof r=="string",r=>r),new d.$6O("options","Formatting options",r=>!0,r=>r)],new d.$7O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$8O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$8O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$8O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$8O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$8O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of Location-instances.",b(k.location.to))),new d.$8O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of Hover-instances.",b(k.Hover.to))),new d.$8O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$6O.Uri,new d.$6O("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>F.$pM.isPosition(o)),r=>r.map(k.Position.from))],new d.$7O("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const n of o.reverse())s=new F.$KM(k.Range.to(n),s);return s}))),new d.$8O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$6O.String.with("query","Search string")],new d.$7O("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(k.WorkspaceSymbol.to))),new d.$8O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(k.CallHierarchyItem.to))),new d.$8O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$6O.CallHierarchyItem],new d.$7O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(k.CallHierarchyIncomingCall.to))),new d.$8O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$6O.CallHierarchyItem],new d.$7O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(k.CallHierarchyOutgoingCall.to))),new d.$8O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:k.Range.to(r.range),placeholder:r.text}})),new d.$8O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$6O.Uri,d.$6O.Position,d.$6O.String.with("newName","The new symbol name")],new d.$7O("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new d.$8O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$6O.Uri,d.$6O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$7O("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new d.$8O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$6O.Uri],new d.$7O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new F.$GN(r.tokenTypes,r.tokenModifiers)})),new d.$8O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$6O.Uri],new d.$7O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Jab)(r);if(o.type==="full")return new F.$IN(o.data,void 0)})),new d.$8O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$6O.Uri,d.$6O.Range.optional()],new d.$7O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new F.$GN(r.tokenTypes,r.tokenModifiers)})),new d.$8O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$6O.Uri,d.$6O.Range],new d.$7O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Jab)(r);if(o.type==="full")return new F.$IN(o.data,void 0)})),new d.$8O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$6O.Uri,d.$6O.Position,d.$6O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$6O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$7O("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new F.$WM([]);const n=r.suggestions.map(i=>k.CompletionItem.to(i,s));return new F.$WM(n,r.incomplete)})),new d.$8O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$6O.Uri,d.$6O.Position,d.$6O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$7O("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new d.$8O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$6O.Uri,d.$6O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$7O("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>b(n=>new F.$OM(k.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new d.$8O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$6O.Uri,new d.$6O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>F.$qM.isRange(r),r=>F.$rM.isSelection(r)?k.Selection.from(r):k.Range.from(r)),d.$6O.String.with("kind","Code action kind to return code actions for").optional(),d.$6O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$7O("A promise that resolves to an array of Command-instances.",(r,o,s)=>b(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const i=new F.$IM(n.title,n.kind?new F.$JM(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=s.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new d.$8O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$6O.Uri],new d.$7O("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new F.$3M(k.Range.to(o.range),k.Color.to(o.color))):[])),new d.$8O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$6O("color","The color to show and insert",r=>r instanceof F.$2M,k.Color.from),new d.$6O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new d.$7O("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new d.$8O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$6O.Uri,d.$6O.Range],new d.$7O("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(k.InlayHint.to.bind(void 0,s)))),new d.$8O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$6O.Uri],new d.$7O("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(k.FoldingRange.to)})),new d.$8O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$7O("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new d.$8O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$6O.Uri,d.$6O.Range,new d.$6O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof F.$qM,r=>k.InlineValueContext.from(r))],new d.$7O("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new d.$8O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$6O("uriOrString","Uri-instance or string (only http/https)",r=>M.URI.isUri(r)||typeof r=="string"&&(0,O.$sg)(r,O.Schemas.http,O.Schemas.https),r=>r),new d.$6O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),d.$6O.String.with("label","").optional()],d.$7O.Void),new d.$8O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$6O.Uri.with("resource","Resource to open"),d.$6O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$6O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],d.$7O.Void),new d.$8O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$6O.Uri.with("left","Left-hand side resource of the diff editor"),d.$6O.Uri.with("right","Right-hand side resource of the diff editor"),d.$6O.String.with("title","Human readable title for the diff editor").optional(),new d.$6O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],d.$7O.Void),new d.$8O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$6O.String.with("title","Human readable title for the changes editor"),new d.$6O("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,n,i]=o;if(!M.URI.isUri(s)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],d.$7O.Void),new d.$8O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$6O.Uri,d.$6O.Position],new d.$7O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$8O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$6O.TypeHierarchyItem],new d.$7O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$8O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$6O.TypeHierarchyItem],new d.$7O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$8O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$6O.TestItem],d.$7O.Void),new d.$8O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$6O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$7O.Void),new d.$8O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$6O.String.with("name","The context key name"),new d.$6O("value","The context key value",()=>!0,r=>r)],d.$7O.Void),new d.$8O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$6O.Uri,d.$6O.StringArray,new d.$6O("MappedEditsContext","Mapped Edits Context",r=>k.MappedEditsContext.is(r),r=>k.MappedEditsContext.from(r))],new d.$7O("A promise that resolves to a workspace edit or null",r=>r?k.WorkspaceEdit.to(r):null))];class u{static register(o){E.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$hj)}}e.$fjc=u;function b(r){return o=>{if(Array.isArray(o))return o.map(r)}}function f(r){if(!Array.isArray(r))return;const o=[];for(const s of r)N.$3t(s)?o.push(k.DefinitionLink.to(s)):o.push(k.location.to(s));return o}}),define(Ce[276],Pe([1,0,11,6,2,4,31,8,7]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=void 0;class k{static{this.a=0}constructor(b,f){this.extension=b,this.provider=f,this.handle=k.a++}}class F{constructor(b){this.session=b,this.responses=[]}}class E{static{this.a=0}constructor(b,f,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=b.getProxy(N.$mM.MainThreadInlineChat),f.registerApiCommand(new A.$8O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$6O("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:d.$rM.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],A.$7O.Void))}registerProvider(b,f,r){const o=new k(b,f);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??b.displayName??b.name,b.identifier.value,typeof f.handleInteractiveEditorResponseFeedback=="function",typeof f.provideFollowups=="function",r?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(b,f,r,o){const s=this.b.get(b);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(f)),i=m.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:n,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=E.a++;return this.d.set(h,new F(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse(b,f,r,o){const s=this.b.get(b);if(!s)return;const n=this.d.get(f.id);if(!n)return;const i={prompt:r.prompt,selection:m.Selection.to(r.selection),wholeRange:m.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(M.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const h={report:async D=>{if(!r.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:D.message,edits:D.edits?.map(m.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:d.$PM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,i,h,o));let p;try{p=await(0,I.$9g)(t,o)}finally{a=!0}if(!p)return;const c=n.responses.push(p)-1,$={wholeRange:m.Range.from(p.wholeRange),placeholder:p.placeholder};if(!E.h(p))return{...$,id:c,type:"editorEdit",message:m.MarkdownString.from(p.contents),edits:[]};const{edits:w,contents:v}=p,l=v!==void 0?m.MarkdownString.from(v):void 0;return w instanceof d.$yM?{...$,id:c,type:"bulkEdit",edits:m.WorkspaceEdit.from(w),message:l}:{...$,id:c,type:"editorEdit",edits:w.map(m.TextEdit.from),message:l}}async $provideFollowups(b,f,r,o){const s=this.b.get(b),n=this.d.get(f),i=n?.responses[r];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(n.session,i,o));return(await(0,I.$9g)(a,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(b,f,r,o){const s=this.b.get(b),n=this.d.get(f),i=n?.responses[r];if(s&&i){const a=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,a)}}$releaseSession(b,f){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$pkc=E}),define(Ce[277],Pe([1,0,2,31]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=void 0;class M{constructor(A,m,d,k,F){this.a=m,this.b=d,this.c=k;const E=new O.$8O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$6O("showOptions","Show Options",u=>!0,u=>u),new O.$6O("resource","Interactive resource Uri",u=>!0,u=>u),new O.$6O("controllerId","Notebook controller Id",u=>!0,u=>u),new O.$6O("title","Interactive editor title",u=>!0,u=>u)],new O.$7O("Notebook and input URI",u=>{if(F.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return F.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return F.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(A,m,d,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:d,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Ckc=M}),define(Ce[278],Pe([1,0,18,11,24,5,6,28,2,20,13,4,31,8,7,76,217,25,50,218]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0,e.$Lkc=w;let a=class{constructor(l,D,g,S,y){this.m=D,this.n=g,this.o=S,this.q=y,this.b=new m.$Bc,this.c=new m.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(E.$mM.MainThreadNotebookKernels);const P=new u.$8O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$6O("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],u.$7O.Void),C=new u.$8O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$6O.Uri],new u.$7O("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(C)}createNotebookController(l,D,g,S,y,P){for(const Se of this.j.values())if(Se.controller.id===D&&k.$Dm.equals(l.identifier,Se.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const C=this.k++,W=this;this.q.trace(`NotebookController[${C}], CREATED by ${l.identifier.value}, ${D}`);const V=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${l.identifier}'`);let q=!1;const R=new N.$7d,z=new N.$7d,G={id:w(l.identifier,D),notebookType:g,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:S||l.identifier.value,preloads:P?P.map(b.NotebookRendererScript.from):[]};let ie=y??V,fe,De;this.a.$addKernel(C,G).catch(Se=>{console.log(Se),q=!0});let we=0;const oe=()=>{if(q)return;const Se=++we;Promise.resolve().then(()=>{Se===we&&this.a.$updateKernel(C,G)})},$e=new m.$Bc,ne={get id(){return D},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return G.label},set label(Se){G.label=Se??l.displayName??l.name,oe()},get detail(){return G.detail??""},set detail(Se){G.detail=Se,oe()},get description(){return G.description??""},set description(Se){G.description=Se,oe()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(Se){G.supportedLanguages=Se,oe()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(Se){G.supportsExecutionOrder=Se,oe()},get rendererScripts(){return G.preloads?G.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Se){ie=Se??V},get interruptHandler(){return fe},set interruptHandler(Se){fe=Se,G.supportsInterrupt=!!Se,oe()},set variableProvider(Se){(0,s.$0F)(l,"notebookVariableProvider"),De=Se,G.hasVariableProvider=!!Se,Se?.onDidChangeVariables(Le=>W.a.$variablesUpdated(Le.uri)),oe()},get variableProvider(){return De},createNotebookCellExecution(Se){if(q)throw new Error("notebook controller is DISPOSED");if(!$e.has(Se.notebook.uri))throw W.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.notebook.uri.toString()}`);return W._createNotebookCellExecution(Se,w(l.identifier,this.id))},createNotebookExecution(Se){if((0,s.$0F)(l,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!$e.has(Se.uri))throw W.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.uri.toString()}`);return W._createNotebookExecution(Se,w(l.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${C}], DISPOSED`),q=!0,this.j.delete(C),R.dispose(),z.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(Se,Le){Le===f.NotebookControllerAffinity2.Hidden&&(0,s.$0F)(l,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(C,Se.uri,Le)},onDidReceiveMessage:z.event,postMessage(Se,Le){return(0,s.$0F)(l,"notebookMessaging"),W.a.$postMessage(C,Le&&W.n.getIdByEditor(Le),Se)},asWebviewUri(Se){return(0,s.$0F)(l,"notebookMessaging"),(0,r.$ezb)(Se,W.m.remote)}};return this.j.set(C,{extensionId:l.identifier,controller:ne,onDidReceiveMessage:z,onDidChangeSelection:R,associatedNotebooks:$e}),ne}getIdByController(l){for(const[D,g]of this.j)if(g.controller===l)return w(g.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const g=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(g,D);const y={dispose:()=>{this.f.delete(g),S.a.$removeKernelDetectionTask(g)}};return this.f.set(g,y),y}registerKernelSourceActionProvider(l,D,g){const S=this.i++,y=typeof g.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,P=this;this.h.set(S,g),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let C;return y!==void 0&&(C=g.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(S),P.a.$removeKernelSourceActionProvider(S,S),C?.dispose()}}}async $provideKernelSourceActions(l,D){const g=this.h.get(l);if(g){const S=new A.$Tc;return(await g.provideNotebookKernelSourceActions(D)??[]).map(P=>b.NotebookKernelSourceAction.from(P,this.o.converter,S))}return[]}$acceptNotebookAssociation(l,D,g){const S=this.j.get(l);if(S){const y=this.n.getNotebookDocument(d.URI.revive(D));g?S.associatedNotebooks.set(y.uri,!0):S.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,y.uri.toString(),g),S.onDidChangeSelection.fire({selected:g,notebook:y.apiNotebook})}}async $executeCells(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(d.URI.revive(D)),P=[];for(const C of g){const W=y.getCell(C);W&&P.push(W.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,y.uri.toString(),P.length),await S.controller.executeHandler.call(S.controller,P,y.apiNotebook,S.controller)}catch(C){this.q.error(`NotebookController[${l}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(d.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,y.apiNotebook);else for(const P of g){const C=y.getCell(P);C&&this.b.get(C.uri)?.cancel()}if(S.controller.interruptHandler){const P=this.c.get(y.uri);g.length&&Array.isArray(P)&&P.length&&P.forEach(C=>C.dispose())}}async $provideVariables(l,D,g,S,y,P,C){const W=this.j.get(l);if(!W)return;const V=this.n.getNotebookDocument(d.URI.revive(g)),q=W.controller.variableProvider;if(!q)return;let R;if(S!==void 0){if(R=this.s[S],!R)return}else this.s={};const z=y==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,G=q.provideVariables(V.apiNotebook,R,z,P,C);let ie=0;for await(const fe of G){if(C.isCancellationRequested)return;const De={id:this.r++,name:fe.variable.name,value:fe.variable.value,type:fe.variable.type,interfaces:fe.variable.interfaces,language:fe.variable.language,expression:fe.variable.expression,hasNamedChildren:fe.hasNamedChildren,indexedChildrenCount:fe.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[De.id]=fe.variable,this.a.$receiveVariable(D,De),ie++>=i.$Bhb)return}}$acceptKernelMessageFromRenderer(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:g}))}$cellExecutionChanged(l,D,g){const y=this.n.getNotebookDocument(d.URI.revive(l)).getCell(D);if(y){const P=g?b.NotebookCellExecutionState.to(g):f.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const y=new t(D,S,this.a);this.b.set(S.uri,y);const P=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),P.dispose(),this.b.delete(S.uri))});return y.asApiObject()}_createNotebookExecution(l,D){const g=this.n.getNotebookDocument(l.uri),S=l.getCells().find(C=>{const W=g.getCellFromApiCell(C);return W&&this.b.has(W.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const y=new c(D,g,this.a),P=y.onDidChangeState(()=>{y.state===p.Resolved&&(y.dispose(),P.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[y,P]),y.asApiObject()}};e.$Kkc=a,e.$Kkc=a=Je([We(4,F.$Oj)],a);var h;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(h||(h={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.m=D,this.n=g,this.b=t.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new M.$ee),this.h=new $(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new n.$ew(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const g=f.$TN.ensureUniqueMimeTypes(D.items,!0);return g===D.items?b.NotebookCellOutput.from(D):b.NotebookCellOutput.from({items:g,id:D.id,metadata:D.metadata})})}async z(l,D,g){const S=this.w(D),y=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:g,outputs:y})}async C(l,D,g){return l=f.$TN.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(b.NotebookCellOutputItem.from),outputId:D.id,append:g})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(g){l.j=g,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(g){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,S,y){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const P=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;l.n.$completeExecution(l.b,new n.$ew({runEndTime:S,lastRunSuccess:g,error:P}))},clearOutput(g){return l.t(),l.z([],g,!1)},appendOutput(g,S){return l.t(),l.z(g,S,!0)},replaceOutput(g,S){return l.t(),l.z(g,S,!1)},appendOutputItems(g,S){return l.t(),l.C(g,S,!0)},replaceOutputItems(g,S){return l.t(),l.C(g,S,!1)}})}}var p;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(p||(p={}));class c extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.h=D,this.j=g,this.b=c.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new M.$ee),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===p.Resolved||this.f===p.Started)throw new Error("Cannot call start again");this.f=p.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===p.Resolved)throw new Error("Cannot call resolve twice");this.f=p.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(l,D){this.f=l,this.g=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new O.$Fh,this.b=Date.now(),(0,O.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>l.complete())}}function w(v,l){return`${v.value}/${l}`}}),define(Ce[66],Pe([1,0,5,4,3,2,17,6,7,171,14,199,24,34,200,41,11,8,31]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=e.$Yjc=e.$Xjc=e.$Wjc=void 0,e.$Wjc=(0,M.$ii)("IExtHostTerminalService");class i{constructor(g,S,y,P){this.l=g,this._id=S,this.m=y,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(W=>this.f=W);const C=this;this.value={get name(){return C.n||""},get processId(){return C.b},get creationOptions(){return C.m},get exitStatus(){return C.h},get state(){return C.j},get selection(){return C.k},sendText(W,V=!0){C.q(),C.l.$sendText(C._id,W,V)},show(W){C.q(),C.l.$show(C._id,W)},hide(){C.q(),C.l.$hide(C._id)},dispose(){C.a||(C.a=!0,C.l.$dispose(C._id))},get dimensions(){if(!(C.d===void 0||C.g===void 0))return{columns:C.d,rows:C.g}}}}async create(g,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??S?.cwd??void 0,env:g.env??void 0,icon:w(g.iconPath)??void 0,color:r.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.o(g.location,S?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,S,y,P,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:r.ThemeColor.isThemeColor(C)?C.id:void 0,location:S?.location||this.o(g,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,S){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,S){this.h=Object.freeze({code:g,reason:S})}setDimensions(g,S){return g===this.d&&S===this.g||g===0||S===0?!1:(this.d=g,this.g=S,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(S=>{S!==g&&(this.b=Promise.resolve(g))})}}e.$Xjc=i;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$7d,this.onProcessData=this.a.event,this.b=new I.$7d,this.d=new I.$7d,this.onDidChangeProperty=this.d.event,this.f=new I.$7d,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,S){this.g.setDimensions?.({columns:g,rows:S})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,S,y){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$7d,this.onDidCloseTerminal=this.H.event,this.I=new I.$7d,this.onDidOpenTerminal=this.I.event,this.J=new I.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new I.$7d,this.onDidChangeShell=this.N.event,this.O=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(O.$mM.MainThreadTerminalService),this.y=new f.$Hub(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:P=>{const C=W=>{const V=W;return this.W(V.instanceId)?.value};switch(P?.$mid){case 15:return C(P);default:{if(Array.isArray(P))for(let W=0;W<P.length&&P[W].$mid===15;W++)P[W]=C(P[W]);return P}}}}),this.B({dispose:()=>{for(const[P,C]of this.g)C.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,S){const y=new i(this.a,(0,b.$Eg)(),g,g.name),P=new a(g.pty);return y.createExtensionTerminal(g.location,S,this.R(g,S).resolvedExtHostIdentifier,w(g.iconPath),v(g.color)).then(C=>{const W=this.S(C,P);this.h[C]=W}),this.f.push(y),y.value}R(g,S){if(S=S||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const y=g.location.parentTerminal;if(y){const P=this.f.find(C=>C.value===y);P&&(S.resolvedExtHostIdentifier=P._id)}}else g.location&&typeof g.location!="object"?S.location=g.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(g,S){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const P=new a(S),C=this.S(g,P);this.h[g]=C}async $acceptActiveTerminalChanged(g){const S=this.b;if(g===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const y=this.W(g);y&&(this.b=y,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,S){const y=this.W(g);y&&this.O.fire({terminal:y.value,data:S})}async $acceptTerminalDimensions(g,S,y){const P=this.W(g);P&&P.setDimensions(S,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(g,S){const y=this.W(g);y&&this.P.fire({terminal:y.value,...S})}async $acceptTerminalMaximumDimensions(g,S,y){this.g.get(g)?.resize(S,y)}async $acceptTerminalTitleChange(g,S){const y=this.W(g);y&&(y.name=S)}async $acceptTerminalClosed(g,S,y){const P=this.Y(this.f,g);if(P!==null){const C=this.f.splice(P,1)[0];C.setExitStatus(S,y),this.H.fire(C.value)}}$acceptTerminalOpened(g,S,y,P){if(S){const V=this.Y(this.f,S);if(V!==null){this.f[V]._id=g,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const C={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:N.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},W=new i(this.a,g,C,y);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(g,S){this.W(g)?._setProcessId(S)}async $startExtensionTerminal(g,S){const y=this.W(g);if(!y)return{message:(0,k.localize)(0,null,g)};y.isOpen||await new Promise(C=>{const W=this.onDidOpenTerminal(async V=>{V===y.value&&(W.dispose(),C())})});const P=this.g.get(g);P?P.startSendingEvents(S):this.j[g]={initialDimensions:S}}S(g,S){const y=new m.$Tc;y.add(S.onProcessReady(C=>this.a.$sendProcessReady(g,C.pid,C.cwd,C.windowsPty))),y.add(S.onDidChangeProperty(C=>this.a.$sendProcessProperty(g,C))),this.y.startBuffering(g,S.onProcessData),y.add(S.onProcessExit(C=>this.U(g,C))),this.g.set(g,S);const P=this.j[g];return P&&S instanceof a&&(S.startSendingEvents(P.initialDimensions),delete this.j[g]),y}$acceptProcessAckDataEvent(g,S){this.g.get(g)?.acknowledgeDataEvent(S)}$acceptProcessInput(g,S){this.g.get(g)?.input(S)}$acceptTerminalInteraction(g){const S=this.W(g);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(g,S){this.W(g)?.setSelection(S)}$acceptProcessResize(g,S,y){try{this.g.get(g)?.resize(S,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(g,S){this.g.get(g)?.shutdown(S)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(S=>this.a.$sendProcessProperty(g,{type:"cwd",value:S}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new d.$oM(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,S,y){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,y),this.a.$registerProfileProvider(S,g.identifier.value),new d.$oM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(g,S,y){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,y),this.a.$registerQuickFixProvider(g,S),new d.$oM(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,S){const y=new u.$ee().token;if(y.isCancellationRequested)return;const P=this.D.get(g);if(!P)return;const C=await P.provideTerminalQuickFixes(S,y);if(C===null||Array.isArray(C)&&C.length===0)return;const W=new m.$Tc;if(this.w.value=W,!Array.isArray(C))return C?s.TerminalQuickFix.from(C,this.Q.converter,W):void 0;const V=[];for(const q of C){const R=s.TerminalQuickFix.from(q,this.Q.converter,W);R&&V.push(R)}return V}async $createContributedProfileTerminal(g,S){const y=new u.$ee().token;let P=await this.C.get(g)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,S);return}this.createTerminalFromOptions(P.options,S)}}async $provideLinks(g,S){const y=this.W(g);if(!y)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const C=new u.$ee;this.G.set(g,C);const W=[],V={terminal:y.value,line:S},q=[];for(const G of this.z)q.push(o.Promises.withAsyncBody(async ie=>{C.token.onCancellationRequested(()=>ie({provider:G,links:[]}));const fe=await G.provideTerminalLinks(V,C.token)||[];C.token.isCancellationRequested||ie({provider:G,links:fe})}));const R=await Promise.all(q);if(C.token.isCancellationRequested)return[];const z=new Map;for(const G of R)G&&G.links.length>0&&W.push(...G.links.map(ie=>{const fe={id:h++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return z.set(fe.id,{provider:G.provider,link:ie}),fe}));return this.F.set(g,z),W}$activateLink(g,S){const y=this.F.get(g)?.get(S);y&&y.provider.handleTerminalLink(y.link)}U(g,S){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const y=this.h[g];y&&(y.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,S)}W(g){return this.X(this.f,g)}X(g,S){const y=this.Y(g,S);return y!==null?g[y]:null}Y(g,S){const y=g.findIndex(P=>P._id===S);return y===-1?null:y}getEnvironmentVariableCollection(g){let S=this.n.get(g.identifier.value);return S||(S=new p,this.$(g.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Z(g,S){const y=(0,E.$7r)(S.map),P=(0,E.$8r)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(g,S.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(g){g.forEach(S=>{const y=S[0],P=new p(S[1]);this.$(y,P)})}$acceptDefaultProfile(g,S){const y=this.s;this.s=g,this.u=S,y?.path!==g.path&&this.N.fire(g.path)}$(g,S){this.n.set(g,S),S.onDidChangeCollection(()=>{this.Z(g,S)})}};e.$Yjc=t,e.$Yjc=t=Je([We(1,n.$4O),We(2,A.$HO)],t);class p{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$7d,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const S=this.h(g);let y=this.a.get(S);return y||(y=new c(this,g),this.a.set(S,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(g,S,y,P){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(g,S,y,P){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(g,S,y,P){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(g,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(g,S.scope),P=this.map.get(y),C=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==S.value||P.type!==S.type||P.options?.applyAtProcessCreation!==C.applyAtProcessCreation||P.options?.applyAtShellIntegration!==C.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const W=this.g(g,S.scope),V={variable:g,...S,options:C};this.map.set(W,V),this.d.fire()}}get(g,S){const y=this.g(g,S),P=this.map.get(y);return P?l(P):void 0}g(g,S){const y=this.h(S);return y.length?`${g}:::${y}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const S=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(g)&&S.set(P.variable,l(P));return S}delete(g,S){const y=this.g(g,S);this.map.delete(y),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[S,y]of this.map)y.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(S);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,S){const y=this.h(S),P=this.descriptionMap.get(y);if(!P||P.description!==g){let C;typeof g=="string"?C=g:C=g?.value.split(`

`)[0];const W={description:C,scope:S};this.descriptionMap.set(y,W),this.d.fire()}}getDescription(g){const S=this.h(g);return this.descriptionMap.get(S)?.description}k(g){const S=this.h(g);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,S){this.b=g,this.d=S,this.a=new I.$7d}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,S,y){this.b.replace(g,S,y,this.d)}append(g,S,y){this.b.append(g,S,y,this.d)}prepend(g,S,y){this.b.prepend(g,S,y,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,S){this.b.getVariableMap(this.d).forEach((y,P)=>g.call(S,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(g,S){super(!1,g,S)}createTerminal(g,S,y){throw new F.$_}createTerminalFromOptions(g,S){throw new F.$_}};e.$Zjc=$,e.$Zjc=$=Je([We(0,n.$4O),We(1,A.$HO)],$);function w(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function v(D){return r.ThemeColor.isThemeColor(D)?D:void 0}function l(D){const g={...D};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[279],Pe([1,0,11,22,24,5,251,99,6,16,34,13,4,17,113,8,7,49,75,60]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=e.$4kc=e.$3kc=void 0;let a=class extends d.$Uc{constructor(C,W,V,q){super(),this.w=q,this.f=this.B(new N.$7d),this.g=new Map,this.s=this.B(new N.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=C.getProxy(u.$mM.MainThreadTesting),this.m=new D(this.h),this.j=new c(this.h,W),V.registerArgumentProcessor({processArgument:R=>{switch(R?.$mid){case 16:{const z=R,G=z.tests[z.tests.length-1].item.extId;return this.g.get(s.$$K.root(G))?.collection.tree.get(G)?.actual??(0,f.$TO)(R)}case 18:{const{test:z,message:G}=R,ie=z.item.extId;return{test:this.g.get(s.$$K.root(ie))?.collection.tree.get(ie)?.actual??(0,f.$TO)({$mid:16,tests:[z]}),message:r.TestMessage.to(G)}}default:return R}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const R=await V.executeCommand("_testing.getExplorerSelection"),z=G=>{const ie=this.g.get(s.$$K.root(G));if(ie)return s.$$K.isRoot(G)?ie.controller:ie.collection.tree.get(G)?.actual};return{include:R?.include.map(z).filter(k.$4f)||[],exclude:R?.exclude.map(z).filter(k.$4f)||[]}})}createTestController(C,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const R=new d.$Tc,z=R.add(new f.$WO(W,V,this.w));z.root.label=V;const G=new Map,ie=new Set,fe=this.h,De={items:z.root.children,get label(){return V},set label(oe){V=oe,z.root.label=oe,fe.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(oe){q=oe,fe.$updateController(W,{canRefresh:!!oe})},get id(){return W},createRunProfile:(oe,$e,ne,Se,Le,re)=>{let L=(0,m.$9i)(oe);for(;G.has(L);)L++;return new S(this.h,G,ie,this.s.event,W,L,oe,$e,ne,Se,Le,re)},createTestItem(oe,$e,ne){return new f.$UO(W,oe,$e,ne)},createTestRun:(oe,$e,ne=!0)=>this.j.createTestRun(W,z,oe,$e,ne),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const $e=oe instanceof Array?oe:[oe];this.h.$markTestRetired($e.map(ne=>s.$$K.fromExtHostTestItem(ne,W).toString()))}},set resolveHandler(oe){z.resolveHandler=oe},get resolveHandler(){return z.resolveHandler},dispose:()=>{R.dispose()}};fe.$registerTestController(W,V,!!q),R.add((0,d.$Sc)(()=>fe.$unregisterTestController(W)));const we={controller:De,collection:z,profiles:G,extension:C,activeProfiles:ie};return this.g.set(W,we),R.add((0,d.$Sc)(()=>this.g.delete(W))),R.add(z.onDidGenerateDiff(oe=>fe.$publishDiff(W,oe.map(i.TestsDiffOp.serialize)))),De}createTestObserver(){return this.m.checkout()}async runTests(C,W=M.CancellationToken.None){const V=$(C);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:C.include?.map(R=>s.$$K.fromExtHostTestItem(R,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:y[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:C.exclude?.map(R=>R.id)},W)}$syncTests(){for(const{collection:C}of this.g.values())C.flushDiff();return Promise.resolve()}async $getCoverageDetails(C,W){return(await this.j.getCoverageDetails(C,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(C){this.j.disposeTestRun(C)}$configureRunProfile(C,W){this.g.get(C)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(C){const W=new Map;for(const[V,q]of Object.entries(C)){const R=this.g.get(V);if(!R)continue;const z=new Map,G=q.filter(fe=>!R.activeProfiles.has(fe)),ie=[...R.activeProfiles].filter(fe=>!q.includes(fe));for(const fe of G)z.set(fe,!0),R.activeProfiles.add(fe);for(const fe of ie)z.set(fe,!1),R.activeProfiles.delete(fe);z.size&&W.set(V,z)}this.s.fire(W)}async $refreshTests(C,W){await this.g.get(C)?.controller.refreshHandler?.(W)}$publishTestResults(C){this.results=Object.freeze(C.map(r.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(C,W){const V=this.g.get(s.$$K.fromString(C).controllerId)?.collection;V&&(await V.expand(C,W<0?1/0:W),V.flushDiff())}$acceptDiff(C){this.m.applyDiff(C.map(W=>i.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(C,W){return Promise.all(C.map(V=>this.y(V,!1,W)))}async $startContinuousRun(C,W){const V=new M.$ee(W),q=await Promise.all(C.map(R=>this.y(R,!0,V.token)));return!W.isCancellationRequested&&!q.some(R=>R.error)&&await new Promise(R=>W.onCancellationRequested(R)),V.dispose(!0),q}async y(C,W,V){const q=this.g.get(C.controllerId);if(!q)return{};const{collection:R,profiles:z}=q,G=z.get(C.profileId);if(!G)return{};const ie=C.testIds.map(oe=>R.tree.get(oe)).filter(k.$4f),fe=C.excludeExtIds.map(oe=>q.collection.tree.get(oe)).filter(k.$4f).filter(oe=>ie.some($e=>$e.fullId.compare(oe.fullId)===2));if(!ie.length)return{};const De=new o.$1N(ie.some(oe=>oe.actual instanceof f.$VO)?void 0:ie.map(oe=>oe.actual),fe.map(oe=>oe.actual),G,W),we=(0,i.$bL)(C)&&this.j.prepareForMainThreadTestRun(De,w.fromInternal(C,q.collection),G,V);try{return await G.runHandler(De,V),{}}catch(oe){return{error:String(oe)}}finally{we&&we.hasRunningTasks&&!V.isCancellationRequested&&await N.Event.toPromise(we.onEnd)}}$cancelExtensionTestRun(C){C===void 0?this.j.cancelAllRuns():this.j.cancelRunById(C)}};e.$3kc=a,e.$3kc=a=Je([We(0,b.$HO),We(1,E.$Oj)],a);const h=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class p extends d.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(C,W,V,q,R){super(),this.z=C,this.C=W,this.D=V,this.F=q,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new N.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new M.$ee(R));const z=this.B(new I.$uh(()=>this.G(),h));this.B(this.m.token.onCancellationRequested(()=>z.schedule()));const G=new N.$7d;this.w=G.event,this.B((0,d.$Sc)(()=>{G.fire(),G.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(C,W){const[,V,q]=s.$$K.fromString(C).path,R=this.y.get(q);if(!R)return[];if(R.backCompatResolve)return R.backCompatResolve(W);const z=this.h.get(V);if(!z)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(z.run,R.coverage,W)??[]}createRun(C){const W=this.z.id,V=this.z.controllerId,q=(0,F.$Eg)(),R=we=>(oe,...$e)=>{if(ie){this.D.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.z.isIncluded(oe)&&(this.I(oe),we(oe,...$e))},z=(we,oe)=>{const $e=oe instanceof Array?oe.map(r.TestMessage.from):[r.TestMessage.from(oe)];if(we.uri&&we.range){const ne={range:r.Range.from(we.range),uri:we.uri};for(const Se of $e)Se.location=Se.location||ne}this.C.$appendTestMessagesInRun(W,q,s.$$K.fromExtHostTestItem(we,V).toString(),$e)},G=(we,oe)=>{const $e=we.uri.toString(),ne=new s.$$K([W,q,$e]).toString();this.y.set($e,{coverage:we,backCompatResolve:oe}),this.C.$appendCoverage(W,q,r.TestCoverage.fromFile(ne,we))};let ie=!1,fe;const De={isPersisted:this.z.isPersisted,token:this.m.token,name:C,onDidDispose:this.w,get coverageProvider(){return fe},set coverageProvider(we){fe=we,we&&Promise.resolve(we.provideFileCoverage(M.CancellationToken.None)).then(oe=>{oe?.forEach($e=>G($e,we.resolveFileCoverage&&(async ne=>(await we.resolveFileCoverage($e,ne)||$e).detailedCoverage)))})},addCoverage:G,enqueued:R(we=>{this.C.$updateTestStateInRun(W,q,s.$$K.fromExtHostTestItem(we,V).toString(),1)}),skipped:R(we=>{this.C.$updateTestStateInRun(W,q,s.$$K.fromExtHostTestItem(we,V).toString(),5)}),started:R(we=>{this.C.$updateTestStateInRun(W,q,s.$$K.fromExtHostTestItem(we,V).toString(),2)}),errored:R((we,oe,$e)=>{z(we,oe),this.C.$updateTestStateInRun(W,q,s.$$K.fromExtHostTestItem(we,V).toString(),6,$e)}),failed:R((we,oe,$e)=>{z(we,oe),this.C.$updateTestStateInRun(W,q,s.$$K.fromExtHostTestItem(we,V).toString(),4,$e)}),passed:R((we,oe)=>{this.C.$updateTestStateInRun(W,q,s.$$K.fromExtHostTestItem(we,this.z.controllerId).toString(),3,oe)}),appendOutput:(we,oe,$e)=>{ie||($e&&(this.z.isIncluded($e)?this.I($e):$e=void 0),this.C.$appendOutputToRun(W,q,O.$ue.fromString(we),oe&&r.location.from(oe),$e&&s.$$K.fromExtHostTestItem($e,V).toString()))},end:()=>{ie||(ie=!0,this.C.$finishedTestRunTask(W,q),--this.g||this.H())}};return this.g++,this.h.set(q,{run:De}),this.C.$startedTestRunTask(W,{id:q,name:C,running:!0}),De}G(){for(const{run:C}of this.h.values())C.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(C){if(!(C instanceof f.$UO))throw new n.$zO(C.id);if(this.j.has(s.$$K.fromExtHostTestItem(C,this.z.controllerId).toString()))return;const W=[],V=this.z.colllection.root;for(;;){const q=r.TestItem.from(C);if(W.unshift(q),this.j.has(q.extId)||(this.j.add(q.extId),C===V))break;C=C.parent||V}this.C.$addTestsToRun(this.z.controllerId,this.z.id,W)}dispose(){this.H(),super.dispose()}}class c{get trackers(){return this.f.values()}constructor(C,W){this.h=C,this.j=W,this.f=new Map,this.g=new Map}getCoverageDetails(C,W){const V=s.$$K.root(C);return this.g.get(V)?.getCoverageDetails(C,W)||[]}disposeTestRun(C){this.g.get(C)?.dispose(),this.g.delete(C);for(const[W,{id:V}]of this.f)V===C&&this.f.delete(W)}prepareForMainThreadTestRun(C,W,V,q){return this.k(C,W,V,q)}cancelRunById(C){this.g.get(C)?.cancel()}cancelAllRuns(){for(const C of this.f.values())C.cancel()}createTestRun(C,W,V,q,R){const z=this.f.get(V);if(z)return z.createRun(q);const G=w.fromPublic(C,W,V,R),ie=$(V);this.h.$startedExtensionTestRun({controllerId:C,continuous:!!V.continuous,profile:ie&&{group:y[ie.kind],id:ie.profileId},exclude:V.exclude?.map(De=>s.$$K.fromExtHostTestItem(De,W.root.id).toString())??[],id:G.id,include:V.include?.map(De=>s.$$K.fromExtHostTestItem(De,W.root.id).toString())??[W.root.id],persist:R});const fe=this.k(V,G,V.profile);return N.Event.once(fe.onEnd)(()=>{this.h.$finishedExtensionTestRun(G.id)}),fe.createRun(q)}k(C,W,V,q){const R=new p(W,this.h,this.j,V,q);return this.f.set(C,R),this.g.set(R.id,R),R}}e.$4kc=c;const $=P=>{if(P.profile){if(!(P.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class w{static fromPublic(C,W,V,q){return new w(C,(0,F.$Eg)(),V.include?.map(R=>s.$$K.fromExtHostTestItem(R,C).toString())??[C],V.exclude?.map(R=>s.$$K.fromExtHostTestItem(R,C).toString())??[],q,W)}static fromInternal(C,W){return new w(C.controllerId,C.runId,C.testIds,C.excludeExtIds,!0,W)}constructor(C,W,V,q,R,z){this.controllerId=C,this.id=W,this.isPersisted=R,this.colllection=z,this.f=V.map(G=>G+"\0"),this.g=q.map(G=>G+"\0")}isIncluded(C){const W=s.$$K.fromExtHostTestItem(C,this.controllerId).toString()+"\0";for(const V of this.g)if(W===V||W.startsWith(V))return!1;for(const V of this.f)if(W===V||W.startsWith(V))return!0;return!1}}e.$5kc=w;class v{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(C){this.k=C,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(C){this.f.add(C)}update(C){Object.assign(C.revived,r.TestItem.toPlain(C.item)),this.f.has(C)||this.g.add(C)}remove(C){if(this.f.has(C)){this.f.delete(C);return}this.g.delete(C);const W=s.$$K.parentId(C.item.extId);if(W&&this.j.has(W.toString())){this.j.add(C.item.extId);return}this.h.add(C)}getChangeEvent(){const{f:C,g:W,h:V}=this;return{get added(){return[...C].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class l extends i.$hL{constructor(){super(...arguments),this.s=new N.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(C){return this.g.get(C)}getMirroredTestDataByReference(C){return this.g.get(C.id)}x(C,W){return{...C,revived:r.TestItem.toPlain(C.item),depth:W?W.depth+1:0,children:new Set}}w(){return new v(this.s)}}class D{constructor(C){this.g=C}checkout(){this.f||(this.f=this.h());const C=this.f;return C.observers++,{onDidChangeTest:C.tests.onDidChangeTests,get tests(){return[...C.tests.rootTests].map(W=>W.revived)},dispose:(0,A.$db)(()=>{--C.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(C){return this.f?.tests.getMirroredTestDataByReference(C)}applyDiff(C){this.f?.tests.apply(C)}h(){const C=new l({asCanonicalUri:W=>W});return this.g.$subscribeToDiffs(),{observers:0,tests:C}}}const g=(P,C,W,V)=>{W?Object.assign(W,V):C.$updateTestRunConfig(P.controllerId,P.profileId,V)};class S{#e;#t;#i;#n;#s;get label(){return this.g}set label(C){C!==this.g&&(this.g=C,g(this,this.#e,this.#n,{label:C}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(C){C!==this.h&&(this.h=C,g(this,this.#e,this.#n,{supportsContinuousRun:C}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(C){C!==this.isDefault&&(C?this.#t.add(this.profileId):this.#t.delete(this.profileId),g(this,this.#e,this.#n,{isDefault:C}))}get tag(){return this._tag}set tag(C){C?.id!==this._tag?.id&&(this._tag=C,g(this,this.#e,this.#n,{tag:C?r.TestTag.namespace(this.controllerId,C.id):null}))}get configureHandler(){return this.f}set configureHandler(C){C!==this.f&&(this.f=C,g(this,this.#e,this.#n,{hasConfigurationHandler:!!C}))}get onDidChangeDefault(){return N.Event.chain(this.#i,C=>C.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(k.$4f))}constructor(C,W,V,q,R,z,G,ie,fe,De=!1,we=void 0,oe=!1){this.controllerId=R,this.profileId=z,this.g=G,this.kind=ie,this.runHandler=fe,this._tag=we,this.h=oe,this.#e=C,this.#s=W,this.#t=V,this.#i=q,W.set(z,this);const $e=y[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);De&&V.add(z),this.#n={profileId:z,controllerId:R,tag:we?r.TestTag.namespace(this.controllerId,we.id):null,label:G,group:$e,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$6kc=S;const y={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[114],Pe([1,0,55,14,90,8,7]),function(ge,e,I,O,M,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=e.$OO=void 0;class m{static{this.c=new M.$MO("TextEditorDecorationType")}constructor(u,b,f){const r=m.c.nextId();u.$registerTextEditorDecorationType(b.identifier,r,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$OO=m;class d{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let f=null;if(u instanceof A.$pM)f=new A.$qM(u,u);else if(u instanceof A.$qM)f=u;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(u,b){this.k(),this.l(new A.$qM(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$qM)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,f){const r=this.c.validateRange(u);this.g.push({range:r,text:b,forceMoveMarkers:f})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=u}}class k{constructor(u,b,f,r){this.c=u,this.d=b,this._accept(f),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}n(u){const b=this.m(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}p(u){const b=this.o(u);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const b=this.q(u);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let f=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(f=!0,b.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,b.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(f=!0,b.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,f=!0,b.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(f=!0,b.insertSpaces=r):this.j!==r&&(this.j=r,f=!0,b.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,f=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,f=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(u.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(u,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(f)})}}e.$PO=k;class F{constructor(u,b,f,r,o,s,n,i){this.id=u,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,s,f),this.e=n,this.f=i;const a=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new O.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof A.$rM))throw(0,O.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$rM)))throw(0,O.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new O.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new O.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new d(r.value,t);return h(p),a.m(p)},insertSnippet(h,t,p={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map($=>N.Range.from($));else if(t instanceof A.$pM){const{lineNumber:$,column:w}=N.Position.from(t);c=[{startLineNumber:$,startColumn:w,endLineNumber:$,endColumn:w}]}else if(t instanceof A.$qM)c=[N.Range.from(t)];else{c=[];for(const $ of t)if($ instanceof A.$qM)c.push(N.Range.from($));else{const{lineNumber:w,column:v}=N.Position.from($);c.push({startLineNumber:w,startColumn:v,endLineNumber:w,endColumn:v})}}return b.$tryInsertSnippet(u,r.value.version,h.value,c,p)},setDecorations(h,t){const p=t.length===0;p&&!a.h.has(h.key)||(p?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(N.$EO(t))return b.$trySetDecorations(u,h.key,N.$FO(t));{const c=new Array(4*t.length);for(let $=0,w=t.length;$<w;$++){const v=t[$];c[4*$]=v.start.line+1,c[4*$+1]=v.start.character+1,c[4*$+2]=v.end.line+1,c[4*$+3]=v.end.character+1}return b.$trySetDecorationsFast(u,h.key,c)}}))},revealRange(h,t){a.n(()=>b.$tryRevealRange(u,N.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(u,N.ViewColumn.from(h))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(o=>o.range);f.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=f.length-1;o<s;o++){const n=f[o].end;if(f[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$QO=F}),define(Ce[67],Pe([1,0,55,5,6,2,3,4,111,17,114,8,13,28,12,39,40]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new b.$Bc,this.d=new O.$7d,this.e=new O.$7d,this.f=new O.$7d,this.g=new O.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],p=[];if(a.removedDocuments)for(const c of a.removedDocuments){const $=N.URI.revive(c),w=this.c.get($);w?.unref()&&(this.c.delete($),h.push(w.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const $=N.URI.revive(c.uri);let w=this.c.get($);if(w&&$.scheme!==f.Schemas.vscodeNotebookCell&&$.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);w||(w=new s(new d.$KO(this.h.getProxy(m.$mM.MainThreadDocuments),$,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set($,w),t.push(w.value)),w.ref()}if(a.removedEditors)for(const c of a.removedEditors){const $=this.b.get(c);this.b.delete(c),$&&p.push($)}if(a.addedEditors)for(const c of a.addedEditors){const $=N.URI.revive(c.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const w=this.c.get($).value,v=new F.$QO(c.id,this.h.getProxy(m.$mM.MainThreadTextEditors),this.i,new o.$V(()=>w.document),c.selections.map(E.Selection.to),c.options,c.visibleRanges.map(l=>E.Range.to(l)),typeof c.editorPosition=="number"?E.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,v)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,M.$Pc)(h),(0,M.$Pc)(p),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return r.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$RO=n,e.$RO=n=Je([We(0,k.$HO),We(1,u.$Oj)],n),e.$SO=(0,A.$ii)("IExtHostDocumentsAndEditors")}),define(Ce[280],Pe([1,0,18,5,4,114,8,7]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;class d{constructor(F,E){this.i=E,this.a=new O.$7d,this.b=new O.$7d,this.c=new O.$7d,this.d=new O.$7d,this.f=new O.$7d,this.g=new O.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=F.getProxy(M.$mM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(F){const E=this.i.allEditors();return F?E:E.map(u=>u.value)}async showTextDocument(F,E,u){let b;typeof E=="number"?b={position:A.ViewColumn.from(E),preserveFocus:u}:typeof E=="object"?b={position:A.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?A.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(F.uri,b),r=f&&this.i.getEditor(f);if(r)return r.value;throw f?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,E){return new N.$OO(this.h,F,E).value}$acceptEditorPropertiesChanged(F,E){const u=this.i.getEditor(F);if(!u)throw new Error("unknown text editor");if(E.options&&u._acceptOptions(E.options),E.selections){const b=E.selections.selections.map(A.Selection.to);u._acceptSelections(b)}if(E.visibleRanges){const b=I.$Hb(E.visibleRanges.map(A.Range.to));u._acceptVisibleRanges(b)}if(E.options&&this.b.fire({textEditor:u.value,options:{...E.options,lineNumbers:A.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const b=m.TextEditorSelectionChangeKind.fromValue(E.selections.source),f=E.selections.selections.map(A.Selection.to);this.a.fire({textEditor:u.value,selections:f,kind:b})}if(E.visibleRanges){const b=I.$Hb(E.visibleRanges.map(A.Range.to));this.c.fire({textEditor:u.value,visibleRanges:b})}}$acceptEditorPositionData(F){for(const E in F){const u=this.i.getEditor(E);if(!u)throw new Error("Unknown text editor");const b=A.ViewColumn.to(F[E]);u.value.viewColumn!==b&&(u._acceptViewColumn(b),this.d.fire({textEditor:u.value,viewColumn:b}))}}getDiffInformation(F){return Promise.resolve(this.h.$getDiffInformation(F))}}e.$pjc=d}),define(Ce[281],Pe([1,0,2,3,4,6,7,8,20,16]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=e.$8kc=void 0,e.$8kc=(0,O.$ii)("IExtHostTimeline");class F{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(M.$mM.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&d.$Dm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this.c.get(r.source)?.get(E(s))?.get(r.handle)}else return;return r}})}async $getTimeline(b,f,r,o){return this.b.get(b)?.provider.provideTimeline(I.URI.revive(f),r,o)}registerTimelineProvider(b,f,r,o){const s=new N.$Tc,n=this.d(f.id,o,s).bind(this);let i;f.onDidChange&&(i=f.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:f.id}),this));const a=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(h,t,p){t?.resetCache&&(s.clear(),a.get(f.id)?.clear());const c=await f.provideTimeline(h,t,p);if(c==null)return;const $=n(h,t);return{...c,source:f.id,items:c.items.map($)}},dispose(){for(const h of a.values())h.get(f.id)?.clear();i?.dispose(),s.dispose()}},r)}d(b,f,r){return(o,s)=>{let n;if(s?.cacheResults){let i=this.c.get(b);i===void 0&&(i=new Map,this.c.set(b,i));const a=E(o);n=i.get(a),n===void 0&&(n=new Map,i.set(a,n))}return i=>{const{iconPath:a,...h}=i,t=`${b}|${i.id??i.timestamp}`;n?.set(t,i);let p,c,$;i.iconPath&&(a instanceof A.$kN?$={id:a.id,color:a.color}:I.URI.isUri(a)?(p=a,c=a):{light:p,dark:c}=a);let w;return A.$PM.isMarkdownString(h.tooltip)?w=m.MarkdownString.from(h.tooltip):(0,k.$Vf)(h.tooltip)?w=h.tooltip:A.$PM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=m.MarkdownString.from(h.detail)):(0,k.$Vf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=h.detail),{...h,id:h.id??void 0,handle:t,source:b,command:i.command?f.toInternal(i.command,r):void 0,icon:p,iconDark:c,themeIcon:$,tooltip:w,accessibilityInformation:i.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,N.$Sc)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$9kc=F;function E(u){return u?.toString()}}),define(Ce[282],Pe([1,0,172,23,2,5,6,210,11,7,16,18,8,53,24,136,25]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;function s(a,h){if((0,F.$Vf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class n extends A.$Uc{constructor(h,t,p){super(),this.f=h,this.g=t,this.h=p,this.a=new Map,this.b=new r.$b0;function c($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>c($)?this.r($):Array.isArray($)&&$.length>0?$.map(w=>c(w)?this.r(w):w):$})}registerTreeDataProvider(h,t,p){const c=this.createTreeView(h,{treeDataProvider:t},p);return{dispose:()=>c.dispose()}}createTreeView(h,t,p){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,p),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:$,hasHandleDrag:w,hasHandleDrop:v,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(h,D),S={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$0F)(p,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$0F)(p,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(y){(0,b.$Hk)(y)&&(0,o.$0F)(p,"treeViewMarkdownMessage"),l.message=y},get title(){return l.title},set title(y){l.title=y},get description(){return l.description},set description(y){l.description=y},get badge(){return l.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?l.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(l.badge=void 0)},reveal:(y,P)=>l.reveal(y,P),dispose:async()=>{await g,this.a.delete(h),l.dispose()}};return this.B(S),S}$getChildren(h,t){const p=this.a.get(h);return p?p.getChildren(t):Promise.reject(new m.$BF(h))}async $handleDrop(h,t,p,c,$,w,v,l){const D=this.a.get(h);if(!D)return Promise.reject(new m.$BF(h));const g=u.DataTransfer.toDataTransfer(p,async S=>(await this.f.$resolveDropFileData(h,t,S)).buffer);return v===h&&l&&await this.j(g,D,l,$,w),D.onDrop(g,c,$)}async j(h,t,p,c,$){const w=this.b.removeDragOperationTransfer($);if(w)(await w)?.forEach((v,l)=>{v&&h.set(l,v)});else if($&&t.handleDrag){const v=t.handleDrag(p,h,c);this.b.addDragOperationTransfer($,v),await v}return h}async $handleDrag(h,t,p,c){const $=this.a.get(h);if(!$)return Promise.reject(new m.$BF(h));const w=await this.j(new k.$gN,$,t,c,p);if(!(!w||c.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$BF(h);return t.hasResolve}$resolve(h,t,p){const c=this.a.get(h);if(!c)throw new m.$BF(h);return c.resolveTreeItem(t,p)}$setExpanded(h,t,p){const c=this.a.get(h);if(!c)throw new m.$BF(h);c.setExpanded(t,p)}$setSelectionAndFocus(h,t,p){const c=this.a.get(h);if(!c)throw new m.$BF(h);c.setSelectionAndFocus(t,p)}$setVisible(h,t){const p=this.a.get(h);if(!p){if(!t)return;throw new m.$BF(h)}p.setVisible(t)}$changeCheckboxState(h,t){const p=this.a.get(h);if(!p)throw new m.$BF(h);p.setCheckboxState(t)}m(h,t,p){const c=this.B(new i(h,t,this.f,this.g.converter,this.h,p));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$0kc=n;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,F.$5f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,p,c,$,w){if(super(),this.I=h,this.J=p,this.L=c,this.M=$,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ee,w.contributes&&w.contributes.views)for(const g in w.contributes.views)for(const S of w.contributes.views[g])S.id===h&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let v,l;const D=N.Event.debounce(this.F.event,(g,S)=>(g||(g={message:!1,elements:[]}),S.element!==!1&&(v||(v=new Promise(y=>l=y),this.G=this.G.then(()=>v)),Array.isArray(S.element)?g.elements.push(...S.element):g.elements.push(S.element)),S.message&&(g.message=!0),g),200,!0);this.B(D(({message:g,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const y=l;return v=null,this.$(S).then(()=>y())})),g&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let p=this.X(h);return p||(p=await this.Y(t)),p?p.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const p=(0,F.$5f)(t.select)?!0:t.select,c=(0,F.$5f)(t.focus)?!1:t.focus,$=(0,F.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(w=>this.W(h,w[w.length-1]).then(v=>this.J.$reveal(this.I,{item:v.item,parentChain:w.map(l=>l.item)},{select:p,focus:c,expand:$})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:p,focus:c,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const p=this.getExtensionElement(h);p&&(t?this.u.fire(Object.freeze({element:p})):this.w.fire(Object.freeze({element:p})))}setSelectionAndFocus(h,t){const p=!(0,E.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,p&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async p=>{const c=this.getExtensionElement(p.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:p.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(p=>p!==void 0);t.forEach(p=>{p.treeItem.checkboxState=p.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(p=>[p.extensionItem,p.newState])})}async handleDrag(h,t,p){const c=[];for(const $ of h){const w=this.getExtensionElement($);w&&c.push(w)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,p),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,p){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,d.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,p):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const p=this.j.get(h);if(p){const c=this.m.get(p);if(c){const $=await this.f.resolveTreeItem(c.extensionItem,p,t)??c.extensionItem;return this.hb($),c.item.tooltip=this.eb($.tooltip),c.item.command=this.fb(c.disposableStore,$.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(p=>this.W(t,p[p.length-1]).then(c=>(p.push(c),p))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,d.$ah)(()=>this.f.getParent(h))}W(h,t){const p=this.m.get(h);return p?Promise.resolve(p):(0,d.$ah)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(c);if($){const w=this.m.get($);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const p=this.getExtensionElement(h);t=p?this.m.get(p):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new f.$ee(this.Z.token);try{const p=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const $=(0,E.$Hb)(c||[]),w=await Promise.all((0,E.$Hb)($).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const v=w.map((l,D)=>l?this.db($[D],l,p):null);return(0,E.$Hb)(v)}finally{t.dispose()}}$(h){if(h.some(p=>!p))return this.Z.dispose(!0),this.Z=new f.$ee,this.tb(),this.J.$refresh(this.I);{const p=this.ab(h);if(p.length)return this.bb(p)}return Promise.resolve(void 0)}ab(h){const t=new Set,p=h.map($=>this.m.get($));for(const $ of p)if($&&!t.has($.item.handle)){let w=$;for(;w&&w.parent&&p.findIndex(v=>w&&w.parent&&v&&v.item.handle===w.parent.item.handle)===-1;){const v=this.j.get(w.parent.item.handle);w=v?this.m.get(v):void 0}w&&!w.parent&&t.add($.item.handle)}const c=[];return t.forEach($=>{const w=this.j.get($);if(w){const v=this.m.get(w);v&&(!v.parent||!t.has(v.parent.item.handle))&&c.push($)}}),c}bb(h){const t={};return Promise.all(h.map(p=>this.cb(p).then(c=>{c&&(t[p]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const p=this.m.get(t);if(p)return this.rb(t),(0,d.$ah)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const $=this.ib(t,c,p.parent);return this.pb(t,$,p,p.parent),p.dispose(),$}return null})}return Promise.resolve(null)}db(h,t,p){const c=this.ib(h,t,p);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,p),c}eb(h){return k.$PM.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,p,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,p=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:p,accessibilityInformation:c}}hb(h){if(!k.$bN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,p){this.hb(t);const c=this.B(new A.$Tc),$=this.kb(h,t,p),w=this.lb(t);return{item:{handle:$,parentHandle:p?p.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,F.$5f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:p,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof k.$kN?h.iconPath:void 0}kb(h,{id:t,label:p,resourceUri:c},$,w){if(t)return`${i.b}/${t}`;const v=s(p,this.N),l=$?$.item.handle:i.a;let D=v?v.label:c?(0,O.$Sg)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const g=this.m.has(h)?this.m.get(h).item.handle:void 0,S=this.X($)||[];let y,P=0;do{if(y=`${l}/${P}:${D}`,w||!this.j.has(y)||g===y)break;P++}while(P<=S.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$kN))return typeof h.iconPath=="string"||M.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$kN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return M.URI.isUri(h)?h:M.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,p,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==p.item.handle&&this.j.delete(p.item.handle),this.ob(h,t);const $=this.X(c)||[],w=$.filter(v=>v.item.handle===p.item.handle)[0];w&&$.splice($.indexOf(w),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const p of t.children){const c=this.j.get(p.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const p of t.children){const c=this.j.get(p.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[283],Pe([1,0,5,6,2,34,8,62,4,7]),function(ge,e,I,O,M,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;class F extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$7d),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,M.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class E extends O.$Uc{static c(){return(0,N.$Eg)()}constructor(f,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=f.getProxy(d.$mM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,r,o,s,n={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,m.$Ejc)(f),t=E.c();this.f.$createWebviewPanel((0,m.$Gjc)(f),t,r,{title:o,panelOptions:u(n),webviewOptions:(0,m.$Hjc)(f,this.m,n),serializeBuffersForPostMessage:h},a);const p=this.j.createNewWebview(t,n,f);return this.createNewWebviewPanel(t,r,o,i,n,p,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((o,s)=>{const n=f[o],i=f[s];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const n=f[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:f}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$Ejc)(f)}),new k.$oM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,o,s){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:a}=n,h=this.j.createNewWebview(f,o.webviewOptions,a),t=this.createNewWebviewPanel(f,r,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(f,r,o,s,n,i,a){const h=new F(f,this.f,i,{viewType:r,title:o,viewColumn:s,panelOptions:n,active:a});return this.g.set(f,h),h}getWebviewPanel(f){return this.g.get(f)}}e.$Ijc=E;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ce[284],Pe([1,0,5,6,62,8,4,7]),function(ge,e,I,O,M,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class d extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,u,b,f,r,o){super(),this.#s=!1,this.#u=this.B(new I.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$7d),this.onDidDispose=this.#l.event,this.#i=b,this.#a=f,this.#e=E,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(E,u){this.d=u,this.b=new Map,this.c=new Map,this.a=E.getProxy(A.$mM.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,b,f){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:E}),this.a.$registerWebviewViewProvider((0,M.$Gjc)(E),u,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$Ejc)(E)}),new m.$oM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,b,f,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:n}=o,i=this.d.createNewWebview(E,{},n),a=new d(E,this.a,u,b,i,!0);this.c.set(E,a),await s.resolveWebviewView(a,{state:f},r)}async $onDidChangeWebviewViewVisibility(E,u){this.e(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.e(E);this.c.delete(E),u.dispose(),this.d.deleteWebview(E)}e(E){const u=this.c.get(E);if(!u)throw new Error("No webview found");return u}}e.$alc=k}),define(Ce[285],Pe([1,0,5,30,33,3]),function(ge,e,I,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=e.$HL=e.OutputChannelUpdateMode=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=void 0,e.$uL="text/x-code-output",e.$vL="output",e.$wL="Log",e.$xL="text/x-code-log-output",e.$yL="log",e.$zL="workbench.panel.output",e.$AL=new M.$zj("inOutput",!1),e.$BL=new M.$zj("activeLogOutput",!1),e.$CL=new M.$zj("activeLogOutput.levelSettable",!1),e.$DL=new M.$zj("activeLogOutput.level",""),e.$EL=new M.$zj("activeLogOutput.levelIsDefault",!1),e.$FL=new M.$zj("outputView.scrollLock",!1),e.$GL=(0,N.$ii)("outputService");var A;(function(d){d[d.Append=1]="Append",d[d.Replace=2]="Replace",d[d.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$HL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new I.$7d,this.onDidRegisterChannel=this.b.event,this.c=new I.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(F=>k.push(F)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}O.$1n.add(e.$HL.OutputChannels,new m),e.$IL=new M.$zj("activeOutputChannel","")}),define(Ce[115],Pe([1,0,4,3,17,20,13,285,63,27,44,140,22,16,43,5,6]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=e.$Nkc=void 0;class s extends A.$Uj{get disposed(){return this.n}constructor(h,t,p,c,$){super(),this.id=h,this.name=t,this.r=p,this.s=c,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(p.getLevel()),this.B(p.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=u.$ue.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,p,c,$,w){this.i=t,this.j=p,this.k=c,this.l=$,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$mM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,p]of this.g)p.visible=t===this.h}createOutputChannel(h,t,p){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,$=(0,b.$Vf)(t)?t:void 0;if((0,b.$Vf)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const v=this.i.environment.extensionLogLevel?.find(([D])=>N.$Dm.equals(p.identifier,D))?.[1];v&&(w=(0,A.$6j)(v));const l=c?this.o(h,w,p):this.n(h,$,p);return l.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(h,w??this.m.getLevel(),l):this.q(h,l)}async n(h,t,p){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,$=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(h,$,t,p.identifier.value);return new s(v,h,w,this.a,p)}async o(h,t,p){const c=await this.p(p),$=h.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(c,`${$}.log`),v=`${p.identifier.value}.${$}`,l=this.l.createLogger(w,{id:v,name:h,logLevel:t,extensionId:p.identifier.value});return new n(v,h,l,this.a,p)}p(h){let t=this.d.get(h.identifier.value);if(!t){const p=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(p)}catch(c){if((0,f.$5k)(c)!==f.FileSystemProviderErrorCode.FileExists)throw c}return p})())}return t}q(h,t){let p=!1;const c=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return h},append($){c(),t.then(w=>w.append($))},appendLine($){c(),t.then(w=>w.appendLine($))},clear(){c(),t.then($=>$.clear())},replace($){c(),t.then(w=>w.replace($))},show($,w){c(),t.then(v=>v.show($,w))},hide(){c(),t.then($=>$.hide())},dispose(){p=!0,t.then($=>$.dispose())}}}r(h,t,p){const c=new o.$Tc,$=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},w=c.add(new r.$7d);function v(l){t=l,w.fire(l)}return p.then(l=>{c.add(l),l.logLevel!==t&&v(l.logLevel),c.add(l.onDidChangeLogLevel(D=>v(D)))}),{...this.q(h,p),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(l,...D){$(),p.then(g=>g.trace(l,...D))},debug(l,...D){$(),p.then(g=>g.debug(l,...D))},info(l,...D){$(),p.then(g=>g.info(l,...D))},warn(l,...D){$(),p.then(g=>g.warn(l,...D))},error(l,...D){$(),p.then(g=>g.error(l,...D))},dispose(){c.dispose()}}}};e.$Nkc=i,e.$Nkc=i=Je([We(0,M.$HO),We(1,k.$XO),We(2,d.$Ajc),We(3,F.$ajc),We(4,A.$Pj),We(5,A.$Oj)],i),e.$Okc=(0,O.$ii)("IExtHostOutputService")}),define(Ce[116],Pe([1,0,3,11]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$5m=(0,I.$ii)("remoteAgentService"),e.$6m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let N=1/0;for(let m=0;m<this.maxSampleCount;m++){const d=await M.getRoundTripTime();if(d===void 0)return;N=Math.min(N,d/2),await(0,O.$jh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(N):A=this.initial.reduce((m,d)=>m+d,0)/this.initial.length,this.lastMeasurement={initial:A,current:N,average:this.average.reduce((m,d)=>m+d,0)/this.average.length,high:typeof A>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[286],Pe([1,0,175,56,30,48,47,6,5,116,21,26,11]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=void 0,e.$ZI=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$1I=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$2I=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$3I=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$4I={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new d.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const f=new b;M.$1n.add(e.$4I.ConfigurationMigration,f);let r=class extends m.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(a=>this.g(a,n?.uri))])}async g(n,i){const a=this.a.inspect(n.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,p]of h){const c=a[t];if(!c)continue;const $=[];if(c.value!==void 0){const w=await this.h(n,t,c.value,i,void 0);for(const v of w??[])$.push([v,[]])}for(const{identifiers:w,value:v}of c.overrides??[])if(v!==void 0){const l=await this.h(n,t,v,i,w);for(const D of l??[])$.push([D,w])}$.length&&await Promise.allSettled($.map(async([[w,v],l])=>this.a.updateValue(w,v.value,{resource:i,overrideIdentifiers:l},p)))}}async h(n,i,a,h,t){const p=$=>{const v=this.a.inspect($,{resource:h})[i];if(v)return t?v.overrides?.find(({identifiers:l})=>(0,E.$Sn)(l,t))?.value:v.value},c=await n.migrateFn(a,p);return Array.isArray(c)?c:[[n.key,c]]}};e.$5I=r,e.$5I=r=Je([We(0,A.$Oi),We(1,N.$ri)],r);let o=class extends m.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!F.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$1n.as(O.$6n.Configuration).registerConfiguration({...e.$2I,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$6I=o,e.$6I=o=Je([We(0,k.$5m)],o)}),define(Ce[287],Pe([1,0,35,12,19,23,183,286,56,3,30]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Dfb=e.$Cfb=void 0,e.$Efb=r,e.$Ffb=o,e.$Cfb=(0,k.$ii)("editorResolverService"),e.$Dfb="workbench.editorAssociations";const E=F.$1n.as(d.$6n.Configuration),u={...m.$1I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var b;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(b||(e.RegisteredEditorPriority=b={}));var f;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function r(s){switch(s){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function o(s,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof s=="string"&&s.indexOf(M.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,N.$Sg)(n);return I.$bk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Ce[288],Pe([1,0,46,12,19,21,23,2,3,204,48,224,116]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=void 0,e.$1L=(0,d.$ii)("pathService");let f=b=class{constructor(o,s,n,i){this.d=o,this.e=s,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,n)}h(o,s,n){return o.scheme===O.Schemas.file||o.scheme===O.Schemas.vscodeRemote?(0,I.$gg)(n??(0,A.$Sg)(o),s===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,k.$XL)(s.getWorkspace());if(n)return n;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:O.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?M.$gc:M.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:O.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$2L=f,e.$2L=f=b=Je([We(1,u.$5m),We(2,E.$JL),We(3,F.$ri)],f)}),define(Ce[117],Pe([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$uK=e.$tK=void 0;class I{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new I(0,0)}with(A){return new I(0,0)}}e.$tK=I;class O{constructor(A,m,d,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,m),this.end=new I(d,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$uK=O;var M;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Ce[45],Pe([1,0,18,35,26,46,15,3,19,14,117,11]),function(ge,e,I,O,M,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$RK=e.$KK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$HK=e.$GK=e.$FK=e.$EK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.TextSearchCompleteMessageType=void 0,e.$BK=s,e.$CK=n,e.$DK=i,e.$IK=l,e.$JK=D,e.$LK=y,e.$MK=P,e.$NK=C,e.$OK=W,e.$PK=V,e.$QK=q,e.$SK=z,e.$UK=fe,e.$VK=De,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.$vK="workbench.view.search",e.$wK="workbench.panel.search",e.$xK="workbench.view.search",e.$yK="search-result",e.$zK="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",f=(u.length+b.length+5)*2;e.$AK=(0,m.$ii)("searchService");var r;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(oe){return!!oe.preview}function n(oe){return!!oe.resource}function i(oe){return!!oe.message}var a;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor($e){this.resource=$e,this.results=[]}}e.$EK=h;class t{constructor($e,ne,Se,Le){this.ranges=ne,this.webviewIndex=Le;const re=Array.isArray(ne)?ne:[ne];if(Se&&Se.matchLines===1&&p(re)){$e=(0,A.$Of)($e,Se.matchLines);let L="",x=0,ve=0;const Oe=Math.floor(Se.charsPerLine/5),ye=[];for(const pe of re){const de=Math.max(pe.startColumn-Oe,0),J=pe.startColumn+Se.charsPerLine;if(de>ve+Oe+f){const Y=u+(de-ve)+b;L+=Y+$e.slice(de,J),x+=de-(ve+Y.length)}else L+=$e.slice(ve,J);ye.push(new $(0,pe.startColumn-x,pe.endColumn-x)),ve=J}this.preview={text:L,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const L=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:$e,matches:(0,I.$2b)(ne,x=>new c(x.startLineNumber-L,x.startColumn,x.endLineNumber-L,x.endColumn))}}}}e.$FK=t;function p(oe){const $e=oe[0].startLineNumber;for(const ne of oe)if(ne.startLineNumber!==$e||ne.endLineNumber!==$e)return!1;return!0}class c{constructor($e,ne,Se,Le){this.startLineNumber=$e,this.startColumn=ne,this.endLineNumber=Se,this.endColumn=Le}}e.$GK=c;class $ extends c{constructor($e,ne,Se){super($e,ne,$e,Se)}}e.$HK=$;var w;(function(oe){oe.List="list",oe.Tree="tree"})(w||(e.ViewMode=w={}));var v;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function l(oe,$e=!0){const ne=oe&&oe.files&&oe.files.exclude,Se=$e&&oe&&oe.search&&oe.search.exclude;if(!ne&&!Se)return;if(!ne||!Se)return ne||Se;let Le=Object.create(null);return Le=M.$Rn(Le,M.$On(ne)),Le=M.$Rn(Le,M.$On(Se),!0),Le}function D(oe,$e){return oe.excludePattern&&O.$bk(oe.excludePattern,$e)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&O.$bk(oe.includePattern,$e)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ne=>{const Se=ne.folder.fsPath;if(N.$ig($e,Se)){const Le=d.$mc(Se,$e);return!ne.includePattern||!!O.$bk(ne.includePattern,Le)}else return!1}):!1:!0}var g;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class S extends Error{constructor($e,ne){super($e),this.code=ne}}e.$KK=S;function y(oe){const $e=oe.message;if((0,k.$4)(oe))return new S($e,g.canceled);try{const ne=JSON.parse($e);return new S(ne.message,ne.code)}catch{return new S($e,g.other)}}function P(oe){const $e={message:oe.message,code:oe.code};return new Error(JSON.stringify($e))}function C(oe){return oe.type==="error"?!0:oe.type==="success"}function W(oe){return oe.type==="success"}function V(oe){return!!oe.path}function q(oe,$e,ne=!0){const Se=oe.searchPath?oe.searchPath:oe.relativePath;return ne?(0,A.$Lf)(Se,$e):O.$bk($e,Se)}class R{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$RK=R;function z(oe,$e){const ne={...oe||{},...$e||{}};return Object.keys(ne).filter(Se=>{const Le=ne[Se];return typeof Le=="boolean"&&Le})}class G{constructor($e,ne){this.c=null,this.a={...$e.excludePattern||{},...ne.excludePattern||{}},this.b=O.$ck(this.a);let Se=$e.includePattern;ne.includePattern&&(Se?Se={...Se,...ne.includePattern}:Se=ne.includePattern),Se&&(this.c=O.$ck(Se))}matchesExcludesSync($e,ne,Se){return!!(this.b&&this.b($e,ne,Se))}includedInQuerySync($e,ne,Se){return!(this.b&&this.b($e,ne,Se)||this.c&&!this.c($e,ne,Se))}includedInQuery($e,ne,Se){const Le=this.b($e,ne,Se),re=()=>this.c?!!this.c($e,ne,Se):!0;return(0,E.$7g)(Le)?Le.then(L=>L?!1:re()):re()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$TK=G;function ie(oe){for(const $e in oe)if(typeof oe[$e]!="boolean")return!0;return!1}function fe(oe){if(!oe)return;let $e;return ne=>($e||($e=(oe()||Promise.resolve([])).then(Se=>Se?we(Se):{})),$e.then(Se=>!!Se[ne]))}function De(oe){if(!oe)return;let $e;return ne=>{if(!$e){const Se=oe();$e=Se?we(Se):{}}return!!$e[ne]}}function we(oe){const $e={};for(const ne of oe)$e[ne]=!0;return $e}}),define(Ce[36],Pe([1,0,18,11,24,5,6,51,12,125,23,15,2,174,3,13,193,48,44,27,17,8,7,59,45,4,52]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p,c,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0;function v(W,V,q){return new F.$Kg(R=>S(R,q)).isEqual(W,V)}function l(W,V,q){return v(W.uri,V.uri,q)?0:(0,E.$ef)(W.uri.toString(),V.uri.toString())}function D(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:v(W.uri,V.uri,q)?(0,E.$ef)(W.name,V.name):(0,E.$ef)(W.uri.toString(),V.uri.toString())}function g(W,V,q,R){const z=W.slice(0).sort((ie,fe)=>q(ie,fe,R)),G=V.slice(0).sort((ie,fe)=>q(ie,fe,R));return(0,I.$Eb)(z,G,(ie,fe)=>q(ie,fe,R))}function S(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class y extends s.$Bi{static toExtHostWorkspace(V,q,R,z){if(!V)return{workspace:null,added:[],removed:[]};const{id:G,name:ie,folders:fe,configuration:De,transient:we,isUntitled:oe}=V,$e=[],ne=q;q?fe.forEach((L,x)=>{const ve=u.URI.revive(L.uri),Oe=y.o(R||q,ve,z);Oe?(Oe.name=L.name,Oe.index=L.index,$e.push(Oe)):$e.push({uri:ve,name:L.name,index:x})}):$e.push(...fe.map(({uri:L,name:x,index:ve})=>({uri:u.URI.revive(L),name:x,index:ve}))),$e.sort((L,x)=>L.index<x.index?-1:1);const Se=new y(G,ie,$e,!!we,De?u.URI.revive(De):null,!!oe,L=>S(L,z)),{added:Le,removed:re}=g(ne?ne.workspaceFolders:[],Se.workspaceFolders,l,z);return{workspace:Se,added:Le,removed:re}}static o(V,q,R){for(let z=0;z<V.folders.length;z++){const G=V.workspaceFolders[z];if(v(G.uri,q,R))return G}}constructor(V,q,R,z,G,ie,fe){super(V,R.map(De=>new s.$Ci(De)),z,G,fe),this.t=q,this.u=ie,this.q=[],this.s=m.$oi.forUris(fe),R.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,F.$Ug)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let P=class{constructor(V,q,R,z,G){this.c=new N.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new N.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$9d,this.C=new Map,this.h=z,this.s=R,this.t=G,this.j=new k.$pm,this.k=new O.$hh,this.o=V.getProxy($.$mM.MainThreadWorkspace),this.q=V.getProxy($.$mM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new y(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,fe=>S(fe,R)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:d.Schemas.untitled,path:(0,F.$Sg)((0,F.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,R,...z){const G=[];if(Array.isArray(z)&&z.forEach(oe=>{u.URI.isUri(oe.uri)&&!G.some($e=>v($e.uri,oe.uri,this.s))&&G.push({uri:oe.uri,name:oe.name||(0,F.$Rg)(oe.uri)})}),this.n||[q,R].some(oe=>typeof oe!="number"||oe<0)||R===0&&G.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+R>ie.length)return!1;const fe=ie.slice(0);fe.splice(q,R,...G.map(oe=>({uri:oe.uri,name:oe.name||(0,F.$Rg)(oe.uri),index:void 0})));for(let oe=0;oe<fe.length;oe++){const $e=fe[oe];if(fe.some((ne,Se)=>Se!==oe&&v($e.uri,ne.uri,this.s)))return!1}fe.forEach((oe,$e)=>oe.index=$e);const{added:De,removed:we}=g(ie,fe,D,this.s);if(De.length===0&&we.length===0)return!1;if(this.o){const oe=V.displayName||V.name;this.o.$updateWorkspaceFolders(oe,q,R,G).then(void 0,$e=>{this.n=void 0;const ne={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,b.localize)(0,null,oe,$e.toString()),ne,[])})}return this.y(fe),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let R,z="";if(typeof V=="string"?(R=u.URI.file(V),z=V):typeof V<"u"&&(R=V,z=V.fsPath),!R)return z;const G=this.getWorkspaceFolder(R,!0);if(!G)return z;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,F.$Xg)(G.uri,R);return q&&G.name&&(ie=`${G.name}/${ie}`),ie}y(V){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:R,removed:z}=y.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:z}))}findFiles(V,q,R,z,G=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ie="",fe=!0;return q===null?fe=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:R,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},G)}findFiles2(V,q={},R,z=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,V,q,z)}async z(V,q,R,z=M.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const G=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,ie={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:G,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let fe;if(V){const{includePattern:De,folder:we}=C(h.GlobPattern.from(V));fe=we,ie.includePattern=De}else{const{includePattern:De,folder:we}=C(h.GlobPattern.from(q));fe=we,ie.filePattern=De}return this.o.$startFileSearch(fe??null,ie,z).then(De=>Array.isArray(De)?De.map(we=>u.URI.revive(we)):[])}async findTextInFiles(V,q,R,z,G=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),fe=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:De,folder:we}=C(h.GlobPattern.from(q.include)),oe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,$e={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:fe,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:De,excludePattern:oe},ne=!1;if(this.u[ie]=Se=>{if(ne)return;const Le=u.URI.revive(Se.resource);Se.results.forEach(re=>{const L=(0,w.$Rh)(re);(0,c.$BK)(L)?R({uri:Le,preview:{text:L.preview.text,matches:(0,I.$2b)(L.preview.matches,x=>new t.$qM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(L.ranges,x=>new t.$qM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):R({uri:Le,text:L.text,lineNumber:L.lineNumber})})},G.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(V,we??null,$e,ie,G);return delete this.u[ie],Se||{}}catch(Se){throw delete this.u[ie],Se}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return u.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return u.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const R=this.t.transformOutgoingScheme(V),z=this.A++;return this.o.$registerEditSessionIdentityProvider(z,R),(0,A.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const R=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const z=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!z),!z)return;const G=await z.provideEditSessionIdentity(R,q);if(this.h.info("Provider returned edit session identifier: ",G),!!G)return G}async $provideEditSessionIdentityMatch(V,q,R,z){this.h.info("Getting edit session identifier for workspaceFolder",V);const G=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!G){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",G);const ie=this.w.get(G.uri.scheme);if(this.h.info(`Provider for scheme ${G.uri.scheme} is defined: `,!!ie),!ie)return;const fe=await ie.provideEditSessionIdentityMatch?.(q,R,z);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(V){return(q,R,z)=>{const G=function(fe){q.call(R,fe)};return G.extension=V,this.B.event(G,void 0,z)}}async $onWillCreateEditSessionIdentity(V,q,R){const z=await this.resolveWorkspaceFolder(u.URI.revive(V));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:z},q,async(G,ie)=>{const fe=Date.now();await Promise.resolve(G),Date.now()-fe>R&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const R=this.t.transformOutgoingScheme(V),z=this.A++;return this.o.$registerCanonicalUriProvider(z,R),(0,A.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(V,q,R){const z=this.C.get(V.scheme);if(!z)return;const G=await z.provideCanonicalUri?.(u.URI.revive(V),q,R);if(G)return G}async $provideCanonicalUri(V,q,R){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:q},R)}};e.$ujc=P,e.$ujc=P=Je([We(0,a.$HO),We(1,i.$XO),We(2,n.$ajc),We(3,r.$Oj),We(4,p.$sjc)],P),e.$vjc=(0,f.$ii)("IExtHostWorkspace");function C(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=u.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Ce[37],Pe([1,0,26,5,36,4,7,195,56,16,11,3,17,13,2]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=e.$xjc=e.$wjc=void 0;function r(p,c){if(c){const $=c.split(".");let w=p;for(let v=0;w&&v<$.length;v++)w=w[$[v]];return w}}function o(p){return p instanceof f.URI}function s(p){return p&&p.uri instanceof f.URI&&p.languageId&&typeof p.languageId=="string"}function n(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function i(p){return p&&p.uri instanceof f.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function a(p){if(o(p))return{resource:p};if(s(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(n(p))return{overrideIdentifier:p.languageId};if(i(p))return{resource:p.uri};if(p===null)return{resource:null}}let h=class{constructor(c,$,w){this.a=c.getProxy(N.$mM.MainThreadConfiguration),this.c=$,this.b=w,this.d=new F.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,$){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,$))}};e.$wjc=h,e.$wjc=h=Je([We(0,u.$HO),We(1,M.$vjc),We(2,b.$Oj)],h);class t{constructor(c,$,w,v){this.a=new O.$7d,this.b=c,this.f=v,this.c=$,this.e=m.$mo.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,$){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$mo.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j($,w))}getConfiguration(c,$,w){const v=a($)||{},l=this.g(c?r(this.e.getValue(void 0,v,this.c.workspace),c):this.e.getValue(void 0,v,this.c.workspace));c&&this.h(c,v,w?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(S){return typeof r(l,S)<"u"},get:(S,y)=>{this.h(c?`${c}.${S}`:S,v,w?.identifier);let P=r(l,S);if(typeof P>"u")P=y;else{let C;const W=(V,q)=>{if((0,k.$Xf)(V)){let R;const z=()=>{C=C||(0,I.$On)(l),R=R||r(C,q)};return new Proxy(V,{get:(G,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return z(),()=>R;if(C)return R=R||r(C,q),R[ie];const fe=G[ie];return typeof ie=="string"?W(fe,`${q}.${ie}`):fe},set:(G,ie,fe)=>(z(),R&&(R[ie]=fe),!0),deleteProperty:(G,ie)=>(z(),R&&delete R[ie],!0),defineProperty:(G,ie,fe)=>(z(),R&&Object.defineProperty(R,ie,fe),!0)})}return Array.isArray(V)?(0,I.$On)(V):V};P=W(P,S)}return P},update:(S,y,P,C)=>{S=c?`${c}.${S}`:S;const W=D(P);return y!==void 0?this.b.$updateConfigurationOption(W,S,y,v,C):this.b.$removeConfigurationOption(W,S,v,C)},inspect:S=>{S=c?`${c}.${S}`:S;const y=this.e.inspect(S,v,this.c.workspace);if(y)return{key:S,defaultValue:(0,I.$On)(y.policy?.value??y.default?.value),globalValue:(0,I.$On)(y.user?.value??y.application?.value),workspaceValue:(0,I.$On)(y.workspace?.value),workspaceFolderValue:(0,I.$On)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$On)(y.default?.override),globalLanguageValue:(0,I.$On)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$On)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$On)(y.workspaceFolder?.override),languageIds:(0,I.$On)(y.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$Rn)(g,l,!1),Object.freeze(g)}g(c){const $=w=>(0,k.$Xf)(w)?new Proxy(w,{get:(v,l)=>$(v[l]),set:(v,l,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(v,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(v,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return $(c)}h(c,$,w){const v=d.$do.test(c)?4:this.d.get(c),l=w?`[${w.value}] `:"";if(v===4){typeof $?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){$?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,$){const w=new m.$oo(c,$,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(v,l)=>w.affectsConfiguration(v,a(l))})}k(c){return c.reduce(($,w)=>($.set(w[0],w[1]),$),new Map)}}e.$xjc=t,e.$yjc=(0,E.$ii)("IExtHostConfiguration")}),define(Ce[118],Pe([1,0,2,11,5,4,7,36,67,37,24,66,17,27,3,12,21,13,78,229,14]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=e.$1kc=e.$Zkc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(h||(h={}));var t;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(t||(t={}));var p;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(p||(p={}));var c;(function(W){function V(z){if(z){const G=z;return G&&!!G.process}else return!1}W.is=V;function q(z){if(z==null)return;const G={process:z.process,args:z.args};return z.options&&(G.options=p.from(z.options)),G}W.from=q;function R(z){if(z!=null)return new A.$0M(z.process,z.args,z.options)}W.to=R})(c||(c={}));var $;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})($||($={}));var w;(function(W){function V(z){if(z){const G=z;return G&&(!!G.commandLine||!!G.command)}else return!1}W.is=V;function q(z){if(z==null)return;const G={};return z.commandLine!==void 0?G.commandLine=z.commandLine:(G.command=z.command,G.args=z.args),z.options&&(G.options=$.from(z.options)),G}W.from=q;function R(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$$M(z.commandLine,z.options):new A.$$M(z.command,z.args?z.args:[],z.options)}W.to=R})(w||(w={}));var v;(function(W){function V(z){if(z){const G=z;return G&&G.customExecution==="customExecution"}else return!1}W.is=V;function q(z){return{customExecution:"customExecution"}}W.from=q;function R(z,G){return G.get(z)}W.to=R})(v||(e.CustomExecutionDTO=v={}));var l;(function(W){function V(q,R){let z;return q.scope!==void 0&&typeof q.scope!="number"?z=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&R&&R.workspaceFile?z=R.workspaceFile:z=i.$tH),{id:q._id,workspaceFolder:z}}W.from=V})(l||(e.TaskHandleDTO=l={}));var D;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(D||(D={}));var g;(function(W){function V(z,G){if(z==null)return[];const ie=[];for(const fe of z){const De=q(fe,G);De&&ie.push(De)}return ie}W.fromMany=V;function q(z,G){if(z==null)return;let ie;z.execution instanceof A.$0M?ie=c.from(z.execution):z.execution instanceof A.$$M?ie=w.from(z.execution):z.execution&&z.execution instanceof A.$_M&&(ie=v.from(z.execution));const fe=h.from(z.definition);let De;return z.scope?typeof z.scope=="number"?De=z.scope:De=z.scope.uri:De=A.TaskScope.Workspace,!fe||!De?void 0:{_id:z._id,definition:fe,name:z.name,source:{extensionId:G.identifier.value,label:z.source,scope:De},execution:ie,isBackground:z.isBackground,group:D.from(z.group),presentationOptions:t.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}W.from=q;async function R(z,G,ie){if(z==null)return;let fe;c.is(z.execution)?fe=c.to(z.execution):w.is(z.execution)?fe=w.to(z.execution):v.is(z.execution)&&(fe=v.to(z._id,ie));const De=h.to(z.definition);let we;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?we=z.source.scope:we=await G.resolveWorkspaceFolder(I.URI.revive(z.source.scope)):we=A.TaskScope.Workspace),!De||!we)return;const oe=new A.$aN(De,we,z.name,z.source.label,fe,z.problemMatchers);return z.isBackground!==void 0&&(oe.isBackground=z.isBackground),z.group!==void 0&&(oe.group=A.$9M.from(z.group._id),oe.group&&z.group.isDefault&&(oe.group=new A.$9M(oe.group.id,oe.group.label),z.group.isDefault===!0&&(oe.group.isDefault=z.group.isDefault))),z.presentationOptions&&(oe.presentationOptions=t.to(z.presentationOptions)),z._id&&(oe._id=z._id),z.detail&&(oe.detail=z.detail),oe}W.to=R})(g||(e.TaskDTO=g={}));var S;(function(W){function V(R){return R}W.from=V;function q(R){if(R)return Object.assign(Object.create(null),R)}W.to=q})(S||(S={}));class y{#e;constructor(V,q,R){this._id=q,this.a=R,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let P=class{constructor(V,q,R,z,G,ie,fe,De){this.q=new M.$7d,this.r=new M.$7d,this.s=new M.$7d,this.u=new M.$7d,this.a=V.getProxy(N.$mM.MainThreadTask),this.b=R,this.c=z,this.d=G,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,R){if(!R)return new A.$oM(()=>{});const z=this.x();return this.j.set(z,{type:q,provider:R,extension:V}),this.a.$registerTaskProvider(z,q),new A.$oM(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(S.from(V)).then(async q=>{const R=[];for(const z of q){const G=await g.to(z,this.b,this.m);G&&R.push(G)}return R})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,R){const z=this.m.get(V.id);z&&(this.o.set(V.id,z),this.e.attachPtyToTerminal(q,await z.callback(R))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const R=this.j.get(V);if(!R)return Promise.reject(new Error("no handler found"));const z=[],G=(0,O.$ah)(()=>R.provider.provideTasks(F.CancellationToken.None)).then(ie=>this.v(q,z,R,ie));return new Promise(ie=>{G.then(fe=>{Promise.all(z).then(()=>{ie(fe)})})})}async $resolveTask(V,q){const R=this.j.get(V);if(!R)return Promise.reject(new Error("no handler found"));if(q.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${R.type}].`);const z=await g.to(q,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const G=await R.provider.resolveTask(z,F.CancellationToken.None);if(!G)return;this.A(G,R);const ie=g.from(G,R.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(ie.execution)&&await this.y(ie,G,!0),await this.w(ie)}x(){return this.h++}async y(V,q,R){const z=await this.a.$createTaskId(V);!R&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,q.execution)),this.m.set(z,q.execution)}async z(V,q){if(typeof V=="string"){const G=this.l.get(V);if(!G)throw new a.$bb("Unexpected: The specified task is missing an execution");return G}const R=this.l.get(V.id);if(R)return R;let z;return q?z=Promise.resolve(new y(this,V.id,q)):z=g.to(V.task,this.b,this.m).then(G=>{if(!G)throw new a.$bb("Unexpected: Task does not exist.");return new y(this,V.id,G)}),this.l.set(V.id,z),z.then(G=>(this.k.set(V.id,G),G))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const R=this.n.values();let z=R.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=R.next()}};e.$Zkc=P,e.$Zkc=P=Je([We(0,u.$HO),We(1,b.$XO),We(2,m.$vjc),We(3,d.$SO),We(4,k.$yjc),We(5,E.$Wjc),We(6,s.$Oj),We(7,n.$9ic)],P);let C=class extends P{constructor(V,q,R,z,G,ie,fe,De){super(V,q,R,z,G,ie,fe,De),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const R=g.from(q,V);if(R===void 0)throw new Error("Task is not valid");if(v.is(R.execution))await this.y(R,q,!1);else throw new a.$_;const z=await this.z(await this.a.$getTaskExecution(R),q);return this.a.$executeTask(R).catch(G=>{throw new Error(G)}),z}v(V,q,R,z){const G=[];if(z)for(const ie of z){if(this.A(ie,R),!ie.definition||!V[ie.definition.type]){const De=ie.source?ie.source:"No task source";this.f.warn(`The task [${De}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=g.from(ie,R.extension);fe&&v.is(fe.execution)?(G.push(fe),q.push(this.y(fe,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:R.extension}}async w(V){if(v.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,R){}};e.$1kc=C,e.$1kc=C=Je([We(0,u.$HO),We(1,b.$XO),We(2,m.$vjc),We(3,d.$SO),We(4,k.$yjc),We(5,E.$Wjc),We(6,s.$Oj),We(7,n.$9ic)],C),e.$2kc=(0,f.$ii)("IExtHostTask")}),define(Ce[289],Pe([1,0,45,29]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=void 0,e.$2K=M,e.$4K=N;function M(A){return"cellResults"in A}e.$3K="rawCell#";function N(A,m){let d=-1;const k=[];let F=[];return A.forEach(u=>{u.range.startLineNumber!==d&&F.length>0&&(k.push([...F]),F=[]),F.push(u),d=u.range.endLineNumber}),F.length>0&&k.push([...F]),k.map(u=>{const b=[],f=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=f;o<=r;o++)b.push(m.getLineContent(o));return new I.$FK(b.join(`
`)+`
`,u.map(o=>new O.$ct(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[290],Pe([1,0,168,22,5,6,28,15,16,2,43,74,4,31,8,7,50,265,112,26,12,219,289,287]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,v,l,D,g,S){this.q=l,this.r=D,this.s=g,this.t=S,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new M.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$7ic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=w.getProxy(u.$mM.MainThreadNotebook),this.c=w.getProxy(u.$mM.MainThreadNotebookDocuments),this.d=w.getProxy(u.$mM.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,C=y.cell.handle,V=this.g.get(P)?.getCell(C);if(V)return V.apiCell}if(y&&y.$mid===14){const P=y.uri,C=this.g.get(P);if(C)return C.apiNotebook}return y}}),c.B(v)}getEditorById(w){const v=this.h.get(w);if(!v)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(w){for(const[v,l]of this.h)if(l.apiEditor===w)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,v){const l=this.g.get(w);if(!l&&!v)throw new Error(`NO notebook document for '${w}'`);return l}static u(w,v){if(!v)return;const l=v.filenamePattern.map(D=>f.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(v.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:v.displayName,filenamePattern:l,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,v,l){const D=c.a++,g=typeof l.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,l),this.b.$registerNotebookCellStatusBarItemProvider(D,g,v);let S;return g!==void 0&&(S=l.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(g))),new r.$oM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,g),S?.dispose()})}async createNotebookDocument(w){const v=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&f.NotebookData.from(w.content)});return k.URI.revive(v)}async openNotebookDocument(w){const v=this.g.get(w);if(v)return v.apiNotebook;const l=await this.c.$tryOpenNotebook(w),D=this.g.get(k.URI.revive(l));return(0,d.$7f)(D?.apiNotebook)}async showNotebookDocument(w,v){k.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let l;typeof v=="object"?l={position:f.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(f.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:l={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,l),g=D&&this.h.get(D)?.apiEditor;if(g)return g;throw D?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,v,l,D){const g=this.f.get(w),S=k.URI.revive(v),y=this.g.get(S);if(!y||!g)return;const P=y.getCellFromIndex(l);if(!P)return;const C=await g.provideCellStatusBarItems(P.apiCell,D);if(!C)return;const W=new N.$Tc,V=this.p.add([W]),R=(Array.isArray(C)?C:[C]).map(z=>f.NotebookStatusBarItem.from(z,this.i,W));return{cacheId:V,items:R}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,v,l,D,g){if((0,m.$Ue)(v))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:v,serializer:l,options:D}),this.b.$registerNotebookSerializer(S,{id:w.identifier,location:w.extensionLocation},v,f.NotebookDocumentContentOptions.from(D),c.u(w,g)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(w,v,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const g=await D.serializer.deserializeNotebook(v.buffer,l);return new o.$ew(f.NotebookData.from(g))}async $notebookToData(w,v,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const g=await D.serializer.serializeNotebook(f.NotebookData.to(v.value),l);return O.$ue.wrap(g)}async $saveNotebook(w,v,l,D,g){const S=k.URI.revive(v),y=this.x.get(w);if(!y)throw new Error("NO serializer found");const P=this.g.get(S);if(!P)throw new Error("Document NOT found");if(P.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new F.$0k((0,I.localize)(0,null,this.z(S)),6);await this.y(S,D);const C={metadata:(0,i.$Wn)(P.apiNotebook.metadata,z=>!(y.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of P.apiNotebook.getCells()){const G=new r.$QN(z.kind,z.document.getText(),z.document.languageId,z.mime,y.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);G.metadata=(0,i.$Wn)(z.metadata,ie=>!(y.options?.transientCellMetadata??{})[ie]),C.cells.push(G)}const W=await y.serializer.serializeNotebook(C,g);await this.s.value.writeFile(S,W);const V=this.s.getFileSystemProviderExtUri(S.scheme),q=await this.s.value.stat(S);return{name:V.basename(S),isFile:(q.type&F.FileType.File)!==0,isDirectory:(q.type&F.FileType.Directory)!==0,isSymbolicLink:(q.type&F.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&F.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((q.permissions??0)&F.FilePermission.Locked),etag:F.$il({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(w,v,l,D,g){const S=this.x.get(w)?.serializer;if(!S)return{limitHit:!1,results:[]};const y=new A.$Cc;await(async(q,R,z)=>{await Promise.all(q.map(async G=>await Promise.all(G.filenamePatterns.map(ie=>{const fe={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(fe,R,De=>{De.forEach(we=>{y.has(we)||D.some($e=>G.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(ne=>(0,p.$Ffb)(ne,we)))||y.add(we)})}).catch(De=>{if(De.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw De})}))))})(l,g,v);const C=new A.$Bc;let W=!1;const V=Array.from(y).map(async q=>{const R=[];try{if(g.isCancellationRequested)return;if(v.maxResults&&[...C.values()].reduce((fe,De)=>fe+De.cellResults.length,0)>v.maxResults){W=!0;return}const z=[],G=this.g.get(q);if(G)G.apiNotebook.getCells().forEach(De=>z.push({input:De.document.getText(),outputs:De.outputs.flatMap(we=>we.items.map(oe=>oe.data.toString()))}));else{const fe=await this.s.value.readFile(q),De=O.$ue.fromString(fe.toString()),we=await S.deserializeNotebook(De.buffer,g);if(g.isCancellationRequested)return;f.NotebookData.from(we).cells.forEach($e=>z.push({input:$e.source,outputs:$e.outputs.flatMap(ne=>ne.items.map(Se=>Se.valueBytes.toString()))}))}if(g.isCancellationRequested)return;z.forEach((fe,De)=>{const we=v.contentPattern.pattern,oe=new h.$EUb(fe.input,void 0,fe.outputs),$e=oe.findInInputs(we),ne=oe.findInOutputs(we),Se=ne.flatMap(Le=>(0,t.$4K)(Le.matches,Le.textBuffer)).map((Le,re)=>(Le.webviewIndex=re,Le));if($e.length>0||ne.length>0){const Le={index:De,contentResults:(0,t.$4K)($e,oe.inputTextBuffer),webviewResults:Se};R.push(Le)}});const ie={resource:q,cellResults:R};C.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...C.values()]}}async y(w,v){const l=await this.s.value.stat(w);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==F.$hl&&typeof l.mtime=="number"&&typeof l.size=="number"&&v.mtime<l.mtime&&v.etag!==F.$il({mtime:v.mtime,size:l.size}))throw new F.$0k((0,I.localize)(1,null),3,v)}z(w){return w.scheme===a.Schemas.file?w.fsPath:w.toString()}A(w,v,l){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const D=new n.$skc(v,this.d,w,l.visibleRanges.map(f.NotebookRange.to),l.selections.map(f.NotebookRange.to),typeof l.viewColumn=="number"?f.ViewColumn.to(l.viewColumn):void 0);this.h.set(v,D)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const l of w.value.removedDocuments){const D=k.URI.revive(l),g=this.g.get(D);g&&(g.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(g.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(w.value.addedDocuments){const l=[];for(const D of w.value.addedDocuments){const g=k.URI.revive(D.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const S=new s.$rkc(this.c,this.q,this.r,g,D);l.push(...D.cells.map(y=>s.$qkc.asModelAddData(y))),this.g.get(g)?.dispose(),this.g.set(g,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(S.apiNotebook)}}if(w.value.addedEditors)for(const l of w.value.addedEditors){if(this.h.has(l.id))return;const D=k.URI.revive(l.documentUri),g=this.g.get(D);g&&this.A(g,l.id,l)}const v=[];if(w.value.removedEditors)for(const l of w.value.removedEditors){const D=this.h.get(l);D&&(this.h.delete(l),this.k?.id===D.id&&(this.k=void 0),v.push(D))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const l=new Set;this.l.forEach(D=>l.add(D.id));for(const D of this.h.values()){const g=l.has(D.id);D._acceptVisibility(g)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(w){const v=b.$6O.String.with("notebookType","A notebook type"),l=new b.$8O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new b.$6O("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>O.$ue.wrap(g))],new b.$7O("Notebook Data",g=>f.NotebookData.to(g.value))),D=new b.$8O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new b.$6O("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$ew(f.NotebookData.from(g)))],new b.$7O("Bytes",g=>g.buffer));w.registerApiCommand(l),w.registerApiCommand(D)}}e.$Bkc=c}),define(Ce[291],Pe([1,0,19,24,42,35,23,64,45]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class k{constructor(u,b,f){this.k=u,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&N.$ck(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&N.$ck(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((f,r)=>{const o=s=>{this.f++,u(s)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),i=I.$oc(n);this.j&&this.j(n,i)||this.v(o,{base:s,basename:i})}),Promise.all(b.map(s=>this.p(s,o))).then(s=>{f({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,M.$6i)(s)))})})}async p(u,b){const f=new O.$ee,r=this.q(u),o=this.r(),s=new d.$TK(this.k,u),n=!s.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=m.$3d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,f.token),h=i.elapsed(),t=m.$3d.create();return this.g&&!this.e||(a&&a.forEach(p=>{const c=I.$hc.relative(u.folder.path,p.path);if(n){const $=I.$oc(p.path);this.v(b,{base:u.folder,relativePath:c,basename:$});return}this.s(o,u.folder,c,b)}),this.g&&!this.e)?null:(this.u(o,s,b),{providerTime:h,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(u){const b=(0,d.$SK)(this.k.includePattern,u.includePattern),f=(0,d.$SK)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:f,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,f,r){if(f===this.a){const s=I.$oc(this.a);this.v(r,{base:b,relativePath:this.a,basename:s})}function o(s){const n=I.$oc(s),i=I.$nc(s);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:b,relativePath:s,basename:n})}o(f)}u({rootEntries:u,pathToEntries:b},f,r){const o=this,s=this.a;function n(i){const a=(0,d.$VK)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const p=i[h],{relativePath:c,basename:$}=p;if(f.matchesExcludesSync(c,$,s!==$?a:void 0))continue;const w=b[c];if(w)n(w);else{if(c===s)continue;o.v(r,p)}if(o.e)break}}n(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class F{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,f,r){const o=this.c(u.cacheKey),s=new k(u,b,o&&o.token);let n=0;const i=a=>{n+=a.length,f(a.map(h=>this.d(h)))};return this.e(s,F.a,i,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new O.$ee),this.b.get(u)}d(u){return u.relativePath?{resource:A.$Vg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,f,r){const o=r.onCancellationRequested(()=>{u.cancel()}),s=i=>{i&&(n.push(i),b>0&&n.length>=b&&(f(n),n=[]))};let n=[];return u.search(s).then(i=>(n.length&&f(n),o.dispose(),i),i=>(n.length&&f(n),o.dispose(),Promise.reject(i)))}}e.$tkc=F}),define(Ce[292],Pe([1,0,18,260,35,96,28,12,19,23,15,16,2,95,185,47,13,48,107,288,45]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=void 0,e.$4L=D;let h=class{constructor(S,y,P,C,W){this.a=S,this.b=y,this.c=P,this.d=C,this.e=W}text(S,y,P={}){S=this.f(S,P);const C=this.a.getValue(),W=y&&y.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(y?.map(s.$Di),P),type:2,contentPattern:S,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:C.search.usePCRE2||W||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(S,y){const P=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const C={...S,wordSeparators:P.editor.wordSeparators};return this.j(S,y)&&(C.isCaseSensitive=!0),this.k(S)&&(C.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),C}file(S,y={}){return{...this.h(S,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(S,y){return S?(S=Array.isArray(S)?S.map(w):w(S),y?this.parseSearchPaths(S):{pattern:p(...Array.isArray(S)?S:[S])}):{}}h(S=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),C=this.g(y.excludePattern,y.expandPatterns),W=S.length>1,V=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(z=>this.q(z,y,C)):S.map(z=>this.r(z,y,C,W))).filter(z=>!!z),q={_reason:y._reason,folderQueries:V,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:C.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const z=I.$Hb(I.$Rb(this.c.groups.map(fe=>fe.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const G=z.filter(fe=>(0,a.$JK)(q,fe.fsPath)),ie=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const R=y.extraFileResources&&y.extraFileResources.filter(z=>(0,a.$JK)(q,z.fsPath));return q.extraFileResources=R&&R.length?R:void 0,q}i(S){const y=[],P=new A.$Bc,C={};let W=!1;return S.forEach(V=>{if(V.scheme===m.Schemas.walkThrough)return;if((0,k.$Zg)(V)){const R=this.b.getWorkspaceFolder(V)?.uri??V.with({path:d.$nc(V.fsPath)});let z=P.get(R);z||(W=!0,z={folder:R,includePattern:{}},y.push(z),P.set(R,z));const G=d.$mc(R.fsPath,V.fsPath);(0,E.$7f)(z.includePattern)[G.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,C[V.fsPath]=!0)}),{folderQueries:y,includePattern:C,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(S,y){if(y.isSmartCase){if(S.isRegExp){if(F.$Mf(S.pattern,!0))return!0}else if(F.$Mf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,b.$pC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const y=ie=>d.$jc(ie)||/^\.\.?([\/\\]|$)/.test(ie),C=(Array.isArray(S)?S:c(S)).map(ie=>{const fe=this.e.resolvedUserHome;return fe?(0,N.$jw)(ie,fe.scheme===m.Schemas.file?fe.fsPath:fe.path):ie}),W=O.$K(C,ie=>y(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>F.$6e(ie,"/")).map(ie=>F.$6e(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),$(ie))),q={},R=this.m(W.searchPaths||[]);R&&R.length&&(q.searchPaths=R);const z=I.$Rb(V),G=p(...z);return G&&(q.pattern=G),q}l(S,y){return y.disregardExcludeSettings?void 0:(0,a.$IK)(S,!y.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const y=S.flatMap(C=>{let{pathPortion:W,globPortion:V}=t(C);return V&&(V=v(V)),this.n(W).flatMap(R=>this.o(R,V))}),P=new Map;return y.forEach(C=>{const W=C.searchPath.toString(),V=P.get(W);V?C.pattern&&(V.pattern=V.pattern||{},V.pattern[C.pattern]=!0):P.set(W,{searchPath:C.searchPath,pattern:C.pattern?p(C.pattern):void 0})}),Array.from(P.values())}n(S){if(d.$jc(S)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:S})}]:[{searchPath:u.URI.file(d.$ic(S))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(S=w(S),S.startsWith("../")||S===".."){const C=d.$hc.resolve(y.path,S);return[{searchPath:y.with({path:C})}]}const P=v(S);return[{searchPath:y,pattern:P}]}else{if(S==="./"||S===".\\")return[];{const y=S.replace(/^\.[\/\\]/,""),C=this.b.getWorkspace().folders.map(W=>{const V=y.match(new RegExp(`^${F.$Ze(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(E.$4f);if(C.length)return C.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&v(V)}});{const W=S.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:S,q=f.localize(0,null,V);throw new Error(q)}}}}o(S,y){const P=S.pattern&&y?`${S.pattern}/${y}`:S.pattern||y,C=[{searchPath:S.searchPath,pattern:P}];return P&&!P.endsWith("**")&&C.push({searchPath:S.searchPath,pattern:P+"/**"}),C}q(S,y,P){const C=this.r((0,s.$Di)(S.searchPath),y,P,!1);return C?{...C,includePattern:S.pattern}:null}r(S,y,P,C){let W;const V=u.URI.isUri(S)?S:S.uri;if(P.searchPaths){const ie=P.searchPaths.filter(fe=>(0,k.$Og)(fe.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),z={...this.l(q,y)||{},...W||{}},G=u.URI.isUri(S)?(0,k.$Sg)(S):S.name;return{folder:V,folderName:C?G:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!q.search.followSymlinks}}};e.$3L=h,e.$3L=h=Je([We(0,r.$Oi),We(1,s.$ri),We(2,n.$wD),We(3,o.$Oj),We(4,i.$1L)],h);function t(g){const S=g.match(/[\*\{\}\(\)\[\]\?]/);if(S){const y=S.index,P=g.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let C=g.substr(0,P.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function p(...g){return g.length?g.reduce((S,y)=>(S[y]=!0,S),Object.create(null)):void 0}function c(g){return M.$ak(g,",").map(S=>S.trim()).filter(S=>!!S.length)}function $(g){return[`**/${g}/**`,`**/${g}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function w(g){return g.replace(/\\/g,"/")}function v(g){return w(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(g){return g.replace(/([?*[\]])/g,"[$1]")}function D(g,S){g=I.$Mb(g,C=>C.toString());const y=[],P=S.getWorkspace();return g&&g.forEach(C=>{let W;if(S.getWorkbenchState()===2)W=(0,k.$Xg)(P.folders[0].uri,C),W&&W!=="."&&(W="./"+W);else{const V=S.getWorkspaceFolder(C);if(V){const q=V.name;if(P.folders.filter(z=>z.name===q).length===1){const z=(0,k.$Xg)(V.uri,C);z===""?W=`./${V.name}`:W=`./${V.name}/${z}`}else W=C.fsPath}}W&&y.push(l(W))}),y}}),define(Ce[293],Pe([1,0,23,2,24,14,3,292,45,48,11]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nvb=u,e.$ovb=r;const E=7e3;function u(o,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],a=[];for(const w of n)if(/^workspaceContains:/.test(w)){const v=w.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||o.forceUsingSearch?a.push(v):i.push(v)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,F.$bh)(),p=w=>t({activationEvent:w}),c=Promise.all(i.map(w=>b(o,w,p))).then(()=>{}),$=f(o,s.identifier,a,p);return Promise.all([c,$]).then(()=>{t(void 0)}),h}async function b(o,s,n){for(const i of o.folders)if(await o.exists(I.$Vg(O.URI.revive(i),s))){n(`workspaceContains:${s}`);return}}async function f(o,s,n,i){if(n.length===0)return Promise.resolve(void 0);const a=new M.$ee,h=o.checkExists(o.folders,n,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},E);let p=!1;try{p=await h}catch(c){N.$4(c)||N.$1(c)}a.dispose(),clearTimeout(t),p&&i(`workspaceContains:${n.join(",")}`)}function r(o,s,n,i){const a=o.get(A.$hi),h=o.get(d.$AK),p=a.createInstance(m.$3L).file(s.map(c=>(0,k.$Di)(O.URI.revive(c))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(p,i).then(c=>!!c.limitHit,c=>N.$4(c)?!1:Promise.reject(c))}}),define(Ce[38],Pe([1,0,164,19,89,23,11,6,51,2,13,4,37,225,82,36,25,108,14,20,22,206,7,102,3,27,85,17,71,86,66,88,5,293,81,208,12,79,64,21,80]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p,c,$,w,v,l,D,g,S,y,P,C,W,V,q,R,z,G){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=e.$0jc=e.$9jc=e.$8jc=void 0,e.$8jc=(0,c.$ii)("IHostUtils");let fe=ie=class extends m.$Uc{constructor(L,x,ve,Oe,ye,pe,de,J,Y,ue,he,Ne,le){super(),this.Y=Ne,this.Z=le,this.a=this.B(new y.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=de,this.j=Oe,this.m=ye,this.s=pe,this.t=Y,this.u=ue,this.w=he,this.y=this.g.getProxy(E.$mM.MainThreadWorkspace),this.z=this.g.getProxy(E.$mM.MainThreadTelemetry),this.C=this.g.getProxy(E.$mM.MainThreadExtensionService),this.D=new A.$hh,this.F=new A.$hh,this.G=new A.$hh,this.H=new A.$hh,this.I=new Le(this.f.extensions.activationEvents),this.L=new s.$20b(this.I,this.f.extensions.allExtensions);const Ie=new i.$Em(this.f.extensions.myExtensions);this.J=new s.$20b(this.I,ne(this.L,Ie)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new f.$Sjc(this.g,this.s),this.N=new C.$1jc(this.g),this.O=J,this.h=L.createChild(new l.$gi([f.$Tjc,this.M],[C.$2jc,this.N])),this.P=this.B(new b.$Rjc(this.J,this.L,{onExtensionActivationError:(Re,je,U)=>{this.C.$onExtensionActivationError(Re,n.$3(je),U)},actualActivateExtension:async(Re,je)=>{if(s.$20b.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,je),new b.$Qjc;const U=this.J.getExtensionDescription(Re);return this.fb(U,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(L){n.$1(L)}}async $(){this.O.onWillDeactivateAll();let L=[];try{L=this.J.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.eb(ye))}catch{}await Promise.all(L)}terminate(L,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${L}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Oe=>{this.s.error(Oe)}),this.g.dispose();const ve=this.$();Promise.race([(0,A.$jh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(L){return this.G.isOpen()?this.P.isActivated(L):!1}async getExtension(L){const x=await this.C.$getExtension(L);return x&&{...x,identifier:new i.$Dm(x.identifier.value),extensionLocation:k.URI.revive(x.extensionLocation)}}ab(L,x){return this.P.activateByEvent(L,x)}bb(L,x){return this.P.activateById(L,x)}activateByIdWithErrors(L,x){return this.bb(L,x).then(()=>{const ve=this.P.getActivatedExtension(L);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(L=>this.J)}getExtensionExports(L){if(this.G.isOpen())return this.P.getActivatedExtension(L).exports;try{return this.P.getActivatedExtension(L).exports}catch{return null}}async cb(L){if(L.scheme===V.Schemas.file&&this.c.fsRealpath){const x=L.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return k.URI.file(ve)}return L}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(L=>new Se(L))),this.Q}async db(L){const x=d.$oi.forUris(ve=>N.$Mg.ignorePathCasing(ve));return await Promise.all(L.map(async ve=>{if(this.wb(ve)){const Oe=await this.cb(ve.extensionLocation);x.set(Oe,ve)}})),x}eb(L){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(L))return x;const ve=this.P.getActivatedExtension(L);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Oe=>(this.s.error(Oe),Promise.resolve(void 0))))}catch(Oe){this.s.error(`An error occurred when deactivating the extension '${L.value}':`),this.s.error(Oe)}try{(0,m.$Pc)(ve.subscriptions)}catch(Oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${L.value}':`),this.s.error(Oe)}return x}async fb(L,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(L.identifier):await this.C.$onWillActivateExtension(L.identifier),this.hb(L,x).then(ve=>{const Oe=ve.activationTimes;return this.C.$onDidActivateExtension(L.identifier,Oe.codeLoadingTime,Oe.activateCallTime,Oe.activateResolvedTime,x),this.gb(L,x,"success",Oe),ve},ve=>{throw this.gb(L,x,"failure"),ve})}gb(L,x,ve,Oe){const ye=we(L,x);this.z.$publicLog2("extensionActivationTimes",{...ye,...Oe||{},outcome:ve})}hb(L,x){const ve=we(L,x);this.z.$publicLog2("activatePlugin",ve);const Oe=this.wb(L);if(!Oe)return Promise.resolve(new b.$Pjc(b.$Mjc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${L.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${L.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ye=new b.$Njc(x.startup);return Promise.all([this.xb(L,(0,N.$Vg)(L.extensionLocation,Oe),ye),this.ib(L)]).then(pe=>(M.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),ie.jb(this.s,L.identifier,pe[0],pe[1],ye))).then(pe=>(M.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),pe))}ib(L){const x=this.Z.createLanguageModelAccessInformation(L),ve=new h.$Vjc(L,this.M),Oe=new h.$Ujc(L.identifier.value,!1,this.M),ye=new W.$3jc(L,this.N),pe=L.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([ve.whenReady,Oe.whenReady,this.O.whenReady]).then(()=>{const J=this;let Y,ue;const he=(0,o.$9F)(L,"ipc")?this.f.messagePorts?.get(i.$Dm.toKey(L.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Oe,secrets:ye,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ne){return O.$kc(L.extensionLocation.fsPath,Ne)},get storagePath(){return J.O.workspaceValue(L)?.fsPath},get globalStoragePath(){return J.O.globalValue(L).fsPath},get logPath(){return O.$kc(J.f.logsLocation.fsPath,L.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,L.identifier.value)},get storageUri(){return J.O.workspaceValue(L)},get globalStorageUri(){return J.O.globalValue(L)},get extensionMode(){return pe},get extension(){return Y===void 0&&(Y=new $e(J,L.identifier,L,de,!1)),Y},get extensionRuntime(){return(0,o.$0F)(L,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(L)},get messagePassingProtocol(){if(!ue){if(!he)return;const Ne=y.Event.buffer(y.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),ue={onDidReceiveMessage:Ne,postMessage:he.postMessage.bind(he)}}return ue}})})}static jb(L,x,ve,Oe,ye){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(L,x,ve,Oe,ye).then(pe=>new b.$Ojc(!1,null,ye.build(),ve,pe,Oe.subscriptions))}static kb(L,x,ve,Oe,ye){if(typeof ve.activate=="function")try{ye.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,de=ve.activate.apply(pe,[Oe]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(de).then(J=>(ye.activateResolveStop(),J))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(ve)}lb(L,x){this.bb(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(L,x=0){const Oe=Date.now();(0,z.$B)(()=>{for(let ye=x;ye<L.length;ye+=1){const pe=L[ye];for(const de of pe.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-Oe>50){this.mb(L,ye);break}else this.lb(pe,de)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(L=>{const x=L.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Oe of ve)if(Oe.activationEvents)for(const ye of Oe.activationEvents)ye==="onStartupFinished"&&this.lb(Oe,ye)})}ob(){const L=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Oe=this.rb(),ye=Promise.all([Oe,L,ve]).then(()=>{});return Promise.race([ye,(0,A.$jh)(1e4)]).then(()=>{this.nb()}),ye}pb(L){return L.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(L,x))).then(()=>{})}async qb(L,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Oe={logService:this.s,folders:L.map(pe=>pe.uri),forceUsingSearch:ve||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,de,J)=>this.y.$checkExists(pe,de,J)},ye=await(0,P.$nvb)(Oe,x);if(ye)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ye.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(L){throw console.error(L),L}}async sb(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:x}=this.f.environment;if(!L||!x)throw new Error(I.localize(0,null));const ve=await this.xb(null,x,new b.$Njc(!1));if(!ve||typeof ve.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Oe,ye)=>{const pe=(Y,ue)=>{Y?(z.$t&&this.s.error("Test runner called back with error",Y),ye(Y)):(z.$t&&(ue?this.s.info(`Test runner called back with ${ue} failures.`):this.s.info("Test runner called back with successful outcome.")),Oe(typeof ue=="number"&&ue>0?1:0))},de=(0,N.$Jg)(x),J=ve.run(de,pe);J&&J.then&&J.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),Oe(0)}).catch(Y=>{z.$t&&this.s.error("Test runner finished with error",Y),ye(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(L,x){return this.S[L]=x,(0,m.$Sc)(()=>{delete this.S[L]})}async getRemoteExecServer(L){const{resolver:x}=await this.ub(L);return x?.resolveExecServer?.(L,{resolveAttempt:0})}async ub(L){const x=L.indexOf("+");if(x===-1)throw new t.$uM("Not an authority that can be resolved!",p.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=L.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(L,x){const ve=R.$3d.create(!1),Oe=()=>`[resolveAuthority(${(0,p.$xl)(L)},${x})][${ve.elapsed()}ms] `,ye=j=>this.s.info(`${Oe()}${j}`),pe=j=>this.s.warn(`${Oe()}${j}`),de=(j,K=void 0)=>this.s.error(`${Oe()}${j}`,K),J=j=>{if(j instanceof t.$uM)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Y=async j=>{ye(`activating resolver for ${j}...`);const{resolver:K,authorityPrefix:H}=await this.ub(j);if(!K)throw de(`no resolver for ${H}`),new t.$uM(`No remote extension installed to resolve ${H}.`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:j}},ue=L.split(/@|%40/g).reverse();ye(`activating remote resolvers ${ue.join(" -> ")}`);let he;try{he=await Promise.all(ue.map(Y)).catch(async j=>{if(!(j instanceof t.$uM)||j._code!==p.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return pe(`resolving nested authorities failed: ${j.message}`),[await Y(L)]})}catch(j){return J(j)}const Ne=new A.$th;Ne.cancelAndSet(()=>ye("waiting..."),1e3);let le,Ie;for(const[j,{authorityPrefix:K,resolver:H,remoteAuthority:ee}]of he.entries())try{if(j===he.length-1)ye("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${K}`),le=await H.resolve(ee,{resolveAttempt:x,execServer:Ie}),M.mark(`code/extHost/didResolveAuthorityOK/${K}`),ye("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$tM.isManagedResolvedAuthority(le)?le:void 0));else{if(ye(`invoking resolveExecServer() for ${ee}`),M.mark(`code/extHost/willResolveExecServer/${K}`),Ie=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ie}),!Ie)throw new t.$uM(`Exec server was not available for ${ee}`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(se){return M.mark(`code/extHost/didResolveAuthorityError/${K}`),de("returned an error",se),Ne.dispose(),J(se)}Ne.dispose();const Re={environmentTunnels:le.environmentTunnels,features:le.tunnelFeatures?{elevation:le.tunnelFeatures.elevation,privacyOptions:le.tunnelFeatures.privacyOptions,protocol:le.tunnelFeatures.protocol===void 0?!0:le.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted,authenticationSession:le.authenticationSessionForInitializingExtensions?{id:le.authenticationSessionForInitializingExtensions.id,providerId:le.authenticationSessionForInitializingExtensions.providerId}:void 0};ye(`returned ${t.$tM.isManagedResolvedAuthority(le)?"managed authority":`${le.host}:${le.port}`}`);let U;if(t.$tM.isManagedResolvedAuthority(le)){const j=x;this.Y.setFactory(j,le.makeConnection),U={authority:L,connectTo:new p.$ul(j),connectionToken:le.connectionToken}}else U={authority:L,connectTo:new p.$vl(le.host,le.port),connectionToken:le.connectionToken};return{type:"ok",value:{authority:U,options:je,tunnelInformation:Re}}}async $getCanonicalURI(L,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,p.$xl)(L)})`);const{resolver:ve}=await this.ub(L);if(!ve)return null;const Oe=k.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Oe;const ye=await(0,A.$ah)(()=>ve.getCanonicalURI(Oe));return ye||Oe}async $startExtensionHost(L){L.toAdd.forEach(pe=>pe.extensionLocation=k.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:ve}=De(this.I,this.L,this.J,L),Oe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(L,x){return x===1?this.D.wait().then(ve=>this.ab(L,!1)):this.G.wait().then(ve=>this.ab(L,!1))}async $activate(L,x){return await this.G.wait(),this.J.getExtensionDescription(L)?(await this.bb(L,x),!0):!1}async $deltaExtensions(L){L.toAdd.forEach(pe=>pe.extensionLocation=k.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:ve}=De(this.I,this.L,this.J,L),Oe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){const x=a.$ue.alloc(L),ve=Math.random()%256;for(let Oe=0;Oe<L;Oe++)x.writeUInt8(ve,Oe);return x}async $updateRemoteConnectionData(L){this.X=L,this.a.fire()}};e.$9jc=fe,e.$9jc=fe=ie=Je([We(0,c.$hi),We(1,e.$8jc),We(2,v.$HO),We(3,r.$vjc),We(4,u.$yjc),We(5,F.$Oj),We(6,$.$XO),We(7,w.$Bjc),We(8,D.$TBb),We(9,g.$Wjc),We(10,q.$5jc),We(11,G.$6jc),We(12,S.$ljc)],fe);function De(re,L,x,ve){re.addActivationEvents(ve.addActivationEvents);const Oe=new s.$20b(re,L.getAllExtensionDescriptions());Oe.deltaExtensions(ve.toAdd,ve.toRemove);const ye=new i.$Em(x.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ve.myToRemove)ye.delete(de);for(const de of ve.myToAdd)ye.add(de);const pe=ne(Oe,ye);return{globalRegistry:Oe,myExtensions:pe}}function we(re,L){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}function oe(re){return re.getAllExtensionDescriptions().map(L=>L.identifier.value).join(",")}e.$0jc=(0,c.$ii)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(L,x,ve,Oe,ye){this.#e=L,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=O.$ic((0,N.$Jg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Oe,this.isFromDifferentExtensionHost=ye}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$$jc=$e;function ne(re,L){return re.getAllExtensionDescriptions().filter(x=>L.has(x.identifier))}class Se{constructor(L){this.a=L}setSearchTree(L){this.a=L}findSubstr(L){return this.a.findSubstr(L)}forEach(L){return this.a.forEach(L)}}e.$_jc=Se;class Le{constructor(L){this.a=new i.$Fm,this.addActivationEvents(L)}readActivationEvents(L){return this.a.get(L.identifier)??[]}addActivationEvents(L){for(const x of Object.keys(L))this.a.set(x,L[x])}}}),define(Ce[294],Pe([1,0,89,2,4,37,25,20,17,27,3,38,13,15]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;let r=class{constructor(a,h,t,p,c,$,w){this.c=a,this.d=h,this.e=t,this.f=p,this.g=c,this.h=$,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$hlc=r,e.$hlc=r=Je([We(2,F.$hi),We(3,N.$yjc),We(4,E.$0jc),We(5,k.$XO),We(6,u.$Oj)],r);let o=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&f.a.size){const h=(0,b.$Ze)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",p=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${p})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,p,c]=h,$=f.a.get(p);if($!==void 0)return console.warn(`${p} as been renamed to ${$}, please update your imports`),t+$+c}c(a){return a.replace(/\\/g,"/")}};o=f=Je([We(0,k.$XO)],o);class s{constructor(a,h,t,p,c){this.c=a,this.d=h,this.e=t,this.f=p,this.g=c,this.nodeModuleName="vscode",this.a=new m.$Fm}load(a,h){const t=this.d.findSubstr(h);if(t){let p=this.a.get(t.identifier);return p||(p=this.c(t,this.e,this.f),this.a.set(t.identifier,p)),p}if(!this.b){let p="";this.d.forEach((c,$)=>p+=`	${$} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${p}`),this.b=this.c(A.$4F,this.e,this.f)}return this.b}}let n=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$mM.MainThreadTelemetry);const p=t.getProxy(M.$mM.MainThreadWindow);this.c=(c,$)=>{const w=O.URI.parse(c);return $?this.g(c,$):w.scheme==="http"||w.scheme==="https"?p.$openUri(w,c,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?p.$openUri(w,c,{}):this.g(c,$)}}load(a,h,t){const p=this.e.findSubstr(h);return p&&(this.a=p.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,d.$HO)],n)}),define(Ce[119],Pe([1,0,40,6,19,73,3,67,65,38,7,36,222,37]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=e.$akc=void 0,e.$akc=(0,A.$ii)("IExtHostVariableResolverProvider");class f extends u.$JP{constructor(s,n,i,a,h,t,p){function c(){if(i){const $=i.activeEditor();if($)return $.document.uri;const w=a.tabGroups.all.find(v=>v.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof F.$$N||w.input instanceof F.$dO)return w.input.modified;if(w.input instanceof F.$0N||w.input instanceof F.$cO||w.input instanceof F.$aO)return w.input.uri}}}super({getFolderUri:$=>{const w=t.folders.filter(v=>v.name===$);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,w)=>h.getConfiguration(void 0,$).get(w),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=c();if($)return M.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const $=c();if($){const w=n.getWorkspaceFolder($);if(w)return M.$ic(w.uri.fsPath)}}},getSelectedText:()=>{if(i){const $=i.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(i){const $=i.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,p?Promise.resolve(p):void 0,Promise.resolve(N.env))}}let r=class extends O.$Uc{constructor(s,n,i,a,h){super(),this.b=s,this.c=n,this.g=i,this.h=a,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$bkc=r,e.$bkc=r=Je([We(0,k.$0jc),We(1,E.$vjc),We(2,m.$SO),We(3,b.$yjc),We(4,d.$Kjc)],r)}),define(Ce[120],Pe([1,0,11,5,2,20,3,4,65,38,17,7,36,214,216,37,119,6,41,31,8]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=e.$fkc=e.$ekc=e.$dkc=e.$ckc=void 0,e.$ckc=(0,A.$ii)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,D,g,S,y,P,C){this.N=D,this.O=g,this.P=S,this.Q=y,this.R=P,this.S=C,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$7d,this.o=new O.$7d,this.q=new O.$7d,this.w=new O.$7d,this.l=l.getProxy(m.$mM.MainThreadDebugService),this.A=new O.$7d,this.C=new O.$7d,this.y=new p(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(l,D){const g=this.W(D);if(!g)return;const S=await this.H.get(l)?.getTreeItem?.(g);return S?this.U(l,S):void 0}registerDebugVisualizationTree(l,D,g){const S=N.$Dm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,g),this.l.$registerDebugVisualizerTree(y,!!g.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(l,D){const g=this.J.get(D)?.item;return g?(await this.H.get(l)?.getChildren?.(g))?.map(y=>this.U(l,y))||[]:[]}async $editVisualizerTreeItem(l,D){const g=this.J.get(l);if(!g)return;const S=await this.H.get(g.provider)?.editItem?.(g.item,D);return this.U(g.provider,S||g.item)}$disposeVisualizedTree(l){const D=this.J.get(l);if(!D)return;const g=[D.children];for(const S of g)if(S)for(const y of S)g.push(this.J.get(y)?.children),this.J.delete(y)}U(l,D){let g=this.I.get(D);return g||(g=this.F++,this.I.set(D,g),this.J.set(g,{provider:l,item:D})),a.DebugTreeItem.from(D,g)}asDebugSourceUri(l,D){const g=l;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let S=`debug:${encodeURIComponent(g.path||"")}`,y="?";return D&&(S+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),S+=`${y}ref=${g.sourceReference}`,M.URI.parse(S)}else{if(g.path)return M.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const D=[];for(const g of l.getAllExtensionDescriptions())if(g.contributes){const S=g.contributes.debuggers;if(S&&S.length>0)for(const y of S)(0,f.$JG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(D=>l.push(D)),l}async $resolveDebugVisualizer(l,D){const g=this.L.get(l);if(!g)throw new Error(`No debug visualizer found with id '${l}'`);let{v:S,provider:y,extensionId:P}=g;if(S.visualization||(S=await y.resolveDebugVisualization?.(S,D)||S,g.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,S.visualization)}async $executeDebugVisualizerCommand(l){const D=this.L.get(l);if(!D)throw new Error(`No debug visualizer found with id '${l}'`);const g=D.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(l){const D=this.m.get(l.sessionId);return D&&{session:D.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,D,g,S){const y=this.W(g),P=this.jb(l,D),C=this.G.get(P);if(!y||!C)return[];const W=await C.provideDebugVisualization(y,S);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:C,extensionId:l});const R=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.kb(l,V.visualization)}}):[]}$disposeDebugVisualizers(l){for(const D of l)this.L.delete(D)}registerDebugVisualizationProvider(l,D,g){if(!l.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=N.$Dm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,g),this.l.$registerDebugVisualizer(S,D),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(l){const D=l.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(D,[],[]);const g=[],S=new Map;for(const y of D)if(y instanceof E.$pN){let P=S.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},S.set(y.location.uri.toString(),P),g.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof E.$qN&&g.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints(l){const D=l.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const g=D.filter(P=>P instanceof E.$pN).map(P=>P.id),S=D.filter(P=>P instanceof E.$qN).map(P=>P.id),y=D.filter(P=>P instanceof E.$rN).map(P=>P.id);return this.l.$unregisterBreakpoints(g,S,y)}startDebugging(l,D,g){return this.l.$startDebugging(l?l.uri:void 0,D,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,D,g){if(!D)return new E.$oM(()=>{});const S=this.d++;return this.f.push({type:l,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(l,g,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new E.$oM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,D,g){if(!g)return new E.$oM(()=>{});if(!this.cb(l,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new E.$oM(()=>{this.h=this.h.filter(y=>y.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,D){if(!D)return new E.$oM(()=>{});const g=this.j++;return this.k.push({type:l,handle:g,factory:D}),new E.$oM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(l,D){return Promise.resolve(void 0)}async $substituteVariables(l,D){let g;const S=await this.ib(l);return S&&(g={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,D)}X(l,D){if(l.type==="implementation")return new $(l.implementation)}Y(){}async $startDASession(l,D){const g=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const P=this.Z(y),C=this.X(P,S);if(!C)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const W=C;return this.D.set(l,W),this.db(S).then(V=>(V&&this.E.set(l,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const R=q,z={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const G=await this.K.sign(R.arguments.value);z.body={signature:G},W.sendResponse(z)}else throw new Error("no signer")}catch(G){z.success=!1,z.message=G.message,W.sendResponse(z)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,f.$OG)(q,!0),g.l.$acceptDAMessage(l,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(l,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(l,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(l,D){D=(0,f.$NG)(D,!1);const g=this.E.get(l);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(D),this.D.get(l)?.sendMessage(D)}$stopDASession(l){const D=this.E.get(l);this.E.delete(l),D&&D.onWillStopSession&&D.onWillStopSession();const g=this.D.get(l);return this.D.delete(l),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const D=[],g=[],S=[];if(l.added)for(const y of l.added){const P=y.id;if(P&&!this.z.has(P)){let C;if(y.type==="function")C=new E.$qN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")C=new E.$rN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const W=M.URI.revive(y.uri);C=new E.$pN(new E.$AM(W,new E.$pM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,E.$nN)(C,P),this.z.set(P,C),D.push(C)}}if(l.removed)for(const y of l.removed){const P=this.z.get(y);P&&(this.z.delete(y),g.push(P))}if(l.changed){for(const y of l.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof E.$qN&&y.type==="function"){const C=P;C.enabled=y.enabled,C.condition=y.condition,C.hitCondition=y.hitCondition,C.logMessage=y.logMessage,C.functionName=y.functionName}else if(P instanceof E.$pN&&y.type==="source"){const C=P;C.enabled=y.enabled,C.condition=y.condition,C.hitCondition=y.hitCondition,C.logMessage=y.logMessage,C.location=new E.$AM(M.URI.revive(y.uri),new E.$pM(y.line,y.character))}S.push(P)}}}this.gb(D,g,S)}async $acceptStackFrameFocus(l){let D;if(l){const g=await this.hb(l.sessionId);l.kind==="thread"?D=new E.$xN(g.api,l.threadId):D=new E.$wN(g.api,l.threadId,l.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(l,D,g){return(0,I.$ah)(async()=>{const S=this.bb(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return S.provideDebugConfigurations(y,g)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,D,g,S){return(0,I.$ah)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return y.resolveDebugConfiguration(P,g,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,D,g,S){return(0,I.$ah)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(P,g,S)})}async $provideDebugAdapter(l,D){const g=this.ab(l);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(g,S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(l){const D=await this.hb(l);this.n.fire(D.api)}async $acceptDebugSessionTerminated(l){const D=await this.hb(l);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,D){(await this.hb(l))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(l,D){const S={session:(await this.hb(l)).api,event:D.event,body:D.body};this.w.fire(S)}Z(l){if(l instanceof E.$sN)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof E.$tN)return{type:"server",port:l.port,host:l.host};if(l instanceof E.$uN)return{type:"pipeServer",path:l.path};if(l instanceof E.$vN)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const D=this.h.filter(g=>g.type===l);if(D.length>0)return D[0].factory}ab(l){const D=this.h.filter(g=>g.handle===l);if(D.length>0)return D[0].factory}bb(l){const D=this.f.filter(g=>g.handle===l);if(D.length>0)return D[0].provider}cb(l,D){if(l.contributes){const g=l.contributes.debuggers;if(g&&g.length>0){for(const S of g)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(l){const g=l.configuration.type,S=this.k.filter(y=>y.type===g||y.type==="*").map(y=>(0,I.$ah)(()=>y.factory.createDebugAdapterTracker(l.api)).then(P=>P,P=>null));return Promise.race([Promise.all(S).then(y=>{const P=y.filter(C=>!!C);if(P.length>0)return new c(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(l,D){const g=D.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new E.$tN(g));if(l){const y=await this.O.getExtensionRegistry();return(0,I.$ah)(()=>l.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(P=>{if(P)return P})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(l,D){}gb(l,D,g){(l.length>0||D.length>0||g.length>0)&&this.A.fire(Object.freeze({added:l,removed:D,changed:g}))}async hb(l){if(l)if(typeof l=="string"){const D=this.m.get(l);if(D)return D}else{let D=this.m.get(l.id);if(!D){const g=await this.ib(l.folderUri),S=l.parent?this.m.get(l.parent):void 0;D=new t(this.l,l.id,l.type,l.name,g,l.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(l){if(l){const D=M.URI.revive(l);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(l,D){return`${l}\0${D}`}kb(l,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${l}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const D=this.mb(l);let g,S;return"id"in D?S=n.ThemeIcon.asClassName(D):g=D,{iconPath:g,iconClass:S}}mb(l){if(l instanceof E.$kN)return{id:l.id};const D=typeof l=="object"&&"dark"in l?l.dark:l,g=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof D=="string"?M.URI.file(D):D,light:typeof g=="string"?M.URI.file(g):g}}};e.$dkc=h,e.$dkc=h=Je([We(0,F.$HO),We(1,u.$vjc),We(2,k.$0jc),We(3,r.$yjc),We(4,d.$Kjc),We(5,o.$akc),We(6,i.$4O)],h);class t{constructor(l,D,g,S,y,P,C){this.f=l,this.g=D,this.h=g,this.j=S,this.k=y,this.l=P,this.m=C}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(D){l.j=D,l.f.$setDebugSessionName(l.g,D)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(D,g){return l.f.$customDebugAdapterRequest(l.g,D,g)},getDebugProtocolBreakpoint(D){return l.f.$getDebugProtocolBreakpoint(l.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$ekc=t;class p{constructor(l){this.value=Object.freeze({append(D){l.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$fkc=p;class c{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(D=>D.onError?D.onError(l):void 0)}onExit(l,D){this.d.forEach(g=>g.onExit?g.onExit(l,D):void 0)}}class $ extends b.$xob{constructor(l){super(),this.h=l,l.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends h{constructor(l,D,g,S,y,P,C){super(l,D,g,S,y,P,C)}};e.$gkc=w,e.$gkc=w=Je([We(0,F.$HO),We(1,u.$vjc),We(2,k.$0jc),We(3,r.$yjc),We(4,d.$Kjc),We(5,o.$akc),We(6,i.$4O)],w)}),define(Ce[295],Pe([1,0,14,89,2,4,243,13,54,71,27,190,17,59,38,61]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(m.$Oj),t=i.get(u.$HO).getProxy(N.$mM.MainThreadErrors);I.setUnexpectedErrorHandler(p=>{a.error(p);const c=I.$3(p);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(m.$Oj),h=i.get(u.$HO),t=i.get(f.$0jc),p=i.get(r.$2O),c=h.getProxy(N.$mM.MainThreadExtensionService),$=h.getProxy(N.$mM.MainThreadErrors),w=await t.getExtensionPathIndex(),v=new WeakMap;function l(S,y){if(v.has(S))return v.get(S).stack;let P="",C,W;for(const q of y)P+=`
	at ${q.toString()}`,W=q.getFileName(),!C&&W&&(C=w.findSubstr(M.URI.file(W)));const V=`${S.name||"Error"}: ${S.message||""}${P}`;return v.set(S,{extensionIdentifier:C?.identifier,stack:V}),V}const D=Symbol("prepareStackTrace wrapped");let g=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(S){if(S===l||!S||S[D]){g=S||l;return}g=function(y,P){return l(y,P),S.call(Error,y,P)},Object.assign(g,{[D]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const y=I.$3(S),P=v.get(S);if(!P?.extensionIdentifier){$.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(P.extensionIdentifier,y);const C=p.onExtensionError(P.extensionIdentifier,S);a.trace("forwarded error to extension?",C,P)})}}e.$ilc=o;class s{constructor(i,a,h,t,p){this.a=h,this.b=new A.$00b(i,null,t),a=s.e(a,this.b);const c=new k.$gi(...(0,d.$hs)());c.set(F.$XO,{_serviceBrand:void 0,...a,messagePorts:p}),c.set(u.$HO,new u.$IO(this.b)),c.set(b.$sjc,new b.$tjc(t)),c.set(f.$8jc,h);const $=new E.$Yq(c,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(w=>w.get(m.$Oj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=$.invokeFunction(w=>w.get(f.$0jc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(N.$mM.MainThreadExtensionService);return M.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>M.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$jlc=s}),define(Ce[296],Pe([1,0,18,11,24,42,12,19,23,2,45]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=e.$vkc=e.$ukc=void 0,e.$wkc=r;class E{constructor(n,i,a){this.d=n,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const a=this.g.folderQueries||[],h=new M.$ee(i);return new Promise((t,p)=>{this.a=new b(n);let c=!1;const $=(w,v)=>{if(!c&&!this.b){const l=this.h(w);r(w)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,c=!0,h.cancel(),w=this.j(w,this.g.maxResults-this.c));const D=this.h(w);this.c+=D,(D>0||!r(w))&&this.a.add(w,v)}};Promise.all(a.map((w,v)=>this.k(w,l=>$(l,v),h.token))).then(w=>{h.dispose(),this.a.flush();const v=w.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||v,messages:(0,I.$Rb)(w.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},w=>{h.dispose();const v=(0,N.$6i)(w);p(new Error(v))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,i),preview:{matches:h.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,a){const h=new F.$TK(this.g,n),t=[],p={report:w=>{if(!this.l(w))return;const v=n.folder.scheme===A.Schemas.file?(0,F.$UK)(()=>this.e.readdir(d.$Ug(w.uri))):void 0,l=d.$Xg(n.folder,w.uri);if(l){const D=h.includedInQuery(l,m.$oc(l),v);(0,O.$7g)(D)?t.push(D.then(g=>{g&&i(w)})):D&&i(w)}}},c=this.n(n);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,p,a):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,p,a),t.length&&await Promise.all(t),$}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,F.$SK)(this.g.includePattern,n.includePattern),a=(0,F.$SK)(this.g.excludePattern,n.excludePattern),h={folder:k.URI.from(n.folder),excludes:a,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$ukc=E;function u(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class b{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!d.$Og(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(f(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$vkc=b;function f(s){return r(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$xkc=o}),define(Ce[121],Pe([1,0,6,4,3,291,17,59,13,2,296]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=e.$ykc=void 0,e.$Akc=u,e.$ykc=(0,M.$ii)("IExtHostSearch");let E=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(O.$mM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$tkc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,n){const i=u(s),a=this.j.get(r);if(a)return this.l.fileSearch(i,a,h=>{this.c.$handleFileMatch(r,o,h.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const a=u(s);return this.t(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$provideAITextSearchResults(r,o,s,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const a=u(s);return this.v(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$enableExtensionHostSearch(){}t(r,o){return new F.$ukc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new F.$ukc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$zkc=E,e.$zkc=E=Je([We(0,A.$HO),We(1,m.$sjc),We(2,d.$Oj)],E);function u(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(r=>k.URI.revive(r))}}function b(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ce[297],Pe([1,0,24,14,5,6,12,32,2,150,146,134,94,20,43,13,57,58,203,4,246,275,78,84,252,231,253,88,254,232,220,31,255,37,256,120,110,257,234,247,258,259,67,65,248,38,261,63,262,44,27,276,277,249,235,263,264,79,80,237,290,266,207,267,278,268,115,238,269,270,271,17,272,121,81,273,239,274,82,85,118,61,66,279,280,250,281,282,86,8,7,240,59,241,62,283,284,109,36,215,77,25,117]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p,c,$,w,v,l,D,g,S,y,P,C,W,V,q,R,z,G,ie,fe,De,we,oe,$e,ne,Se,Le,re,L,x,ve,Oe,ye,pe,de,J,Y,ue,he,Ne,le,Ie,Re,je,U,j,K,H,ee,se,Fe,Ve,Qe,xe,tt,at,it,nt,ct,ft,Ue,ot,Z,X,me,qe,Xe,Me,dt,Pt,zt,xt,Jt,_t,Et,Qt,Vt,ai,Ye,ei){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=ti;function ti(ht){const vt=ht.get(re.$XO),si=ht.get(Le.$ajc),ii=ht.get(ne.$Ajc),Ft=ht.get(oe.$0jc),mt=ht.get(Qt.$vjc),Mt=ht.get(ct.$2O),Wt=ht.get(P.$yjc),Xt=ht.get(Pt.$sjc),Ke=ht.get(ee.$HO),Zt=ht.get(at.$Tjc),jt=ht.get(it.$Bjc),Ut=ht.get(r.$Pj),$t=ht.get(r.$Oj),Tt=ht.get(qe.$TBb),Rt=ht.get(t.$9ic),Lt=ht.get(Et.$clc),ni=ht.get(Ve.$2jc),oi=ht.get(De.$Kjc),qt=ht.get(J.$6jc),It=ht.get(p.$gjc),Dt=ht.get(v.$ljc);Ke.set(i.$nM.ExtHostFileSystemInfo,si),Ke.set(i.$nM.ExtHostLogLevelServiceShape,Ut),Ke.set(i.$nM.ExtHostWorkspace,mt),Ke.set(i.$nM.ExtHostConfiguration,Wt),Ke.set(i.$nM.ExtHostExtensionService,Ft),Ke.set(i.$nM.ExtHostStorage,Zt),Ke.set(i.$nM.ExtHostTunnelService,Tt),Ke.set(i.$nM.ExtHostWindow,Lt),Ke.set(i.$nM.ExtHostSecretState,ni),Ke.set(i.$nM.ExtHostTelemetry,Mt),Ke.set(i.$nM.ExtHostEditorTabs,oi),Ke.set(i.$nM.ExtHostManagedSockets,qt),Ke.set(i.$nM.ExtHostAuthentication,It),Ke.set(i.$nM.ExtHostChatProvider,Dt);const Ht=Ke.set(i.$nM.ExtHostDecorations,ht.get(V.$ikc)),Ct=Ke.set(i.$nM.ExtHostDocumentsAndEditors,ht.get(fe.$SO)),wt=Ke.set(i.$nM.ExtHostCommands,ht.get(S.$4O)),St=Ke.set(i.$nM.ExtHostTerminalService,ht.get(ft.$Wjc)),kt=Ke.set(i.$nM.ExtHostDebugService,ht.get(W.$ckc)),ui=Ke.set(i.$nM.ExtHostSearch,ht.get(Fe.$ykc)),ri=Ke.set(i.$nM.ExtHostTask,ht.get(nt.$2kc)),li=Ke.set(i.$nM.ExtHostOutputService,ht.get(je.$Okc)),di=Ke.set(i.$nM.ExtHostLocalization,ht.get(de.$5jc)),Yt=Ke.set(i.$nM.ExtHostUrls,new zt.$_kc(Ke)),At=Ke.set(i.$nM.ExtHostDocuments,new ie.$djc(Ke,Ct)),be=Ke.set(i.$nM.ExtHostDocumentContentProviders,new z.$kkc(Ke,Ct,$t)),Ae=Ke.set(i.$nM.ExtHostDocumentSaveParticipant,new G.$lkc($t,At,Ke.getProxy(i.$mM.MainThreadBulkEdits))),ae=Ke.set(i.$nM.ExtHostNotebook,new ue.$Bkc(Ke,wt,Ct,At,ii,ui)),Q=Ke.set(i.$nM.ExtHostNotebookDocuments,new Ne.$Ikc(ae)),ke=Ke.set(i.$nM.ExtHostNotebookEditors,new le.$Jkc($t,ae)),Be=Ke.set(i.$nM.ExtHostNotebookKernels,new Ie.$Kkc(Ke,vt,ae,wt,$t)),Ze=Ke.set(i.$nM.ExtHostNotebookRenderers,new Re.$Mkc(Ke,ae)),He=Ke.set(i.$nM.ExtHostNotebookDocumentSaveParticipant,new he.$Hkc($t,ae,Ke.getProxy(i.$mM.MainThreadBulkEdits))),rt=Ke.set(i.$nM.ExtHostEditors,new ot.$pjc(Ke,Ct)),yt=Ke.set(i.$nM.ExtHostTreeViews,new me.$0kc(Ke.getProxy(i.$mM.MainThreadTreeViews),wt,$t)),Kt=Ke.set(i.$nM.ExtHostEditorInsets,new g.$qjc(Ke.getProxy(i.$mM.MainThreadEditorInsets),rt,vt.remote)),Bt=Ke.set(i.$nM.ExtHostDiagnostics,new q.$cjc(Ke,$t,si,Ct)),Ot=Ke.set(i.$nM.ExtHostLanguages,new pe.$Fkc(Ke,At,wt.converter,Xt)),ut=Ke.set(i.$nM.ExtHostLanguageFeatures,new ye.$ejc(Ke,Xt,At,wt,Bt,$t,Rt,Mt)),Ci=Ke.set(i.$nM.ExtHostFileSystem,new $e.$nkc(Ke,ut)),gi=Ke.set(i.$nM.ExtHostFileSystemEventService,new Se.$okc(Ke,$t,Ct)),$i=Ke.set(i.$nM.ExtHostQuickOpen,(0,H.$Skc)(Ke,mt,wt)),wi=Ke.set(i.$nM.ExtHostSCM,new se.$Ukc(Ke,wt,At,$t)),Pi=Ke.set(i.$nM.ExtHostQuickDiff,new K.$Rkc(Ke,Xt)),Mi=Ke.set(i.$nM.ExtHostShare,new Qe.$Vkc(Ke,Xt)),Vi=Ke.set(i.$nM.ExtHostComments,(0,y.$rjc)(Ke,wt,At)),Wi=Ke.set(i.$nM.ExtHostProgress,new j.$Qkc(Ke.getProxy(i.$mM.MainThreadProgress))),qi=Ke.set(i.$nM.ExtHostLabelService,new Oe.$Ekc(Ke)),yi=Ke.set(i.$nM.ExtHostTheming,new Z.$7kc(Ke)),Ri=Ke.set(i.$nM.ExtHostTimeline,new X.$9kc(Ke,wt)),ki=Ke.set(i.$nM.ExtHostWebviews,new xt.$Fjc(Ke,vt.remote,mt,$t,Rt)),Ei=Ke.set(i.$nM.ExtHostWebviewPanels,new Jt.$Ijc(Ke,ki,mt)),Hi=Ke.set(i.$nM.ExtHostCustomEditors,new C.$Jjc(Ke,At,jt,ki,Ei)),Ki=Ke.set(i.$nM.ExtHostWebviewViews,new _t.$alc(Ke,ki)),vi=Ke.set(i.$nM.ExtHostTesting,new Ue.$3kc(Ke,$t,wt,Ct)),Gi=Ke.set(i.$nM.ExtHostUriOpeners,new dt.$$kc(Ke)),gn=Ke.set(i.$nM.ExtHostProfileContentHandlers,new U.$Pkc(Ke));Ke.set(i.$nM.ExtHostInteractive,new x.$Ckc(Ke,ae,Ct,wt,$t));const mn=Ke.set(i.$nM.ExtHostInlineChat,new L.$pkc(Ke,wt,At,$t)),Ai=Ke.set(i.$nM.ExtHostChatAgents2,new w.$kjc(Ke,$t,wt)),Oi=Ke.set(i.$nM.ExtHostChatVariables,new l.$njc(Ke)),Ji=Ke.set(i.$nM.ExtHostChat,new $.$jjc(Ke)),Qi=Ke.set(i.$nM.ExtHostAiRelatedInformation,new a.$8ic(Ke)),Xi=Ke.set(i.$nM.ExtHostAiEmbeddingVector,new we.$mkc(Ke)),Zi=Ke.set(i.$nM.ExtHostIssueReporter,new ve.$Dkc(Ke)),Di=Ke.set(i.$nM.ExtHostStatusBar,new tt.$Ykc(Ke,wt.converter)),Yi=Ke.set(i.$nM.ExtHostSpeech,new xe.$Wkc(Ke)),xi=Object.values(i.$nM);Ke.assertRegistered(xi);const _i=new c.$ijc(Ke,Ct),$n=new D.$ojc(Ke),bi=new Y.$Gkc(Ke,$t),Fi=new R.$jkc(Ke);return h.$fjc.register(wt),function(Te,ci,en){function et(_){return(ce,ze,st)=>{const bt=_(Nt=>{try{ce.call(ze,Nt)}catch(zi){O.$2(new Error(`[ExtensionListenerError] Extension '${Te.identifier.value}' FAILED to handle event: ${zi.toString()}`,{cause:zi})),Mt.onExtensionError(Te.identifier,zi)}});return st?.push(bt),bt}}const pt=function(){let _=!Te.isUnderDevelopment;function ce(){_||($t.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function ze(st){if(Array.isArray(st))st.forEach(ze);else if(typeof st=="string")ce();else{const bt=st;typeof bt.scheme>"u"&&ce(),typeof bt.exclusive=="boolean"&&(0,Ye.$0F)(Te,"documentFiltersExclusive")}return st}}(),tn={getSession(_,ce,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,Ye.$0F)(Te,"authLearnMore"),It.getSession(Te,_,ce,ze)},getSessions(_,ce){return(0,Ye.$0F)(Te,"authGetSessions"),It.getSessions(Te,_,ce)},async hasSession(_,ce){return(0,Ye.$0F)(Te,"authSession"),!!await It.getSession(Te,_,ce,{silent:!0})},get onDidChangeSessions(){return et(It.onDidChangeSessions)},registerAuthenticationProvider(_,ce,ze,st){return It.registerAuthenticationProvider(_,ce,ze,st)}},nn={registerCommand(_,ce,ze){return wt.registerCommand(!0,_,ce,ze,void 0,Te)},registerTextEditorCommand(_,ce,ze){return wt.registerCommand(!0,_,(...st)=>{const bt=rt.getActiveTextEditor();if(!bt){$t.warn("Cannot execute "+_+" because there is no active text editor.");return}return bt.edit(Nt=>{ce.apply(ze,[bt,Nt,...st])}).then(Nt=>{Nt||$t.warn("Edits from command "+_+" were not applied.")},Nt=>{$t.warn("An error occurred while running command "+_,Nt)})},void 0,void 0,Te)},registerDiffInformationCommand:(_,ce,ze)=>((0,Ye.$0F)(Te,"diffCommand"),wt.registerCommand(!0,_,async(...st)=>{const bt=Ct.activeEditor(!0);if(!bt){$t.warn("Cannot execute "+_+" because there is no active text editor.");return}const Nt=await rt.getDiffInformation(bt.id);ce.apply(ze,[Nt,...st])},void 0,void 0,Te)),executeCommand(_,...ce){return wt.executeCommand(_,...ce)},getCommands(_=!1){return wt.getCommands(_)}},Ni={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return et(St.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$0F)(Te,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$0F)(Te,"telemetry"),et(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ct.$1O)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,ce){return ct.$ZO.validateSender(_),Mt.instantiateLogger(Te,_,ce)},openExternal(_,ce){return Lt.openUri(_,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===vt.environment.appUriScheme)return Yt.createAppUri(_);try{return await Lt.asExternalUri(_,{allowTunneling:!!vt.remote.authority})}catch(ce){if((0,A.$rg)(_,A.Schemas.http)||(0,A.$rg)(_,A.Schemas.https))return _;throw ce}},get remoteName(){return(0,o.$um)(vt.remote.authority)},get remoteAuthority(){return(0,Ye.$0F)(Te,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return et($t.onDidChangeLogLevel)},registerIssueUriRequestHandler(_){return(0,Ye.$0F)(Te,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Te,_)},registerIssueDataProvider(_){return(0,Ye.$0F)(Te,"handleIssueUri"),Zi.registerIssueDataProvider(Te,_)},get appQuality(){return(0,Ye.$0F)(Te,"resolvers"),vt.quality},get appCommit(){return(0,Ye.$0F)(Te,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ni);const rn={createTestController(_,ce,ze){return vi.createTestController(Te,_,ce,ze)},createTestObserver(){return(0,Ye.$0F)(Te,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ye.$0F)(Te,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ye.$0F)(Te,"testObserver"),et(vi.onResultsChanged)},get testResults(){return(0,Ye.$0F)(Te,"testObserver"),vi.results}},Si=vt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,sn={getExtension(_,ce){(0,Ye.$9F)(Te,"extensionsAny")||(ce=!1);const ze=ci.mine.getExtensionDescription(_);if(ze)return new oe.$$jc(Ft,Te.identifier,ze,Si,!1);if(ce){const st=ci.all.getExtensionDescription(_);if(st)return new oe.$$jc(Ft,Te.identifier,st,Si,!0)}},get all(){const _=[];for(const ce of ci.mine.getAllExtensionDescriptions())_.push(new oe.$$jc(Ft,Te.identifier,ce,Si,!1));return _},get allAcrossExtensionHosts(){(0,Ye.$0F)(Te,"extensionsAny");const _=new b.$Em(ci.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ce=[];for(const ze of ci.all.getAllExtensionDescriptions()){const st=!_.has(ze.identifier);ce.push(new oe.$$jc(Ft,Te.identifier,ze,Si,st))}return ce},get onDidChange(){return(0,Ye.$9F)(Te,"extensionsAny")?et(M.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):et(ci.mine.onDidChange)}},on={createDiagnosticCollection(_){return Bt.createDiagnosticCollection(Te.identifier,_)},get onDidChangeDiagnostics(){return et(Bt.onDidChangeDiagnostics)},getDiagnostics:_=>Bt.getDiagnostics(_),getLanguages(){return Ot.getLanguages()},setTextDocumentLanguage(_,ce){return Ot.changeLanguage(_.uri,ce)},match(_,ce){const ze=Xe.LanguageSelector.from(_);let st;return(0,F.$Wt)(ze)&&(st=ae.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(Nt=>Nt.document===ce))?.apiNotebook),(0,F.$Vt)(ze,ce.uri,ce.languageId,!0,st?.uri,st?.notebookType)},registerCodeActionsProvider(_,ce,ze){return ut.registerCodeActionProvider(Te,pt(_),ce,ze)},registerDocumentPasteEditProvider(_,ce,ze){return(0,Ye.$0F)(Te,"documentPaste"),ut.registerDocumentPasteEditProvider(Te,pt(_),ce,ze)},registerCodeLensProvider(_,ce){return ut.registerCodeLensProvider(Te,pt(_),ce)},registerDefinitionProvider(_,ce){return ut.registerDefinitionProvider(Te,pt(_),ce)},registerDeclarationProvider(_,ce){return ut.registerDeclarationProvider(Te,pt(_),ce)},registerImplementationProvider(_,ce){return ut.registerImplementationProvider(Te,pt(_),ce)},registerTypeDefinitionProvider(_,ce){return ut.registerTypeDefinitionProvider(Te,pt(_),ce)},registerHoverProvider(_,ce){return ut.registerHoverProvider(Te,pt(_),ce,Te.identifier)},registerEvaluatableExpressionProvider(_,ce){return ut.registerEvaluatableExpressionProvider(Te,pt(_),ce,Te.identifier)},registerInlineValuesProvider(_,ce){return ut.registerInlineValuesProvider(Te,pt(_),ce,Te.identifier)},registerDocumentHighlightProvider(_,ce){return ut.registerDocumentHighlightProvider(Te,pt(_),ce)},registerMultiDocumentHighlightProvider(_,ce){return ut.registerMultiDocumentHighlightProvider(Te,pt(_),ce)},registerLinkedEditingRangeProvider(_,ce){return ut.registerLinkedEditingRangeProvider(Te,pt(_),ce)},registerReferenceProvider(_,ce){return ut.registerReferenceProvider(Te,pt(_),ce)},registerRenameProvider(_,ce){return ut.registerRenameProvider(Te,pt(_),ce)},registerNewSymbolNamesProvider(_,ce){return(0,Ye.$0F)(Te,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(Te,pt(_),ce)},registerDocumentSymbolProvider(_,ce,ze){return ut.registerDocumentSymbolProvider(Te,pt(_),ce,ze)},registerWorkspaceSymbolProvider(_){return ut.registerWorkspaceSymbolProvider(Te,_)},registerDocumentFormattingEditProvider(_,ce){return ut.registerDocumentFormattingEditProvider(Te,pt(_),ce)},registerDocumentRangeFormattingEditProvider(_,ce){return ut.registerDocumentRangeFormattingEditProvider(Te,pt(_),ce)},registerOnTypeFormattingEditProvider(_,ce,ze,...st){return ut.registerOnTypeFormattingEditProvider(Te,pt(_),ce,[ze].concat(st))},registerDocumentSemanticTokensProvider(_,ce,ze){return ut.registerDocumentSemanticTokensProvider(Te,pt(_),ce,ze)},registerDocumentRangeSemanticTokensProvider(_,ce,ze){return ut.registerDocumentRangeSemanticTokensProvider(Te,pt(_),ce,ze)},registerSignatureHelpProvider(_,ce,ze,...st){return typeof ze=="object"?ut.registerSignatureHelpProvider(Te,pt(_),ce,ze):ut.registerSignatureHelpProvider(Te,pt(_),ce,typeof ze>"u"?[]:[ze,...st])},registerCompletionItemProvider(_,ce,...ze){return ut.registerCompletionItemProvider(Te,pt(_),ce,ze)},registerInlineCompletionItemProvider(_,ce,ze){return ce.handleDidShowCompletionItem&&(0,Ye.$0F)(Te,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$0F)(Te,"inlineCompletionsAdditions"),ze&&(0,Ye.$0F)(Te,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Te,pt(_),ce,ze)},registerInlineEditProvider(_,ce){return(0,Ye.$0F)(Te,"inlineEdit"),ut.registerInlineEditProvider(Te,pt(_),ce)},registerDocumentLinkProvider(_,ce){return ut.registerDocumentLinkProvider(Te,pt(_),ce)},registerColorProvider(_,ce){return ut.registerColorProvider(Te,pt(_),ce)},registerFoldingRangeProvider(_,ce){return ut.registerFoldingRangeProvider(Te,pt(_),ce)},registerSelectionRangeProvider(_,ce){return ut.registerSelectionRangeProvider(Te,_,ce)},registerCallHierarchyProvider(_,ce){return ut.registerCallHierarchyProvider(Te,_,ce)},registerTypeHierarchyProvider(_,ce){return ut.registerTypeHierarchyProvider(Te,_,ce)},setLanguageConfiguration:(_,ce)=>ut.setLanguageConfiguration(Te,_,ce),getTokenInformationAtPosition(_,ce){return(0,Ye.$0F)(Te,"tokenInformation"),Ot.tokenAtPosition(_,ce)},registerInlayHintsProvider(_,ce){return ut.registerInlayHintsProvider(Te,_,ce)},createLanguageStatusItem(_,ce){return Ot.createLanguageStatusItem(Te,_,ce)},registerDocumentDropEditProvider(_,ce,ze){return ut.registerDocumentOnDropEditProvider(Te,_,ce,(0,Ye.$9F)(Te,"dropMetadata")?ze:void 0)}},pn={get activeTextEditor(){return rt.getActiveTextEditor()},get visibleTextEditors(){return rt.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,ce,ze){d.URI.isUri(_)&&_.scheme===A.Schemas.vscodeRemote&&!_.authority&&Rt.report("workspace.showTextDocument",Te,"A URI of 'vscode-remote' scheme requires an authority.");const st=await(d.URI.isUri(_)?Promise.resolve(an.openTextDocument(_)):Promise.resolve(_));return rt.showTextDocument(st,ce,ze)},createTextEditorDecorationType(_){return rt.createTextEditorDecorationType(Te,_)},onDidChangeActiveTextEditor(_,ce,ze){return et(rt.onDidChangeActiveTextEditor)(_,ce,ze)},onDidChangeVisibleTextEditors(_,ce,ze){return et(rt.onDidChangeVisibleTextEditors)(_,ce,ze)},onDidChangeTextEditorSelection(_,ce,ze){return et(rt.onDidChangeTextEditorSelection)(_,ce,ze)},onDidChangeTextEditorOptions(_,ce,ze){return et(rt.onDidChangeTextEditorOptions)(_,ce,ze)},onDidChangeTextEditorVisibleRanges(_,ce,ze){return et(rt.onDidChangeTextEditorVisibleRanges)(_,ce,ze)},onDidChangeTextEditorViewColumn(_,ce,ze){return et(rt.onDidChangeTextEditorViewColumn)(_,ce,ze)},onDidCloseTerminal(_,ce,ze){return et(St.onDidCloseTerminal)(_,ce,ze)},onDidOpenTerminal(_,ce,ze){return et(St.onDidOpenTerminal)(_,ce,ze)},onDidChangeActiveTerminal(_,ce,ze){return et(St.onDidChangeActiveTerminal)(_,ce,ze)},onDidChangeTerminalDimensions(_,ce,ze){return(0,Ye.$0F)(Te,"terminalDimensions"),et(St.onDidChangeTerminalDimensions)(_,ce,ze)},onDidChangeTerminalState(_,ce,ze){return et(St.onDidChangeTerminalState)(_,ce,ze)},onDidWriteTerminalData(_,ce,ze){return(0,Ye.$0F)(Te,"terminalDataWriteEvent"),et(St.onDidWriteTerminalData)(_,ce,ze)},onDidExecuteTerminalCommand(_,ce,ze){return(0,Ye.$0F)(Te,"terminalExecuteCommandEvent"),et(St.onDidExecuteTerminalCommand)(_,ce,ze)},get state(){return Lt.getState(Te)},onDidChangeWindowState(_,ce,ze){return et(Lt.onDidChangeWindowState)(_,ce,ze)},showInformationMessage(_,...ce){return bi.showMessage(Te,m.default.Info,_,ce[0],ce.slice(1))},showWarningMessage(_,...ce){return bi.showMessage(Te,m.default.Warning,_,ce[0],ce.slice(1))},showErrorMessage(_,...ce){return bi.showMessage(Te,m.default.Error,_,ce[0],ce.slice(1))},showQuickPick(_,ce,ze){return $i.showQuickPick(Te,_,ce,ze)},showWorkspaceFolderPick(_){return $i.showWorkspaceFolderPick(_)},showInputBox(_,ce){return $i.showInput(_,ce)},showOpenDialog(_){return Fi.showOpenDialog(Te,_)},showSaveDialog(_){return Fi.showSaveDialog(_)},createStatusBarItem(_,ce,ze){let st,bt,Nt;return typeof _=="string"?(st=_,bt=ce,Nt=ze):(bt=_,Nt=ce),Di.createStatusBarEntry(Te,st,bt,Nt)},setStatusBarMessage(_,ce){return Di.setStatusBarMessage(_,ce)},withScmProgress(_){return Rt.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Wi.withProgress(Te,{location:Me.ProgressLocation.SourceControl},(ce,ze)=>_({report(st){}}))},withProgress(_,ce){return Wi.withProgress(Te,_,ce)},createOutputChannel(_,ce){return li.createOutputChannel(_,ce,Te)},createWebviewPanel(_,ce,ze,st){return Ei.createWebviewPanel(Te,_,ce,ze,st)},createWebviewTextEditorInset(_,ce,ze,st){return(0,Ye.$0F)(Te,"editorInsets"),Kt.createWebviewEditorInset(_,ce,ze,st,Te)},createTerminal(_,ce,ze){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,ce,ze)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,ce){return St.registerProfileProvider(Te,_,ce)},registerTerminalQuickFixProvider(_,ce){return(0,Ye.$0F)(Te,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,Te.identifier.value,ce)},registerTreeDataProvider(_,ce){return yt.registerTreeDataProvider(_,ce,Te)},createTreeView(_,ce){return yt.createTreeView(_,ce,Te)},registerWebviewPanelSerializer:(_,ce)=>Ei.registerWebviewPanelSerializer(Te,_,ce),registerCustomEditorProvider:(_,ce,ze={})=>Hi.registerCustomEditorProvider(Te,_,ce,ze),registerFileDecorationProvider(_){return Ht.registerFileDecorationProvider(_,Te)},registerUriHandler(_){return Yt.registerUriHandler(Te,_)},createQuickPick(){return $i.createQuickPick(Te)},createInputBox(){return $i.createInputBox(Te)},get activeColorTheme(){return yi.activeColorTheme},onDidChangeActiveColorTheme(_,ce,ze){return et(yi.onDidChangeActiveColorTheme)(_,ce,ze)},registerWebviewViewProvider(_,ce,ze){return Ki.registerWebviewViewProvider(Te,_,ce,ze?.webviewOptions)},get activeNotebookEditor(){return ae.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,ce,ze){return et(ae.onDidChangeActiveNotebookEditor)(_,ce,ze)},get visibleNotebookEditors(){return ae.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(ae.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,ce,ze){return et(ke.onDidChangeNotebookEditorSelection)(_,ce,ze)},onDidChangeNotebookEditorVisibleRanges(_,ce,ze){return et(ke.onDidChangeNotebookEditorVisibleRanges)(_,ce,ze)},showNotebookDocument(_,ce){return ae.showNotebookDocument(_,ce)},registerExternalUriOpener(_,ce,ze){return(0,Ye.$0F)(Te,"externalUriOpener"),Gi.registerExternalUriOpener(Te.identifier,_,ce,ze)},registerProfileContentHandler(_,ce){return(0,Ye.$0F)(Te,"profileContentHandlers"),gn.registerProfileContentHandler(Te,_,ce)},registerQuickDiffProvider(_,ce,ze,st){return(0,Ye.$0F)(Te,"quickDiffProvider"),Pi.registerQuickDiffProvider(pt(_),ce,ze,st)},get tabGroups(){return oi.tabGroups},registerShareProvider(_,ce){return(0,Ye.$0F)(Te,"shareProvider"),Mi.registerShareProvider(pt(_),ce)}},an={get rootPath(){return Rt.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return mt.getWorkspaceFolder(_)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(_){throw new O.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,ce,...ze)=>mt.updateWorkspaceFolders(Te,_,ce||0,...ze),onDidChangeWorkspaceFolders:function(_,ce,ze){return et(mt.onDidChangeWorkspace)(_,ce,ze)},asRelativePath:(_,ce)=>mt.getRelativePath(_,ce),findFiles:(_,ce,ze,st)=>mt.findFiles(_,ce,ze,Te.identifier,st),findFiles2:(_,ce,ze)=>((0,Ye.$0F)(Te,"findFiles2"),mt.findFiles2(_,ce,Te.identifier,ze)),findTextInFiles:(_,ce,ze,st)=>{(0,Ye.$0F)(Te,"findTextInFiles");let bt,Nt;return typeof ce=="object"?(bt=ce,Nt=ze):(bt={},Nt=ce,st=ze),mt.findTextInFiles(_,bt||{},Nt,Te.identifier,st)},save:_=>mt.save(_),saveAs:_=>mt.saveAs(_),saveAll:_=>mt.saveAll(_),applyEdit(_,ce){return _i.applyWorkspaceEdit(_,Te,ce)},createFileSystemWatcher:(_,ce,ze,st)=>{let bt;return typeof ce=="boolean"?bt={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!st,correlate:!1}:ce&&((0,Ye.$0F)(Te,"createFileSystemWatcher"),bt={...ce,correlate:!0}),gi.createFileSystemWatcher(mt,Te,_,bt)},get textDocuments(){return At.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let ce;const ze=_;if(typeof _=="string")ce=Promise.resolve(d.URI.file(_));else if(d.URI.isUri(_))ce=Promise.resolve(_);else if(!ze||typeof ze=="object")ce=At.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>(st.scheme===A.Schemas.vscodeRemote&&!st.authority&&Rt.report("workspace.openTextDocument",Te,"A URI of 'vscode-remote' scheme requires an authority."),At.ensureDocumentData(st).then(bt=>bt.document)))},onDidOpenTextDocument:(_,ce,ze)=>et(At.onDidAddDocument)(_,ce,ze),onDidCloseTextDocument:(_,ce,ze)=>et(At.onDidRemoveDocument)(_,ce,ze),onDidChangeTextDocument:(_,ce,ze)=>et(At.onDidChangeDocument)(_,ce,ze),onDidSaveTextDocument:(_,ce,ze)=>et(At.onDidSaveDocument)(_,ce,ze),onWillSaveTextDocument:(_,ce,ze)=>et(Ae.getOnWillSaveTextDocumentEvent(Te))(_,ce,ze),get notebookDocuments(){return ae.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,ce){let ze;if(d.URI.isUri(_))ze=_,await ae.openNotebookDocument(_);else if(typeof _=="string")ze=d.URI.revive(await ae.createNotebookDocument({viewType:_,content:ce}));else throw new Error("Invalid arguments");return ae.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(_,ce,ze){return et(Q.onDidSaveNotebookDocument)(_,ce,ze)},onDidChangeNotebookDocument(_,ce,ze){return et(Q.onDidChangeNotebookDocument)(_,ce,ze)},onWillSaveNotebookDocument(_,ce,ze){return et(He.getOnWillSaveNotebookDocumentEvent(Te))(_,ce,ze)},get onDidOpenNotebookDocument(){return et(ae.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(ae.onDidCloseNotebookDocument)},registerNotebookSerializer(_,ce,ze,st){return ae.registerNotebookSerializer(Te,_,ce,ze,(0,Ye.$9F)(Te,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(_,ce,ze)=>et(en.onDidChangeConfiguration)(_,ce,ze),getConfiguration(_,ce){return ce=arguments.length===1?void 0:ce,en.getConfiguration(_,ce,Te)},registerTextDocumentContentProvider(_,ce){return be.registerTextDocumentContentProvider(_,ce)},registerTaskProvider:(_,ce)=>(Rt.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider(Te,_,ce)),registerFileSystemProvider(_,ce,ze){return(0,N.$Rc)(Ci.registerFileSystemProvider(Te,_,ce,ze),ii.addFileSystemProvider(_,ce,ze))},get fs(){return ii.value},registerFileSearchProvider:(_,ce)=>((0,Ye.$0F)(Te,"fileSearchProvider"),ui.registerFileSearchProvider(_,ce)),registerTextSearchProvider:(_,ce)=>((0,Ye.$0F)(Te,"textSearchProvider"),ui.registerTextSearchProvider(_,ce)),registerAITextSearchProvider:(_,ce)=>((0,Ye.$0F)(Te,"aiTextSearchProvider"),(0,Ye.$0F)(Te,"textSearchProvider"),ui.registerAITextSearchProvider(_,ce)),registerRemoteAuthorityResolver:(_,ce)=>((0,Ye.$0F)(Te,"resolvers"),Ft.registerRemoteAuthorityResolver(_,ce)),registerResourceLabelFormatter:_=>((0,Ye.$0F)(Te,"resolvers"),qi.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ye.$0F)(Te,"resolvers"),Ft.getRemoteExecServer(_)),onDidCreateFiles:(_,ce,ze)=>et(gi.onDidCreateFile)(_,ce,ze),onDidDeleteFiles:(_,ce,ze)=>et(gi.onDidDeleteFile)(_,ce,ze),onDidRenameFiles:(_,ce,ze)=>et(gi.onDidRenameFile)(_,ce,ze),onWillCreateFiles:(_,ce,ze)=>et(gi.getOnWillCreateFileEvent(Te))(_,ce,ze),onWillDeleteFiles:(_,ce,ze)=>et(gi.getOnWillDeleteFileEvent(Te))(_,ce,ze),onWillRenameFiles:(_,ce,ze)=>et(gi.getOnWillRenameFileEvent(Te))(_,ce,ze),openTunnel:_=>((0,Ye.$0F)(Te,"tunnels"),Tt.openTunnel(Te,_).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Ye.$0F)(Te,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(_,ce,ze)=>((0,Ye.$0F)(Te,"tunnels"),et(Tt.onDidChangeTunnels)(_,ce,ze)),registerPortAttributesProvider:(_,ce)=>((0,Ye.$0F)(Te,"portsAttributes"),Tt.registerPortsAttributesProvider(_,ce)),registerTunnelProvider:(_,ce)=>((0,Ye.$0F)(Te,"tunnelFactory"),Tt.registerTunnelProvider(_,ce)),registerTimelineProvider:(_,ce)=>((0,Ye.$0F)(Te,"timeline"),Ri.registerTimelineProvider(_,ce,Te.identifier,wt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:_=>((0,Ye.$0F)(Te,"workspaceTrust"),mt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,ce,ze)=>et(mt.onDidGrantWorkspaceTrust)(_,ce,ze),registerEditSessionIdentityProvider:(_,ce)=>((0,Ye.$0F)(Te,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(_,ce)),onWillCreateEditSessionIdentity:(_,ce,ze)=>((0,Ye.$0F)(Te,"editSessionIdentityProvider"),et(mt.getOnWillCreateEditSessionIdentityEvent(Te))(_,ce,ze)),registerCanonicalUriProvider:(_,ce)=>((0,Ye.$0F)(Te,"canonicalUriProvider"),mt.registerCanonicalUriProvider(_,ce)),getCanonicalUri:(_,ce,ze)=>((0,Ye.$0F)(Te,"canonicalUriProvider"),mt.provideCanonicalUri(_,ce,ze))},cn={get inputBox(){return Rt.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(Te)},createSourceControl(_,ce,ze){return wi.createSourceControl(Te,_,ce,ze)}},Ti={createCommentController(_,ce){return Vi.createCommentController(Te,_,ce)}},un={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Ye.$9F)(Te,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(_,ce){return(0,Ye.$0F)(Te,"debugVisualization"),kt.registerDebugVisualizationProvider(Te,_,ce)},registerDebugVisualizationTreeProvider(_,ce){return(0,Ye.$0F)(Te,"debugVisualization"),kt.registerDebugVisualizationTree(Te,_,ce)},onDidStartDebugSession(_,ce,ze){return et(kt.onDidStartDebugSession)(_,ce,ze)},onDidTerminateDebugSession(_,ce,ze){return et(kt.onDidTerminateDebugSession)(_,ce,ze)},onDidChangeActiveDebugSession(_,ce,ze){return et(kt.onDidChangeActiveDebugSession)(_,ce,ze)},onDidReceiveDebugSessionCustomEvent(_,ce,ze){return et(kt.onDidReceiveDebugSessionCustomEvent)(_,ce,ze)},onDidChangeBreakpoints(_,ce,ze){return et(kt.onDidChangeBreakpoints)(_,ce,ze)},onDidChangeActiveStackItem(_,ce,ze){return(0,Ye.$0F)(Te,"debugFocus"),et(kt.onDidChangeActiveStackItem)(_,ce,ze)},registerDebugConfigurationProvider(_,ce,ze){return kt.registerDebugConfigurationProvider(_,ce,ze||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,ce){return kt.registerDebugAdapterDescriptorFactory(Te,_,ce)},registerDebugAdapterTrackerFactory(_,ce){return kt.registerDebugAdapterTrackerFactory(_,ce)},startDebugging(_,ce,ze){return!ze||typeof ze=="object"&&"configuration"in ze?kt.startDebugging(_,ce,{parentSession:ze}):kt.startDebugging(_,ce,ze||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,ce){return kt.asDebugSourceUri(_,ce)}},ln={registerTaskProvider:(_,ce)=>ri.registerTaskProvider(Te,_,ce),fetchTasks:_=>ri.fetchTasks(_),executeTask:_=>ri.executeTask(Te,_),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(_,ce,ze)=>et(ri.onDidStartTask)(_,ce,ze),onDidEndTask:(_,ce,ze)=>et(ri.onDidEndTask)(_,ce,ze),onDidStartTaskProcess:(_,ce,ze)=>et(ri.onDidStartTaskProcess)(_,ce,ze),onDidEndTaskProcess:(_,ce,ze)=>et(ri.onDidEndTaskProcess)(_,ce,ze)},hn={createNotebookController(_,ce,ze,st,bt){return Be.createNotebookController(Te,_,ce,ze,st,(0,Ye.$9F)(Te,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(_,ce)=>ae.registerNotebookCellStatusBarItemProvider(Te,_,ce),createRendererMessaging(_){return Ze.createRendererMessaging(Te,_)},createNotebookControllerDetectionTask(_){return(0,Ye.$0F)(Te,"notebookKernelSource"),Be.createNotebookControllerDetectionTask(Te,_)},registerKernelSourceActionProvider(_,ce){return(0,Ye.$0F)(Te,"notebookKernelSource"),Be.registerKernelSourceActionProvider(Te,_,ce)},onDidChangeNotebookCellExecutionState(_,ce,ze){return(0,Ye.$0F)(Te,"notebookCellExecutionState"),et(Be.onDidChangeNotebookCellExecutionState)(_,ce,ze)}},vn={t(..._){if(typeof _[0]=="string"){const ce=_.shift(),ze=!_||typeof _[0]!="object"?_:_[0];return di.getMessage(Te.identifier.value,{message:ce,args:ze})}return di.getMessage(Te.identifier.value,_[0])},get bundle(){return di.getBundle(Te.identifier.value)},get uri(){return di.getBundleUri(Te.identifier.value)}},bn={_version:1,registerInteractiveEditorSessionProvider(_,ce){return(0,Ye.$0F)(Te,"interactive"),mn.registerProvider(Te,_,ce)},registerInteractiveSessionProvider(_,ce){return(0,Ye.$0F)(Te,"interactive"),Ji.registerChatProvider(Te,_,ce)},transferChatSession(_,ce){return(0,Ye.$0F)(Te,"interactive"),Ji.transferChatSession(_,ce)}},dn={getRelatedInformation(_,ce){return(0,Ye.$0F)(Te,"aiRelatedInformation"),Qi.getRelatedInformation(Te,_,ce)},registerRelatedInformationProvider(_,ce){return(0,Ye.$0F)(Te,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Te,_,ce)},registerEmbeddingVectorProvider(_,ce){return(0,Ye.$0F)(Te,"aiRelatedInformation"),Xi.registerEmbeddingVectorProvider(Te,_,ce)}},fn={registerChatResponseProvider(_,ce,ze){return(0,Ye.$0F)(Te,"chatProvider"),Dt.registerLanguageModel(Te,_,ce,ze)},registerChatVariableResolver(_,ce,ze){return(0,Ye.$0F)(Te,"chatVariableResolver"),Oi.registerVariableResolver(Te,_,ce,ze)},registerMappedEditsProvider(_,ce){return(0,Ye.$0F)(Te,"mappedEditsProvider"),ut.registerMappedEditsProvider(Te,_,ce)},createChatParticipant(_,ce){return(0,Ye.$0F)(Te,"chatParticipant"),Ai.createChatAgent(Te,_,ce)}},Li={get languageModels(){return(0,Ye.$0F)(Te,"languageModels"),Dt.getLanguageModelIds()},onDidChangeLanguageModels:(_,ce,ze)=>((0,Ye.$0F)(Te,"languageModels"),Dt.onDidChangeProviders(_,ce,ze)),sendChatRequest(_,ce,ze,st){return(0,Ye.$0F)(Te,"languageModels"),Dt.sendChatRequest(Te,_,ce,ze,st)}},ji={registerSpeechProvider(_,ce){return(0,Ye.$0F)(Te,"speech"),Yi.registerProvider(Te.identifier,_,ce)}};return{version:vt.version,ai:dn,authentication:tn,commands:nn,comments:Ti,chat:fn,debug:un,env:Ni,extensions:sn,interactive:bn,l10n:vn,languages:on,lm:Li,notebooks:hn,scm:cn,speech:ji,tasks:ln,tests:rn,window:pn,workspace:an,Breakpoint:Me.$oN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$iO,CallHierarchyIncomingCall:Me.$MM,CallHierarchyItem:Me.$LM,CallHierarchyOutgoingCall:Me.$NM,CancellationError:O.$5,CancellationTokenSource:I.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$IM,CodeActionKind:Me.$JM,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$OM,Color:Me.$2M,ColorInformation:Me.$3M,ColorPresentation:Me.$4M,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$VM,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$WM,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$_M,DebugAdapterExecutable:Me.$sN,DebugAdapterInlineImplementation:Me.$vN,DebugAdapterNamedPipeServer:Me.$uN,DebugAdapterServer:Me.$tN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$LN,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$CM,DiagnosticRelatedInformation:Me.$BM,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$oM,DocumentHighlight:Me.$EM,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$FM,DocumentLink:Me.$1M,DocumentSymbol:Me.$HM,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$yN,InlineValueText:Me.$zN,InlineValueVariableLookup:Me.$AN,InlineValueEvaluatableExpression:Me.$BN,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:M.$7d,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$NN,FileDecoration2:Me.$NN,FileSystemError:Me.$EN,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:Me.$FN,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$qN,InlineCompletionItem:Me.$XM,InlineCompletionList:Me.$YM,Hover:Me.$DM,IndentAction:E.IndentAction,Location:Me.$AM,MarkdownString:Me.$PM,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Me.$QM,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$pM,ProcessExecution:Me.$0M,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$MN,Range:Me.$qM,RelativePattern:Me.$mN,Selection:Me.$rM,SelectionRange:Me.$KM,SemanticTokens:Me.$IN,SemanticTokensBuilder:Me.$HN,SemanticTokensEdit:Me.$JN,SemanticTokensEdits:Me.$KN,SemanticTokensLegend:Me.$GN,ShellExecution:Me.$$M,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$SM,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$RM,SnippetString:Me.$zM,SourceBreakpoint:Me.$pN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$GM,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$aN,TaskGroup:Me.$9M,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$5M,TerminalQuickFixTerminalCommand:Me.$7M,TerminalQuickFixOpener:Me.$6M,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$8M,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$vM,SnippetTextEdit:Me.$xM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$lN,ThemeIcon:Me.$kN,TreeItem:Me.$bN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$9N,UIKind:ai.UIKind,Uri:d.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$yM,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$hN,DocumentPasteEditKind:Me.$iN,DocumentPasteEdit:Me.$jN,InlayHint:Me.$UM,InlayHintLabelPart:Me.$TM,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$uM,ResolvedAuthority:Me.$sM,ManagedResolvedAuthority:Me.$tM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$XN,NotebookRange:Me.$PN,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$QN,NotebookData:Me.$RN,NotebookRendererScript:Me.$VN,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$TN,NotebookCellOutputItem:Me.$SN,NotebookCellStatusBarItem:Me.$UN,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$wM,NotebookKernelSourceAction:Me.$WN,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$ZN,LinkedEditingRanges:Me.$YN,TestResultState:Me.TestResultState,TestRunRequest:Me.$1N,TestMessage:Me.$2N,TestTag:Me.$3N,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:ei.TextSearchCompleteMessageType,DataTransfer:Me.$gN,DataTransferItem:Me.$cN,TestCoverageCount:Me.$4N,FileCoverage:Me.$5N,StatementCoverage:Me.$6N,BranchCoverage:Me.$7N,DeclarationCoverage:Me.$8N,FunctionCoverage:Me.$8N,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$0N,TabInputTextDiff:Me.$$N,TabInputTextMerge:Me.$_N,TabInputCustom:Me.$aO,TabInputNotebook:Me.$cO,TabInputNotebookDiff:Me.$dO,TabInputWebview:Me.$bO,TabInputTerminal:Me.$eO,TabInputInteractiveWindow:Me.$fO,TabInputChat:Me.$gO,TabInputTextMultiDiff:Me.$hO,TelemetryTrustedValue:s.$4o,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$wN,Thread:Me.$xN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$jO,ChatResponseFileTreePart:Me.$kO,ChatResponseAnchorPart:Me.$lO,ChatResponseProgressPart:Me.$mO,ChatResponseReferencePart:Me.$oO,ChatResponseCommandButtonPart:Me.$nO,ChatRequestTurn:Me.$pO,ChatResponseTurn:Me.$qO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$rO,LanguageModelChatUserMessage:Me.$sO,LanguageModelChatAssistantMessage:Me.$tO,LanguageModelSystemMessage:Me.$rO,LanguageModelUserMessage:Me.$sO,LanguageModelAssistantMessage:Me.$tO,LanguageModelError:Me.$uO,NewSymbolName:Me.$DN,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$vO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(Ce[298],Pe([1,0,54,115,36,110,37,31,67,66,118,120,121,82,86,78,109,63,44,81,61,65,236,13,119,79,80,84,88]),function(ge,e,I,O,M,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,p,c,$,w,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$gs)($.$5jc,$.$4jc,1),(0,I.$gs)(p.$Pj,t.$elc,1),(0,I.$gs)(r.$9ic,r.$0ic,1),(0,I.$gs)(m.$4O,m.$3O,0),(0,I.$gs)(v.$gjc,v.$hjc,0),(0,I.$gs)(l.$ljc,l.$mjc,0),(0,I.$gs)(A.$yjc,A.$wjc,0),(0,I.$gs)(s.$Ajc,s.$zjc,0),(0,I.$gs)(E.$ckc,E.$gkc,0),(0,I.$gs)(N.$ikc,N.$hkc,0),(0,I.$gs)(d.$SO,d.$RO,0),(0,I.$gs)(w.$6jc,w.$7jc,0),(0,I.$gs)(n.$ajc,n.$_ic,0),(0,I.$gs)(O.$Okc,O.$Nkc,1),(0,I.$gs)(u.$ykc,u.$zkc,0),(0,I.$gs)(b.$Tjc,b.$Sjc,0),(0,I.$gs)(F.$2kc,F.$1kc,0),(0,I.$gs)(k.$Wjc,k.$Zjc,0),(0,I.$gs)(f.$TBb,f.$UBb,0),(0,I.$gs)(o.$clc,o.$blc,0),(0,I.$gs)(M.$vjc,M.$ujc,0),(0,I.$gs)(i.$2jc,i.$1jc,0),(0,I.$gs)(a.$2O,a.$YO,0),(0,I.$gs)(h.$Kjc,h.$Ljc,0),(0,I.$gs)(c.$akc,c.$bkc,0)}),define(Ce[299],Pe([1,0,297,38,2,294,7,11,242]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0;class k extends N.$hlc{j(){}getModule(b,f){for(const r of this.b){const o=r(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends O.$9jc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(d.$nnc);const b=this.h.invokeFunction(I.$dlc);this.r=this.h.createInstance(k,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,f,r){f=f.with({path:E(f.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=M.URI.revive(await this.C.$asBrowserUri(f)),n=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),a=`${f.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(w){throw console.error(o?`Loading code for extension ${o} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${f.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const p={},c={exports:p},$=w=>{const v=this.r.getModule(w,f);if(v===void 0)throw new Error(`Cannot load module '${w}'`);return v};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,p,$),c.exports!==p?c.exports:p}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,m.$jh)(10)}}e.$onc=F;function E(u,b){return u.endsWith(b)?u:u+b}}),define(Ce[300],Pe([1,0,70,54,13,38,205,85,299]),function(ge,e,I,O,M,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$gs)(M.$Oj,new I.$fi(A.$glc,[!0],!0)),(0,O.$gs)(N.$0jc,d.$onc,0),(0,O.$gs)(m.$Bjc,m.$Cjc,0)}),define(Ce[306],Pe([1,0,22,5,77,295,244,19,89,12,2,298,300]),function(ge,e,I,O,M,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function r(t){self.fetch=async function(p,c){return p instanceof Request||b(String(p))&&(p=(await t(F.URI.parse(String(p)))).toString(!0)),f(p,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(p,c,$,w,v){(async()=>(b(c.toString())&&(c=(await t(F.URI.parse(c.toString()))).toString(!0)),super.open(p,c,$??!0,w,v)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(p,c){if(/^file:/i.test(p.toString()))p=k.$Cg.uriToBrowserUri(F.URI.parse(p.toString())).toString(!0);else if(/^vscode-remote:/i.test(p.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(g){function S(C){return typeof C=="string"||C instanceof URL?String(C).replace(/^file:\/\//i,"vscode-file://vscode-app"):C}const y=fetch.bind(self);self.fetch=function(C,W){return C instanceof Request?y(C,W):y(S(C),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(C,W,V,q,R){return super.open(C,S(W),V??!0,q,R)}};const P=importScripts.bind(self);self.importScripts=(...C)=>{P(...C.map(S))},P(g)}.toString()}('${p}'))`;c=c||{},c.name=`${name} -> ${c.name||m.$oc(p.toString())}`;const v=new Blob([w],{type:"application/javascript"}),l=URL.createObjectURL(v);return new t(l,c)}}else self.Worker=class extends A.$pnc{constructor(t,p){super(u,t,{name:m.$oc(t.toString()),...p})}};const o=new class{constructor(){this.pid=void 0}exit(t){E()}};class s{constructor(){const p=new MessageChannel,c=new O.$7d;let $=!1;u(p.port2,[p.port2]),p.port1.onmessage=w=>{const{data:v}=w;if(!(v instanceof ArrayBuffer)){console.warn("UNKNOWN data received",v);return}const l=I.$ue.wrap(new Uint8Array(v,0,v.byteLength));if((0,M.$Mm)(l,2)){$=!0,i("received terminate message from renderer");return}c.fire(l)},this.protocol={onMessage:c.event,send:w=>{if(!$){const v=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);p.port1.postMessage(v,[v])}}}}}function n(t){return new Promise(p=>{const c=t.onMessage($=>{c.dispose();const w=JSON.parse($.toString());t.send((0,M.$Lm)(0)),p({protocol:t,initData:w})});t.send((0,M.$Lm)(1))})}let i=t=>E();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){d.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(p){a(p)&&n(t.protocol).then(c=>{d.mark("code/extHost/didWaitForInitData");const $=new N.$jlc(c.protocol,c.initData,o,null,p.data);r(w=>$.asBrowserUri(w)),i=w=>$.terminate(w)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7c827a5e0ddbba66425ea54e33430bce8f53c84/core/vs/workbench/api/worker/extensionHostWorker.js.map
